#include <iostream>
#include <vector>
using namespace std;

int main(){
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> finalpos(1005, 0);
    vector<int> curpos(n,0);
    vector<vector<bool>> seen(n+5,vector<bool>(n+5,false));
    for(int i =0 ; i < n; i++){
        int x;
        cin >> x;
        finalpos[x] = i+1;
        curpos[i] = i+1;
    }
    vector<pair<int,int>> res;

    for(int i = 0; i < n; i++){
        bool bad = false;
        for(int j = n-1; j>0 ;j--){
            if(finalpos[curpos[j]]<finalpos[curpos[j-1]] || !seen[curpos[j-1]][curpos[j]]){
                res.push_back({curpos[j],curpos[j-1]});
                seen[curpos[j]][curpos[j-1]] = true;
                swap(curpos[j],curpos[j-1]);
            }else if(j==n-1){
                bad = true;
                break;
            }
        }
        if(bad)break;
    }

    cout << res.size() << endl;
    for(auto i: res){
        cout << i.first << " " << i.second << endl;
    }
}