#include<bits/stdc++.h>
using namespace std;

#define int long long

const int sz = 2e5 + 5;

char s[5][sz];
int color[5][sz], d[5][sz], cnt[2], used[5][sz];
vector<pair<int, int>>q;
vector<pair<int, int>>g[5][sz];

void create(int x, int y){
    // cout << x << ' ' << y << endl;
    cnt[color[x][y]]++;
    if(color[x-1][y] == -1 and s[x-1][y] == '.'){
        color[x-1][y] = 1 - color[x][y];
        create(x-1, y);        
    }if(color[x+1][y] == -1 and s[x+1][y] == '.'){
        color[x+1][y] = 1 - color[x][y];
        create(x+1, y);        
    }if(color[x][y+1] == -1 and s[x][y+1] == '.'){
        color[x][y+1] = 1 - color[x][y];
        create(x, y+1);        
    }if(color[x][y-1] == -1 and s[x][y-1] == '.'){
        color[x][y-1] = 1 - color[x][y];
        create(x, y-1);        
    }
    if(d[x][y] == 1){
        q.push_back({x, y});
    }
}

void solve(){
    int n; cin >> n;
    q.clear();
    for(int i = 1; i <= 2; i++){
        for(int j = 1; j <= n; j++){
            color[i][j] = -1, d[i][j] = 0, used[i][j] = 0;
            g[i][j].clear();
        }
    }
    for(int i = 0; i <= 3; i ++){
        for(int j = 0; j <= n + 1; j++){
            if(i == 0 or i == 3 or j == 0 or j == n + 1){ s[i][j] = '#'; continue;}
            cin >> s[i][j];
        }
    }
    for(int i= 1; i <= 2; i++){
        for(int j = 1; j <= n; j++){
            if(s[i][j] != '.') continue;
            for(int x = i -1 ; x <= i + 1; x++){
                for(int y = j - 1; y <= j + 1; y++){
                    if(s[x][y] != '.') continue;
                    if((x == i or y == j) and (x != i or y != j)){
                        d[i][j]++;
                        g[i][j].push_back({x, y});
                    }
                }
            }
        }
    }
    bool ok = true;
    for(int i = 1; i <= 2; i++){
        for(int j = 1; j <= n; j++){
            if(color[i][j] == -1 and s[i][j] =='.'){
                q.clear();
                int say = 0;
                cnt[0] = cnt[1] = 0;
                color[i][j] = 0; create(i, j);
                if(cnt[0] != cnt[1]){ cout << "None\n"; return;}
                while(!q.empty()){
                    auto c = q.back();
                    q.pop_back();
                    if(used[c.first][c.second]) continue;
                    used[c.first][c.second] = true;
                    say+=2;
                    for(auto [x, y]: g[c.first][c.second]){
                        if(!used[x][y]){
                            c = {x, y};
                            break;
                        }
                    }
                    used[c.first][c.second] = true;
                    int timer = 0;
                    for(auto [x, y]: g[c.first][c.second]){
                        if(!used[x][y]){
                            d[x][y]--;
                            if(d[x][y] == 1) q.push_back({x, y});
                        }
                    }
                }
                // cout << say << ' ' << cnt[1] + cnt[0] << endl;
                ok &= (say == cnt[1] + cnt[0]);
            }
        }
    }
    cout << (ok ? "Unique" : "Multiple") << '\n';
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t; cin >> t; while(t--) solve();
}