#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

int ind[1001];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >>n;
    vector<int> c(n+1);
    vector<int> res(n+1);
    for(int i = 1 ; i <= n ; i++)
    {
        cin >> c[i];
        ind[i] = i;
        res[i] = i;
    }
    vector<pair<int , int>> ans;
    for(int i = 1 ; i < n ; i++)
    {
        int curind = c[i];
        int indx = ind[c[i]];
        for(int j = indx ; j > i ; j--)
        {
            ans.push_back({res[j] , res[j-1]});
            swap(ind[res[j]] , ind[res[j-1]]);
            swap(res[j] , res[j-1]);
        }
    }
    for(int i = 1 ; i < n ; i++)
    {
        vector<pair<int , int>> tmp;

        int j = i;
        while(j+1 <= n && c[j] < c[j+1])
        {
            ans.push_back({c[j+1] , c[j]});
            tmp.push_back({c[j] , c[j+1]});
            j++;
        }
        reverse(tmp.begin() , tmp.end());
        for(auto x:tmp)
        {
            ans.push_back(x);
        }
    }
    cout << ans.size()<< endl;
    for(auto el:ans)
    {
        cout << el.first << " " << el.second << endl;
    }
//    for(auto el:ans1)
//    {
//        cout << el.first << " " << el.second << endl;
//    }
    return 0;
}
