#include <iostream>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <numeric>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <fstream>
#include <memory>
#include <thread>
// cout<<fixed<<setprecision(10)<<res<<endl;

#define ll long long

using namespace std;

ll mx = 10000000000;

bool calc(string& s) {
	if (s[0] == '0' && isdigit(s[1])) return false;

	ll ans1 = 0, ans2 = 0;
	ll idx = 0;
	bool add = true;
	ll sub = 0;
		while (idx < s.length()) {
			if (s[idx] == '=') {
				if (idx == 0 || idx == s.size() - 1) return false;
				if (add) ans1 += sub;
				else ans1 -= sub;
				ans2 = ans1;
				ans1 = 0;
				sub = 0;
				add = true;

				if (idx + 1 < s.size() && s[idx + 1] == '0') {
					if (idx + 2 < s.size() && isdigit(s[idx + 2])) return false;
				}
			}
			else if (s[idx] == '+') {
				if (idx == 0 || idx == s.size() - 1) return false;
				if (add) ans1 += sub;
				else ans1 -= sub;
				sub = 0;

				if (idx + 1 < s.size() && s[idx + 1] == '0') {
					if (idx + 2 < s.size() && isdigit(s[idx + 2])) return false;
				}
				
			}
			else if(s[idx] == '-'){
				if (idx == 0 || idx == s.size() - 1) return false;
				if (add) ans1 += sub;
				else ans1 -= sub;
				add = false;
				sub = 0;

				if (idx + 1 < s.size() && s[idx + 1] == '0') {
					if (idx + 2 < s.size() && isdigit(s[idx + 2])) return false;
				}
			}
			else {
				sub = sub * 10 + (s[idx] - '0');
				if (sub >= mx) return false;
			}

			idx++;	
		}

		if (sub >= mx) return false;
		if (add)ans1 += sub;
		else ans1 -= sub;
	return ans1 == ans2;
}


int main()
{
	//cout << calc("11+11-2=112+32-12");
	string s; cin >> s;

	//return 0;
	if (calc(s)) {
		cout << "Correct" << endl;
		return 0;
	}
	ll n = s.size();
	for (int i = 0; i < s.size(); i++) {
		if (i == 0 && !isdigit(s[i + 1])) continue;
		else if (i == n - 1 && !isdigit(s[i - 1])) continue;
		else if (i != 0 && i != n-1 && !isdigit(s[i - 1]) && !isdigit(s[i + 1])) continue;
		if (!isdigit(s[i])) continue; 
		char c = s[i];

		for (int j = 0; j < s.size(); j++) {
			if (i > j) {
				s.insert(s.begin() + j, c);

				s.erase(s.begin() + 1 + i);
				if (calc(s)) {
					cout << s << endl;
					return 0;
				}

				s.insert(s.begin() + 1 + i, c);

				s.erase(s.begin() + j);
			}
			else if (i < j) {

				s.insert(s.begin() + j, c);

				s.erase(s.begin() + i);
				if (calc(s)) {
					cout << s << endl;
					return 0;
				}

				s.insert(s.begin() + i, c);

				s.erase(s.begin() + j);

			}
			
		}
	}
	cout << "Impossible" << endl;

	return 0;
}
