#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <queue>
#include <cstdint>
using namespace std;

bool check2(string s) {
   //  cout << "!" << s << endl;
    if (s.empty()) return false;
    if (s[0] == '+' || s[0] == '-') s = s.substr(1);
    if (s == "0") return true;
    if (s[0] == '0') return false;
    if (s.empty()) return false;
    if (s.size() > 10) return false;

    return all_of(s.begin(), s.end(), [](char ch) {
                  return ch >= '0' && ch <= '9'; });
}

bool check(string s) {
    auto epos = s.find("=");

    if (epos == s.npos)
        return false;
    else {
        string left = s.substr(0, epos);
        string right = s.substr(epos + 1);
        if (left.empty() || right.empty()) return false;

        bool pos = true;

        string buf = "";
        int64_t ans = 0;
        for (int i = 0; i < left.size(); i++) {
            if (left[i] >= '0' && left[i] <= '9')
                buf += (left[i]);
            else {
                if (!check2(buf)) return false;
                ans += atoi(buf.c_str());
                buf.clear();
                buf += (left[i]);
            }
        }

        if (!check2(buf)) return false;
        ans += atoi(buf.c_str());

        buf = "";
        for (int i = 0; i < right.size(); i++) {
            if (right[i] >= '0' && right[i] <= '9')
                buf += (right[i]);
            else {
                if (!check2(buf)) return false;
                ans -= atoi(buf.c_str());
                buf.clear();
                buf += (right[i]);
            }
        }
                if (!check2(buf)) return false;
        ans -= atoi(buf.c_str());

        if (ans==0) return true;
    }
    return false;
}

/*
int dp[3][N]={0};

void solve() {
    int n;cin>>n;
    string s1, s2;
    cin >> s1 >> s2;
  dp[0][0]=dp[1][0]=dp[2][0]=1;

    if (s1[0] == '#'){
        dp[1][1] = 1;
    }

    if(s2[0]=='#') dp[2][1] = 1;
    if(s1[0] == '#' && s1[0] == '#') dp[0][1] = 1;


    for (int i = 2; i <= n; i++) {
        dp[0][i]=dp[1][i]=dp[2][i]=0;
        if (s1[i-1] == '.' && s2[i-1]=='.') {
            dp[0][i] = dp[0][i-1];
            dp[0][i]+=dp[1][i-1]*dp[2][i-1];
        }
        if(s1[i-1]=='.' && s1[i-2]=='.'){
            dp[1][i] = dp[1][i - 2];
            if(dp[0][i-2] && (s2[i-1]==s2[i-2]))
               dp[1][i] += dp[0][i - 2];
        }
        if(s2[i-1]=='.' && s2[i-2]=='.'){
            dp[2][i] = dp[2][i - 2];
            if(dp[0][i-2] && (s1[i-1]==s1[i-2]))
               dp[2][i] += dp[0][i - 2];
        }
        if(s1[i-1]=='#'){
            dp[1][i]=dp[0][i-1]+dp[1][i-1];

        }
        if(s2[i-1]=='#'){
            dp[2][i]=dp[0][i-1]+dp[2][i-1];

        }
        if(s2[i-1]=='#' && s1[i-1]=='#'){
            dp[0][i]=dp[0][i-1] + dp[1][i-1]*dp[2][i-1] ;

        }

    }
    for(int i=0;i<3;i++){
        for(int j=1;j<=n;j++)
        cout<<dp[i][j]<<' ';
       cout<<endl;
    }
 long long    ans = dp[0][n] + dp[1][n]* dp[2][n];
    if(ans==0) cout<<"None"<<endl;
    else if(ans==1) cout<<"Unique"<<endl;
    else cout<<"Multiple"<<endl;

}

*/
/*
int ch[1002][1002]={0},ind[1002],ind2[1002];
static pair<int, int> arr[1003], arr2[1003];
vector<pair<int,int>> ans;
void solve()
{
    int n,x,cnt=0,sum=0;
    cin>>n;
    for(int i = 1;i <= n;i++){
        arr[i].first = i;
        cin >> arr[i].second;
    }



    for(int i = 1;i <= n;i++){
            arr2[i] = arr[i];
    }

    for (int i = 1; i < n; i++) {
        for (int j = 1; j <= n -i ; j++)
        {
            if (arr[j].second > arr[j+1].second) {
                ans.push_back({arr[j].second, arr[j+1].second});
                swap(arr[j], arr[j+1]);
                ch[arr[j].second][arr[j+1].second] = 1;
            }
        }
    }

   // for(int i = 1;i <= n;i++){
    //        cout << arr[i].second <<  " ";
    //}
    //cout<<endl;

    reverse(ans.begin(), ans.end());

    for (int i = 1; i < n; i++) {
        if (ch[arr2[i].second][arr2[i + 1].second] == 0 &&
            ch[arr2[i + 1].second][arr2[i].second] == 0){
                ans.push_back({arr2[i + 1].second, arr2[i].second});
                ans.push_back({arr2[i].second, arr2[i + 1].second});
                ch[arr2[i].second][arr2[i + 1].second] = 1;
                ch[arr2[i + 1].second][arr2[i].second] = 1;

            }
    }


    for (int i = 1; i < n; i++) {
        if (ch[arr[i].second][arr[i + 1].second] == 0 &&
            ch[arr[i + 1].second][arr[i].second] == 0){
                ans.insert(ans.begin(), {arr[i + 1].second, arr[i].second});
                ans.insert(ans.begin(), {arr[i].second, arr[i + 1].second});

            }
    }


    cout<<ans.size()<<endl;
    for(auto p:ans) cout<<p.first<<' '<<p.second<<endl;

}*/

void solve() {
    string s;
    cin>>s;

    int n = s.size();
    if (check(s)) {
        cout<<"Correct\n";
        return;
    }
    bool can=false;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++) {
            string ns = s;
            char c = ns[j];
            ns.erase(ns.begin() + j);
            ns.insert(ns.begin() + i, c);

            if (check(ns)) {
                    can = true;
                cout << ns << endl;
                return;
            }
        }
    }
    if (!can) cout<<"Impossible\n";
}

int main()
{
    int t = 1;
    // cin >> t;
    while (t--) {
            solve();

    }

    return 0;
}
