#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
using namespace std;

vector<int> pl[200005],v[200005];
vector<array<int, 2>> pairs;
vector<array<int, 2>> res;
int d[200005];
int dp[200005][2];
int from[200005];
int pid[200005], n, a, b;
int sum, did, pa;

void dfs(int ver, int par){
    sum =0;
    for(int to:v[ver]){
        if(to != par){
            dfs(to, ver);
            sum += max(dp[to][0], dp[to][1]);
        }
    }
    dp[ver][0] = sum;
    for(int to:v[ver]){
        if(to == par)
            continue;
        sum -= max(dp[to][0], dp[to][1]);

        if(sum + dp[to][0] + 1 > dp[ver][1]){
            dp[ver][1] = sum + dp[to][0] + 1;
            from[ver] = to;
        }

        sum += max(dp[to][0], dp[to][1]);
    }
    //cout<<ver<<" "<<dp[ver][0]<<" "<<dp[ver][1]<<endl;
}

void find_pairs(int ver, int par, int can){
    did=0;
  //  cout<<ver<<" "<<par<<" "<<can<<endl;
    if(can && dp[ver][1] > dp[ver][0]){
        pairs.push_back({ver, from[ver]});
        pid[ver] = from[ver];
        pid[from[ver]] = ver;
        find_pairs(from[ver], ver, 0);
        did = 1;
    }
    for(int to:v[ver]){
        if(to == par)
            continue;
        if(to != from[ver] || !did)
        find_pairs(to, ver, 1);
    }
}


int find_other(int i){
    if(pl[d[i]][0] == i)
        return pl[d[i]][1];
    else
        return pl[d[i]][0];
}

void swp(int a, int b){
    for(int i=0;i<2;i++){
        for(int j=0;j<2;j++){
            if(pl[d[a]][i] == a && pl[d[b]][j] == b){
                swap(pl[d[a]][i], pl[d[b]][j]);
                i=2;j=2;
            }
        }
    }
    res.push_back({b, a});
    swap(d[b], d[a]);

}

void solve(){
    scanf("%d", &n);
    for(int i=1;i<=n*2;i++){
        scanf("%d", &d[i]);
        pl[d[i]].push_back(i);
    }
    for(int i=1;i<n*2;i++){
        scanf("%d%d", &a, &b);
        v[a].push_back(b);
        v[b].push_back(a);
    }
    dfs(1, 0);
    find_pairs(1, 0, 1);
    for(auto[a, b]: pairs){
        while(1){
         //   cout<<"-------"<<endl;
         //   cout<<a<<" "<<b<<endl;
         //   cout<<d[a]<<" "<<d[b]<<endl;
            if(d[a] == d[b])
                break;
            pa = find_other(a);
         //   cout<<pa<<endl;
            swp(b, pa);
            if(pid[pa] == 0)
                break;
            a = pa;
            b = pid[pa];
        }
    }

    printf("%d\n", (int)res.size());
    for(auto[a, b]: res){
        printf("%d %d\n", a, b);
    }
    pairs.clear();
    res.clear();
    for(int i=1;i<=n*2;i++){
        from[i]=0;
        pid[i]=0;
        dp[i][0]=dp[i][1]=0;
        v[i].clear();
        pl[i].clear();
    }
}
int main() {

    int t;
    scanf("%d", &t);

    while(t--){
        solve();
    }


    return 0;
}
