#include <bits/stdc++.h>
using namespace std;
#define m_p make_pair
#define fi first
#define se second
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(),(x).end()
typedef long long ll;
const int N = 100005;

int n;
pair<string, string> ty[N];
vector<int> g[N];
int q[N];
bool c[N];

bool hav(const pair<string, string>& a, const pair<string, string>& b)
{
    return (a.fi == b.fi && a.se == b.se);
}

void solvv(const pair<string, string>& tyy, vector<int>& ans)
{
    queue<int> qu;
    for (int x = 1; x <= n; ++x)
    {
        if (ty[x] == tyy && q[x] == 0 && c[x] == false)
            qu.push(x);
    }
    while (!qu.empty())
    {
        int x = qu.front();
        qu.pop();
        c[x] = true;
        ans.push_back(x);
        for (int i = 0; i < g[x].size(); ++i)
        {
            int h = g[x][i];
            --q[h];
            if (hav(ty[h], tyy) && q[h] == 0 && c[h] == false)
            {
                qu.push(h);
            }
        }
    }
}

void finish(const vector<int>& ans)
{
    if (sz(ans) != n)
    {
        cout << "-1\n";
        return;
    }
    for (int i = 0; i < n; ++i)
        cout << ans[i] << ' ';
    cout << "\n";
}

void solv()
{
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> ty[i].fi >> ty[i].se;

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        ++q[y];
    }

    vector<int> ans;
    solvv(m_p("unset", "false"), ans);

    bool z = false;
    for (int x = 1; x <= n; ++x)
    {
        if (hav(ty[x], m_p("set", "true")) && q[x] == 0)
        {
            ans.push_back(x);
            for (int i = 0; i < g[x].size(); ++i)
            {
                int h = g[x][i];
                --q[h];
            }
            z = true;
            break;
        }
    }

    if (!z)
    {
        finish(ans);
        return;
    }
    solvv(m_p("set", "false"), ans);

    z = false;
    for (int x = 1; x <= n; ++x)
    {
        if (hav(ty[x], m_p("unset", "true")) && q[x] == 0)
        {
            ans.push_back(x);
            for (int i = 0; i < g[x].size(); ++i)
            {
                int h = g[x][i];
                --q[h];
            }
            z = true;
            break;
        }
    }
    if (!z)
    {
        finish(ans);
        return;
    }
    solvv(m_p("unset", "false"), ans);

    finish(ans);
}

int main()
{
    #ifdef KNIGHT
    freopen("input.txt", "r", stdin);
    #endif // KNIGHT
    ios::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--)
    {
        solv();
    }
    return 0;
}
