#include <iostream>
#include <cmath>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <algorithm>
#include <string>
#include <cstring>
#include <bitset>
#include <list>
#include <iterator>
#include <functional>
#include <unordered_map>
#include <sstream>
#include <numeric>
#include <cassert>
#include <iomanip>
#include <array>


#define endl '\n'

#define ll long long

#define rep(k , n) for(int k = 0; k < n ; k ++)
#define repp(k , n) for(int k = 1 ; k <= n ; k ++)
#define per(k , n) for(int k = n - 1 ; k >= 0 ; k --)
#define inn(k , n , a) for(int k = 0 ; k < n ; k ++) cin >> a[k];

using namespace std;

bool bounds(int x, int y, int n, int m)
{
    return (x >= 0 && y >= 0 && x < n && y < m);
}

int n;

void mz(vector<vector<int>>& v, int i, int j)
{
    if (bounds(i - 1, j, 2, n))
        v[i - 1][j]--;
    if (bounds(i + 1, j, 2, n))
        v[i + 1][j]--;
    if (bounds(i, j - 1, 2, n))
        v[i][j - 1]--;
    if (bounds(i, j + 1, 2, n))
        v[i][j + 1]--;
}

void solve(){

    cin >> n;

    vector<vector<int>> v(2, vector<int>(n));
    vector<vector<char>> g(2, vector<char>(n));
    

    int wertilebi = 0;
    for (int i = 0; i < 2; i++)
    {
        char c;
        for (int j = 0; j < n; j++)
        {
            cin >> c;
            g[i][j] = c;
            if (c == '.')
            {
                if (bounds(i - 1, j, 2, n))
                    v[i - 1][j]++;
                if (bounds(i + 1, j, 2, n))
                    v[i + 1][j]++;
                if (bounds(i, j - 1, 2, n))
                    v[i][j - 1]++;
                if (bounds(i, j + 1, 2, n))
                    v[i][j + 1]++;
                
                wertilebi++;
            }
        }
    }

    bool b = true;
    while(b)
    {
        b = false;

        if (!wertilebi)
        {
            cout << "Unique\n";
            return;
        }

        for (int i = 0; i < 2; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (g[i][j] == '#')
                    continue;
                
                if (v[i][j] == 0)
                {
                    cout << "None\n";
                    return;
                }

                if (v[i][j] == 1)
                {
                    b = true;

                    int x, y;
                    if (bounds(i - 1, j, 2, n) && g[i - 1][j] == '.')
                    {
                        x = i - 1;
                        y = j;
                    }
                    else if (bounds(i + 1, j, 2, n) && g[i + 1][j] == '.')
                    {
                        x = i + 1;
                        y = j;
                    }
                    else if (bounds(i, j - 1, 2, n) && g[i][j - 1] == '.')
                    {
                        x = i;
                        y = j - 1;
                    }
                    else if (bounds(i, j + 1, 2, n) && g[i][j + 1] == '.')
                    {
                        x = i;
                        y = j + 1;
                    }

                    g[i][j] = '#';
                    g[x][y] = '#';

                    wertilebi -= 2;

                    mz(v, i, j);
                    mz(v, x, y);
                }
            }
        }
    }

    cout << "Multiple\n";
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int t = 1;
    cin >> t;
    while(t--){
        solve();
        //cout << endl;
    }
    

    
   


}