import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int[] standing = new int[n];
        HashMap<Integer, Integer> map = new HashMap<>();

        for (int i = 0; i < n; i++) {
            int cur = sc.nextInt();
            standing[i] = cur;
            map.put(cur, i);
        }

        int[] cur = new int[n];
        for (int i = 1; i < n + 1; i++) {
            cur[i - 1] = i;
        }

        ArrayList<Integer> print = new ArrayList<>();
        long swap = 0;
        for (int i = 0; i < n; i++) {
            int j = standing[i] - 1;
            while (standing[i] != cur[j]){
                j++;
            }
            while (j > map.get(standing[i])){
                int temp = cur[j];
                print.add(standing[i]);
                print.add(cur[j - 1]);
                swap++;

                cur[j] = cur[j - 1];
                cur[j - 1] = temp;


                j--;
            }
        }

        int[] tars = new int[n];
        HashMap<Integer, Integer> map2 = new HashMap<>();
        for (int i = 0; i < n ; i++) {
            tars[i] = n - i;
            map2.put(tars[i], i);
        }

        for (int i = 0; i < n; i++) {
            int j = n - tars[i];
            while (tars[i] != cur[j]){
                j++;
            }
            while (j > map2.get(tars[i])){
                int temp = cur[j];
                print.add(tars[i]);
                print.add(cur[j - 1]);
                swap++;

                cur[j] = cur[j - 1];
                cur[j - 1] = temp;


                j--;
            }
        }

        for (int i = 0; i < n; i++) {
            int j = n - standing[i] ;
            while (standing[i] != cur[j]) {
                j++;
            }
            while (j > map.get(standing[i])) {
                int temp = cur[j];
                print.add(standing[i]);
                print.add(cur[j - 1]);
                swap++;

                cur[j] = cur[j - 1];
                cur[j - 1] = temp;


                j--;
            }
        }

        System.out.println(swap);
        for (int i = 0; i < print.size(); i+=2) {
            System.out.println(print.get(i) + " " + print.get(i+1));
        }
    }
}