#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 201;

void solve() {

    auto sum = [&](string exp) -> int {
        exp += '+';
        string s = "";
        int res = 0;
        int sign = 1;
        // cout << exp << endl;
        for (int i = 0; i < (int)exp.size(); ++i) {
            if (exp[i] == '-' || exp[i] == '+') {
                res += stoll(s) * (sign == 1 ? 1 : -1);
                sign = exp[i] == '+';
                s.clear();
            } else {
                s += exp[i];
            }
        }
        return res;
    };

    auto is_valid_expression = [&](string exp) -> bool {
        exp += '+';
        string num = "";
        for (int i = 0; i < (int)exp.size(); ++i) {
            if (exp[i] == '+' || exp[i] == '-') {
                if (num.size() == 0 || num.size() > 10) {
                    return false;
                }

                if (num != "0" && num[0] == '0') {
                    return false;
                }

                num.clear();
            } else {
                num += exp[i];
            }
        }
        return true;
    };

    auto is_valid_equality = [&](string exp) -> bool {        
        string lft, rht;
        bool seen = false;
        for (int i = 0; i < (int)exp.size(); ++i) {
            if (exp[i] == '=') {
                if (i == 0 || i == (int)exp.size() - 1 || exp[i - 1] == '-' || exp[i - 1] == '+' || exp[i + 1] == '-' || exp[i + 1] == '+') {
                    return false;
                }
                seen = true;
            } else {
                (seen == false ? lft : rht) += exp[i];
            }
        }

        // cout << exp << endl << lft << ' ' << rht << endl << is_valid_expression(lft) << ' ' << is_valid_expression(rht) << endl;

        return is_valid_expression(lft) && is_valid_expression(rht);

    };

    
    auto check = [&](string exp) -> bool {
        if (is_valid_equality(exp) == false) {
            return false;
        }
        string lft, rht;
        bool seen = false;
        for (int i = 0; i < (int)exp.size(); ++i) {
            if (exp[i] == '=') {
                seen = true;
            } else {
                (seen == false ? lft : rht) += exp[i];
            }
        }

        // cout << lft << ' ' << rht << endl << sum(lft) << endl << sum(rht) << endl;

        
        return sum(lft) == sum(rht);
    };


    string s; cin >> s;
    string os = s;

    if (check(s)) {
        cout << "Correct\n";
        return;
    }
    
    for (int i = 0; i < (int)s.size(); ++i) {
        if (s[i] < '0' || s[i] > '9') {
            continue;
        }
        int j = i;
        while (j > 0) {
            swap(s[j], s[j - 1]);
            --j;
            if (check(s)) {
                cout << s << endl;
                return;
            }
        }

        while (j + 1 < (int)s.size()) {
            swap(s[j], s[j + 1]);
            ++j;
            if (check(s)) {
                cout << s << endl;
                return;
            }
        }

        while (j > i) {
            swap(s[j], s[j - 1]);
            --j;
        }
        assert(s == os);
    }

    cout << "Impossible\n";
}

main() {
    int t = 1; // cin >> t;
    for (int _ = 0; _ < t; ++_) {
        solve();
    }
}