import java.io.*;
import java.util.Arrays;
import java.util.stream.IntStream;

public class A {

    private static final BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    private static int count = 0;

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(reader.readLine());

        int[] input = Arrays.stream(reader.readLine().split(" ")).mapToInt(Integer::parseInt).toArray();

        int[] arr = IntStream.range(1, n + 1).toArray();
        for (int i = 0; i < arr.length; i++) {
            for (int j = i + 1; j < arr.length; j++) {
                int temp = arr[i];
                arr[i] = arr[j];
                arr[j] = temp;

                count++;

                writer.write((j + 1) + " " + (i + 1));
                writer.newLine();
            }
        }
        bubbleSort(arr, input);
        System.out.println(count);
        writer.flush();
    }

    public static void bubbleSort(int[] arr, int[] input) {
        if (Arrays.equals(arr, input)) {
            return;
        }
        try {
            for (int i = 0; i < arr.length; i++) {
                for (int j = i + 1; j < arr.length; j++) {
                    int temp = arr[i];
                    arr[i] = arr[j];
                    arr[j] = temp;

                    count++;

                    writer.write(arr[i] + " " + arr[j]);
                    if (Arrays.equals(arr, input)) {
                        return;
                    }
                    writer.newLine();
                }
            }
        } catch (IOException ex) {
        }

    }

}