#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <functional>

using namespace std;

void solve(int test_ind){
	int n, m, q;
	cin >> n >> m >> q;
	vector<pair<long long, long long> > td(n);
	for (int i=0;i<n;++i) cin >> td[i].second;
	for (int i=0;i<n;++i) cin >> td[i].first;
	sort(td.begin(), td.end());
	long long dsm = 0;
	vector<long long> v;
	for (int i=0;i<n;++i) {
		dsm += td[i].second;
		v.push_back(td[i].first - dsm);
	}
	for (int i=n-2;i>=0;--i) {
		v[i] = min(v[i], v[i+1]);
	}
	vector<long long> l(m);
	for (auto &i: l) cin >> i;
	for (int i=1;i<m;++i) {
		l[i] += l[i-1];
	}
	for (int i=0;i<q;++i) {
		long long t;
		cin >> t;
		int ind = lower_bound(td.begin(), td.end(), make_pair(t, 0ll)) - td.begin();
		long long sm;
		if (ind == n) {
			sm = t - td.back().first + v.back();
		} else {
			sm = min(t, v[ind]);
			if (ind) {
				sm = min(sm, v[ind-1] + t - td[ind-1].first);
			}
		}
		int c = upper_bound(l.begin(), l.end(), sm) - l.begin();
		cout << max(c, 0) << endl;
	}
}

int main(){
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int t=1;
	cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
