/**
 *    author:  tourist
 *    created: 05.12.2024 13:55:09
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt;
  cin >> tt;
  while (tt--) {
    int W, H;
    cin >> W >> H;
    struct Rect {
      int w, h;
      int x, y;
      int dx, dy;
      bool operator ==(const Rect& rhs) const {
        return x == rhs.x && y == rhs.y && dx == rhs.dx && dy == rhs.dy;
      }
    };
    array<Rect, 2> rects;
    for (auto& r : rects) {
      cin >> r.w >> r.h >> r.x >> r.y >> r.dx >> r.dy;
    }
    auto memo = rects;
    int64_t num = 0;
    int64_t den = 0;
    do {
      den += 1;
      int inter = 1;
      if (rects[0].x + rects[0].w <= rects[1].x || rects[1].x + rects[1].w <= rects[0].x) {
        inter = 0;
      }
      if (rects[0].y + rects[0].h <= rects[1].y || rects[1].y + rects[1].h <= rects[0].y) {
        inter = 0;
      }
      num += inter;
      for (int i = 0; i < 2; i++) {
        rects[i].x += rects[i].dx;
        rects[i].y += rects[i].dy;
        if (rects[i].x == 0 || rects[i].x == W - rects[i].w) {
          rects[i].dx *= -1;
        }
        if (rects[i].y == 0 || rects[i].y == H - rects[i].h) {
          rects[i].dy *= -1;
        }
      }
    } while (memo != rects);
    auto red = gcd(num, den);
    cout << num / red << "/" << den / red << '\n';
  }
  return 0;
}
