#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 10;

vector<int> g[N];
int  used[N];
int m, n;
vector<int> ans;
bool has_cycle = false;
void dfs(int v) {
    // cout << "dfs" << v << '\n';
    // cout << v << '|';
    used[v] = 1;
    for (int to: g[v]) {
        if (used[to] == 1) {
            has_cycle = true;
            return;
        }
        if (used[to] == 0) {
            dfs(to);
        }
    }
    used[v] = 2;
    ans.push_back(v);
}

void top_sort() {
    for (int i = 0; i < m; i++) {
        used[i] = 0;
    }
    ans.clear();
    has_cycle = false;
    for (int i = 0; i < m; i++) {
        if (used[i] == 0) {
            dfs(i);
            // cout << '\n';
        }    
    }
    reverse(ans.begin(), ans.end());
}

int main() {
    // int m;
    cin >> m;
    vector<pair<char, int>> op(m);
    for (int i = 0; i < m; i++) {
        string s;
        string res;
        cin >> s >> res;
        op[i] = {s[0], (res == "true" ? true : false)};
    }
    // int m;
    cin >> n;
    vector<int> cnt(m, 0);
    // vector<pair<int, int>> g(m);
    for (int i = 0; i < n; i++) {
        // cin >> g[i].first >> g[i].second;
        int f, t;
        cin >> f >>  t;
        f--, t--;
        g[f].push_back(t);
        cnt[f]++;
        // g[t].push_back(f);
    }
    // cout << "sz " << g.size() << '\n';
    int true_count = 0;
    for (int i = 0; i < m; i++) {
        if (op[i].second) {
            true_count++;
        }
    }
    if (true_count == 0) {
        for (int i = 0; i < m; i++) {
            if (op[i].first == 's') {
                cout << "-1";
                return 0;
            }
        }
        top_sort();
        for (int x: ans) cout << x + 1 << ' ';
        return 0;
    }
    if (true_count == 1) {
        int main_op = -1;
        for (int i = 0; i < m; i++) {
            if (op[i].second) {
                if (op[i].first == 's') main_op = i;
            }
        }
        if (main_op == -1) {
            cout << "-1";
            return 0;
        }
        for (int i = 0; i < m; i++) {
            if (i == main_op) continue;
            if (op[i].first == 's') {
                g[main_op].push_back(i);
            } else {
                g[i].push_back(main_op);
            }
        }
        top_sort();
        if (has_cycle) {
            cout << "-1";
            return 0;
        }
        for (int x: ans) cout << x + 1 << ' ';
        return 0;
    }
    int S = -1, U = -1;
    for (int i = 0; i < m; i++) {
        if (op[i].first == 's' && op[i].second == true) {
            S = i;
        }
        if (op[i].first == 'u' && op[i].second == true) {
            U = i;
        }
    }
    if (S == -1 || U == -1) {
        cout << "-1";
        return 0;
    }
    // cout << S << ' ' << U << '\n';
    g[S].push_back(U);
    for (int i = 0; i < m; i++) {
        if (i == S) continue;
        if (i == U) continue;
         if (op[i].first == 's') {
            g[S].push_back(i);
            g[i].push_back(U);
        }
        if (op[i].first == 'u' && cnt[i] == 0) {
            g[U].push_back(i);
        }
    }
    // for (int i = 0; i < m; i++) {
    //     for (int to: g[i]) {
    //         cout << i << ' ' << to << '\n';
    //     }
    // }
    top_sort();
    if (has_cycle) {
        cout << "-1";
        return 0;
    }
    for (int x: ans) cout << x + 1 << ' ';
}