

def isdigit(char):
    return char >= '0' and char <= '9'

def check(exp):
    carry = ""
    for i in range(len(exp)):
        if isdigit(exp[i]):
            carry += exp[i]
        else:
            if carry and len(carry) > 10:
                return False
            carry = ""
    if carry and len(carry) > 10:
        return False
    try:
        left = exp.split('=')[0]
        right = exp.split('=')[1]
        return eval(left) == eval(right)
    except Exception as e:
        return False

def main():
    exp = str(input())
    if check(exp) == True:
        print('Correct')
        return
    for i in range(len(exp)):
        for j in range(len(exp)):
            if i == j:
                continue
            if isdigit(exp[i]) and isdigit(exp[j]):
                if (i - 1 >= 0 and isdigit(exp[i - 1])) or (i + 1 < len(exp) and isdigit(exp[i + 1])):
                    if (j - 1 >= 0 and isdigit(exp[j - 1])) or (j + 1 < len(exp) and isdigit(exp[j + 1])):
                        if i < j:
                            new_exp = exp[0:i+1] + exp[j] + exp[i+1:j] + exp[j+1:len(exp)]
                        else:
                            new_exp = exp[0:j] + exp[j + 1:i + 1] + exp[j] + exp[i + 1:len(exp)]
                        # print(new_exp, check(new_exp))
                        if check(new_exp) == True:
                            print(new_exp)
                            return
    print('Impossible')


main()