

def isdigit(char):
    return '0' <= char <= '9'

def check(exp):
    carry = ""
    for i in range(len(exp)):
        if isdigit(exp[i]):
            carry += exp[i]
        else:
            # print(carry)
            if carry and (len(carry) > 10 or (len(carry) > 1 and carry[0] == '0')):
                return False
            carry = ""
    if carry and (len(carry) > 10 or (len(carry) > 1 and carry[0] == '0')):
        return False
    try:
        left, right = exp.split('=')
        # print(left, eval(left), right, eval(right))
        return eval(left) == eval(right)
    except Exception as e:
        return False

def main():
    exp = str(input())
    if check(exp) == True:
        print('Correct')
        return
    for i in range(len(exp)):
        for j in range(len(exp)):
            if i == j:
                continue
            if isdigit(exp[j]):
                if (j - 1 >= 0 and isdigit(exp[j - 1])) or (j + 1 < len(exp) and isdigit(exp[j + 1])):
                        if i < j:
                            new_exp = exp[0:i+1] + exp[j] + exp[i+1:j] + exp[j+1:len(exp)]
                        else:
                            new_exp = exp[0:j] + exp[j + 1:i + 1] + exp[j] + exp[i + 1:len(exp)]
                        # print(new_exp, check(new_exp))
                        if check(new_exp) == True:
                            print(new_exp)
                            return
    print('Impossible')

# print('012'[0] == '0')
main()