#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define F first
#define S second
#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) x.begin(), x.end()

const int N = 4500, mod = 1e9+7;

const double ff = sqrt(2)/2.0;

const double dx[] = {0,-ff,-1,-ff,0,ff,1,ff};
const double dy[] = {1,ff,0,-ff,-1,-ff,0,ff};
const double eps = 1e-10;

double dist(double x, double y, double a, double b) {
    return (x-a)*(x-a) + (y-b)*(y-b);
}

map<pair<double,double>,int> ord;
pair<double,double> pts[N];

bool G[N][N];

void solve() {
    int n;
    cin >> n;
    double X, Y;
    X=Y=0;
    int dir = 0;
    int sz = 0;
    vector<pair<int,int>> ptvec;

    for(int i = 1; i <= n; i ++) {
        string s;
        cin >> s;
        if(s == "rotate") {
            int d;
            cin >> d;
            dir += (d/45);
            dir %= 8;
        }
        if(s == "move") {
            double d;
            cin >> d;
            X += dx[dir]*d;
            Y += dy[dir]*d;
        }
        if(s == "draw") {
            double d;
            cin >> d;
            int p1, p2;
            if(ord.find({X,Y}) == ord.end()) {
                ord[{X, Y}] = ++sz;
                pts[sz] = {X, Y};
            }
            p1 = ord[{X,Y}];

            X += dx[dir]*d;
            Y += dy[dir]*d;
            if(ord.find({X,Y}) == ord.end()) {
                ord[{X,Y}] = ++sz;
                pts[sz] = {X, Y};
            }
            p2 = ord[{X,Y}];

            G[p1][p2] = G[p2][p1] = 1;
            ptvec.push_back({p1,p2});
        }
    }
    double sumX = 0;
    double sumY = 0;

    for(int i = 1; i <= sz; i ++) {
        sumX += pts[i].F;
        sumY += pts[i].S;
    }
    double cenX = sumX/sz;
    double cenY = sumY/sz;

    set<int> st;
    for(int i = 1; i <= sz; i ++) {
        int cnt = 0;
        vector<int> curpts;
        for(int j = 1; j <= sz; j ++) {
            double d1 = dist(pts[i].F, pts[i].S, cenX, cenY);
            double d2 = dist(pts[j].F, pts[j].S, cenX, cenY);
            if(abs(d1-d2) < eps) {
                curpts.push_back(j);
                cnt ++;
            }
        }
        int edgs = 0;
        for(auto x: curpts) {
            for(auto y: curpts) {
                if(G[x][y]) {
                    edgs ++;
                }
            }
        }
        edgs /= 2;
        if(cnt == 2) {
            st.insert(2);
            continue;
        }
        st.insert(__gcd(cnt, edgs));
    }
    if(st.size() > 1) {
        cout << 360;
    }
    else if(*st.begin() == 2) {
        cout << 180;
    }
    else if(*st.begin() == 4) {
        cout << 90;
    }
    else if(*st.begin() == 8) {
        cout << 45;
    }
    else {
        cout << 360;
    }
}






int main() {
    ios
    int tt = 1;
    // cin >> tt;
    while(tt --) {
        solve();
    }
}