#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define F first
#define S second
#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(x) x.begin(), x.end()

const int N = 4500, mod = 1e9+7;

const double ff = sqrt(2)/2.0;

const double dx[] = {0,-ff,-1,-ff,0,ff,1,ff};
const double dy[] = {1,ff,0,-ff,-1,-ff,0,ff};
const double eps = 1e-10;

map<pair<double,double>,int> ord;
pair<double,double> pts[N];

double dist(double x, double y, double a, double b) {
    return (x-a)*(x-a) + (y-b)*(y-b);
}



double dist(int p1, int p2) {
    return dist(pts[p1].F , pts[p1].S , pts[p2].F , pts[p2].S);
}

bool G[N][N];

void solve() {
    int n;
    cin >> n;
    double X, Y;
    X=Y=0;
    int dir = 0;
    int sz = 0;
    vector<pair<int,int>> ptvec;

    for(int i = 1; i <= n; i ++) {
        string s;
        cin >> s;
        if(s == "rotate") {
            int d;
            cin >> d;
            dir += (d/45);
            dir %= 8;
        }
        if(s == "move") {
            double d;
            cin >> d;
            X += dx[dir]*d;
            Y += dy[dir]*d;
        }
        if(s == "draw") {
            double d;
            cin >> d;
            int p1 = -1, p2 = -1;
            for(int j = 1; j <= sz; j ++) {
                if(dist(X,Y, pts[j].F, pts[j].S) < eps) {
                    p1 = j;
                    break;
                }
            }
            if(p1 == -1) {
                p1 = ++sz;
                pts[p1] = {X,Y};
            }

            X += dx[dir]*d;
            Y += dy[dir]*d;
            for(int j = 1; j <= sz; j ++) {
                if(dist(X,Y, pts[j].F, pts[j].S) < eps) {
                    p2 = j;
                    break;
                }
            }
            if(p2 == -1) {
                p2 = ++sz;
                pts[p2] = {X,Y};
            }

            G[p1][p2] = G[p2][p1] = 1;
            ptvec.push_back({p1,p2});
        }
    }
    if(ptvec.size() == 1) {
        cout << 180;
        return;
    }
//    cout << sz << endl;
    double maxX = 0, minX = 0;
    double maxY = 0, minY = 0;

    for(int i = 1; i <= sz; i ++) {
        maxX = max(maxX, pts[i].F);
        minX = min(minX, pts[i].F);

        maxY = max(maxY, pts[i].S);
        minY = min(minY, pts[i].S);
    }
    double cenX = (maxX + minX)/2;
    double cenY = (maxY+minY)/2;
//    cout << cenX << ' ' << cenY << endl;
//    for(int i = 1; i <= sz; i ++) {
//        cout << pts[i].F << ' ' << pts[i].S << ' ' << dist(pts[i].F , pts[i].S, cenX, cenY) << endl;
//    }
//    return;
    set<int> st;

    for(auto [p1, p2]: ptvec) {
        int cnt = 0;
        for(auto [p3, p4]: ptvec) {
            if(abs(dist(p1, p2)-dist(p3, p4)) < eps) {
                double d1 = dist(pts[p1].F, pts[p1].S, cenX, cenY);
                double d2 = dist(pts[p2].F, pts[p2].S, cenX, cenY);
                double d3 = dist(pts[p3].F, pts[p3].S, cenX, cenY);
                double d4 = dist(pts[p4].F, pts[p4].S, cenX, cenY);
                if(d1 > d2) swap(d1, d2);
                if(d3 > d4) swap(d3, d4);
                if(abs(d1-d3) < eps && abs(d2-d4) < eps) {
                    cnt ++;
                }
            }
        }
        st.insert(cnt);
    }

    if(st.size() > 1) {
        cout << 360;
    }
    else if(*st.begin() == 2) {
        cout << 180;
    }
    else if(*st.begin() == 4) {
        cout << 90;
    }
    else if(*st.begin() == 8) {
        cout << 45;
    }
    else {
        cout << 360;
    }
}

/*
15
draw 1
rotate 45
draw 1
rotate 45
draw 1
rotate 45
draw 1
rotate 45
draw 1
rotate 45
draw 1
rotate 45
draw 1
rotate 45
draw 1
 * */









int main() {
    ios
    int tt = 1;
    // cin >> tt;
    while(tt --) {
        solve();
    }
}