#include<bits/stdc++.h>

#define DEBUGSTR_WNAME(os, name, a) \
    do { (os) << (name) << " = " << (a) << std::endl; } while(false)

#define DEBUGSTR(os, a) DEBUGSTR_WNAME((os), #a, (a))
#define DEBUG(a) DEBUGSTR_WNAME(std::cout, #a, (a))

#define ll long long
#define ld long double

#define pii pair<int, int>
#define vi vector<int>
#define vl vector<ll>

#define all(x) x.begin(), x.end()
#define sz(x)  (int)x.size()
#define pb push_back
#define fi first
#define se second

using namespace std;

const int N = (int)2e5 + 2000;
const int M = (int)1e7 + 200;
const ll mod = (ll)1e9+7;
const ll inf = (ll)1e18 + 7;
const char nl = '\n';

bool used[N];
vector<int> g[N];
vector<int> ord;

void dfs(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    ord.pb(v);
}

void solve() {
    int n; cin >> n;

    vector<string> c(n);
    for (int i = 0; i < n; ++i) {
        string a, b; cin >> a >> b;
        string cur;
        cur += a[0];
        cur += b[0];
        c[i] = cur;
    }

    int m; cin >> m;
    vector<int> in(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        --u, --v;
        g[u].pb(v);
        in[v]++;
    }

    vector<vector<int>> comp;
    for (int i = 0; i < n; ++i) {
        if (!used[i] && in[i] == 0) {
            ord.clear();
            dfs(i);
            comp.pb(ord);
        }
    }

    vector<int> ans;
    bool ok = true;
    int state = 0;
    while(ok) {
        ok = false;
        for (auto &v : comp) {
            if (!state) {
                while (!v.empty() && c[v.back()] == "uf") {
                    ok = true;
                    ans.pb(v.back());
                    v.pop_back();
                }
            } else {
                while (!v.empty() && c[v.back()] == "sf") {
                    ok = true;
                    ans.pb(v.back());
                    v.pop_back();
                }
            }
        }
        for (auto &v : comp) {
            if (!state) {
                if (!v.empty() && c[v.back()] == "st") {
                    state = 1;
                    ok = true;
                    ans.pb(v.back());
                    v.pop_back();
                    break;
                }
            } else {
                if (!v.empty() && c[v.back()] == "ut") {
                    state = 0;
                    ok = true;
                    ans.pb(v.back());
                    v.pop_back();
                    break;
                }
            }
        }
    }/*
    for (auto v : comp) {
        for (int x : v) cout << x << " ";
        cout << "\n";
    }
    cout << "\n";
    for (int x : ans) cout << x << " ";
    cout << "\n";*/
    for (auto v : comp) {
        if (!v.empty()) {
            cout << "-1";
            return;
        }
    }
    for (int x : ans) cout << x + 1 << " ";
}

int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int test = 1;
    // cin >> test;
    while(test--) {
        solve();
        cout << nl;
    }
}
