#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define pf push_front
#define fi first
#define se second
#define all(a) a.begin(),a.end()

const int N = 5e5 + 9;
ll a[N] , b[N] , c[N], d[N] , dp[N];


string my_add1( string a, string b ){
        ll x , y , s = 0 , f = 0;
        x = a.size() - 1 , y = b.size() - 1;
        string c = "";
        while(x >= 0 || y >= 0){
            if(x >= 0)
                f += (a[x] - '0');
            if(y >= 0)
                f += (b[y] - '0');
            c += (f % 10 + '0');
            f /= 10;
            x-- , y--;
        }
        if(f)
        c += (f + '0');
        reverse(all(c));
        return c;
}

string my_subtract(string a , string b){
    if(a[0] == '-'){
        a.erase(0 , 1);
        return "-" + my_add1(a , b);
    }else{
        ll x , y , s = 0 , i ,  f = 0 , k = 0;
        if(a.size() < b.size() || (a.size() == b.size() && a < b)){
            k = 1;
            swap(a , b);
        }
        x = a.size() - 1 , y = b.size() - 1;
        string c = "";
        while(x >= 0 || y >= 0){
            char ch = '0';
            if(y >= 0)
                ch = b[y];
            if(a[x] < '0')
                a[x] = '9' , a[x - 1]--;
            if(a[x] >= ch){
                c += (a[x] - ch) + '0';
            }else {
                a[x - 1]--;
                c += (a[x] - '0' + 10 - (ch - '0')) + '0';
            }
            x-- , y--;
        }
        reverse(all(c));
        string d = c ;
        c = "";
        f = 0;
        for(i = 0; i < d.size(); i++){
            if(d[i] != '0')
                f = 1;
            if(f == 1)
                c += d[i];
        }
        if(c.size() == 0)
            c = "0";
        string sign = "";
        if(k == 1)
            sign = "-";
        return sign + c;
    }
}

string my_add( string a, string b ){
    if(a[0] == '-'){
        a.erase(0 , 1);
        return my_subtract(b , a);
    }else {
        ll x , y , s = 0 , f = 0;
        x = a.size() - 1 , y = b.size() - 1;
        string c = "";
        while(x >= 0 || y >= 0){
            if(x >= 0)
                f += (a[x] - '0');
            if(y >= 0)
                f += (b[y] - '0');
            c += (f % 10 + '0');
            f /= 10;
            x-- , y--;
        }
        if(f)
        c += (f + '0');
        reverse(all(c));
        return c;
    }
}


string solve(string a){
    string sum, cur ;
    char sign = ' ';
    for ( char i : a ){
        if ( i == '+' ){
            if ( sign == ' ' ){
                sum = cur ;
            }
            else if( sign == '+'){
                sum = my_add(sum, cur) ;
            }
            else{
                sum = my_subtract(sum, cur) ;
            }
            sign = '+' ;
            cur = "" ;
        }
        else if ( i == '-' ){
            if ( sign == ' ' ){
                sum = cur ;
            }
            else if( sign == '+'){
                sum = my_add(sum, cur) ;
            }
            else{
                sum = my_subtract(sum, cur) ;
            }
            sign = '-' ;
            cur = "" ;
        }
        else{
            cur += i ;
            if (cur.size() > 10){
                return "big" ;
            }
        }
    }
    // checking the last //
    if ( sign == ' ' ){
        sum = cur ;
    }
    else if ( sign == '+' ){
        sum = my_add(sum,cur) ;
    }
    else{
        sum = my_subtract(sum, cur) ;
    }

    return sum ;
}


pair<string, string> divide_parts( string a ){
    string fi, se ;
    bool found = false ;

    for ( char i : a ){
        if ( i == '=' ){
            found = true ;
        }
        else if( found ){
            se += i ;
        }
        else{
            fi += i ;
        }
    }

    string solved_fi = solve(fi) ;
    string solved_se = solve(se) ;

    return {solved_fi, solved_se} ;
}


int main(){
    // cout << my_subtract("6", "6") ;
    string a ; cin >> a ;

    string first_part , second_part;
    pair<string,string>p = divide_parts( a ) ;

    //cout << p.fi << " " << p.se << endl ;

    if ( p.fi == p.se ){
        cout << "Correct" ;
        return 0 ;
        //cout << first_part << "="<<second_part ;
    }

    int n = (int)a.size() ;

    for ( int i = 1 ; i < n ; i ++ ){
        if ( a[i] == '=' or a[i] == '+' or a[i] == '-' ){continue ;}
        if ( i && i < n-1 && a[i+1] == '0' ){
            if ( a[i-1] == '=' || a[i-1]=='+' || a[i-1]=='-' ){continue ;}
        }
        if ( !i && i<n-1 && a[i+1] == '0' ){
            continue ;
        }


        // checking the length of the digit //
        int num = 0 ;
        if ( i && a[i-1] >= '0' && a[i-1] <= '9' ){
            num ++ ;
        }
        if ( i < n-1 && a[i+1] >= '0' && a[i+1] <= '9' ){
            num ++ ;
        }
        if ( !num ){continue;}

        string new_a = a.substr(0,i) + a.substr(i+1, n-i-1 ) ;
        char chosen = a[i] ;

        for ( int j = 0 ; j < n-1 ; j ++ ){
            // if ( a[j] == '=' or a[j] == '+' or a[j] == '-' ){continue ;}

            // if the number itself is zero //
            if ( j && new_a[j] == '0' ){
                if ( new_a[j-1] == '=' || new_a[j-1] == '+' || new_a[j-1] == '-' ){
                    continue ;
                }
            }

            // if the previous number is the first zero //
            if ( j && new_a[j-1] == '0' ){
                if ( new_a[j-2] == '=' || new_a[j-2] == '-' || new_a[j-2] == '+' ){
                    continue ;
                }
                if ( j == 1 ){
                    continue ;
                }
            }

            // if the first number is zero //
            if ( !j && new_a[j] == '0' ){
                continue ;
            }


            // if our chosen is zero and we are trying to place it in the beginning //
            if ( chosen == '0' ){
                if ( !j ){
                    continue ;
                }
                if ( new_a[j-1] == '=' || new_a[j-1] == '+' || new_a[j-1] == '-' ){
                    continue ;
                }
            }

            string newest_a = new_a.substr(0, j) + chosen + new_a.substr(j, n-j-1) ;

            //cout << "# " << newest_a << '\n' ;

            // Checking if the new equation is correct //
            p = divide_parts(newest_a) ;
            // cout << p.fi << " " << p.se << endl ;

            if ( p.fi == p.se && p.fi != "big" && p.se != "big" ){
                cout << newest_a ;
                return 0 ;
                //cout << first_part << "="<<second_part ;
            }
        }
        // cout << "\n\n" ;
    }


    cout << "Impossible" ;
}




