#include<bits/stdc++.h>

using namespace std;
#define pb push_back
#define fi first
#define se second

string s[2];
    int n;
bool check(int i, int j) {
    int cnt = 0;
    if(i == 1 && s[i-1][j] == '.') ++cnt;
    if(i == 0 && s[i+1][j] == '.') ++cnt;
    if(j != 0 && s[i][j-1] == '.') ++cnt;
    if(j != n-1 && s[i][j+1] == '.') ++cnt;
    return cnt == 1;
}

void solve() {
    cin >> n;
    cin >> s[0] >> s[1];
    bool used[4][n];
    for(int i = 0; i < n; ++i) used[0][i] = used[1][i] = false;

    queue<pair<int,int> > q;
    int counter = 0;
    for(int i = 0; i < 2; ++i) {
        for(int j = 0; j < n; ++j) {
            if(s[i][j] == '.') {
                counter++;
                if(check(i,j)) q.push({i,j});
            }
        }
    }
    if(counter % 2 == 1) {
        cout << "None\n";
        return;
    }

    while(!q.empty()) {
        pair<int,int> p = q.front();
        q.pop();
        int i = p.first, j = p.second;
        if(s[i][j] != '.') continue;

        int x = -1, y = -1;
        if(i == 1 && s[i-1][j] == '.') x = i - 1, y = j;
        if(i == 0 && s[i+1][j] == '.') x = i + 1, y = j;
        if(j != 0 && s[i][j-1] == '.') x = i, y = j - 1;
        if(j != n-1 && s[i][j+1] == '.') x = i, y = j + 1;

        if(x == -1 || y == -1) {
            cout << "None\n";
            return;
        }
        s[i][j] = '#';
        s[x][y] = '#';
        counter -= 2;

        if(x == 1 && s[x-1][y] == '.') {
            int xx = x - 1, yy = y;
            if(check(xx,yy)) q.push({xx,yy});
        }
        if(x == 0 && s[x+1][y] == '.') {
            int xx = x + 1, yy = y;
            if(check(xx,yy)) q.push({xx,yy});
        }
        if(y != 0 && s[x][y-1] == '.') {
            int xx = x, yy = y-1;
            if(check(xx,yy)) q.push({xx,yy});
        }
        if(y != n - 1 && s[x][y+1] == '.') {
            int xx = x, yy = y+1;
            if(check(xx,yy)) q.push({xx,yy});
        }
    }
    if(counter > 2) cout << "Multiple\n";
    else cout << "Unique\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T;
    cin >> T;
    while(T--) {
        solve();
    }

    return 0;
}
