#include <iostream>
#include <vector>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;

    if (n == 1)
    {
        cout << 0 << endl;
        return 0;
    }

    vector<int> fin(n);

    for (int i = 0; i < n; ++i)
    {
        cin >> fin[i];
    }

    vector<pair<int, int>> res;

    for (int i = 0; i < n - 1; ++i)
    {
        for (int j = 0; j < n - i - 1; ++j)
        {
            if (fin[j] < fin[j + 1])
            {
                swap(fin[j + 1], fin[j]);
                res.push_back({fin[j + 1], fin[j]});
            }
        }
    }

    for (int i = 0; i < n - 1; ++i)
    {
        for (int j = 0; j < n - i - 1; ++j)
        {
            if (fin[j] > fin[j + 1])
            {
                swap(fin[j + 1], fin[j]);
                res.push_back({fin[j + 1], fin[j]});
            }
        }
    }

    cout << res.size() << endl;

    for (auto it = res.rbegin(); it != res.rend(); advance(it, 1))
    {
        cout << it->first << ' ' << it->second << '\n';
    }

    cout << flush;

    return 0;
}