
#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define int long long

vector<vector<int> > G;

struct Task {
   int a;
   int d;
};
const int INF = 1e18;
void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<int>ep(m + 5), t(q + 5), pref(m + 5);
    vector<Task> tasks(n);

    for(int i = 0; i < n; i ++) cin >> tasks[i].a;
    for(int i = 0; i < n; i ++) cin >> tasks[i].d;

    for(int i = 1; i <= m; i ++) {
        cin >> ep[i];
        pref[i] = pref[i - 1] + ep[i];
    }
    for(int i = 0; i < q; i ++) cin >> t[i];


    sort(all(tasks), [](Task l, Task r){
        return l.d < r.d;
    });


    vector<pair<int, int> > v;

    v.push_back({tasks.back().d, tasks.back().d});

    int last = tasks.back().d;
    for(int i = n - 1; i >= 0; i --) {
        int point = min(tasks[i].d, last) - tasks[i].a;

        if(tasks[i].d >= last) {
            v[v.size() - 1].first = point;
        } else {
            v.push_back({point, tasks[i].d});
        }

        last = point;
    }
    sort(all(v));

    vector<int> freeTime(v.size());
    int sum = 0, begin = 0;
    for(int i = 0 ; i < v.size(); i ++) {
        sum += v[i].first - begin;
        begin = v[i].second;

        freeTime[i] = sum;
    }


    for(int i = 0; i < q; i ++) {
        int x = t[i];

        auto it = lower_bound(v.begin(), v.end(), make_pair(x, INF));

        if(it == v.end()) it --;

        auto ind = it - v.begin();

        int time = freeTime[ind] + max(0LL, x - v[ind].second);

        int l = 1, r = m , md;

        while(l < r) {
            md = (l + r + 1) / 2;

            if(pref[md] <= time) {
                l = md;
            } else {
                r = md - 1;
            }
        }

        cout << l<< " ";
    }
}

signed main() {

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}


// #.......##
// ##..#.##..
/*
2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10
 */