

def fsignums(part):
    signs = []
    for c in part:
        if c == '+' or c == '-':
            signs.append(c)
    nums = []
    numstemp = part.split("+")
    for numlist in numstemp:
        numlistt = numlist.split('-')
        for num in numlistt:
            nums.append(num)
    return signs, nums

def evl(signs, nums):
    sums = int(nums[0])
    if nums[0][0]=='0':
        return sums, 1
    for i in range(len(signs)):
        if nums[i+1][0] == '0':
            return sums, 1
        if signs[i] == '+':
            sums += int(nums[i+1])
        else:
            sums -= int(nums[i+1])
    return sums, 0

def remove(str, r):
    if str[r] == '+' or str[r] == '-' or str[r] == '=':
        return -1, str
    else:
        if r == 1 and str[0] == '0':
            return -1, str
        if r > 1 and str[r-1] == '0' and (str[r-2] == '+' or str[r-2] == '-' or str[r-2] == '='):
            return -1, str
        if r > 1 and (str[r-1] == '+' or str[r-1] == '-' or str[r-1] == '=') and (r < len(str)-1) and (str[r+1] == '+' or str[r+1] == '-' or str[r+1] == '='):
            return -1, str
        if r == len(str) - 1 and r > 0 and (str[r-1] == '+' or str[r-1] == '-' or str[r-1] == '='):
            return -1, str
        cn = str[r]
        return cn, str[:r] + str[r + 1:]

def insert(str, i, r, cn):
    if r < i:
        i -= 1
    return str[:i] + cn + str[i:]

def checknums(nums):
    for num in nums:
        if len(num) > 10 or len(num) == 0:
            return 1
    return 0

def tst():
    s = input()

    r = 3
    i = 6
    cn, s = remove(s, r)
    if cn==-1:
        print(cn)
        return
    s = insert(s, i, r, cn)
    lst = s.split('=')
    partL, partR = lst[0], lst[1]

    signsL, numsL = fsignums(partL)
    signsR, numsR = fsignums(partR)
    print(evl(signsL, numsL), evl(signsR, numsR))

def mn():
    s = input()

    ln = len(s)

    ls = s.split('=')
    partL, partR = ls[0], ls[1]

    signsL, numsL = fsignums(partL)
    signsR, numsR = fsignums(partR)
    if evl(signsL, numsL) == evl(signsR, numsR):
        print("Correct")
        return

    for i in range(ln):
        for r in range(ln):
            if r == i:
                continue

            cn, st = remove(s, r)
            if cn == -1:
                continue
            st = insert(st, i, r, cn)
            lst = st.split('=')
            partL, partR = lst[0], lst[1]

            signsL, numsL = fsignums(partL)
            signsR, numsR = fsignums(partR)
            if(checknums(numsR) or checknums(numsL)):
                continue
            r1, er = evl(signsL, numsL)
            if er:
                continue
            r2, er = evl(signsR, numsR)
            if er:
                continue

            if  r1 == r2:
                print(st)
                return

    print("Impossible")

mn()
