// #051, room 4220
#include <iostream>
#include <string>
#include <stdio.h>

using namespace std;
#define ll long long int

bool check_equality(const string& s){
	ll a = 0, b = 0;
	ll r = 0, q = 1;
	int n = s.length();
	int i = 0;

	for(i = 0; i < n && s[i] != '='; ++ i){
		if(s[i] >= 48 && s[i] < 58)
			r = r * 10 + s[i] - 48;
		else
			a += r * q;
		if(s[i] == '+')
			q = 1, r = 0;
		else if(s[i] == '-')
			q = -1, r = 0;
	}
	a += q * r;
	q = 1;
	r = 0;
	for(i ++; i < n ; ++ i){
		if(s[i] >= 48 && s[i] < 58)
			r = r * 10 + s[i] - 48;
		else
			b += r * q;
		if(s[i] == '+')
			q = 1, r = 0;
		else if(s[i] == '-')
			q = -1, r = 0;
	}
	b += q * r;

	// cout << s << " ~ " << a << '=' << b << '\n';

	return a == b;
}

bool can_er(const string & s, int i){
	if(i == 0){
		if(s[i + 1] > 48 && s[i + 1] < 58 || s[i + 1] == '-')
			return true;
		return false;
	}
	if(i == s.length() - 1){
		return s[i - 1] >= 48 && s[i - 1] < 58;
	}
	if(s[i -1] == '=' && s[i + 1] == '-')
		return true;

	return s[i - 1] >= 48 && s[i - 1] < 58 || s[i + 1] > 48 && s[i + 1] < 58;
}

bool can_in(const string & s, int i, int x){
	if(i == 0 && s[i] == '-')
		return true;
	if(i == 0 && x == '0')
		return false;
	if(s[i - 1] == '=' && s[i] == '-')
		return true;
	if((s[i - 1] == '=' ||s[i - 1] == '-' ||s[i - 1] == '+') && x == '0')
		return false;

	int k = 0;
	for(int j = i - 1; j >= 0 && s[j] >= 48 && s[j] < 58; --j){
		k ++;
		// cout << s[j] << ' ';
	}

	for(int j = i; i < s.length() && s[j] >= 48 && s[j] < 58; ++ j){
		k ++;
		// cout << s[j] << ' ';

	}

	// cout << k << '\n';
	if(k >= 10)
		return false; 

	return true;
}

int main(){
	// freopen("input.txt", "r", stdin);


	string s;

	cin >> s;

	if(check_equality(s))
		cout << "Correct\n";
	else{
		int n = s.length();
		for(int i = 0; i < n; ++ i){
			if(s[i] == '-' || s[i] == '+' || s[i] == '=' || !can_er(s, i))
				continue;
			string str = s.substr(0, i) + s.substr(i + 1);
			char c = s[i];

			for(int j = 0; j < n; ++ j){ // j ={0, n -1}
				string str2;
				if(j < n - 1)   // str.size = n -1 (n-2 = max)
					str2 = str.substr(0, j) + c + str.substr(j); 
				else
					str2 = str + c;
				// cout << str2 << ' ' << c << '\n';
				if(!can_in(str, j, c))
					continue;
				// if(j > 0)
				// 	cout << str[j - 1] << '\n';
				// cout << "!2 " << (str[j - 1] == '=') << ' ' << (str[j - 1] == '-') << ' ' <<( str[j - 1] == '-')  << ' ' << (c == '0') << "\n";
				if(check_equality(str2)){
					cout << str2 << '\n';
					return 0;
				}
			}
		}
		cout << "Impossible\n";
	} 

	return 0;
}
// #051, room 4220
