from copy import deepcopy

# length = 10
# pol = [list('#.......##'), list('##..#.##..')]
# pol = [list('###'), list('###')]
# pol = [list('........'), list('........')]
# pol = [list('...#..'), list('..#...')]

NN = int(input())


def func(val: list[list[str]]):
    size = len(val[0])
    cells = deepcopy(val)
    for i in range(size):
        x, y = cells[0][i], cells[1][i]
        if x == '#' and y == '#':
            continue
        
        if x == '.' and y == '#':
            if i + 1 == size or cells[0][i+1] == '#':
                return 'None'
            
            cells[0][i] = '#'
            cells[0][i+1] = '#'
        elif x == '#' and y == '.':
            if i + 1 == size or cells[1][i+1] == '#':
                return 'None'
            
            cells[1][i] = '#'
            cells[1][i+1] = '#'
    
    for i in range(size-1):
        x1, y1 = cells[0][i], cells[1][i]
        x2, y2 = cells[0][i+1], cells[1][i+1]
        
        if x1 == '.' and x2 == '.' and y1 == '.' and y2 == '.':
            return 'Multiple'

    return 'Unique'


answers = []
for _ in range(NN):
    n = int(input())
    pol = [list(input()) for _ in range(2)]
    answers.append(func(pol))    

print(*answers, sep='\n')
