#include <iostream>
#include <vector>
#include <string>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<string> v(2);
        cin >> v[0] >> v[1];

        bool ok = true;
        for (int i = 0; i < n; i++) {
            if (v[0][i] == v[1][i])
                continue;

            if (v[0][i] == '.' && i + 1 < n && v[0][i + 1] == '.')
                v[0][i] = v[0][i + 1] = '#';
            else if (v[1][i] == '.' && i + 1 < n && v[1][i + 1] == '.')
                v[1][i] = v[1][i + 1] = '#';
            else
                ok = false;
        }

        if (!ok) {
            cout << "None\n";
            continue;
        }

        bool unique = true;
        for (int i = 0; i + 1 < n; i++)
            if (v[0][i] == '.' && v[0][i + 1] == '.')
                unique = false;

        if (unique)
            cout << "Unique" << '\n';
        else
            cout << "Multiple\n";
    }

    return 0;
}
