#ifndef LOCAL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
using namespace std;
using ll = int64_t;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& x : a) cin >> x, --x;
    vector<int> cur(n);
    iota(cur.begin(), cur.end(), 0);
    vector<pair<int, int>> ans;
    for (int it = n; it--;) {
        int x = a[it];
        int pos = find(cur.begin(), cur.end(), x) - cur.begin();
        for (int i = pos - 1; i >= 0; i--) {
            ans.emplace_back(cur[i + 1], cur[i]);
            swap(cur[i + 1], cur[i]);
        }
        for (int i = 0; i < pos - 1; ++i) {
            ans.emplace_back(cur[i + 1], cur[i]);
            swap(cur[i + 1], cur[i]);
        }
        for (int i = pos; i < it; ++i) {
            ans.emplace_back(cur[i + 1], cur[i]);
            swap(cur[i + 1], cur[i]);
        }
    }
    cout << ans.size() << endl;
    for (auto [a, b] : ans) {
        cout << a + 1 << ' ' << b + 1 << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    auto start = clock();
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
#ifdef LOCAL
    cerr << "TIME: " << 1e3 * (clock() - start) / CLOCKS_PER_SEC << " ms\n";
#endif
    return 0;
}