#ifndef LOCAL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
using namespace std;
using ll = int64_t;

void solve() {
    string s;
    cin >> s;
    auto eval = [&] {
        int last = 0;
        vector<string> lhs, rhs;
        vector<char> lhs_op = {'+'}, rhs_op = {'+'};
        bool left = true;
        for (int i = 0; i < sz(s); ++i) {
            auto& v = left ? lhs : rhs;
            auto op_v = left ? lhs_op : rhs_op;
            if (s[i] == '+' || s[i] == '-') {
                op_v.push_back(s[i]);
                v.push_back(s.substr(last, i - last));
                last = i + 1;
            } else if (s[i] == '=') {
                op_v.push_back(s[i]);
                v.push_back(s.substr(last, i - last));
                last = i + 1;
                left = false;
            }
        }
        rhs.push_back(s.substr(last));
        for (auto& str : lhs) {
            if (sz(str) > 10 || sz(str) == 0 || str[0] == '0' && sz(str) != 1) {
                return false;
            }
        }
        for (auto& str : rhs) {
            if (sz(str) > 10 || sz(str) == 0 || str[0] == '0' && sz(str) != 1) {
                return false;
            }
        }
        ll l = 0;
        for (int i = 0; i < sz(lhs); ++i) {
            if (lhs_op[i] == '+') {
                l += stoll(lhs[i]);
            } else {
                l -= stoll(lhs[i]);
            }
        }
        ll r = 0;
        for (int i = 0; i < sz(rhs); ++i) {
            if (rhs_op[i] == '+') {
                r += stoll(rhs[i]);
            } else {
                r -= stoll(rhs[i]);
            }
        }
        return l == r;
    };
    if (eval()) {
        cout << "Correct\n";
        return;
    }
    for (int i = 0; i < sz(s); ++i) {
        if (isdigit(s[i])) {
            char c = s[i];
            string t = s;
            s.erase(s.begin() + i);
            for (int j = 0; j <= sz(t); ++j) {
                t.insert(t.begin() + j, c);
                if (eval()) {
                    cout << t << '\n';
                    return;
                }
                t.erase(t.begin() + j);
            }
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
    auto start = clock();
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) solve();
#ifdef LOCAL
    cerr << "TIME: " << 1e3 * (clock() - start) / CLOCKS_PER_SEC << " ms\n";
#endif
    return 0;
}