#include <iostream>
#include <iomanip>
#include <vector>
#include <deque>
#include <queue>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <algorithm>

using namespace std;

void F() {
	int n;
	cin >> n;
	vector<int> a(n + 1);
	for (int i = 0; i < n; i++)
		cin >> a[i + 1];
	vector<int> b(n);
	iota(b.begin(), b.end(), 1);
	vector<pair<int, int>> ans;
	for (int i = n; i > 0; i--) {
		int j = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
		while (j > 0) {
			ans.push_back({ b[j - 1], b[j] });
			swap(b[j], b[j - 1]);
			j--;
		}
		while (j + 1 < b.size()) {
			ans.push_back({ b[j], b[j + 1] });
			swap(b[j], b[j + 1]);
			j++;
		}
		b.pop_back();
	}
	cout << ans.size() << '\n';
	for (auto i : ans)
		cout << i.second << ' ' << i.first << '\n';

}

int main() {
#ifdef ROMA
	FILE* stream;
	freopen_s(&stream, "input.txt", "r", stdin);
	//freopen_s(&stream, "output.txt", "w", stdout);
#endif
	cin.tie(0)->sync_with_stdio(0);
	int t = 1;
	//cin >> t;
	while (t--)
		F();
}