#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;

const ll INF = 2e18;

using ld = long double;
using pt = pair<ld, ld>;

const int maxn = 1 << 12;

int memory[maxn];

int transform(string s) {
    int ans = 0;
    for (char c : s) {
        ans *= 16;
        if ('0' <= c && c <= '9') {
            ans += c - '0';
        } else {
            ans += 10 + c - 'a';
        }
    }
    return ans;
}

void solve() {
    int x;
    cin >> x;
    int const_pos = 1 << 10;
    int ok_end = 10 + const_pos;
    int bad_end = 20 + const_pos;
    memory[const_pos] = 1;
    memory[ok_end] = const_pos * 16 + 0;
    memory[ok_end + 1] = transform("fff0");
    memory[ok_end + 2] = transform("f000");
    memory[bad_end] = const_pos * 16 + 1;
    memory[bad_end + 1] = transform("fff0");
    memory[bad_end + 2] = transform("f000");
    memory[maxn - 1] = x;
    for (int i = 0; i < 16; i++) {
        if (x & (1 << i)) {
            memory[i * 3] = transform("fff") * 16 + i;
            memory[i * 3 + 1] = (i * 3 + 2) * 16 + 8;
            memory[i * 3 + 2] = 128 + 256 + i * 3;
            memory[128 + 256 + i * 3] = memory[128 + 256 + i * 3 + 1] = 0;
            memory[128 + 256 + i * 3 + 2] = i * 3 + 3;
            memory[128 + i * 3] = memory[128 + i * 3 + 1] = 0;
            memory[128 + i * 3 + 2] = bad_end;
        } else {
            memory[i * 3] = transform("fff") * 16 + i;
            memory[i * 3 + 1] = (i * 3 + 2) * 16 + 8;
            memory[i * 3 + 2] = 128 + 256 + i * 3;
            memory[128 + 256 + i * 3] = memory[128 + 256 + i * 3 + 1] = 0;
            memory[128 + 256 + i * 3 + 2] = bad_end;
            memory[128 + i * 3] = memory[128 + i * 3 + 1] = 0;
            memory[128 + i * 3 + 2] = i * 3 + 3;
        }
    }
    memory[16 * 3] = memory[16 * 3 + 1] = 0;
    memory[16 * 3 + 2] = ok_end;
    for (int i = 0; i < maxn - 1; i++) {
        string s;
        int was = memory[i];
        for (int _ = 0; _ < 4; _++) {
            int cur = was % 16;
            was /= 16;
            if (cur < 10) {
                s += '0' + cur;
            } else {
                s += 'a' + cur - 10;
            }
        }
        reverse(all(s));
        cout << s << " ";
    }
    cout << endl;
}

void evaluate() {
    int ip = 0;
    while (ip < maxn - 2) {
        cout << ip << endl;
        int a = memory[ip], b = memory[ip + 1], c = memory[ip + 2];
        int bit = memory[a >> 4] >> (a & 15);
        bit &= 1;
        memory[b >> 4] = (memory[b >> 4] & ((1 << 16) - 1 - (1 << (b & 15)))) | (bit << (b & 15));
        ip = memory[ip + 2];
    }
    cout << (memory[maxn - 1] & 1) << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    precalc();
//    cin >> t;
    while (t--) {
        solve();
    }
    memory[maxn - 1] = 11;
//    evaluate();
    return 0;
}