#include <bits/stdc++.h>

using namespace std;

#define vec std::vector

void solve() {
    int n, q, m;
    cin >> n >> m >> q;
    vec<pair<long long, int>> works(n);
    for (int i = 0; i < n; ++i) {
        cin >> works[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> works[i].first;
    }
    sort(works.begin(), works.end());

    vec<long long> need_start(n);
    need_start[n - 1] = works[n - 1].first - works[n - 1].second;
    for (int i = n - 2; i >= 0; --i) {
        need_start[i] = min(need_start[i + 1], works[i].first) - works[i].second;
    }
    vec<long long> pref_ep(m + 1);
    for (int i = 0; i < m; ++i) {
        cin >> pref_ep[i + 1];
        pref_ep[i + 1] += pref_ep[i];
    }
    vec<pair<long long, int>> check(q);
    for (int i = 0; i < q; ++i) {
        cin >> check[i].first;
        check[i].second = i;
    }
    sort(check.begin(), check.end());
    vec<long long> ans(q);
    int l = 0;
    long long pref = 0;
    for (auto &q : check) {
        while (l < n && works[l].first <= q.first) {
            pref += works[l].second;
            l++;
        }

        long long free = q.first;
        if (l != 0)  {
            free -= pref;
        }
        if (l != n) {
            free -= max(0ll, q.first - need_start[l]);
        }

        int l_bin = 0, r_bin = m + 1;
        while (r_bin - l_bin > 1) {
            int m_bin = (r_bin + l_bin) / 2;
            if (pref_ep[m_bin] <= free) {
                l_bin = m_bin;
            } else {
                r_bin = m_bin;
            }
        }
        ans[q.second] = l_bin;
    }
    for (auto &el : ans) {
        cout << el << ' ';
    }
    cout << '\n';
}


int main() {
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        solve();
    }
}
