#pragma optimize("SEX_ON_THE_BEACH")

#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#define int long long
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()

#ifdef HOME
    #define debug(...) { cerr << #__VA_ARGS__ << " " << __VA_ARGS__ << endl; }
    #define say(...) { cerr << __VA_ARGS__ << endl; }
#else
    #define debug(...) 0;
    #define say(...) 0;
#endif


pair<bool,int> get(string s){
    vector<string> a;
    int i = 0;
    
    for(i = 0; i < sz(s);){
        string t;
        while (i < sz(s) && s[i] >= '0' && s[i] <= '9')
        {
            t.push_back(s[i]);
            i++;
        }
        if(t.size()) a.push_back(t);

        if (i >= sz(s)) continue;
    
        if(s[i] == '+' || s[i] == '-')
        {
            a.push_back(string(1,s[i]));
            i++;
        }
    }
    int sum = 0;
    int v = 1;
    for(int i = 0; i < sz(a);i++)
    {
        if(i%2 ==0){
            if(a[i] == "+" || a[i] == "-") return {false,0};
            if(a[i][0] == '0') return {false,0};
            if(sz(a[i]) > 10) return {false,0};
            sum += v * atol(a[i].c_str());
        }else{
            if(!(a[i] == "+" ||  a[i] == "-")) return {false, 0};
            if(a[i] == "-") v= -1;
            else v = 1;
        }
    }
    return {true, sum};
}


bool check(string s){
    debug(s);
    replace(s.begin(),s.end(),'=', ' ');
    stringstream str(s);
    string l, r;
    str >> l;
    str >> r;
    auto [s1, sum1] = get(l);
    auto [s2, sum2] = get(r);
    return s1 && s2 && (sum1 == sum2);
}


void solve(int test = 0) {
    string s;
    cin >> s;

    if(check(s)){
        cout << "Correct" << "\n";
        return;
    }
    // return;

    for(int i = 0; i < sz(s); i++){
        if(!(s[i] >= '0' && s[i] <= '9')){
            continue;
        }

        string l;
        string r;
        for(int j =0 ;j < sz(s);j++){
           if(j == i) continue;
            r.push_back(s[j]);
        }
        string t = l + s[i] + r;
        if(check(t)) {
            cout << t << '\n';
            return;
        }
        reverse(all(r));
        while (sz(r))
        {
            l.push_back(r.back());
            r.pop_back();
            reverse(all(r));
            string t = l + s[i] + r;
            reverse(all(r));
            check(t);
            if(check(t)){
                cout << t << "\n";
                return;
            }
        }
    }
    cout << "Impossible\n";        


    
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << '\n';
        say("=================================================");
    }
}
