#pragma optimize("SEX_ON_THE_BEACH")

#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;

#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()

#ifdef HOME
    #define debug(...) { cerr << #__VA_ARGS__ << " " << __VA_ARGS__ << endl; }
    #define say(...) { cerr << __VA_ARGS__ << endl; }
#else
    #define debug(...) 0;
    #define say(...) 0;
#endif


void solve(int test = 0) {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> arr(n);
    for (int i = 0; i < n; ++i) cin >> arr[i].ff;
    for (int i = 0; i < n; ++i) cin >> arr[i].ss;
    sort(all(arr), [](auto a, auto b) { return a.ss < b.ss; });
    vector<ll> l(m);
    for (int i = 0; i < m; ++i) cin >> l[i];
    for (int i = 1; i < m; ++i) l[i] += l[i - 1];
    for (int i = 1; i < n; ++i) arr[i].ff += arr[i - 1].ff;
    vector<ll> canbe(n);
    for (int i = 0; i < n; ++i) {
        canbe[i] = arr[i].ss - arr[i].ff;
    }
    for (int i = n - 2; i >= 0; --i) {
        canbe[i] = min(canbe[i], canbe[i + 1]);
    }
    for (int i = 0; i < q; ++i) {
        ll t;
        cin >> t;
        int id = upper_bound(all(arr), t, [](ll y, pair<ll, ll> x) { return y < x.ss; }) - arr.begin();
        ll can = l.back();
        if (id) {
            can = min(can, t - arr[id - 1].ff);
        }
        if (id < arr.size()) {
            can = min(can, canbe[id]);
        }
        cout << upper_bound(all(l), can) - l.begin() << " ";
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);

    int t = 1;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << '\n';
        say("=================================================");
    }
}