#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

#define p_b push_back
#define e_b emplace_back
#define m_p make_pair
#define fi first
#define se second
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF = 1e18 + 2;
const ll N = 1e6 + 2;

bool correct(string s) {
    bool part = 0, sgn = 0;
    ll num = 0, l = 0, r = 0;
    for(char c : s) {
        if(isdigit(c)) {
            num = num * 10 + (c - '0');
            continue;
        }
        if(!part) l += num * (sgn ? -1 : 1);
        else r += num * (sgn ? -1 : 1);

        if(c == '+') sgn = 0;
        else if(c == '-') sgn = 1;
        else if(c == '=') {
            part = 1;
            sgn = 0;
        }
        num = 0;
    }

    r += num * (sgn ? -1 : 1);
    return l == r;
}

bool good(string s) {
    ll n = sz(s);
    for(ll i = 1; i < n - 1; i++) {
        if(s[i] == '0' && !isdigit(s[i - 1]) && isdigit(s[i + 1])) {
            return 0;
        }
    }
    if(s[0] == '0' && isdigit(s[1])) {
        return 0;
    }

    for(ll i = 0; i < n - 1; i++) {
        if(!isdigit(s[i]) && !isdigit(s[i + 1])) {
            return 0;
        }
    }

    ll cnt = 0;
    for(ll i = 0; i < n; i++) {
        if(isdigit(s[i])) {
            cnt++;
            continue;
        }
        if(cnt > 10) return 0;
        cnt = 0;
    }
    if(cnt > 10) return 0;

    if(!isdigit(s[0])) {
        return 0;
    }
    if(!isdigit(s.back())) {
        return 0;
    }
    return 1;
}

void solve() {
    string s;
    cin >> s;
    if(correct(s)) {
        cout << "Correct";
        return;
    }

    ll n = sz(s);
    for(ll a = 0; a < n; a++) {
        for(ll b = 0; b <= n; b++) {
            string t = "";
            for(ll i = 0; i < n; i++) {
                if(i == b) t += s[a];
                if(i != a) t += s[i];
            }
            if(b == n) t += s[a];
            if(good(t) && correct(t)) {
                cout << t;
                return;
            }
        }
    }

    cout << "Impossible";
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
    return 0;
}
