#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

#define p_b push_back
#define e_b emplace_back
#define m_p make_pair
#define fi first
#define se second
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF = 1e18 + 2;
const ll N = 1e6 + 2;

int n, m;
vector<pll> edges[N];
vector<pll> redges[N];
int dst[N];
int md[N][2];

void calc_dst() {
    priority_queue<pll, vector<pll>, greater<>> q;
    fill(dst, dst + n, INF);
    dst[n - 1] = 0;
    q.push({0, n - 1});
    while (!q.empty()) {
        auto [d, v] = q.top();
        q.pop();
        if (d != dst[v]) continue;
        for (auto [to, w]: redges[v]) {
            if (d + w < dst[to]) {
                dst[to] = d + w;
                q.emplace(d + w, to);
            }
        }
    }
}

void calc_md() {
    priority_queue<tuple<int, int, pll>, vector<tuple<int, int, pll>>, greater<>> q;
    for (int i = 0; i < n; i++) {
        md[i][0] = md[i][1] = INF;
        if (i != n - 1 && dst[i] == INF) {
            md[i][1] = 0;
            q.emplace(0, dst[i], m_p(i, 1));
        }
    }
    while (!q.empty()) {
        auto [d, _, p] = q.top();
        auto [v, fl] = p;
        q.pop();
        if (d != md[v][fl]) continue;
        if (fl == 0) {
            vector<int> u1, u2;
            for (auto [to, w]: edges[v]) {
                (dst[to] == dst[v] + w ? u1 : u2).p_b(md[to][1]);
            }
            int cur = d;
            if (!u1.empty()) cur = min(cur, *max_element(all(u1)) - 1);
            md[v][1] = cur;
            q.emplace(cur, dst[v], m_p(v, 1));
            continue;
        }
        for (auto [to, w]: redges[v]) {
            if (d + 1 < md[to][0]) {
                md[to][0] = d + 1;
                q.emplace(d + 1, dst[to], m_p(to, 0));
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        if (v == n - 1) continue;
        edges[v].e_b(u, w);
        redges[u].e_b(v, w);
    }

    calc_dst();

    if (dst[0] == INF) {
        cout << -1<<'\n';
        return;
    }

    calc_md();

//    for (int i = 0; i < n; i++) cout << dst[i] << " ";
//    cout << '\n';
//    for (int j = 0; j < 2; j++) {
//        for (int i = 0; i < n; i++) {
//            cout << md[i][j] << " ";
//        }
//        cout << '\n';
//    }

    cout << min(n, md[0][1] - 1);
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();
    return 0;
}
