#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

#define p_b push_back
#define e_b emplace_back
#define m_p make_pair
#define fi first
#define se second
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF = 1e18 + 2;
const ll N = 1e6 + 2;

pll arr[N];
ll ep[N], pr_arr[N], pr_ep[N], suf[N];

void solve() {
    ll n, m, q;
    cin >> n >> m >> q;
    for(ll i = 1; i <= n; i++) {
        cin >> arr[i].S;
    }
    for(ll i = 1; i <= n; i++) {
        cin >> arr[i].F;
    }
    for(ll i = 1; i <= m; i++) {
        cin >> ep[i];
    }

    sort(arr + 1, arr + n + 1);
    for(ll i = 1; i <= n; i++) {
        pr_arr[i] = pr_arr[i - 1] + arr[i].S;
    }
    for(ll i = 1; i <= m; i++) {
        pr_ep[i] = pr_ep[i - 1] + ep[i];
    }
    suf[n + 1] = INF;
    for(ll i = n; i >= 0; i--) {
        suf[i] = min(suf[i + 1], arr[i].F - pr_arr[i]);
    }

    auto func = [&](ll p, ll t) {
        ll pos = upper_bound(arr, arr + n + 1, MP(t, INF)) - arr - 1;
        return pr_arr[pos] + pr_ep[p] <= t && suf[pos + 1] >= pr_ep[p];
    };

    while(q--) {
        ll t;
        cin >> t;
        ll l = 0, r = m;
        while(l < r) {
            ll mid = (l + r + 1) / 2;
            if(func(mid, t)) l = mid;
            else r = mid - 1;
        }
        cout << l << ' ';
    }
    cout << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll q;
    cin >> q;
    while(q--) {
        solve();
    }

    return 0;
}
