#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

#define p_b push_back
#define e_b emplace_back
#define m_p make_pair
#define fi first
#define se second
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF = 1e18 + 2;
const ll N = 1e6 + 2;

ll lcm(ll a, ll b) {
    return a * b / __gcd(a, b);
}

bool intersect(ll l1, ll r1, ll l2, ll r2) {
    if(l1 > l2) {
        swap(l1, l2);
        swap(r1, r2);
    }
    return l2 <= r1;
}

ve<bool> calc(ll n, ll p1, ll l1, ll v1, ll p2, ll l2, ll v2) {
    ll its = lcm(2 * (n - l1), 2 * (n - l2));
    ve<bool> res(its);
    for(ll it = 0; it < its; it++) {
        res[it] = intersect(p1, p1 + l1 - 1, p2, p2 + l2 - 1);
        ll to1 = p1 + v1, to2 = p2 + v2;
        if(!(0 <= to1 && to1 + l1 <= n)) {
            v1 *= -1;
            to1 = p1 + v1;
        }
        if(!(0 <= to2 && to2 + l2 <= n)) {
            v2 *= -1;
            to2 = p2 + v2;
        }
        p1 = to1;
        p2 = to2;
    }
    return res;
}

struct rect {
    ll w, h, x, y, dx, dy;
};

void solve() {
    ll n, m;
    cin >> n >> m;

    rect r1, r2;
    cin >> r1.w >> r1.h >> r1.x >> r1.y >> r1.dx >> r1.dy;
    cin >> r2.w >> r2.h >> r2.x >> r2.y >> r2.dx >> r2.dy;

    ve<bool> vx = calc(n, r1.x, r1.w, r1.dx, r2.x, r2.w, r2.dx);
    ve<bool> vy = calc(m, r1.y, r1.h, r1.dy, r2.y, r2.h, r2.dy);

    ll gc = __gcd(sz(vx), sz(vy));
    ll ch = 0, zn = 0;

    for(ll i = 0; i < gc; i++) {
        ll cx = 0, cy = 0;
        for(ll j = i; j < sz(vx); j += gc) {
            cx += vx[j];
        }
        for(ll j = i; j < sz(vy); j += gc) {
            cy += vy[j];
        }
        ch += cx * cy;
    }

    ch *= gc;
    zn = sz(vx) * sz(vy);
    ll g = __gcd(ch, zn);
    ch /= g;
    zn /= g;
    cout << ch << '/' << zn << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll q;
    cin >> q;
    while(q--) {
        solve();
    }

    return 0;
}
