#include <bits/stdc++.h>

    using namespace  std;
#define int long long

    int n;
    vector<int> pos;
    unordered_map<int, int> where;
    vector<pair<int, int>> ans;
    vector<vector<bool>> used;

    void swapp(int i, int j) { // i < j
        used[pos[i]][pos[j]] = false;
        ans.push_back({pos[i], pos[j]});
        swap(where[pos[i]], where[pos[j]]);
        swap(pos[i], pos[j]);
    }

    void try_swap(int i, int j) {
        if (j >= n) {
            return;
        }
        if (used[pos[i]][pos[j]] && used[pos[j]][pos[i]]) {
            swapp(i, j);
            try_swap(i + 1, j + 1);
            swapp(i, j);
        }
    }

    int32_t main() {
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);

        cin >> n;
        pos.resize(n);
        used.resize(n + 1, vector<bool> (n + 1, true));
        for (int i = 0; i < n; ++i) {
            cin >> pos[i];
            where[pos[i]] = i;
        }
        vector<int> pos_copy = pos;

        for (int i = 0; i < n - 1; ++i) {
            for (int j = 0; j < n - i - 1; ++j) {
                if (pos[j] > pos[j + 1])
                    swapp(j, j + 1);
            }
        }
//    for (int i = 0; i < n; ++i) {
//        cout << pos[i] << ' ';
//    }
//    cout << '\n';

        pos = pos_copy;
        ans.clear();
        for (int i = 0; i < n; ++i) {
            where[pos[i]] = i;
        }
        for (int j = 0; j < n - 1; ++j) {
            try_swap(j, j + 1);
        }
        for (int i = 0; i < n - 1; ++i) {
            for (int j = 0; j < n - i - 1; ++j) {
                if (pos[j] > pos[j + 1])
                    swapp(j, j + 1);
                for (int z = 0; z < n - 1; ++z) {
                    try_swap(z, z + 1);
                }
            }
        }
        for (int j = 0; j < n - 1; ++j) {
            try_swap(j, j + 1);
        }


//    for (int i = 0; i < n; ++i) {
//        cout << pos[i] << ' ';
//    }
//    cout << '\n';

        cout << ans.size() << '\n';
        reverse(ans.begin(), ans.end());
        for (auto i: ans) {
            cout << i.first << ' ' << i.second << '\n';
        }

        return 0;
    }