#include <bits/stdc++.h>

using namespace  std;
#define int long long

int n;
vector<int> places_now;
unordered_map<int, int> dict_now;
vector<int> places_last;
vector<pair<int, int>> ans;
vector<pair<int, int>> ans1;
vector<vector<bool>> used;

void swap_func(int i, int j, bool ans1_push = false) { // i -> j
    if (ans1_push) {
        ans1.push_back({places_now[i], places_now[j]});
    }
    ans.push_back({places_now[i], places_now[j]});

    used[places_now[i]][places_now[j]] = 0;
    swap(dict_now[places_now[i]], dict_now[places_now[j]]);
    swap(places_now[i], places_now[j]);
}

void check_next(int i, int j, bool ans1_push = false) {
    if (j == n || i ==  n) {
        return;
    }
    if (used[places_now[i]][places_now[j]] && used[places_now[j]][places_now[i]]) {
        swap_func(j, i);
        check_next(j + 1, i + 1, ans1_push);
        swap_func(j, i);
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vector<vector<int>> data;
    cin >> n;
    places_now.resize(n);
    places_last.resize(n);
    used.resize(n+ 1, vector<bool> (n + 1, true));
    for (int i = 0; i < n; ++i) {
        dict_now[i + 1] = i;
        places_now[i] = i + 1;
        cin >> places_last[i];
    }

    data.push_back(places_now);
    for (int i = 0; i < n; ++i) {
        int cur_place = dict_now[places_last[i]];
        while (cur_place != i) {
            if (cur_place > i) {
                swap_func(cur_place, cur_place - 1);
                data.push_back(places_now);
                cur_place--;
            } else {
                swap_func(cur_place + 1, cur_place);
                data.push_back(places_now);
                cur_place++;
            }
        }
    }

    for (int cur = 0; cur < data.size(); cur++) {
        for (int i = 0; i < n - 1; ++i) {
            check_next(i, i + 1, true);
        }
        if (cur != data.size() - 1)
        ans1.push_back(ans[cur]);
    }


    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first << ' ' << i.second << '\n';

    }

    return 0;
}