


#include <bits/stdc++.h>

using namespace  std;
#define int long long

void solve()
{
    int n;
    std::cin >> n;
    std::string t[2];
    std::cin >> t[0] >> t[1];
//    std::cout << "DONE READING " << n <<  std::endl;
    struct node {
        int x;
        int y;
        int dirx;
        int diry;
//        node(int x, int y) : x(x), y(y) {}
    };
    std::queue<node> q;
    std::vector<std::pair<int, int>> steps = {
            {0, 1}, {0, -1}, {1, 0}, {-1, 0}
    };
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            if (t[i][j] == '#') continue;
            int cnt = 0;
            int dx, dy;
            for (auto [x, y]: steps) {
                int xx = i + x;
                int yy = j + y;

                if (0 <= xx and xx < 2 and 0 <= yy and yy < n and t[xx][yy] != '#') {
                    cnt++;
                    dx = x;
                    dy = y;
                }
            }
            if (cnt == 1) {
                q.emplace(i, j, dx, dy);
            }
        }
    }

    auto to_next = [&](int i, int j){
        if (!(0 <= i and i < 2 and 0 <= j and j < n and t[i][j] != '#')) {
            return;
        }
        int cnt = 0;
        int dx, dy;
        for (auto [x, y]: steps) {
            int xx = i + x;
            int yy = j + y;

            if (0 <= xx and xx < 2 and 0 <= yy and yy < n and t[xx][yy] != '#') {
                cnt++;
                dx = x;
                dy = y;
            }
        }
        if (cnt == 1) {
            assert(t[i][j] == '.');
            assert(t[i + dx][j + dy] == '.');
            q.emplace(i, j, dx, dy);
        }
    };

    while (!q.empty()) {
        auto [x, y, dx, dy] = q.front(); q.pop();
        if (t[x][y] == '#') continue;
//        std::cout << x << ' ' << y << ' ' << dx << ' ' << dy << std::endl;
        int xx = x + dx;
        int yy = y + dy;
        if (t[xx][yy] == '#') continue;
        t[x][y] = '#';
        t[xx][yy] = '#';
//        std::cout << t[0] << '\n' << t[1] << std::endl << std::endl;
        for (auto [dxx, dyy]: steps) {
            to_next(xx + dxx, yy + dyy);
        }
    }

    int cnt1 = std::count(t[0].begin(), t[0].end(), '#');
    int cnt2 = std::count(t[1].begin(), t[1].end(), '#');

    if (cnt1 + cnt2 == 2 * n) {
        std::cout<<"Unique\n";
        return;
    }

    for (int i = 0; i < n - 1; ++i) {
        if (t[0][i] == '.' and t[0][i + 1] == '.' and t[1][i] == '.' and t[1][i + 1] == '.') {
            std::cout << "Multiple\n";
            return;
        }
    }
    std::cout << "None\n";
}

int32_t main() {
    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }
}
