#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) begin(a), end(a)
#define len(a) int((a).size())
#define rep(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd;


vector<int> result;
int x;
int cur = 0;
int last = (1 << 16) - 16;
int one;
int zero;

int make_zero(){
    int v = cur;
    result[cur++] = 0;
    for(int i = 0; i < 16; i += 1){
        int u = cur;
        cur += 3;
        result[u] = 16 * v;
        result[u + 1] = last + i;
        if(i == 15){
            result[u + 2] = (1 << 12);
        } else{
            result[u + 2] = u + 3;
        }    
    }
    return v + 1;
}

int make_one(){
    int v = cur;
    result[cur++] = 1;
    for(int i = 0; i < 16; i += 1){
        int u = cur;
        cur += 3;
        result[u] = 16 * v + i;
        result[u + 1] = last + i;
        if(i == 15){
            result[u + 2] = (1 << 12);
        } else{
            result[u + 2] = u + 3;
        }    
    }
    return v + 1;
}


int unconditional_jump(int go){
    int v = cur;
    cur += 4;
    result[v] = 0;
    result[v + 1] = 0;
    result[v + 2] = go;
    return v;
}


int conditional_jump(int bit, int case0, int case1){
    while((cur & 4) != 0){
        ++cur;
    }
    int u = unconditional_jump(case0);
    int v = unconditional_jump(case1);
    int x = cur;
    cur += 4;
    result[x + 2] = u;
    result[x] = bit;
    result[x + 1] = 16 * (x + 2) + 2;
    return x;
}


int make_flex(){
    int go = one;
    for(int i = 0; i < 16; i += 1){
        if((x >> i) & 1){
            go = conditional_jump(last + i, zero, go);
        } else{
            go = conditional_jump(last + i, go, zero);
        }
    }
    return go;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin >> x;
    result.resize((1 << 16) / 16);
    cur = 3;
    one = make_one();
    zero = make_zero();
    int go = make_flex();
    result[0] = result[1] = 0;
    result[2] = go;
    for(int i = 0; i < cur; i += 1){
        int val = result[i];
        string s = "0000";
        rep(j, 4){
            int aboba = val % 16;
            val /= 16;
            if(aboba < 10){
                s[3 - j] = '0' + aboba;
            } else{
                s[3 - j] = 'a' + (aboba - 10);
            }
        }
        cout << s << " ";
    }
    return 0;
}
