#include  <bits/stdc++.h>

typedef long long ll;

#define mp make_pair

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(2 * n);
    vector<vector<int>> ind(n);
    vector<int> a(2 * n);
    for (int i = 0; i < 2 * n; ++i) {
        cin >> a[i];
        --a[i];
        ind[a[i]].push_back(i);
    }
    for (int i = 1; i < 2 * n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<pair<int, int>> match;
    vector<vector<int>> dp(2 * n, vector<int>(2));
    auto dfs = [&](auto& self, int v, int p) -> void {
        int sum = 0;
        for (int to : g[v]) {
            if (p == to) continue;
            self(self, to, v);
            dp[v][0] += max(dp[to][0], dp[to][1]);
            sum += max(dp[to][1], dp[to][0]);
        }
        for (int to : g[v]) {
            if (p == to) continue;
            dp[to][1] = max(dp[to][1], 1 + sum - max(dp[to][0], dp[to][1]) + dp[to][0]);
        }
    };
    dfs(dfs, 0, -1);
    auto getmatch = [&](auto& self, int v, int p, int val) -> void {
        if (val == 0) {
            for (int to : g[v]) {
                if (to == p) continue;
                if (dp[to][0] > dp[to][1]) self(self, to, v, 0);
                else self(self, to, v, 1);
            }
        } else {
            int sum = 0;
            for (int to : g[v]) {
                if (p == to) continue;
                sum += max(dp[to][1], dp[to][0]);
            }
            pair<int, int> best = {-1, 0};
            for (int to : g[v]) {
                if (p == to) continue;
                best = max(best, {1 + sum - max(dp[to][0], dp[to][1]) + dp[to][0], to});

            }
            if (best.first >= 0) {
                match.emplace_back(v, best.second);
            }
            for (int to : g[v]) {
                if (p == to) continue;
                if (to == best.second) self(self, to, v, 0);
                else {
                    if (dp[to][0] > dp[to][1]) self(self, to, v, 0);
                    else self(self, to, v, 1);
                }
            }
        }
    };
    int best = (dp[0][0] > dp[0][1] ? 0 : 1);
    getmatch(getmatch, 0, -1, best);
    vector<vector<pair<int, int>>> ng(n);
    vector<int> cnt(n);
    vector<vector<int>> inm(n);
    for (int i = 0; i < size(match); ++i) {
        auto [u, v] = match[i];
        ng[a[u]].emplace_back(a[v], i);
        ng[a[v]].emplace_back(a[u], i);
        inm[a[u]].push_back(u);
        inm[a[v]].push_back(v);
        ++cnt[a[u]];
        ++cnt[a[v]];
    }
    vector<char> used(n), usedm(match.size());
    vector<pair<int, int>> ans;
    for (int expected_cnt = 1; expected_cnt <= 2; expected_cnt++) {
        for (int i = 0; i < n; ++i) {
            if (used[i] || cnt[i] != expected_cnt) continue;
            vector<int> path;
            vector<pair<int, int>> edg;
            int st = i;
            while (true) {
                path.push_back(st);
                bool succ = false;
                for (auto &[to, j]: ng[st]) {
                    if (!used[to] and !usedm[j]) {
                        succ = true;
                        used[to] = true;
                        usedm[j] = true;
                        const auto &[u, v] = match[j];
                        edg.push_back(st == a[u] ? mp(u, v) : mp(v, u));
                        st = to;
                        break;
                    }
                }
                if (!succ) break;
            }

            if (path.back() != i) {
                for (auto &[to, j]: ng[path.back()]) {
                    if (to == i and !usedm[j]) {
                        auto [u, v] = match[j];
                        edg.push_back(a[u] != to ? mp(u, v) : mp(v, u));
                    }
                }
            }

            if (size(path) == 1) continue;
            if (size(path) == 2 and cnt[path[0]] == 1) {
                int x = edg[0].first;
                int y = edg[0].second;
                ans.emplace_back(y, ind[a[x]][0] ^ ind[a[x]][1] ^ x);
            } else if (cnt[path[0]] == 1) {
assert(cnt[path.back()] == 1);
                int x = edg[0].first;
                int y = edg.back().second;
                ans.emplace_back(y, ind[path[0]][0] ^ ind[path[0]][1] ^ x);
                //edg.pop_back();
                //edg.emplace_back(edg.back().second, x);
                edg.back().second = ind[path[0]][0] ^ ind[path[0]][1] ^ x;
                for (int i = 1; i < size(edg); ++i) {
                    assert(a[edg[i - 1].second] == a[edg[i].first]);
                }
                int l = 0, r = (int) size(edg) - 1;
                int f = 0;
                while (l < r) {
                    if (f == 0) {
                        ans.emplace_back(edg[l].first, edg[r].first);
                        --r;
                        f ^= 1;
                    } else {
                        ans.emplace_back(edg[l].second, edg[r].second);
                        ++l;
                        f ^= 1;
                    }
                }
            } else {
                for (int v: path) {
assert(cnt[v] == 2);
                }
                int l = 0, r = (int) size(edg) - 1;
                int f = 0;
                while (l < r) {
                    if (f == 0) {
                        ans.emplace_back(edg[l].first, edg[r].first);
                        --r;
                        f ^= 1;
                    } else {
                        ans.emplace_back(edg[l].second, edg[r].second);
                        ++l;
                        f ^= 1;
                    }
                }
            }
        }
    }
    assert(size(ans) <= n);
    cout << ans.size() << '\n';
    for (auto [i, j] : ans) {
        cout << i + 1 << ' ' << j + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}