#include <iostream>
#include <string.h>
#include <vector>
using namespace std;
typedef long long ll;
bool calc(vector<ll>& numL, vector<ll>& numR, vector<ll>& opL, vector<ll>& opR){
    ll sumL = numL[0], sumR = numR[0];
    for(int i = 0; i < opL.size(); i++){
        if(opL[i])
            sumL += numL[i+1];
        else
            sumL -= numL[i+1];
    }
    for(int i = 0; i < opR.size(); i++){
        if(opR[i])
            sumR += numR[i+1];
        else
            sumR -= numR[i+1];
    }
    //cout << sumL << " " << sumR << endl;
    return sumL==sumR;
}

bool read_str(char in[200]){
    vector<ll> numbersL, operationsL;
    numbersL.reserve(100);
    operationsL.reserve(100);
    int n = strlen(in);
    int last = 0;
    int i = 0;
    for(; i < n && in[i] != '='; i++){
        if(in[i] == '+' || in[i] == '-'){
            operationsL.push_back(in[i] == '+');
            in[i] == '\0';
            numbersL.push_back(stoll(in+last));
            last = i+1;
        }
    }
    numbersL.push_back(stoll(in+last));
    last = i + 1;
    vector<ll> numbersR, operationsR;
    numbersR.reserve(100);
    operationsR.reserve(100);
    for(; i < n && in[i]; i++){
        if(in[i] == '+' || in[i] == '-'){
            operationsR.push_back(in[i] == '+');
            in[i] == '\0';
            numbersR.push_back(stoll(in+last));
            last = i+1;
        }
    }
    numbersR.push_back(stoll(in+last));
    return calc(numbersL, numbersR, operationsL, operationsR);
}

int main()
{
    char in[200];
    cin >> in;

    int n = strlen(in);
    if(read_str(in)){
        cout << "Correct" << endl;
        return 0;
    }
    for(int i = 0; i < n; i++){
        if(in[i] < '0' || in[i] > '9')
            continue;
        char ch = in[i];
        if((in[i-1] < '0' || in[i-1] > '9') && (in[i+1] < '0' || in[i+1] > '9'))
            continue;
        for(int j = i-1; j >= 0; j--)
            in[j+1] = in[j];
        in[0] = ch;
        //cout << in << endl;
        if((ch != '0' || in[1] < '0' || in[1] > '9') && read_str(in)){
            cout << in << endl;
            return 0;
        }
        for(int j = 0; j < n-1; j++){
            swap(in[j+1],in[j]);
            //cout << in << endl;
            if(in[j] == '0'){
                if(j == 0 && !(in[j+1] < '0' || in[j+1] > '9'))
                    continue;
                if(j < n - 1 &&(in[j-1] < '0' || in[j-1] > '9') && !(in[j+1] < '0' || in[j+1] > '9'))
                    continue;
            }
        //cout << in << endl;
            if(in[j+1] == '0'){
                if(j < n - 2 &&(in[j] < '0' || in[j] > '9') && !(in[j+2] < '0' || in[j+2] > '9'))
                    continue;
            }
            //cout << in << endl;
            if(read_str(in)){
                cout << in << endl;
                return 0;
            }
        }
        for(int j = n-2; j >= i; j--)
            in[j+1] = in[j];
        in[i] = ch;
        //cout << in << endl;
    }
    cout << "Impossible" << endl;
}
