puzzle = input()

def val(s):
    a, b = s.split('=')
    if a.startswith('+') or a.startswith('-'): return False
    if b.startswith('+') or b.startswith('-'): return False
    if a.endswith('+') or a.endswith('-'): return False
    if b.endswith('+') or b.endswith('-'): return False
    for c in '++ +- -+ --'.split():
        if c in a or c in b: return False
    return eval(a) == eval(b)

def solve():
    if val(puzzle):
        return 'Correct'
    else:
        n = len(puzzle)
        for i in range(n):
            if not puzzle[i].isdigit(): continue
            for j in range(i+1, n+1):
                p = puzzle[:i] + puzzle[i+1:j] + puzzle[i] + puzzle[j:]
                try:
                    if val(p): return p
                except: pass
            for j in range(i):
                p = puzzle[:j] + puzzle[i] + puzzle[j:i] + puzzle[i+1:]
                try:
                    if val(p): return p
                except: pass
    return 'Impossible'

print(solve())
