#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define mp make_pair
#define ins insert
#define sz(x) (int)x.size()
#define ln "\n"
#define fi(a,b) for(auto i = a; i <= b; i++)
#define fj(a,b) for(auto j = a; j <= b; j++)
#define fo(a,b) for(auto o = a; o <= b; o++)

#define fdi(a,b) for(auto i = a; i >= b; i--)
#define fdj(a,b) for(auto j = a; j >= b; j--)
#define fdo(a,b) for(auto o = a; o >= b; o--)

#define All(x) x.begin(), x.end()
#define Allf(x) x.begin()+1, x.end()
#define fx(A) for(auto& x : A)
#define fy(A) for(auto& y : A)
#define fz(A) for(auto& z : A)

typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<vector<int>> vvi;
typedef vector<vector<ll>> vvll;
template <typename T>
ostream& operator<<(ostream& os, vector<T> v) {
	fz(v) {
		os << z << ' ';
	}
	return os;
}

template <typename T>
ostream& operator<<(ostream& os, set<T> v) {
	fz(v) {
		os << z << ' ';
	}
	return os;
}

template <typename T, typename V>
ostream& operator<<(ostream& os, pair<T,V> v) {
	os << "(" << v.first << ";" << v.second << ")";
	return os;
}


#ifdef LOCAL
	#define dbg(x) { cerr << __LINE__ << "\t" << #x << ": " << x << ln; }
#else
	#define dbg(x) {}
#endif
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define SET_TRUE  1
#define SET_FALSE  2
#define UNSET_TRUE  3
#define UNSET_FALSE  4

const int K = 5;
vector<vll>nodes(K+1);

ll n;
vector<vll>e;
ll S = -1, T = -1;
int q1 = 0;
int q2 = 0;

vll color;
void dfs(int x) {
	if(color[x]) return;
	color[x] = 1;
	fy(e[x]) {
		dfs(y);
	}
}
void add_edge(int x, int y) {
	e[x].pb(y);
}
bool flag = 1;
void dfs2(int x) {
	if(color[x]) return;
	color[x] = 1;
	fy(e[x]) {
		if(color[y] == 1) flag = 0;
		dfs2(y);
	}
	color[x] = 2;
	
}
vll ans;
void dfs3(int x) {
	if(color[x]) return;
	color[x] = 1;
	fy(e[x]) dfs3(y);
	
	ans.pb(x);
}

void topsort() {
	color = vll(n+1);
	flag = 1;
	fi(1, n) dfs2(i);
	if(!flag) {
		cout << -1 << ln;
		return;
	}
	color = vll(n+1);
	fi(1, n) dfs3(i);
	reverse(All(ans));
	fz(ans) {
		cout << z << ' ';
	}
	cout << ln;
	
}
void solve() {
	color = vll(n+1);
	if(q1 > 0) {
		fz(nodes[SET_FALSE]) {
			add_edge(S,z);
		}
	}
	if(q2 > 0) {
		fz(nodes[SET_FALSE]) {
			add_edge(z, T);
		}
	}
	
	if(q1 > 0 && q2 > 0) {
		if(q1 > 0) dfs(S);
		if(q2 > 0) dfs(T);
		if(q1 > 0 && q2 > 0) {
			add_edge(S,T);
		}
		fz(nodes[SET_FALSE]) {
			dfs(z);
		}
		fz(nodes[UNSET_FALSE]) {
			if(color[z]) {
				if(q2 > 0) {
					add_edge(T, z);
				}
			} else {
				if(q1 > 0) {
					add_edge(z, S);
				}
			}
		}
	} else {
		if(q2 == 0 && q1 > 0) {
			fz(nodes[UNSET_FALSE]) {
				add_edge(z, S);
			}
		} else {
			
		}
	}
	fi(1, n) {
		dbg(i);
		dbg(e[i]);
	}
	topsort();
	
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	cin >> n;
	e = vector<vll>(n+1);
	fi(1, n) {
		string a,b;
		cin >> a >> b;
		if(a == "set" && b == "true") {
			S = i;
			nodes[SET_TRUE].pb(i);
			q1++;
		}
		if(a == "set" && b == "false") {
			nodes[SET_FALSE].pb(i);
		}
		if(a == "unset" && b == "true") {
			T = i;
			q2++;
			nodes[UNSET_TRUE].pb(i);
		}
		if(a == "unset" && b == "false") {
			nodes[UNSET_FALSE].pb(i);
		}
	}
	int m;
	cin >> m;
	fi(1, m) {
		int x,y;
		cin >> x >> y;
		e[x].pb(y);
	}
	if(q2 == 2 || q1 == 2) {
		cout << -1 << ln;
		return 0;
	}
	if(q2 > 0 && q1 == 0) {
		cout << -1 << ln;
		return 0;
	}
	if(sz(nodes[SET_FALSE]) > 0 && q1 == 0) {
		cout << -1 << ln;
		return 0;
	}
	
	solve();
}