#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <utility>
#include <cmath>
#include <stack>
#include <deque>
#include <bitset>
#include <fstream>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <cstdint>

#define int long long

using namespace std;

const int MOD7 = (int)1e9 + 7;
const int MOD9 = (int)1e9 + 7;

int gcd(int a, int b) {
	return (b == 0 ? a : gcd(b, a % b));
}

int binPow(int x, int y) {
	if (y == 0) {
		return 1;
	}

	if (y % 2 == 0) {
		int t = binPow(x, y / 2);
		return t * t;
	}

	return x * binPow(x, y - 1);
}

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;

bool check(vector<string>& v, vll& sign) {
	ll val = 0;

	for (int i = 0; i < v.size(); ++i) {
		val += stoll(v[i]) * sign[i];
	}

	return (val == 0);
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	map<int, int> mp;
	for (int i = 0; i < n; i++)
		mp[v[i]] = i + n + 1;
	vector<pair<ll, ll>> ans, buf(n);
	for (int i = 0; i < n; i++)
		buf[i] = { i + 1,i + 1 };
	for (int i = 0; i < n; i++)
	{
		buf[0].second = mp[buf[0].first];
		int pos = 0;
		while (pos <n - 1 &&buf[pos].second > buf[pos + 1].second ) {
			ans.push_back({ buf[pos+1].first,buf[pos ].first });
			swap(buf[pos], buf[pos + 1]);
			pos++;
		}
	}
	cout << ans.size()<<'\n';
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i].first << ' ' << ans[i].second << '\n';
}