#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <utility>
#include <cmath>
#include <stack>
#include <deque>
#include <bitset>
#include <fstream>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <cstdint>

#define int long long

using namespace std;

const int MOD7 = (int)1e9 + 7;
const int MOD9 = (int)1e9 + 7;

int gcd(int a, int b) {
	return (b == 0 ? a : gcd(b, a % b));
}

int binPow(int x, int y) {
	if (y == 0) {
		return 1;
	}

	if (y % 2 == 0) {
		int t = binPow(x, y / 2);
		return t * t;
	}

	return x * binPow(x, y - 1);
}

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;

bool check(vector<string>& v, vll& sign) {
	ll val = 0;

	for (int i = 0; i < v.size(); ++i) {
		val += stoll(v[i]) * sign[i];
	}

	return (val == 0);
}

bool corr(string& s1, string& s2) {
	return (s1[0] != '0' || s1.size() == 1) && (s2[0] != '0' || s2.size() == 1) && (s1.size() <= 10) && (s2.size() <= 10);
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	string s;
	cin >> s;

	vector<string> v;
	vll sign;
	string tmp = "";
	ll cursign = 1;
	ll ind = 1;
	vector<char> ops;

	for (int i = 0; i < s.size(); ++i) {
		if (s[i] != '+' && s[i] != '-' && s[i] != '=') {
			tmp.push_back(s[i]);
		}
		else {
			v.push_back(tmp);
			sign.push_back(cursign * ind);
			ops.push_back(s[i]);

			if (s[i] == '-') {
				cursign = -1;
			}
			else if (s[i] == '+') {
				cursign = 1;
			}
			else {
				ind = -1;
				cursign = 1;
			}

			tmp.clear();
		}
	}

	v.push_back(tmp);
	sign.push_back(cursign * ind);

	if (check(v, sign)) {
		cout << "Correct";
		return 0;
	}

	for (int i = 0; i < v.size(); ++i) {
		for (int j = 0; j < v[i].size(); ++j) {
			if (v[i].size() > 1) {
				for (int i2 = 0; i2 < v.size(); ++i2) {
					for (int j2 = 0; j2 <= v[i2].size(); ++j2) {
						char f = v[i][j];
						bool flag = false;

						if (j2 < j && i == i2) {
							flag = true;
						}

						v[i2].insert(v[i2].begin() + j2, f);

						if (flag) {
							v[i].erase(v[i].begin() + j + 1);
						}
						else {
							v[i].erase(v[i].begin() + j);
						}

						if (corr(v[i], v[i2])) {
							if (check(v, sign)) {
								cout << v[0];

								for (int i = 1; i < v.size(); ++i) {
									cout << ops[i - 1] << v[i];
								}

								return 0;
							}
						}


						if (flag) {
							v[i].insert(v[i].begin() + j + 1, f);
						}
						else {
							v[i].insert(v[i].begin() + j, f);
						}

						v[i2].erase(v[i2].begin() + j2);
					}
				}
			}
		}
	}

	cout << "Impossible";
}