#include <bits/stdc++.h>

using namespace std;

template<class A, class B> inline void umin(A& a, B b) { if (b < a) a = b; }
template<class A, class B> inline void umax(A& a, B b) { if (b > a) a = b; }

void solve() {
    int n; cin >> n;
    string s[2];
    cin >> s[0] >> s[1];
    for (int i = 0; i < n; ++i) for (int j : {0, 1}) s[j][i] = s[j][i] == '.';
    auto dp = vector(n + 1, array<char, 4>{});
    dp[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 4; ++j) {
            if (dp[i][j] == 0) continue;
            auto cur = dp[i][j];
            int ms = (s[0][i]) + (s[1][i]) * 2;
            if (j == 3) {
                if (ms != 3) {
                    continue;
                }
                umin(dp[i + 1][0] += cur, 2);
            } else if (j == 1) {
                if (!(ms & 1)) {
                    continue;
                }
                ms ^= 1;
                umin(dp[i + 1][ms] += cur, 2);
            } else if (j == 2) {
                if (!(ms & 2)) {
                    continue;
                }
                ms ^= 2;
                umin(dp[i + 1][ms] += cur, 2);
            } else if (j == 0) {
                if (ms == 3) {
                    umin(dp[i + 1][0] += cur, 2);
                }
                umin(dp[i + 1][ms] += cur, 2);
            }
        }
    }
    int ans = dp[n][0];
    cout << (ans == 0 ? "None" : ans == 1 ? "Unique" : "Multiple") << '\n';
}

signed main() {
    int t = 1;
#ifdef KEK
    freopen("../input", "r", stdin);
    freopen("../output", "w", stdout);
    cin >> t;
#else
    cin.tie(0); cout.tie(0); std::ios::sync_with_stdio(false);
    cin >> t;
#endif
    for (int i = 0; i < t; ++i) {
        solve();
    }
}