#include <bits/stdc++.h>
//#define int long long
using namespace std;

vector<pair<int, int>> answer;
vector<int> colors;

void do_nghaaa(int i, int j) {
    answer.push_back({i, j});
    swap(colors[i], colors[j]);
}



void solve() {
    answer.clear();
    colors.clear();


    int n; cin >> n;
    vector<int> a(2 * n); for(int& i : a) {
        cin >> i;
        --i;
    }
    colors = a;
    vector<vector<int>> gr(2 * n);
    for (int i = 0; i < 2 * n - 1; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    vector<array<int, 2>> dp(2 * n);
    vector<int> pred(2 * n, -1);

    function<void(int, int)> dfs = [&](int v, int par) {
        dp[v] = {0, 0};
        pred[v] = -1;

        vector<array<int, 2>> interesting;
        for (auto u : gr[v]) {
            if (u == par) {
                continue;
            }
            dfs(u, v);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            interesting.push_back(array<int, 2>{dp[u][1] - dp[u][0], u});
        }
        dp[v][1] = dp[v][0];
        sort(interesting.begin(), interesting.end(), greater<>());
        if (interesting.empty()) {
            return;
        } else {
            auto [greatest_diff, best_u] = interesting[0];
            dp[v][1] += greatest_diff + 1;
            pred[v] = best_u;
        }
    };

    dfs(0, -1);
    vector<array<int, 2>> matching;

    function<void(int, int, bool)> restore_ans = [&](int v, int par, bool can_take) {
      if (!can_take || dp[v][0] >= dp[v][1]) {
          for (auto u : gr[v]) {
              if (u == par) {
                  continue;
              }
              restore_ans(u, v, true);
          }
      } else {
          matching.push_back(array{v, pred[v]});
          for (auto u : gr[v]) {
              if (u == par) {
                  continue;
              }
              if (u == pred[v]) {
                  restore_ans(u, v, false);
              } else {
                  restore_ans(u, v, true);
              }
          }
      }
    };
    restore_ans(0, -1, true);




    vector<pair<int, int>> pos(n, make_pair(-1, -1));
    for (int i = 0; i < 2 * n; i++) {
        int c = a[i];
        if (pos[c].first == -1)
            pos[c].first = i;
        else
            pos[c].second = i;
    }
    vector<int> where(n * 2);
    for (int c = 0; c < n; c++) {
        auto [i, j] = pos[c];
        where[i] = j;
        where[j] = i;
    }
    vector<int> paired(n * 2, -1);
    for (auto [i, j] : matching) {
        paired[i] = j;
        paired[j] = i;
    }

    // cerr << "where: ";
    // for (int i : where)
    //     cerr << i << " ";
    // cerr << "\n";
    // cerr << "paired: ";
    // for (int i : paired)
    //     cerr << i << " ";
    // cerr << "\n";


    vector<bool> used(n * 2);
    for (int i = 0; i < 2 * n; i++) {
        if (!used[i] && paired[i] == -1) {
            used[i] = true;
            int j = where[i];
            vector<pair<int, int>> edges;
            edges.push_back({i, i});
            int cnt = 0;
            for (; paired[j] != -1;) {
                // cerr << "i, j: " << i << " " << j << "\n";
                cnt++;
                int x = j;
                int y = paired[x];
                used[x] = used[y] = true;
                j = where[y];
                edges.push_back({x, y});
            }
            used[j] = true;
            edges.push_back({j, j});
            if (cnt == 0)
                continue;

            for (int k = (cnt - 1) / 2; k >= 0; k--) {
                int w = cnt - k;
                do_nghaaa(edges[k + 1].first, edges[w + 1].first);
                if (k == 0 && cnt % 2)
                    break;
                do_nghaaa(edges[k].second, edges[w + 1].second);
            }
        }
    }
    // cerr << answer.size() << "\n";
    for (int i = 0; i < 2 * n; i++) {
        if (!used[i]) {
            int x = i;
            int x2 = where[i];
            if (paired[x] == x2)
                continue;
            while (colors[x] != colors[paired[x]]) {
                used[x] = used[x2] = true;
                int y = paired[x2];
                int y2 = where[y];

                // cerr << "x, y, x2, y2: " << x << " " << y << " " << x2 << " " << y2 << "\n";

                do_nghaaa(x2, paired[x]);
                x = x2;
                x2 = y2;
            }
            used[x] = used[paired[x]] = true;
        }
    }

    cout << answer.size() << "\n";
    for (auto [i, j] : answer)
        cout << i + 1 << " " << j + 1 << "\n";
}

int32_t main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

#ifdef dimss
    freopen("test.txt", "r", stdin);
#endif

    int T; cin >> T;
    while (T--)
        solve();
    return 0;
}
