#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <sstream>
#include <cstring>
#include <numeric>
#include <ctime>
#include <unordered_map>
#include <unordered_set>

using namespace std;

vector<int> p;
int n;
vector < pair<int, int>> ans;
void not_doing(int a, int b) {
	if (a == b) {
		return;
	}
	for (int i = a + 1; i <= b; i++) {
		ans.push_back({ p[i], p[a] });
	}
	for (int i = b; i > a; i--) {
		ans.push_back({ p[a], p[i] });
	}
}

void solve() {
	int n;
	cin >> n;
	unordered_map<int, unordered_set<int>> was;
	vector<int> curr;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		p.push_back(t);
		curr.push_back(i + 1);
	}
	int i = 0;
	while (i < n) {
		if (curr[i] == p[i]) {
			i++;
		}
		if (i == n)
			break;
		int j = i;
		while (curr[j] != p[j]) {
			swap(curr[j], curr[j + 1]);
			ans.push_back({ curr[j], curr[j + 1] });
			was[curr[j]].insert(curr[j + 1]);
			j++;
		}
	}
	for (int l = 0; l < n; l++) {
		bool f = false;
		for (int r = l + 1; r < n; r++) {
			if (was[p[r]].count(p[l]) != 0 || was[p[l]].count(p[r]) != 0) {
				not_doing(l, r - 1);
				f = true;
				break;
			}
		}
		if (!f) {
			not_doing(l, n - 1);
		}
	}
	cout << ans.size() << "\n";
	for (auto x : ans) {
		cout << x.first << " " << x.second << "\n";
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}