from bisect import bisect, bisect_left, bisect_right
from collections import deque

def main():
    res = []
    h, e, q = map(int, input().split())
    ht = list(map(int, input().split()))
    hd = list(map(int, input().split()))
    ht_hd = sorted(zip(ht, hd), key=lambda x: (x[1], x[0]))
    ht = [i[0] for i in ht_hd]
    hd = [i[1] for i in ht_hd]
    et = list(map(int, input().split()))
    qt = list(map(int, input().split()))
    qt_itsh = sorted(zip(qt, list(range(len(qt)))), key=lambda x: x[0])
    qt = [i[0] for i in qt_itsh]
    itsh = [i[1] for i in qt_itsh]

    watched = 0
    may_spent_times = [float("inf")]
    for hd_idx in range(len(hd) - 1, -1, -1):
        may_spent_times.append(min(hd[hd_idx] - sum(ht[:hd_idx+1]), may_spent_times[-1]))
    may_spent_times = may_spent_times[1:][::-1]
    prev_time_to_spend = 0
    total_spent = 0
    for qt_item in qt:
        hd_right = min(bisect_left(hd, qt_item), len(hd) - 1)
        time_to_spend = may_spent_times[hd_right] - total_spent
        if hd[hd_right] < qt_item:
            time_to_spend += qt_item - hd[hd_right]
        while et:
            if time_to_spend < et[0]:
                break
            total_spent += et[0]
            time_to_spend -= et.pop(0)
            watched += 1
        res.append(watched)

    return [res[i] for i in itsh]


tests = int(input())
for _ in range(tests):
    print(*main())