#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

void sm(int &a, int b) {
    a += b;
    if (a > 2) {
        a = 2;
    }
}

int solve() {
    int n;
    cin >> n;
    string a, b;
    cin >> a >> b;

    auto check_mask = [&](int i, int mask)->bool {
        if (i < 0 || i >= n) return 0;
        if (a[i] == '#' && !(mask & 1)) return 0;
        if (b[i] == '#' && !(mask & 2)) return 0;
        if ((i + 1 < n && a[i + 1] == '#') && !(mask & 4)) return 0;
        if ((i + 1 < n && b[i + 1] == '#') && !(mask & 8)) return 0;
        return 1;
    };

    int M = 4;
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(2, vector<int>(2)));
    dp[0][0][0] = 1;
    for (int i = 0; i < n; i++) {
        // 0, 0
        if (a[i] == '.' && b[i] == '.') {
            sm(dp[i + 1][0][0], dp[i][0][0]);
            if (i + 1 < n && a[i + 1] == '.' && b[i + 1] == '.') {
                sm(dp[i + 2][0][0], dp[i][0][0]);
            }
        } else if (a[i] == '.' && b[i] == '#') {
            sm(dp[i + 1][0][0], dp[i][1][0]);
            sm(dp[i][0][1], dp[i][0][0]);
        } else if (a[i] == '#' && b[i] == '.') {
            sm(dp[i + 1][0][0], dp[i][0][1]);
            sm(dp[i][1][0], dp[i][0][0]);
        } else {
            sm(dp[i + 1][0][0], dp[i][0][0]);
        }
        if (i + 1 < n && a[i] == '.' && a[i + 1] == '.') {
            sm(dp[i + 1][1][0], dp[i][0][1]);
        }
        if (i + 1 < n && b[i] == '.' && b[i + 1] == '.') {
            sm(dp[i + 1][0][1], dp[i][1][0]);
        }
    }
    if (dp[n][0][0] == 0) {
        cout << "None\n";
    } else if (dp[n][0][0] == 1) {
        cout << "Unique\n";
    } else {
        cout << "Multiple\n";
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
