#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const N = 3e5 + 4;
int const inf = 1e9 + 7;
int const mod = 998244353;
ll const INF = 1e18; 

bool is_correct(const string& s) {
	ll val = 0;
	bool was_eq = 0;
	char sgn = '+';
	size_t l = 0;
	while (l < s.size()) {
		if (s[l] == '=') {
			was_eq = true;
			sgn = '+';
			++l;
			continue;
		}
		if (!isdigit(s[l])) {
			sgn = s[l];
			//cerr << sgn << '\n';
			++l;
			continue;
		}
		size_t r = l + 1;
		while (r < s.size() && isdigit(s[r])) {
			++r;
		}
		int len = r - l;
		if (len > 10 || (len > 1 && s[l] == '0')) return false;
		ll num = 0;
		while (l < r) {
			num = num * 10 + (s[l] - '0');
			++l;
		}
		val += num * ((sgn == '-') ^ was_eq ? -1 : 1);
	}		
	//cerr << val << '\n';
	return val == 0;
}

string solve() {
	string s;
	cin >> s;
	if (is_correct(s)) {
		return "Correct";
	}
	for (size_t i = 0; i < s.size(); ++i) {
		if (!isdigit(s[i])) continue;
		string t = s;
		t.erase(t.begin() + i);
		for (size_t j = 0; j < t.size(); ++j) {
			string ns = t;
			ns.insert(ns.begin() + j, s[i]);
			if (is_correct(ns)) {
				return ns;
			}
		}
	}
	return "Impossible";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	//cin >> t;
	while (t--) {
		cout << solve() << '\n';
	}
	return 0;
}