#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const N = 3e5 + 4;
int const inf = 1e9 + 7;
int const mod = 998244353;
ll const INF = 1e18; 

void solve() {
	int n;
	cin >> n;
	string s[2];
	cin >> s[0] >> s[1];
	int how[2][n];
	for (int i = 0; i < n; i++) how[0][i] = how[1][i] = 0;
	int tp = 0;
	for (int i = 0; i < n; i++) {
		if (s[0][i] == '#' && s[1][i] == '#') continue;
		else if (s[0][i] == '#' && s[1][i] == '.') {
			if (i == n-1 || s[1][i+1] == '#') {
				cout << "None\n";
				return;
			}
			s[1][i] = s[1][i+1] = '#';
		}
		else if (s[0][i] == '.' && s[1][i] == '#') {
			if (i == n-1 || s[0][i+1] == '#') {
				cout << "None\n";
				return;
			}
			s[0][i] = s[0][i+1] = '#';
		}
		else {
			if (i != n-1 && s[0][i+1] == '.' && s[1][i+1] == '.') tp = 1;
			s[0][i] = s[1][i] = '.';
		}
	}
	if (tp) cout << "Multiple\n";
	else cout << "Unique\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}