#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
	template <typename K, typename V, typename Comp = less<K>>
using rbt_map = tree<K, V, Comp, rb_tree_tag, tree_order_statistics_node_update>;
	template <typename K, typename Comp = less<K>>
using rbt_set = rbt_map<K, null_type, Comp>;
	template <typename T>
void relax_min(T& a, const T& b) {
	if (b < a) a = b;
}
	template <typename T>
void relax_max(T& a, const T& b) {
	if (a < b) a = b;
}


#define all(x) (x).begin(), (x).end()
#define ft first
#define sc second

ld const PI = acos(-1);
int const N = 3e5 + 4;
int const inf = 1e9 + 7;
int const mod = 998244353;
ll const INF = 1e18; 

vector<int> tr;
int sum(int i, int l, int r, int j) {
	if (j < l || r <= j) return 0;
	if (l+1 == r) return tr[i];
	int k = (l+r)/2;
	return tr[i] + sum(2*i+1, l, k, j) + sum(2*i+2, k, r, j);
}
void upd(int i, int l, int r, int ql, int qr, int v) {
	if (qr <= l || r <= ql) return;
	if (ql <= l && r <= qr) {
		tr[i] += v;
		return;
	}
	int k = (l+r)/2;
	upd(2*i+1, l, k, ql, qr, v);
	upd(2*i+2, k, r, ql, qr, v);
}

void solve() {
	int WW, HH;
	cin >> WW >> HH;
	int W[2], H[2], w[2], h[2], x[2], y[2], dx[2], dy[2];
	for (int i = 0; i < 2; i++) {
		cin >> w[i] >> h[i] >> x[i] >> y[i] >> dx[i] >> dy[i];
	}
	W[0] = WW-w[0];
	H[0] = HH-h[0];
	W[1] = WW-w[1];
	H[1] = HH-h[1];
	vector<tuple<int, int, int, int>> s[2];
	for (int i = 0; i < 2; i++) {
		s[i].emplace_back(x[i], y[i], dx[i], dy[i]);
	}
	auto check = [&]()->bool {
		int lx1 = x[0], rx1 = w[0]+x[0];
		int ly1 = y[0], ry1 = h[0]+y[0];
		int lx2 = x[1], rx2 = w[1]+x[1];
		int ly2 = y[1], ry2 = h[1]+y[1];
		if (rx1 <= lx2 || rx2 <= lx1 || ry1 <= ly2 || ry2 <= ly1) return 0;
		return 1;
	};
	auto mv = [&](int i)->void {
		if (x[i] == 0 && dx[i] == -1) {
			dx[i] = 1;
		}
		if (x[i] == W[i] && dx[i] == 1) {
			dx[i] = -1;
		}
		if (y[i] == 0 && dy[i] == -1) {
			dy[i] = 1;
		}
		if (y[i] == H[i] && dy[i] == 1) {
			dy[i] = -1;
		}
		x[i] += dx[i];
		y[i] += dy[i];
	};
	int fl0 = 0, fl1 = 0;
	while (!fl0 || !fl1) {
		mv(0);
		mv(1);
		// cout << x[0] << y[0] << " " << x[1] << y[1] << "\n";
		if (!fl0) s[0].emplace_back(x[0], y[0], dx[0], dy[0]);
		if (!fl1) s[1].emplace_back(x[1], y[1], dx[1], dy[1]);
		if (s[0].back() == s[0][0]) {
			fl0 = 1;
			s[0].pop_back();
		}
		if (s[1].back() == s[1][0]) {
			fl1 = 1;
			s[1].pop_back();
		}
	}
	int n[2];
	n[0] = s[0].size(); n[1] = s[1].size();
	int g = gcd(n[0], n[1]);
	ll ALL = (ll)n[0] * (ll)n[1] / g;
	ll ANS = 0;
	for (int ind = 0; ind < g; ind++) {
		// vector<pair<int, int>> p(n[1] / g);
		// vector<tuple<int, int, int, int>> r(n[0] / g);
		vector<tuple<int, int, int, int>> tos;
		map<int, int> cum;
		for (int i = ind; i < n[1]; i += g) {
			auto [x, y, dx, dy] = s[1][i];
			// p[i/g] = {x, y};
			tos.emplace_back(y, 0, x, 0);
			cum[x] = 0;
		}
		for (int i = ind; i < n[0]; i += g) {
			auto [x, y, dx, dy] = s[0][i];
			int lx = x-w[1]+1, rx = x+w[0];
			int ly = y-h[1]+1, ry = y+h[0]-1;
			// r[i/g] = {lx, rx, ly, ry};
			tos.emplace_back(ly, -1, lx, rx);
			tos.emplace_back(ry, 1, lx, rx);
			cum[lx] = 0;
			cum[rx] = 0;
		}
		int X = 0;
		for (auto &[a, b] : cum) b = X++;
		sort(all(tos));
		tr.assign(4*X, 0);
		for (auto &[Y, tp, x1, x2] : tos) {
			x1 = cum[x1];
			x2 = cum[x2];
			if (tp == -1) {
				upd(0, 0, X, x1, x2, 1);
			} else if (tp == 0) {
				ANS += sum(0, 0, X, x1);
			} else {
				upd(0, 0, X, x1, x2, -1);
			}
		}
	}
	ll G = gcd(ANS, ALL);
	cout << ANS / G << "/" << ALL / G << "\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	#ifdef LOCAL
	freopen("in", "r", stdin);
	freopen("out", "w", stdout);
	//cin >> t;
	#endif
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}

/*

2
3 3
1 1 1 1 1 1
1 1 1 1 1 -1
5 4
2 2 1 1 -1 -1
2 1 2 2 1 -1

*/