#include <iostream>
#include <iomanip>
#include <chrono>
#include <string>
#include <vector>
#include <algorithm>
#include <stdio.h>
#define ff first
#define ss second
#define all(v) v.begin(), v.end()

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<long long, long long>;



void test_case() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<pll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].ss;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].ff;
    }
    sort(all(a));
    vector<ll> l(m);
    for (int i = 0; i < m; i++) cin >> l[i];

    vector<ll> qus(q);
    for (int i = 0; i < q; i++) cin >> qus[i];

    vector<int> order(q);
    for (int i = 0; i < q; i++) {
        order[i] = i;
    }
    sort(all(order), [&](int i, int j) {
        return qus[i] < qus[j];
    });

    vector<ll> t(n);
    for (int i = n - 1; i >= 0; i--) {
        ll ded = a[i].ff;
        if (i < n - 1 && t[i + 1] < ded) ded = t[i + 1];
        t[i] = ded - a[i].ss;
    }

    int pl = 0, pt = 0;
    vector<ll> ans(q);
    ll sum = 0, sum_l = 0;
    for (int i : order) {
        int cur = qus[i];
        while (pt < n && t[pt] + a[pt].ss <= cur) {
            sum += a[pt].ss;
            pt++;
        }
        ll otr = cur - sum;
        if (pt < n && t[pt] < cur) otr -= (cur - t[pt]);

        while (pl < m && sum_l + l[pl] <= otr) {
            sum_l += l[pl];
            pl++;
        }

        ans[i] = pl;
    }

    for (ll i : ans) cout << i << " ";
    cout << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int t = 1;
    cin >> t;

    while (t--) {
        test_case();
    }
#ifdef LOCAL
    fprintf(stdout, "\n>>Runtime: %.3f ms\n", (double) (clock() - tStart) / CLOCKS_PER_SEC * 1000);
#endif
    return 0;
}
