def check(s):
    if len(s) == 0:
        return False

    if len(s) == 1:
        return s.isalnum()

    if not s[0].isalnum():
        return False

    if s[0] == '0' and s[1].isalnum():
        return False

    if not s[-1].isalnum():
        return False

    for i in range(1, len(s)):
        if not s[i - 1].isalnum() and not s[i].isalnum():
            return False

    for i in range(2, len(s)):
        if not s[i - 2].isalnum() and s[i - 1] == '0' and s[i].isalnum():
            return False

    cur = 0
    for i in range(len(s)):
        if s[i].isalnum():
            cur += 1
            if cur > 10:
                return False
        else:
            cur = 0

    return True


def solve():
    s = input().strip()
    a, b = s.split('=')
    if eval(a) == eval(b):
        return 'Correct'

    for i in range(len(s)):
        if s[i].isalnum():
            sFORi = s[:i] + s[i + 1:]
            for j in range(len(s)):
                newS = sFORi[:j] + s[i] + sFORi[j:]
                a, b = newS.split('=')
                if check(a) and check(b):
                    if eval(a) == eval(b):
                        return newS

    return 'Impossible'


print(solve())
