#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(v) v.begin(), v.end()

mt19937_64 rnd(228);

vector<bool> used;
ll n;
vector<vector<ll>> graph;

vector<ll> value;
ll ans = 0;
void dfs(ll v){
    used[v] = true;

    ans += value[v];

    for(auto &to : graph[v]){
        if(!used[to]){
            dfs(to);
        }
    }
}
ll node(ll i,ll j){
    return i * n + j;
}
void solve() {

    cin >> n;

    used.assign(n*2, false);
    graph.assign(n*2,{});
    value.assign(n*2,0);
    vector<vector<char>> a(2,vector<char>(n));
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];

            if(a[i][j] == '#'){
                continue;
            }


            ll v = node(i,j);

            value[v] = ((i + j) % 2 == 0 ? 1 : -1);


            if(i > 0 && a[i-1][j] == '.'){
                ll to = node(i-1,j);

                graph[v].push_back(to);
                graph[to].push_back(v);
            }
            if(j > 0 && a[i][j-1] == '.'){
                ll to = node(i,j-1);

                graph[v].push_back(to);
                graph[to].push_back(v);
            }
        }
    }

    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            ll v = node(i,j);
            if(a[i][j] == '#' || used[v]){
                continue;
            }

            ans = 0;
            dfs(v);

            if(ans != 0){
                cout << "None" << "\n";
                return;
            }
        }
    }

    ans = 0;

    a[0].insert(a[0].begin(),'#');
    a[1].insert(a[1].begin(),'#');

    n++;
    for (int i = 0; i < n - 2; ++i) {
        if(a[0][i] == '.'){
            ans += ((i ) % 2 == 0 ? 1 : -1);
        }
        if(a[1][i] == '.'){
            ans += ((i + 1) % 2 == 0 ? 1 : -1);
        }
        if(ans != 0){
            continue;
        }
        if(a[1][i+1] == '#'){
            continue;
        }
        if(a[1][i+2] == '#'){
            continue;
        }
        if(a[0][i+1] == '#'){
            continue;
        }
        if(a[0][i+2] == '#'){
            continue;
        }

        cout << "Multiple" << "\n";
        return;
    }
    cout << "Unique" << "\n";

}

int main() {
    ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);

    int t;
    cin >> t;

    for (int i = 0; i != t; ++i) {
        solve();
    }

    return 0;
}