#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stdlib.h>
#include <stdio.h>

//#define int long long
#define ll long long

bool mult = false;
using namespace std;

bool checkPossibility(vector<int> a, vector<int> b, int n){
    vector<pair<int, int>> aa(n);
    unordered_set<int> segments;
    int curr = 1;
    for(int i = 0; i < n; i++){
        if(a[i] == 1){
            aa[i] = {-1, -1};
            continue;
        }

        int cnt = 0;
        int start = i;
        while(i < n && a[i] == 0){
            cnt++;
            aa[i] = {curr, (i - start) % 2}; // 0 true
            i++;
        }
        i--;

        if(cnt % 2 != 0){
            segments.insert(curr);
        }
        curr++;
    }

    unordered_set<int> fixed;

    for(int i = 0; i < n; i++){
        int start = i;
        unordered_map<int, int> intersections;
        unordered_set<int> used;
        while(i < n && b[i] == 0){
            if(aa[i].first != -1) {
                if(used.count(aa[i].first) == 0 && (aa[i].second != 0 || (i - start) % 2 != 0)){
                    intersections[aa[i].first]--;
                }
                used.insert(aa[i].first);
                intersections[aa[i].first]++;
                if(segments.count(aa[i].first) > 0){
                    if(aa[i].second == 0 && (i - start) % 2 == 0){
                        fixed.insert(aa[i].first);
                    }
                }
            }
            i++;
        }

        for(pair<int, int> p : intersections){
            if(p.second >= 2){
                mult = true;
            }
        }
    }

    return segments.size() == fixed.size();
}

void solve() {
    mult = false;
    int n;
    cin >> n;

    vector<vector<int>> field(2, vector<int> (n));
    for(int i = 0; i < 2; i++){
        string s;
        cin >> s;
        for(int j = 0; j < n; j++){
            field[i][j] = s[j] == '.' ? 0 : 1;
        }
    }

    if(!checkPossibility(field[0], field[1], n) || !checkPossibility(field[1], field[0], n)){
        cout << "None" << "\n";
        return;
    }

    if(mult){
        cout << "Multiple" << "\n";
        return;
    }

    cout << "Unique" << "\n";


}

int main() {
    std:ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    for(int i = 0; i < t; i++){
        solve();
    }
    return 0;
}
