#include <bits/stdc++.h>
#pragma gcc optimize("O3, unroll-loops")
#pragma gcc target ("avx2")
using namespace std;

bool dig (char c)
{
    if (c >= '0' && c <= '9')
        return 1;
    else
        return 0;
}
bool zn (char c)
{
    if (c == '+' || c == '-' || c == '=')
        return 1;
    else
        return 0;
}

bool isCorrect(string s)
{
    if (!dig(s[0]) || (s[0] == '0' && dig(s[1])))
        return 0;

    int c = 0;
    for (int i = 0; i < s.size(); i++)
    {
        if (i > 0 && zn(s[i]) && zn(s[i-1]))
            return 0;

        if ((i < s.size() - 1 && dig(s[i+1])) && s[i] == '0' && ( i == 0 || !dig(s[i-1]) ))
            return 0;

        if (dig(s[i]))
            c++;

        if (c > 10)
            return 0;

        if (zn(s[i]))
            c = 0;
    }

    if (zn(s[s.size()-1]))
        return 0;

    return 1;
}

bool calc(string s)
{
    long long sign = 1;
    long long cur = 0, rez[2]{}, part = 0;
    for (int i = 0; i < s.size(); i++)
    {
        if (zn(s[i]))
        {
            rez[part] += sign * cur;
            cur = 0;

            sign = (s[i] != '-' ? 1 : -1);
        }

        if (dig(s[i]))
        {
            cur = cur * 10 + (int)(s[i] - '0');
        }

        if (s[i] == '=')
            part++;
    }
    rez[part] += sign * cur;


    return (rez[0] == rez[1]);
}

void solve()
{
    string s;
    cin >> s;

    //cout << isCorrect(s) << endl;
    //cout << calc(s) << endl;


    if (calc(s))
    {
        cout << "Correct";
        return;
    }

    //cout << isCorrect("123456789+987654321=1111111100+11-1") << endl;
    //cout << calc("123456789+987654321=1111111100+11-1") << endl;

    for (int i = 0; i < s.size(); i++)
    {
        if (!dig[i]) continue;

        for (int j = -1; j < (int)s.size(); j++)
        {
            string s1 = s;
            char c = s1[i];

            s1.erase(i, 1);
            if (j == -1)
            {
                s1 = c + s1;
            }
            else
            {
                s1.insert(j, 1, c);
            }

            //cout << s1 << endl;
            if (isCorrect(s1) && calc(s1))
            {
                cout << s1;
                return;
            }
        }
    }

    cout << "Impossible";
    return;
}
int main()
{
    ios_base::sync_with_stdio(false);
    +cin.tie(nullptr);
    int t = 1;
    while (t--)
    {
        solve();
        cout << "\n";
    }
    return 0;
}
/*
10
#.......##
##..#.##..


*/


