#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pll = array<ll,2>;
using pii = array<int, 2>;
#define all(x) x.begin(), x.end()

inline bool set_true(const pii& op) { return op[0] == 1 && op[1] == 1; }
inline bool set_false(const pii& op) { return op[0] == 1 && op[1] == 0; }
inline bool unset_true(const pii& op) { return op[0] == 0 && op[1] == 1; }
inline bool unset_false(const pii& op) { return op[0] == 0 && op[1] == 0; }

std::tuple<bool, vector<int>, vector<int>> solve(vector<int> current, auto cond, unordered_map<int, int>& next, vector<pii>& op, bool fail_if_none, bool fail_if_different) {
//failed, ans, next current
    vector<int> ans;
    vector<int> req, other;
    for (int i: current) {
        if (cond(op[i])) {
            req.push_back(i);
        } else {
            other.push_back(i);
        }
    }

    int o;
    while (!req.empty()) {
        o = req.back();
        if (fail_if_different && !cond(op[o])) {
            return {true, {}, {}};
        }
        req.pop_back();
        ans.push_back(o);
        if (next.count(o) != 0) {
            if (cond(op[next[o]])) {
                req.push_back(next[o]);
            } else {
                other.push_back(next[o]);
            }
        }
    }

    if (fail_if_none && ans.size() == 0) {
        return {true, {}, {}};
    }
    if (fail_if_different && other.size() != 0) {
        return {true, {}, {}};
    }
    return {false, ans, other};
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<pii> op(n);
    string op1, op2;
    int set = 0, unset = 0;
    for (int i = 0; i < n; ++i) {
        cin >> op1 >> op2;
        op[i][0] = op1 == "set";
        op[i][1] = op2 == "true";
        set += set_true(op[i]);
        unset += unset_true(op[i]);
    }
    // set - 1 unset - 0
    // true - 1 false - 0

    int m;
    cin >> m;
    unordered_map<int, int> next;
    unordered_set<int> deps;
    int a, b;
    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        --a;
        --b;
        deps.insert(b);
        next[a] = b;
    }

    if (set == 2 || (set == 0 && unset == 1) || (set == 0 && unset == 2)) {
        std::cout << -1 << endl;
        return 0;
        return 0;
    }
    assert((set + unset == 0 || (set == 1 && unset == 0) || (set == 1 && unset == 1)));

    vector<int> ans;
    if (set + unset == 0) {
        vector<int> cur;
        for (int i = 0; i < n; ++i) {
            if (deps.count(i) == 0) {
                cur.push_back(i);
            }
        }

        auto [failed, part_ans, cur2] = solve(cur, unset_false, next, op, false, true);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }
    } else if (set == 1 && unset == 0) {
        vector<int> cur;
        for (int i = 0; i < n; ++i) {
            if (deps.count(i) == 0) {
                cur.push_back(i);
            }
        }

        bool failed;
        vector<int> part_ans;

        std::tie(failed, part_ans, cur) = solve(cur, unset_false, next, op, false, false);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }

        std::tie(failed, part_ans, cur) = solve(cur, set_true, next, op, true, false);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }

        std::tie(failed, part_ans, cur) = solve(cur, set_false, next, op, false, true);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }

    } else if (set == 1 && unset == 1) {
               vector<int> cur;
        for (int i = 0; i < n; ++i) {
            if (deps.count(i) == 0) {
                cur.push_back(i);
            }
        }

        bool failed;
        vector<int> part_ans;

        std::tie(failed, part_ans, cur) = solve(cur, unset_false, next, op, false, false);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }

        std::tie(failed, part_ans, cur) = solve(cur, set_true, next, op, true, false);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }

        std::tie(failed, part_ans, cur) = solve(cur, set_false, next, op, false, false);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }

        std::tie(failed, part_ans, cur) = solve(cur, unset_true, next, op, true, false);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }

        std::tie(failed, part_ans, cur) = solve(cur, unset_false, next, op, false, true);
        if (failed) {
            cout << -1 << endl;
            return 0;
        }
        for (auto i: part_ans) {
            ans.push_back(i);
        }

    }

    for (auto i: ans) {
        std::cout << i + 1 << ' ';
    }
    std::cout << endl;
}