#include <bits/stdc++.h>

using namespace std;

int main() {

    int n;
    cin >> n;

    vector<pair<int, int>> a(n + 1);

    int cnt1 = 0;

    for(int i=1;i<=n;i++) {
        string s, t;
        cin >> s >> t;
        if (s == "set") a[i].first = 1;
        else a[i].first = 2;
        if (t == "false") a[i].second = 0;
        else a[i].second = 1;

        if (a[i].first == 1 && a[i].second == 1) cnt1++;
    }

    map<int, vector<int>> g;

    int m;
    cin >> m;

    set<int> op;

    for(int i=1;i<=n;i++)
        op.emplace(i);

    for(int i=0;i<m;i++) {
        int v, u;
        cin >> v >> u;

        g[v].emplace_back(u);
        op.erase(u);
    }

    if(cnt1 == 2) {
        cout << "-1\n";
        return 0;
    }

    vector<int> ans;
    vector<int> used(n + 1, 0);

    function<int(int, pair<int, int>)> dfs = [&] (int x, pair<int, int> tp) {
        if (used[x] == 1) return 0;
        if (a[x] == tp) {
            used[x] = 1;
            ans.emplace_back(x);
            op.erase(x);
            for (auto to: g[x]) {
                dfs(to, tp);
            }
            return 1;
        }
        else {
            op.emplace(x);
            return 0;
        }
    };

    bool good = 1;

    auto dop = op;
    for(auto x:dop) {
        dfs(x, make_pair(2, 0));
    }

    dop = op;
    int f = 0;
    for(auto x:dop) {
        f |= dfs(x, make_pair(1, 1));
        if (f == 1) break;
    }
    if (f == 0) good = 0;

    dop = op;
    for(auto x:dop) {
        if (good == 0) break;
        dfs(x, make_pair(1, 0));
    }
    dop = op;
    f = 0;
    for(auto x:dop) {
        if (good == 0) break;
        f |= dfs(x, make_pair(2, 1));
        if (f == 1) break;
    }
    if (f == 0) good = 0;

    dop = op;
    for(auto x:dop) {
        if (good == 0) break;
        dfs(x, make_pair(2, 0));
    }

    if (ans.size() != n) {
        cout << "-1\n";
        return 0;
    }

    for(auto x:ans) {
        cout << x << " ";
    }
    cout << endl;

    return 0;
}
