def correct_help(s):
    if len(s) == 0:
        return False
    sym = '+-'
    cur = 0
    if s[0] in sym:
        return False

    if s[-1] in sym:
        return False

    for i in range(len(s) - 1):
        if s[i] in sym and s[i + 1] in sym:
            return False

    for i in range(len(s)):
        if s[i] in sym:
            cur = 0
        else:
            cur += 1
        if cur > 10:
            return False
    return True

def correct(s):
    a, b = s.split('=')
    return correct_help(a) and correct_help(b)

def eval_s(s):
    s = s.replace("=", "==")
    try:
        return eval(s)
    except:
        return False

def main():
    s = input()

    if eval_s(s):
        print("Correct")
        return

    for i in range(len(s)):
        if s[i] == '-' or s[i] == '+' or s[i] == '=':
            continue
        t = s[:i] + s[i + 1:]
        for j in range(len(t)):
            k = t[:j] + s[i] + t[j:]

            if not correct(k):
                continue

            if eval_s(k):
                print(k)
                return

    print("Impossible")

main()