#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <string>

#define ll long long;
#define nl "\n";

const int N = 1e5 + 10;

using namespace std;

vector<int> g[N];
bool dependon[N], vis[N], ok[N], setop[N];
int in[N];
int settrue = -1, unsettrue = -1;

signed main()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	vector<int> ans;
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		string s1, s2;
		cin >> s1 >> s2;

		if (s1 == "set") setop[i] = 1;
		if (s2 == "true") {
			if (s1 == "set") {
				settrue = i;
			}
			else {
				unsettrue = i;
			}
		}
	}

	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[u].push_back(v);
		in[v]++;
	}

	set<int> openedset, openedunset;
	for (int i = 0; i < n; i++) {
		if (in[i] == 0) {
			if (!setop[i]) {
				if (i != unsettrue) openedunset.insert(i);
			}
		}
	}
	
	while (openedunset.size()) {
		int now = *openedunset.begin();
		openedunset.erase(openedunset.begin());
		ok[now] = 1;
		ans.push_back(now);

		for (int i : g[now]) {
			in[i]--;
			if (in[i] == 0 && !setop[i] && i != unsettrue) {
				openedunset.insert(i);
			}
		}
	}

	bool state = false;

	if (settrue > -1 && in[settrue] == 0) {
		ok[settrue] = 1;
		ans.push_back(settrue);
		state = true;
		for (int i : g[settrue]) {
			in[i]--;
		}
		for (int i = 0; i < n; i++) {
			if (in[i] == 0 && setop[i] && !ok[i]) {
				openedset.insert(i);
			}
		}

		while (openedset.size()) {
			int now = *openedset.begin();
			openedset.erase(openedset.begin());
			ok[now] = 1;
			ans.push_back(now);

			for (int i : g[now]) {
				in[i]--;
				if (in[i] == 0 && setop[i] && !ok[i]) {
					openedset.insert(i);
				}
			}
		}

		if (unsettrue > -1 && in[unsettrue] == 0) {
			for (int i : g[unsettrue]) {
				in[i]--;
			}
			ok[unsettrue] = 1;
			ans.push_back(unsettrue);
			state = false;
		}
	}

	if (!state) {
		for (int i = 0; i < n; i++) {
			if (!ok[i] && in[i] == 0 && !setop[i]) {
				openedunset.insert(i);
			}
		}

		while (openedunset.size()) {
			int now = *openedunset.begin();
			openedunset.erase(openedunset.begin());
			ok[now] = 1;
			ans.push_back(now);

			for (int i : g[now]) {
				in[i]--;
				if (in[i] == 0 && !setop[i] && !ok[i]) {
					openedunset.insert(i);
				}
			}
		}
	}

	bool res = 1;
	for (int i = 0; i < n; i++) {
		if (!ok[i]) res = 0;
	}


	if (res == 0) {
		cout << -1 << nl;
	}
	else {
		for (int i = 0; i < n; i++) {
			cout << ans[i] + 1 << (i == n - 1 ? "" : " ");
		}
	}

	return 0;
}