#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>
#include <string>

#define ll long long;
#define nl "\n";

using namespace std;

void solve() {
	long long n, m, q;
	cin >> n >> m >> q;
	vector<pair<long long, long long>> tasks(n);
	vector<pair<long long, long long>> tasks1(n);
	vector<long long> a(n);
	for (long long i = 0; i < n; i++) cin >> a[i];
	vector<long long> d(n);
	for (long long i = 0; i < n; i++) cin >> d[i];

	for (long long i = 0; i < n; i++) {
		tasks1[i] = { d[i], a[i] };
	}
	sort(tasks1.begin(), tasks1.end());

	long long right = 1e17;
	for (long long i = n - 1; i >= 0; i--) {
		long long nowright = min(right, tasks1[i].first);
		tasks[i] = { nowright - tasks1[i].second + 1, nowright };
		right = tasks[i].first - 1;
	}
	sort(tasks.begin(), tasks.end());

	vector<long long> l(m);
	for (long long i = 0; i < m; i++) {
		cin >> l[i];
		if (i > 0) l[i] += l[i - 1];
	}
	multiset<pair<long long, int>> t;
	for (long long i = 0; i < q; i++) {
		long long num;
		cin >> num;
		t.insert({ num, i });
	}
	long long sum_used = 0;
	long long indinterrupt = 0;

	vector<long long> res(q);
	for (auto p : t) {
		long long taskend = p.first;
		long long currtask = p.second;

		while (indinterrupt < n && tasks[indinterrupt].second <= taskend) {
			sum_used += tasks[indinterrupt].second - tasks[indinterrupt].first + 1;
			indinterrupt++;
		}

		long long right = taskend + 1;
		if (indinterrupt < n) {
			right = min(right, tasks[indinterrupt].first);
		}
		long long space = right - sum_used - 1;
		long long l1 = 0, r1 = m;
		while (l1 < r1) {
			long long m1 = (l1 + r1 + 1) / 2;

			long long summ = m1 == 0 ? 0 : l[m1 - 1];
			if (summ <= space) {
				l1 = m1;
			}
			else {
				r1 = m1 - 1;
			}
		}
		res[currtask] = l1;
	}

	for (long long i = 0; i < q; i++) {
		cout << res[i] << (i == q - 1 ? "" : " ");
	}
	cout << nl;
}

signed main()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}