#include<bits/stdc++.h>
using namespace std;
 
#define ll long long
#define all(x) (x).begin(), (x).end()
#define int long long
bool validate(string s) {
    int n = s.size();
    for (int i = 0; i < n; i++) {
        if (s[i] == '0') {
            if (i + 1 < n && '0' <= s[i + 1] && s[i + 1] <= '9') {
                return false;
            }
        }
    }
    return true;
}
 
struct comp {
    static bool operator() (pair<int,int> i1, pair<int, int> i2) {
        if (i1.second - i1.first != i2.second - i2.first) {
                return i1.second - i1.first < i2.second - i2.first;
            }
            if (i2.second != i1.second) {
                return i1.second < i2.second;
            }
            return i1.first > i2.first;
    }
};
 
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    vector<int> ans;
    vector<bool> used;
    int T = 1;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        int m;
        cin >> m;
        int q;
        cin >> q;
        vector<int> a(n);
        vector<int> d(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        for (int i = 0; i < n; i++)  {
            cin >> d[i];
        }
        vector<int> l(m);
        for (int i = 0; i < m; i++) {
            cin >> l[i];
        }
        vector<int> ans(m);
        multiset<pair<int, int>, comp> st;
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int i, int j) { 
            return comp::operator()({a[i], d[i]}, {a[j], d[j]});
        });
        for (auto& i : ord) {
            st.insert({a[i], d[i]});
        }
        int j = 0;
        int sub = 0;
        int cur_time = 0;
        while (j < m && st.size() > 0) {
            if (!st.empty()) {
                while (j < m && st.begin()->second - st.begin()->first - cur_time - l[j] >= 0) {
                    cur_time += l[j];
                    ans[j] = cur_time;
                    j++;
                }
            cur_time += st.begin()->first;
            st.erase(st.begin());
            }
        }
        // if (j == m && st.size() > 0) {
        //     cur_time += a[st.begin()->first];
        //     st.erase(st.begin());
        // }
        while (j < m && st.size() == 0) {
            cur_time += l[j];
            ans[j] = cur_time;
            j++;
        }
        for (int i = 0; i < q; i++) {
            int t;
            cin >> t;
            auto it = upper_bound(ans.begin(), ans.end(), t);
            if (it == ans.end()) {
                cout << m << ' ';
            } else {
                cout << it - ans.begin() << ' ';
            }
        }
        cout << endl;
    } 
}