#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()

vector<vector<int> > g;
vector<int> a;
vector<vector<int> > dp;
vector<int> p;

void dfs(int v, int pr) {
    int sum1 = 0, sum0 = 0, summax = 0;
    for (auto i : g[v]) {
        if (i != pr)  dfs(i, v);
        sum1 += dp[i][1];
        sum0 += dp[i][0];
        summax += max(dp[i][0], dp[i][1]);
    }
    for (auto i : g[v]) {
        if (i != pr) {
            dp[v][0] += max(dp[i][0], dp[i][1]);
            if (dp[v][1] < dp[i][0] + summax - max(dp[i][0], dp[i][1]) + 1) {
                dp[v][1] = dp[i][0] + summax - max(dp[i][0], dp[i][1]) + 1;
                p[v] = i;
            }
        }
    }
}
vector<pair<int, int> > otr;
void vost(int v, int pr, int st) {
    if (st == 0) {
        for (auto i : g[v]) {
            if (i != pr) vost(i, v, 1);
        }
    } else {
        if (p[v] == -1) return;
        otr.push_back({v, p[v]});
        vost(p[v], v, 0);
        for (auto i : g[v]) {
            if (i != pr && i != p[v]) {
                if (dp[i][0] > dp[i][1]) {
                    vost(i, v, 0);
                } else {
                    vost(i, v, 1);
                }
            }
        }
    }
}
void solve() {
    int n;
    cin >> n;
    g.clear();
    g.resize(2 * n + 1);
    a.clear();
    a.resize(2 * n + 1);
    vector<set<int> > pos(n + 1);
    vector<bool> used(2 * n + 1, 0);
    vector<pair<int, int> > ans;
    for (int i = 1; i <= 2 * n; i++) {
        cin >> a[i];
        pos[a[i]].insert(i);
    }
    for (int i = 1; i < 2 * n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dp.clear();
    dp.resize(2 * n + 1, vector<int>(2, 0));
    p.clear();
    p.resize(2 * n + 1, -1);
    otr.clear();
    dfs(1, 1);
    if (dp[1][0] > dp[1][1]) vost(1, 1, 0);
    else vost(1, 1, 1);
    int ll1 = 0;
    for (auto [l, r] : otr) {
        if (a[l] == a[r]) continue; 
        for(;;) {
            ll1++;
        }
        if (used[l]) {
            int col = a[l];
            int u = r;
            int v = (l == (*pos[col].begin())) ? *(++pos[col].begin()) : (*pos[col].begin());
            pos[col].erase(v);
            pos[a[r]].erase(u);
            pos[col].insert(u);
            pos[a[r]].insert(v);
            swap(a[u], a[v]);
            for (;;) {
                ll1++;
            }
            used[u] = 1;
            used[v] = 1;
            if (u != v) {
                ans.push_back({u, v});
            }
        } else {
            int col = a[r];
            int u = l;
            int v = (r == *pos[col].begin()) ? *(++pos[col].begin()) : (*pos[col].begin());
            pos[col].erase(v);
            pos[a[l]].erase(u);
            pos[col].insert(u);
            pos[a[l]].insert(v);
            swap(a[u], a[v]);
            for (;;) {
                ll1++;
            }
            used[u] = 1;
            used[v] = 1;
            if (u != v) {
            ans.push_back({u, v});
            }
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans) {
        cout << i.first << " " << i.second << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    } 
}
