#include <iostream>
#include <bits/stdc++.h>

using namespace std;

template <typename T>
ostream &operator<<(ostream &ostr, vector <T> &v){
    for (T& elem : v){
        ostr << v << ' ';
    }
    return ostr;
}

template <typename T>
istream &operator>>(istream &istr, vector <T> &v){
    for (T &elem : v){
        istr >> elem;
    }
    return istr;
}

bool Dset(bool &x){
    return !x ? true : false;
}

bool Dunset(bool &x){
    return x;
}

int main() {
    int n;
    cin >> n;
    vector <int> v(n);
    vector <int> src(n);
    cin >> src;
//    cin >> v;
    for (int i = 0; i < n; i++)
        v[i] = i+1;
    map <int, bool> mp;

    vector <vector <bool> > used(n+1, vector <bool> (n+1));
    vector <pair<int, int> > result;
    for (int i = 0; i < n; i++){
        int index = 0;
        int resIndex = 0;
        bool inRight;
        int maxDistance = 0;
        for (int j = 1; j <= n; j++){
            int fP = std::find(v.begin(), v.end(), j+1) - v.begin();
            int sP = std::find(src.begin(), src.end(),j+1) - src.begin();
            int distance = abs(fP - sP);
            if (distance > maxDistance){
                maxDistance = distance;
                index = fP;
                resIndex = sP;
                inRight = sP > fP;
            }
        }
        for (int j = index; j != resIndex; inRight ? j++ : j--){
            int fP = j;
            int sP = j + (inRight ? 1 : -1);

            int hash1 = v[fP]*1000+v[sP];
            mp[hash1] = true;
            if (inRight)
                result.emplace_back(v[sP], v[fP]);
            else
                result.emplace_back(v[fP], v[sP]);
            swap(v[fP], v[sP]);
        }
    }

    stack <pair<int, int>> st;
    vector <pair<int, int> > fullAnswer;
    for (int i = 0; i < n; i++) {
        v[i] = i+1;
    }
    for (auto &[el1, el2] : result){
        for (int i = 0; i < n-1; i++){
            int index = i;
            int srcElem = v[i];
            while (index + 1 < n && !mp[srcElem*1000+v[index+1]] && !mp[v[index+1]*1000+srcElem]){
                st.emplace(v[index+1], srcElem);
                fullAnswer.emplace_back(v[index+1], srcElem);
                mp[srcElem*1000+v[index+1]] = mp[v[index+1]*1000+srcElem] = true;
                index++;
            }
            while (!st.empty()){
                auto [f, s] = st.top();
                st.pop();
                fullAnswer.emplace_back(s, f);
            }
        }
        fullAnswer.emplace_back(el1, el2);
    }
    for (int i = 0; i < n-1; i++){
        int index = i;
        int srcElem = v[i];
        while (index + 1 < n && !mp[srcElem*1000+v[index+1]] && !mp[v[index+1]*1000+srcElem]){
            st.emplace(v[index+1], srcElem);
            fullAnswer.emplace_back(v[index+1], srcElem);
            mp[srcElem*1000+v[index+1]] = mp[v[index+1]*1000+srcElem] = true;
            index++;
        }
        while (!st.empty()){
            auto [f, s] = st.top();
            st.pop();
            fullAnswer.emplace_back(s, f);
        }
    }
//    for (int i = 0; i < n-1; i++){
//        int index = i;
//        int srcElem = v[i];
//        while (index + 1 < n && !mp[srcElem*1000+v[index+1]] && !mp[v[index+1]*1000+srcElem]){
//            st.emplace(v[index+1], srcElem);
//            result.emplace_back(v[index+1], srcElem);
//
//            index++;
//        }
//        while (!st.empty()){
//            auto [f, s] = st.top();
//            st.pop();
//            result.emplace_back(s, f);
//        }
//    }

    cout << fullAnswer.size() << '\n';
    for (auto [f, s] : fullAnswer){
        cout << f << ' ' << s << '\n';
    }
    return 0;
}
