#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define f(i, a) for(int i = 0; i < (int)a; i++)
#define F(i, b, a) for(int i = b; i <= (int)a; i++)
#define vi vector<int>

const int mod = 1e9 + 7;
const double eps = 1e-10;
const double PI = acos(-1);
const int SZ = 1e5 + 5;
const int maxN = 1e5 + 5;
int types[maxN];
bool res[maxN];
vi g[maxN];
int cnt[maxN];
#define SET 1
#define UNSET 0

class comp1 {
	bool operator()(int l, int r) {
		if (cnt[l] == cnt[r]) return types[l] < types[r];
		return cnt[l] < cnt[r];
	}
};

class comp2 {
	bool operator()(int l, int r) {
		if (cnt[l] == cnt[r]) return types[l] > types[r];
		return cnt[l] < cnt[r];
	}
};

set<pair<pair<int, int>, int>> sfalse;// comp1
set<pair<pair<int, int>, int>> strue; // comp2
vector<int> ans;
void del(int v) {
	// cout << "cnt[" << v << "] = " << cnt[v] << " types[" << v << "] = " << types[v] << endl;
	// cout << "add " << v << " to ans " << endl;
	ans.push_back(v);
	sfalse.erase({{cnt[v], types[v]}, v});
	strue.erase({{cnt[v], -types[v]}, v});
	for (auto to : g[v]) {
		sfalse.erase({{cnt[to], types[to]}, to});
		strue.erase({{cnt[to], -types[to]}, to});
		cnt[to]--;
		sfalse.insert({{cnt[to], types[to]}, to});
		strue.insert({{cnt[to], -types[to]}, to});
	}
}

bool check(vector<int>& ans) {
	int cur = false;
	for (auto x : ans) {
		int typ = types[x];
		bool re = res[x];
		if (typ == SET) {
			if (re == true && cur == false) {
				cur = true;
			}  else if (re == true) {
				return false;
			}
		} else if (typ == UNSET) {
			if (re == true && cur == true) {
				cur = false;
			} else if (re == true ) {
				return false;
			}
		}
	}
	return true;
}

void solve(){
	int n;
	cin >> n;
	int st = 0;
	int stfirst = 0;
	int ut = 0;
	int utfirst = 0;
	for (int i = 1; i <= n; i++) {
		string type, rr;
		cin >> type >> rr;
		bool r = false;
		if (rr == "true") {
			r = true;
		}
		res[i] = r;
		int t = 0;
		if (type == "set") {
			t = 1;
		}
		types[i] = t;
		if (types[i] == SET && res[i] == true) {
			st++;
			stfirst = i;
		}
		if (types[i] == UNSET && res[i] == true) {
			ut++;
			utfirst = i;
		}
	}
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int a,b;
		cin >> a >> b;
		g[a].pb(b);
		cnt[b]++;
	}
	if (ut > 1) {
		cout << "-1"; return;
	} 
	if (st > 1) {
		cout << "-1"; return;
	}

	bool cur = false;
	for (int i = 1; i <= n; i++) {
		sfalse.insert({{cnt[i], types[i]}, i});
		strue.insert({{cnt[i], -types[i]}, i});
	}

	while(sfalse.size() > 0) {
		int curv = sfalse.begin() -> second;
		if (types[curv] == SET || cnt[curv] != 0 || res[curv] == true) {
			break;
		} 

		// cout << "now check 1 " << curv << endl;
		del(curv);
	}

	if (st != 0) {
		st--;
		if (cnt[stfirst] != 0) {
			cout << -1; return;
		}
		del(stfirst);
	} else {
		if (strue.size() != 0) {
			cout << -1; return;
		}
	}

	while(strue.size() > 0) {
		int curv = (strue.begin()) -> second;
		if (types[curv] == UNSET || cnt[curv] != 0 || res[curv] == true) {
			break;
		} 
		// cout << "now check 2" << curv << endl;
		del(curv);
	}

	if (ut != 0) {
		ut--;
		if (cnt[utfirst] != 0) {
			cout << -1; return;
		}
		del(utfirst);
	// cout << "make cur = " << false << endl;
	}


	while(sfalse.size() > 0) {
		int curv = (sfalse.begin()) -> second;
		if (types[curv] == SET || cnt[curv] != 0 || res[curv] == true) {
			break;
		}
		// cout << "now check 3" << curv << endl;
		del(curv);

	}
	// cout << strue.size() << " " << sfalse.size() << endl;
	if (strue.size() != 0 || sfalse.size() != 0) {
		cout << -1; return;
	}
	if (ans.size() != n) {
		cout << -1; return;
	}
	if(check(ans) == false) {
		cout << -1; return;
	}

	for (auto x:  ans) cout << x << " ";
}

signed main(){
	#ifdef LOCAL
	freopen("ind", "r", stdin);
	// freopen("out", "w", stdout);
	#endif
	int t = 1;
	// cin >> t;
	while(t--){
		solve();
		cout << '\n';
	}

}