#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define f(i, a) for(int i = 0; i < (int)a; i++)
#define F(i, b, a) for(int i = b; i <= (int)a; i++)


const int mod = 1e9 + 7;
const double eps = 1e-10;
const double PI = acos(-1);
const int SZ = 1e5 + 5;

bool valid(string s) {
	// cout << "valid for " << s << endl;

	s += "+";
	int n = s.size();

	if (s[n - 2] < '0' || s[n - 2] > '9') return false;
	int last = -1;
	for (int i = 0; i < n; i++) {
		if (s[i] == '-' || s[i] == '+') {
			int len = i - last - 1;
			if (len > 1 && s[last + 1] == '0') return false;
			if (len > 10 || (len == 0 && last != -1)) return false;
			last = i; 
		}
	}
	return true;
}

long long eval(string s) {
	long long ans = 0;
	vector<int> pos;
	int n = s.size();
	for (int i = 0; i < n; i++) {
		if (s[i] == '-' || s[i] == '+') pos.push_back(i);
	}
	pos.push_back(n);
	ans = pos[0] != 0 ? stoll(s.substr(0, pos[0])) : 0;
	for (int i = 1; i < pos.size(); i++) {
		int dig = pos[i];
		long long cur = stoll(s.substr(pos[i - 1] + 1, pos[i] - pos[i - 1] - 1));
		if (s[pos[i - 1]] == '-') cur *= -1;
		// cout << "cur = " << cur << endl;
		ans += cur;
	}
	return ans;
}

bool check(string s) {
	// cout << "call check for " << s << endl;
	int n = s.size();

	int cur = s.find("=");
	string l = s.substr(0, cur);
	string r = s.substr(cur + 1);
	// cout << l << " " << r << endl;
	// cout << valid(l) << " " << valid(r) << endl;
	if (valid(l) == false || valid(r) == false) return false;
	long long left = eval(l);
	long long right = eval(r);
	// cout << "left = " << left << endl;
	// cout << "right = " << right << endl;
	return left == right;
	return false;
}

string sw(string s, int i, int j) {
	// cout << "start sw " << i << " " << j << endl;
	string l = s.substr(0, i);
	string cur = s.substr(i, 1);
	string r = s.substr(i + 1);
	if (i < j) j--;

	s = l + r;

	l = s.substr(0, j);
	r = s.substr(j);
	return l + cur + r;
	// cout << "end sw " << i << " " << j << endl;
}

void solve(){
	string s;
	cin >> s;
	int n = s.size();
	if (check(s)) {
		cout << "Correct" << endl;
		return;
	}
	for (int i = 0; i < n; i++) {
		for(int j = 0; j <= n; j++) {
			if (i == j) continue;
			string cur = sw(s, i, j);
			
			if (check(cur) == true) {
				cout << cur << endl;
				return;
			}
		}
	}
	cout << "Impossible" << endl;
}

signed main(){
	#ifdef LOCAL
	freopen("ine", "r", stdin);
	// freopen("out", "w", stdout);
	#endif
	int t = 1;
	// cin >> t;
	while(t--){
		solve();
		cout << '\n';
	}

}