#include <iostream>
#include <vector>
#include <array>
#include <string>

using namespace std;

#define int long long
void read(vector<int>& a) {
	for (int i = 0; i < a.size(); ++i) {
		cin >> a[i];
	}
}
void print(const vector<int>& a) {
	for (int i = 0; i < a.size(); ++i) {
		cout << a[i] << " ";
	}
	cout << endl;
}


void solveA() {
	int a[1000], b[1000], c[1000];
	int n;

	bool swapped[1000][1000];

	cin >> n;

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	for (int i = 0; i < n; i++) {
		c[a[i] - 1] = i;
	}

	vector<pair<int, int>> v;

	int s = 0;
	for (int i = 0; i < n; ++i) {
		b[i] = i;
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n - 1; ++j) {
			if (c[b[j]] > c[b[j + 1]]) {
				v.push_back({ b[j + 1] + 1, b[j] + 1 });
				swap(b[j], b[j + 1]);
				swapped[b[j]][b[j + 1]] = 1;
				swapped[b[j + 1]][b[j]] = 1;
			}
		}
	}

	for (int i = 1; i < n; ++i) {
		int p = i;
		while (p > 0 && !swapped[b[p]][b[p - 1]]) {
			v.push_back({ b[p] + 1, b[p - 1] + 1 });
			swapped[b[p]][b[p - 1]] = 1;
			swapped[b[p - 1]][b[p]] = 1;
			swap(b[p], b[p - 1]);
			//cout << p << endl;
			--p;
		}

		//cout << endl;

		while (p < i) {
			++p;
			v.push_back({ b[p] + 1, b[p - 1] + 1 });
			swap(b[p], b[p - 1]);
			//cout << p << " " << p - 1 << endl;
		}
	}

	cout << v.size() << endl;
	for (auto& x : v) {
		cout << x.first << " " << x.second << endl;
	}
}

bool cmp(const pair<int, int>& a, const pair<int, int>& b) {
	return a.second < b.second;
}

bool cmp1(const pair<pair<int, int>, int>& a, const pair<pair<int, int>, int>& b) {
	return a.first.second < b.first.second;
}

bool cmp2(const pair<pair<int, int>, int>& a, const pair<pair<int, int>, int>& b) {
	return a.second < b.second;
}

void solveJ() {
	int test; cin >> test;
	for (; test > 0; test--) {
		int n, m, q; cin >> n >> m >> q;
		
		vector<int> a(n), d(n), l(m), t(q);
		read(a);
		read(d);
		read(l);
		read(t);
		// Solution

		vector<pair<int, int>> opt(n);
		for (int i = 0; i < n; ++i) {
			opt[i].first = i;
			opt[i].second = d[i] - a[i];
		}
		sort(opt.begin(), opt.end(), cmp);

		vector<pair<pair<int, int>, int>> epis;
		for (int i = 0; i < q; ++i) {
			epis.push_back({ { 0, t[i] }, i });
		}

		sort(epis.begin(), epis.end(), cmp1);

		int numEpis = 0, time = 0, numHome = 0, numZvon = 0;
		while (numEpis < m) {
			while (numEpis < m && (numHome == n || time + l[numEpis] <= opt[numHome].second)) {
				while (numZvon < q && epis[numZvon].first.second >= time && epis[numZvon].first.second < time + l[numEpis]) {
					epis[numZvon].first.first = numEpis;
					++numZvon;
				}
				time += l[numEpis];
				++numEpis;
			}
			while (numHome < n && numZvon < q && numEpis < m && epis[numZvon].first.second >= time && epis[numZvon].first.second < time + a[opt[numHome].first]) {
				epis[numZvon].first.first = numEpis;
				++numZvon;
			}
			if (numHome < n) {
				time += a[opt[numHome].first];
				++numHome;
			}
		}

		while (numZvon < q) {
			epis[numZvon].first.first = numEpis;
			numZvon++;
		}

		sort(epis.begin(), epis.end(), cmp2);

		// Answer
		vector<int> episodes(q);
		for (int i = 0; i < q; ++i) {
			episodes[i] = epis[i].first.first;
		}
		print(episodes);
	}
	// test
	/*
	2
	1 2 3
	10
	15
	5 5
	5 15 20
	3 4 5
	8 100 8
	10 150 20
	2 32 1 1
	9 200 51 50 10
	*/
}


int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	solveJ();
}