#include <bits/stdc++.h>

using namespace std;

struct dz{
    long long a;
    long long d;
};

bool operator<(dz a, dz b) {
    return a.d < b.d;
}

void solve() {
    long long n,m,q;
    cin >> n >> m >> q;
    vector <dz> ad(n), t(q);
    vector <long long int> l(m), s(n+1);
    vector <long long int> pa, pl; //prefix summ
    for(long long i =0; i < n; ++i) {
        cin >> ad[i].a;
    }
    for(long long i =0; i < n; ++i) {
        cin >> ad[i].d;
    }
    for(long long i =0; i < m; ++i) {
        cin >> l[i];
    }
    for(long long i =0; i < q; ++i) {
        cin >> t[i].d;
        t[i].a = i;
    }
    sort(ad.begin(), ad.end());

    pa.push_back(0);
    for(auto i : ad){
        pa.push_back(i.a + pa.back());
    }

    pl.push_back(0);
    for(auto i : l){
        pl.push_back(i + pl.back());
    }

    s[n] = 1000000000000000009;
    for(long long i = n-1; i >=0; --i) {
        s[i] = min(s[i+1], ad[i].d) - ad[i].a;
    }

    sort(t.begin(), t.end());
    long long film = 0, line = 0;
    for(long long i = 0; i < q; ++i) {
        while (line < n && ad[line].d <= t[i].d) {
            line++;
        }
        long long av_time = min(t[i].d, s[line]) - pa[line];
        while (film <= m && pl[film] <= av_time) {
            film++;
        }

        t[i].d = t[i].a;
        t[i].a = film-1;
    }

    sort(t.begin(), t.end());
    for(long long i = 0; i < q; ++i) {
        cout << t[i].a << ' ';
    }
    cout << '\n';
}

/*

4
5 4 8
1 2 3 4 1
10 10 10 10 11
1 2 3 4
1 3 6 10 11 12 13 14
4 4 5
0 0 0 0
10 10 10 10
1 2 3 4
1 3 6 10 11
1 1 1
1
10
1000000000
1000000000000000
1 1 1
1
10
10
10
*/

int main(){
    long long test;
    cin >> test;
    for(long long i =0; i < test; ++i) {
        solve();
    }
}
