#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const int ITERS = 20, SMALL_RANGE = 20;

int ask(ll x) {
    cout << x << endl;
    int res;
    cin >> res;
    if (res == 3) {
        exit(0);
    }
    if (res == -1) {
        assert(false);
    }
    return res;
}

void solve(ll l, ll r, int start_cnt = 0) {
    if (l + SMALL_RANGE >= r) {
        for (ll i = l; i < r; i++) {
            if (ask(i) == 2) {
                return;
            }
        }
        assert(false);
    }
    ll m = (l + r) / 2;
    int res = ask(m);
    if (res == 2) {
        return;
    }
    int cnt = res > 0;
    res = ask((l + m) / 2);
    if (res == 2) {
        return;
    }
    cnt += res > 0;
    for (int j = 0; j < ITERS; j++) {
        res = ask(0);
        if (res == 2) {
            return;
        }
        cnt += res > 0;
    }
    if (cnt <= 1) {
        solve(m + 1, r, 0);
    } else {
        solve(l, m, 1);
    }
}

void solve() {
    ll n;
    int k;
    cin >> n >> k;
    while (k--) {
        solve(1, n + 1);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

/*
9
draw 1
rotate 90
draw 2
rotate 90
draw 2
rotate 90
draw 2
rotate 90
draw 1
 */