#include <bits/stdc++.h>

using namespace std;
using pi = pair<int, int>;
using ll = long long;

void solve() {
    int n, m, q; cin >> n >> m >> q;

    vector<pair<ll, ll>> hw(n);
    for (int i = 0; i < n; ++i) {
        cin >> hw[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> hw[i].first;
    }
    sort(hw.begin(), hw.end());

    for (int i = 0; i + 1 < n; ++i) {
        hw[i+1].second += hw[i].second;
    }

    vector<ll> suf(n+1);
    suf[n] = 1e18;
    for (int i = n; i--; ) {
        suf[i] = min(suf[i+1], hw[i].first - hw[i].second);
    }

    hw.insert(hw.begin(), pair<ll, ll>{  0, 0 });

    vector<ll> ps(m+1);
    for (int i = 1; i <= m; ++i) cin >> ps[i];
    for (int i = 0; i < m; ++i) ps[i+1] += ps[i];

    while (q--) {
        ll t; cin >> t;
        auto it = lower_bound(hw.begin(), hw.end(), pair<ll, ll>{ t, 0 });

        const int pos = max<int>(0, it - hw.begin() - 1);
        const ll ans = min(suf[pos], t - hw[pos].second);

        auto jt = upper_bound(ps.begin(), ps.end(), ans) - ps.begin() - 1;
        cout << jt << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}


/*
2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10
 */