#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;

const ll super_inf = 1e18;

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int test;
    cin >> test;
    while (test--) {
        int n, q, m;
        cin >> n >> m >> q;
        vector<int> a(n), l(m);
        vector<ll> d(n), t(q);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> d[i];
        }
        for (int i = 0; i < m; i++) {
            cin >> l[i];
        }
        for (int i = 0; i < q; i++) {
            cin >> t[i];
        }

        vector<int> ord(n);
        for (int i = 0; i < n; i++) {
            ord[i] = i;
        }
        sort(all(ord), [&](int i, int j){return d[i] < d[j];});

        vector<ll> pref(n), pref_sum(n);
        ll suma = 0;
        for (int i = 0; i < n; i++) {
            suma += a[ord[i]];
            pref_sum[i] = suma;
            pref[i] = d[ord[i]] - suma;
        }
        vector<ll> mn(n + 1, super_inf);
        for (int i = n - 1; i >= 0; i--) {
            mn[i] = min(pref[i], mn[i + 1]);
        }

        vector<ll> pref_L(m);
        for (int i = 0; i < m; i++) {
            if (i > 0) {
                pref_L[i] = pref_L[i - 1];
            }

            pref_L[i] += l[i];
        }

        for (int i = 0; i < q; i++) {
            int L = -1, R = n;
            while (R - L > 1) {
                int mid = (R + L) / 2;
                if (d[ord[mid]] <= t[i]) {
                    L = mid;
                } else {
                    R = mid;
                }
            }
            int l = -1, r = m;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                ll total_sum = pref_L[mid];
                if (L >= 0) {
                    total_sum += pref_sum[L];
                }

                if (total_sum > t[i]) {
                    r = mid;
                    continue;
                }

                if (mn[L + 1] < pref_L[mid]) {
                    r = mid;
                    continue;
                }

                l = mid;
            }

            cout << l + 1 << ' ' ;
        }
        cout << endl;
    }
    return 0;
}
