#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <inttypes.h>
#include <queue>
using namespace std;

using var = int64_t;

void solve() {
    var n;
    cin >> n;
    vector<pair<var, var>>  cmd(n);
    string tmp, res;
    var stru = -1, utru = -1, ks = 0, ku = 0;
    for (var i = 0; i < n; ++i) {
        cin >> tmp >> res;
        if (tmp == "set") {
            cmd[i].first = 1;
            if (res == "true"){
                stru = i;
                ++ks;
            }
            cmd[i].second = (res == "true");
        } else {
            cmd[i].first = 0;
            if (res == "true"){
                utru = i;
                ++ku;
            }
            cmd[i].second = (res == "true");
        }
    }
    var m;
    cin >> m;
    var u, v;
    vector<vector<var>> g(n);
    for (var i = 0; i < n; ++i){
        g[i].push_back(0);
    }
    for (var i = 0; i < m; ++i){
        cin >> u >> v;
        --u;--v;
        g[u].push_back(v);
        ++g[v][0];
    }
    
    if (ks > 1 || ku > 1){
        //cout << "tut\n";
        cout << -1 << "\n";
        return;
    }
    queue <var> qs;
    queue <var> qu;
    vector <var> ans;
    for (var i = 0; i < n; ++i){
        if (g[i][0] == 0){
            if (cmd[i].first == 1){
                qs.push(i);
            }else{
                qu.push(i);
            }
        }
    }

    while (true){
        if (qu.empty()){
            break;
        }
        var cur = qu.front();
        qu.pop();
        if (cur == utru){
            if (qu.empty()){
                qu.push(cur);
                break;
            }else{
                qu.push(cur);
            }
        }else{
            ans.push_back(cur);
            for (var i = 1; i < g[cur].size(); ++i){
                var to = g[cur][i];
                --g[to][0];
                if (g[to][0] == 0){
                    if (cmd[to].first == 1){
                        qs.push(to);
                    }else{
                        qu.push(to);
                    }
                }
            }
        }
    }

    var fl = 0;
    while (true){
        //cout << qs.size() << "\n";
        if (fl > (var)qs.size() + 2){
            //cout << "mama\n";
            cout << -1 << "\n";
            return;
        }
        if (qs.empty()){
            break;
        }
        var cur = qs.front();
        // cout << cur << " ";
        qs.pop();
        if (fl != -1){
            // cout << "come\n";
            if (cur != stru){
                // cout << "come2\n";
                qs.push(cur);
                ++fl;
                continue;
            }else{
                // cout << "come3\n";
                fl = -1;
            }
        }
        ans.push_back(cur);
        for (var i = 1; i < g[cur].size(); ++i){
            var to = g[cur][i];
            --g[to][0];
            if (g[to][0] == 0){
                if (cmd[to].first == 1){
                    qs.push(to);
                 }else{
                    qu.push(to);
                }
            }
        }
    }

     fl = 0;
    while (true){
        if (fl > (var)qu.size() + 2){
            // cout << "aboba\n";
            cout << -1 << "\n";
            return;
        }
        if (qu.empty()){
            break;
        }
        var cur = qu.front();
        qu.pop();
        if (fl != -1){
            if (cur != utru){
                qu.push(cur);
                ++fl;
                continue;
            }else{
                fl = -1;
            }
        }
        ans.push_back(cur);
        for (var i = 1; i < g[cur].size(); ++i){
            var to = g[cur][i];
            --g[to][0];
            if (g[to][0] == 0){
                if (cmd[to].first == 1){
                    qs.push(to);
                }else{
                    qu.push(to);
                }
            }
        }
    }

    if (ans.size() != n){
        // cout << "lol\n";
        cout << "-1\n";
        return;
    }
    for (auto it: ans){
        cout << it + 1 << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t=1;
    // cin >> t;
    while (t > 0){
        solve();
        --t;
    }
}

/*
2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10

*/