#include <iomanip>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void solve();

int main()
{	
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

void solve() {
	int n; cin >> n;
	vector<int> cars(n);
	for (int i = 0; i < n; ++i) {
		cin >> cars[i];
	}

	if (n == 1) {
		cout << 0 << '\n';
		return;
	}

	vector<pair<int, int>> ans;

	int right = n;
	for (int i = 0; i < right; ++i) {
		int idx_max = 0;
		int max = cars[0];
		for (int j = 0; j < right; ++j) {
			if (max < cars[j]) {
				max = cars[j];
				idx_max = j;
			}
		}

		while (idx_max > 0) {
			//cout << cars[idx_max] << ' ' << cars[idx_max - 1] << '\n';
			ans.push_back({ cars[idx_max], cars[idx_max - 1] });
			swap(cars[idx_max], cars[idx_max - 1]);
			--idx_max;
		}

		while (idx_max < right - 1) {
			//cout << cars[idx_max + 1] << ' ' << +cars[idx_max] << '\n';
			ans.push_back({ cars[idx_max + 1], cars[idx_max] });
			swap(cars[idx_max + 1], cars[idx_max]);
			++idx_max;
		}

		right--;
	}

	reverse(ans.begin(), ans.end());

	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); ++i) {
		cout << ans[i].second << ' ' << ans[i].first << '\n';
	}
}