#include <iomanip>
#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#define ll long long

using namespace std;

void solve();

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}
}

void solve() {
	int n;
	cin >> n;
	vector<vector<char>> floor(2, vector<char>(n));

	for (int i = 0; i < 2; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> floor[i][j];
		}
	}

	ll ans = 0;

	function<void(int)> bruteForce = [&](int cur) {
		if (cur == n) {
			++ans;
			return;
		}

		if (floor[0][cur] == '.') {
			if (floor[1][cur] == '.') {
				floor[0][cur] = floor[1][cur] = '#';
				bruteForce(cur + 1);
				floor[0][cur] = floor[1][cur] = '.';
				if (ans > 1) return;

				if (cur + 1 < n && floor[1][cur + 1] == '.' && floor[0][cur + 1] == '.') {
					floor[1][cur] = floor[1][cur + 1] = '#';
					floor[0][cur] = floor[0][cur + 1] = '#';
					bruteForce(cur + 1);
					floor[1][cur] = floor[1][cur + 1] = '.';
					floor[0][cur] = floor[0][cur + 1] = '.';
				}

				return;
			}

			if (cur + 1 < n && floor[0][cur + 1] == '.') {
				floor[0][cur] = floor[0][cur + 1] = '#';
				bruteForce(cur + 1);
				floor[0][cur] = floor[0][cur + 1] = '.';
				if (ans > 1) return;
			}
		} else {
			if (cur + 1 < n && floor[1][cur] == '.' && floor[1][cur + 1] == '.') {
				floor[1][cur] = floor[1][cur + 1] = '#';
				bruteForce(cur + 1);
				floor[1][cur] = floor[1][cur + 1] = '.';
				if (ans > 1) return;
			}
		}

		if (floor[0][cur] == floor[1][cur] && floor[0][cur] == '#') {
			bruteForce(cur + 1);
		}
	};

	bruteForce(0);

	if (ans == 0) {
		cout << "None\n";
	}
	else if (ans == 1) {
		cout << "Unique\n";
	}
	else {
		cout << "Multiple\n";
	}
}