#include <bits/stdc++.h>

using namespace std;

const int SIZE = 1e3 + 5;
int n;
int default_a[SIZE];
int tmp_a[SIZE];

unordered_map<int,int> position;
vector<tuple<int,int>> v;
map<tuple<int,int>,int> cnt_swap;
void fill(){
    cin >> n;
    for(int i = 1; i<= n; ++i){
        for(int j = i + 1; j<= n; ++j){
            cnt_swap[{i,j}] = 2;
        }
        position[i] = i;
        cin >> default_a[i];
        tmp_a[i] = i;
    }
}

void print(){
    cout << v.size() << endl;
    for (const auto& [x,y] : v){
        cout << x << " " << y << endl;
    }
}

void make_additional_swap(){
    for(int j = 1; j < n; ++j){
        int minim = min(tmp_a[j], tmp_a[j+1]);
        int maxim = max(tmp_a[j],tmp_a[j+1]);
        if(cnt_swap[{minim,maxim}] == 2){
            v.push_back({tmp_a[j+1],tmp_a[j]});
            v.push_back({tmp_a[j],tmp_a[j+1]});
        }
    }
}

void make_correct_order(){
    for(int i = 1; i<= n; ++i){
        if (tmp_a[i] == default_a[i]){
            int k = 0;
            int j = i + 1;
            while(j <= n){
                int minim = min(tmp_a[i],tmp_a[j]);
                int maxim = max(tmp_a[i],tmp_a[j]);
                if(cnt_swap[{minim,maxim}] == 2){
                    ++k;
                    ++j;
                    cnt_swap[{minim,maxim}] = 0;
                }
                else{
                    break;
                }
            }
            for ( j = i + 1; j <= i + k; ++j){
                v.push_back({tmp_a[j],tmp_a[i]});
            }
            for (j = i + k; j>= i + 1; --j){
                v.push_back({tmp_a[i],tmp_a[j]});
            }
        }
        else{
            int get_pos = position[default_a[i]];

            int k = 0;
            int j = get_pos + 1;
            while(j <= n){
                int minim = min(tmp_a[get_pos],tmp_a[j]);
                int maxim = max(tmp_a[get_pos],tmp_a[j]);
                if(cnt_swap[{minim,maxim}] == 2){
                    ++k;
                    ++j;
                    cnt_swap[{minim,maxim}] = 0;
                }
                else{
                    break;
                }
            }
            for ( j = get_pos + 1; j <= get_pos + k; ++j){
                v.push_back({tmp_a[j],tmp_a[get_pos]});
            }
            for (j = get_pos + k; j>= get_pos + 1; --j){
                v.push_back({tmp_a[get_pos],tmp_a[j]});
            }

            while (tmp_a[i] != default_a[i]){
                int tmp_position = position[default_a[i]];
                int left_val = tmp_a[tmp_position - 1], right_val = tmp_a[tmp_position];
                int minim = min(left_val, right_val);
                int maxim = max(left_val, right_val);
                v.push_back({right_val,left_val});
                position[left_val] = tmp_position, position[right_val] = tmp_position - 1;
                swap(tmp_a[tmp_position],tmp_a[tmp_position-1]);
                cnt_swap[{minim,maxim}] -= 1;
            }
        }

    }


}
void solve(){
    fill();

    make_correct_order();

    make_additional_swap();

    print();
}
int main() {
    cin.tie(0); cout.tie(0);
    int t = 1; // cin >> t;
    while (t--){
        solve();
    }
    return 0;
}