
#include <bits/stdc++.h>

using namespace std;
using ll = long long ;
using ull = unsigned long long;
using ld = long double;
struct triple{
    ll first, second, third;
    auto operator<=>(const triple&) const = default;
};

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;

using pll = pair<ll,ll>;
using vll = vector<pll>;
using vvll = vector<vll>;

using vlll = vector<triple>;
using vvlll = vector<vlll>;

using vs = vector<string>;
using vld = vector<ld>;

#define fi first
#define se second
#define th third

#define X first
#define Y second
#define Z third

#define con continue
#define pb push_back
#define re return

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(x) (int)(x).size()

template <typename T>
inline void sort(T & v) {
    sort(all(v));
}

template <typename T>
inline void reverse(T & v) {
    reverse(all(v));
}

template <typename T>
inline void unique( T & v) {
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
}

template <typename T>
void smin(T& s, const T& ot) {
    s = min(s, ot);
}

template <typename T>
void smax(T& s, const T& ot) {
    s = max(s, ot);
}

template <typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.fi >> p.se; return in;
}

template <typename T>
istream& operator>>(istream &in, vector<T> &p) {
    for (auto &x : p) in >> x; return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream &out, pair<T1, T2> &p) {
    out << p.fi << p.se; return out;
}

//template <typename T1, typename T2>
//ostream& operator<<(ostream &out, pair<T1, T2> &p) {
//    out << p.fi << p.se; return out;
//}

void solve()
{
    vector<pair<ll,ll>> ans;
    ll n;
    cin >> n;
    vector<ll> v(n);
    cin >> v;

    list<ll> l;
    for(int i = 1; i <= n; i++)
        l.push_back(i);
    reverse(all(l));

    for(int i = n -1; i >= 0; i--) {
        auto it = l.begin();
        while(*it != v[i]) it++;
        l.erase(it++);
        while(it != l.end()) {
            ans.push_back({v[i], *it});
            it++;
        }
        l.push_back(v[i]);
    }
    cout << ans.size() << endl;
    for(auto x : ans)
        cout << x.fi << ' ' << x.se << endl;
}




int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    // cin >> t;
    while(t--)
        solve();

    return 0;
}
