#define __GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
#define int long long

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

bool check(string s) {
    int n = s.size();
    if (s[0] == '-' || s[0] == '+' || s[0] == '=')
        return false;
    if (s[n - 1] == '-' || s[n - 1] == '+' || s[n - 1] == '=')
        return false;

    bool aft = true;
    int temp = 0;
    for (int i = 0; i < n; i++) {
        if (s[i] >= '0' && s[i] <= '9') {
            temp++;
            if (aft) {
                aft = false;
                if (s[i] == '0' && (i + 1 < n - 1 && s[i + 1] >= '0' && s[i + 1] <= '9'))
                    return false;
            }
        } else {
            if (temp > 10)
                return false;
            temp = 0;
            if (aft)
                return false;
            aft = true;
        }
    }
    if (temp > 10)
        return false;
    return true;
}

bool al(string s) {
    int a[2] = {0, 0};
    int ind = 0, n = s.size(), mn = 1;

    if (!check(s))
        return false;

    for (int i = 0; i < n;) {
        int temp = 0;

        while (i < n && s[i] >= '0' && s[i] <= '9') {
            temp = temp * 10 + (s[i] - '0');
            i++;
        }
        a[ind] += mn * temp;

        if (i >= n)
            break;

        if (s[i] == '-')
            mn = -1;
        if (s[i] == '+')
            mn = 1;
        if (s[i] == '=') {
            ind++;
            mn = 1;
        }
        i++;
    }

    return a[0] == a[1];
}

string thom(string &s, int i, int j) {
    int n = s.size(), mi = min(i, j), ma = max(i, j);

    string s1, s2, s3;
    for (int q = 0; q < mi; q++)
        s1 += s[q];
    for (int q = mi + 1; q < ma; q++)
        s2 += s[q];
    for (int q = ma + 1; q < n; q++)
        s3 += s[q];

    if (i < j)
        s1 += s2 + s[j] + s[i] + s3;
    else
        s1 += s[i] + string(1, s[j]) + s2 + s3;

    return s1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;

    if (al(s)) {
        cout << "Correct";
        return 0;
    }

    int n = s.size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;

            if (s[i] < '0' || s[i] > '9')
                continue;

            auto beb = thom(s, i, j);
            //cout << i << " " << j << " " << beb << " " << al(beb) << endl;

            auto sos = al(beb);
            if (sos) {
                cout << beb;
                return 0;
            }
        }
    }

    cout << "Impossible";
    return 0;
}
