#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define forn(i, n) for (ll i = 0; i < (n); ++i)

struct Way {
	int t = 0;
	Way(int t) : t(t) {} 

	Way &operator +=(Way other) {
		t += other.t;
		t = min(t, 2); 
		return *this;
	}
};

void solve() {
	int n;
	cin >> n;

	string s1, s2;
	cin >> s1 >> s2;

	vector<vector<Way>> dp(n + 1, vector<Way>(4, 0));
	dp[0][3] = 1;

	forn(i, n) {
		if (s1[i] == '.' && s2[i] == '.') {
			dp[i + 1][3] += dp[i][3]; // |
			dp[i + 1][1] += dp[i][2];
			dp[i + 1][2] += dp[i][1];
			if (i && s1[i - 1] == '.' && s2[ i - 1] == '.') {
				dp[i + 1][3] += dp[i - 1][3]; // |
			}
		} else if (s1[i] == '.') {
			// 2
			dp[i + 1][2] += dp[i][3];
			dp[i + 1][3] += dp[i][2];
		} else if (s2[i] == '.') {
			dp[i + 1][1] += dp[i][3];
			dp[i + 1][3] += dp[i][1];
		} else {
			dp[i + 1][3] = dp[i][3];
		}
	}
	// forn(i, 3) {
	// 	forn(j, n + 1) {
	// 		cout << dp[j][i + 1].t << " ";
	// 	}
	// 	cout << "\n";
	// }
	// cout << "\n";


	switch(dp.back()[3].t) {
		case 0:
			cout << "None\n"; 
			return;
		case 1:
			cout << "Unique\n"; 
			return;
		case 2:
			cout << "Multiple\n"; 
			return;
	} 
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}
}