// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include<vector>
#include<unordered_map>
#include<string>
int n;
std::unordered_map<int, std::string>letters{};
std::unordered_map<int, int>candidates{};
std::unordered_map<int, std::vector<int>>edges{};
int st = -1;
int ut = -1;
void solve0()
{
	std::vector<int>res{};
	std::vector<int> curUF{};
	for (auto i : candidates)
	{
		if (!i.second)
		{
			if(letters[i.first]=="UF")
			curUF.push_back(i.first);
		}
	}
	while (curUF.size() > 0)
	{
		std::vector<int>nextCurUF{};
		for (int i : curUF)
		{
			for (int j : edges[i])
			{
				candidates[j] -= 1;
				if (candidates[j] == 0)
				{
					if (letters[j] == "UF")
						nextCurUF.push_back(j);
				}
			}
			res.push_back(i);
		}
		curUF = nextCurUF;
	}
	if (res.size() != n)
	{
		std::cout << -1;
	}
	else
	{
		for (int i = 0; i < n; i++)
		{
			std::cout << res[i]<<" ";
		}
	}
}

void solve1()
{
	std::vector<int>res{};
	std::vector<int> curUF{};
	std::vector<int> curSF{};
	for (auto i : candidates)
	{
		if (!i.second)
		{
			if (letters[i.first] == "UF")
				curUF.push_back(i.first);
			if (letters[i.first] == "SF")
				curSF.push_back(i.first);
		}
	}
	while (curUF.size() > 0)
	{
		std::vector<int>nextCurUF{};
		for (int i : curUF)
		{
			for (int j : edges[i])
			{
				candidates[j] -= 1;
				if (candidates[j] == 0)
				{
					if (letters[j] == "UF")
						nextCurUF.push_back(j);
					if (letters[j] == "SF")
						curSF.push_back(j);
				}
			}
			res.push_back(i);
		}
		curUF = nextCurUF;
	}
	if (candidates[st])
	{
		std::cout << -1;
		return;
	}
	res.push_back(st);
	for (int j : edges[st])
	{
		candidates[j] -= 1;
		if (candidates[j] == 0)
		{
			if (letters[j] == "UF")
				curUF.push_back(j);
			if (letters[j] == "SF")
				curSF.push_back(j);
		}
	}
	while (curSF.size() > 0)
	{
		std::vector<int>nextCurSF{};
		for (int i : curSF)
		{
			for (int j : edges[i])
			{
				candidates[j] -= 1;
				if (candidates[j] == 0)
				{
					if (letters[j] == "UF")
						curUF.push_back(j);
					if (letters[j] == "SF")
						nextCurSF.push_back(j);
				}
			}
			res.push_back(i);
		}
		curSF = nextCurSF;
	}
	if (res.size() != n)
	{
		std::cout << -1;
	}
	else
	{
		for (int i = 0; i < n; i++)
		{
			std::cout << res[i]<<" ";
		}
	}
}


void solve2()
{
	std::vector<int>res{};
	std::vector<int> curUF{};
	std::vector<int> curSF{};
	for (auto i : candidates)
	{
		if (!i.second)
		{
			if (letters[i.first] == "UF")
				curUF.push_back(i.first);
			if (letters[i.first] == "SF")
				curSF.push_back(i.first);
		}
	}
	while (curUF.size() > 0)
	{
		std::vector<int>nextCurUF{};
		for (int i : curUF)
		{
			for (int j : edges[i])
			{
				candidates[j] -= 1;
				if (candidates[j] == 0)
				{
					if (letters[j] == "UF")
						nextCurUF.push_back(j);
					if (letters[j] == "SF")
						curSF.push_back(j);
				}
			}
			res.push_back(i);
		}
		curUF = nextCurUF;
	}
	if (candidates[st])
	{
		std::cout << -1;
		return;
	}
	res.push_back(st);
	for (int j : edges[st])
	{
		candidates[j] -= 1;
		if (candidates[j] == 0)
		{
			if (letters[j] == "UF")
				curUF.push_back(j);
			if (letters[j] == "SF")
				curSF.push_back(j);
		}
	}
	while (curSF.size() > 0)
	{
		std::vector<int>nextCurSF{};
		for (int i : curSF)
		{
			for (int j : edges[i])
			{
				candidates[j] -= 1;
				if (candidates[j] == 0)
				{
					if (letters[j] == "UF")
						curUF.push_back(j);
					if (letters[j] == "SF")
						nextCurSF.push_back(j);
				}
			}
			res.push_back(i);
		}
		curSF = nextCurSF;
	}
	if (candidates[ut])
	{
		std::cout << -1;
		return;
	}
	res.push_back(ut);
	for (int j : edges[ut])
	{
		candidates[j] -= 1;
		if (candidates[j] == 0)
		{
			if (letters[j] == "UF")
				curUF.push_back(j);
			if (letters[j] == "SF")
				curSF.push_back(j);
		}
	}
	while (curUF.size() > 0)
	{
		std::vector<int>nextCurUF{};
		for (int i : curUF)
		{
			for (int j : edges[i])
			{
				candidates[j] -= 1;
				if (candidates[j] == 0)
				{
					if (letters[j] == "UF")
						nextCurUF.push_back(j);
					if (letters[j] == "SF")
						curSF.push_back(j);
				}
			}
			res.push_back(i);
		}
		curUF = nextCurUF;
	}
	if (res.size() != n)
	{
		std::cout << -1;
	}
	else
	{
		for (int i = 0; i < n; i++)
		{
			std::cout << res[i] << " ";
		}
	}
}

int main()
{
	std::cin >> n;
	int sfCount = 0;
	int stCount = 0;
	int utCount = 0;

	for (int i = 1; i <= n; i++)
	{
		std::string first, second;
		std::cin >> first >> second;
		if (first[0] == 's' and second[0] == 't')
		{
			stCount += 1;
			st = i;
			letters[i] = "ST";
		}
		else if (first[0] == 's' and second[0] == 'f')
		{
			sfCount += 1;
			letters[i] = "SF";
		}
		else if (first[0] == 'u' and second[0] == 't')
		{
			utCount += 1;
			ut = i;
			letters[i] = "UT";
		}
		else
		{
			letters[i] = "UF";
		}
		candidates[i] = 0;
	}

	int m;
	std::cin >> m;
	for (int i = 1; i <= m; i++)
	{
		int first = 0;
		int second = 0;
		edges[first] = std::vector<int>{};
		edges[first].push_back(second);
		candidates[second] += 1;
	}
	if (sfCount && !stCount || utCount && !stCount || stCount == 2)
	{
		std::cout << -1;
		return 0;
	}
	if (utCount && stCount)
	{
		solve2();
	}
	else if (stCount)
	{
		solve1();
	}
	else
	{
		solve0();
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started:
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
