#include<algorithm>
#include <iostream>
#include<sstream>
#include<string>

#include <cmath>
#include<cstdio>
#include<cstdint>
#include<deque>
#include<iomanip>
#include<iostream>
#include<list>
#include<map>
#include<set>
#include<stack>
#include<vector>
#include<unordered_map>
#include<unordered_set>
using namespace std;
typedef long long ll;
#define all(v) v.begin, v.end();
template <typename T> using vc = vector<T>;

bool is_lead(string &s) {
	return s.size() >= 2 && s[0] == '0' && (s[1] != '+' && s[1] != '-' && s[1] != '=');
}

bool validate(string& s) {
	vector<string> nums;
	int n = s.size();
	string tmp;
	ll prev = 0;
	ll prev_ev = 0;
	char prev_op = '+';
	for (int i = 0; i < n; i++) {
		if (s[i] != '+' && s[i] != '-' && s[i] != '=') {
			tmp += s[i];
		}
		else {
			if (tmp == "")
				return false;
			if (is_lead(tmp))
				return false;
			
			ll num = stoll(tmp);
			if (prev_op == '+') {
				prev += num;
			}
			if (prev_op == '-') {
				prev -= num;
			}
			prev_op = s[i];
			if (prev_op == '=') {
				prev_op = '+';
				prev_ev = prev;
				prev = 0;
			}
			tmp = "";
		}
	}
	if (tmp == "")
		return false;
	if (is_lead(tmp))
		return false;
	ll num = stoll(tmp);
	if (prev_op == '+') {
		prev += num;
	}
	if (prev_op == '-') {
		prev -= num;
	}
	return prev_ev == prev;
}

void solve() {
	string s;
	cin >> s;
	if (validate(s)) {
		cout << "Correct\n";
		return;
	}
	for (int i = 0; i + 1 < s.size(); i++) {
		if (s[i] == '-' && s[i] == '+' && s[i] == '=') continue;
		for (int j = i + 1; j + 1 < s.size(); j++) {
			string tmp = s;
			string a = tmp.substr(0, i);
			string b = tmp.substr(i + 1, j - i);
			string c = tmp.substr(j + 1, s.size() - j - 1);
			string test = a + b + s[i] + c;
			if (validate(test)) {
				cout << test << "\n";
				return;
			}
		}
	}
	cout << "Impossible\n";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;

#ifdef _DEBUG 
	FILE* file = new FILE;
	freopen_s(&file, "../input.txt", "r", stdin);
#endif
	//cout << setprecision(10);
	//cout << fixed;
	while (tests--) { solve(); }
}

