#include<algorithm>
#include <iostream>
#include<sstream>
#include<string>
#include <cmath>
#include<cstdio>
#include<cstdint>
#include<deque>
#include<iomanip>
#include<iostream>
#include<list>
#include<map>
#include<set>
#include<stack>
#include<vector>
#include<unordered_map>
#include<unordered_set>
using namespace std;
typedef long long ll;
#define all(v) v.begin, v.end();
template <typename T> using vc = vector<T>;

vc<pair<int, int>> diffs = { { 0,1 }, { 0,-1 }, { 1,0 }, { -1,0 } };

int getBorders(int i, int j, vc<string>& floor) {
	int borders = 1;
	int n = floor[0].size();
	if (i < 0 || i > 1 || j < 0 || j >= n || floor[i][j] != '.')
		return 0;
	borders += j == 0 || floor[i][j-1] == '#';
	borders += j == n - 1 || floor[i][j+1] == '#';
	borders += floor[!i][j] == '#';
	return borders;
}

void solve() {
	int n;
	cin >> n;
	vc<string> floor(2);
	cin >> floor[0] >> floor[1];
	set<pair<int, int>> side3;
	for (int i = 0; i < 2; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (floor[i][j] == '#')
			{
				continue;
			}

			if (getBorders(i, j, floor) == 3) {
				side3.insert({ i, j });
			}
		}
	}
	;
	while (!side3.empty())
	{
		auto pr = *side3.begin();
		if (getBorders(pr.first, pr.second, floor) != 3) {
			side3.erase(pr);
			continue;
			//cout << "Nonedrgdfg";
			//return;
		}
		pair<int, int> neighbour;
		if (floor[!pr.first][pr.second] == '.') {
			neighbour = { !pr.first, pr.second };
		}
		else if (pr.second == 0 || floor[pr.first][pr.second+1] == '.'){
			neighbour = { pr.first, pr.second + 1 };
		}
		else {
			neighbour = { pr.first, pr.second - 1 };
		}
		floor[pr.first][pr.second] = '#';
		floor[neighbour.first][neighbour.second] = '#';
		for (auto& diff : diffs)
		{
			if (getBorders(pr.first + diff.first, pr.second + diff.second, floor) == 3) {
				side3.insert({ pr.first + diff.first, pr.second + diff.second });
			}
			if (getBorders(neighbour.first + diff.first, neighbour.second + diff.second, floor) == 3) {
				side3.insert({ neighbour.first + diff.first, neighbour.second + diff.second });
			}
		}
		side3.erase(pr);
		side3.erase(neighbour);
	}
	;
	int not_filled = 0;
	for (int i = 0; i < 2; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if (floor[i][j] == '#')
			{
				continue;
			}
			not_filled++;
			if (getBorders(i, j, floor) == 4) {
				cout << "None";
				return;
				side3.insert({ i, j });
			}
		}
	}
	if (not_filled) {
		cout << "Multiple";
	}
	else {
		cout << "Unique";
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;

#ifdef _DEBUG 
	FILE* file = new FILE;
	freopen_s(&file, "../input.txt", "r", stdin);
#endif
	//cout << setprecision(10);
	//cout << fixed;
	cin >> tests;
	while (tests--) { solve(); cout << "\n"; }
}

