/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("tree-vectorize")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//*/
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef long double ld;
typedef pair<ll, ll> pll;

// #define f first 
// #define s second
// #define x first 
// #define y second

string repl(string &s, int from, int to) {
    char rmd = s[from];
    string nw;
    for (int i = 0; i < s.length(); ++i) {
        if (i != from) nw.push_back(s[i]);
    }

    string res;
    for (int i = 0; i < s.length(); ++i) {
        if (i == to) {
            res.push_back(rmd);
        }

        if (i < nw.length()) {
            res.push_back(nw[i]);
        }
    }

    return res;
}

bool is_nana(char c) {
    return c == '+' || c == '-' || c == '=';
}

bool is_num(char c) {
    return ('0' <= c) && (c <= '9');
}

ll eval(string &s, ll &mx) {
    ll sum = 0;

    vector<string> parts {""};
    for (int i = 0; i < s.length(); ++i) {
        if (is_nana(s[i])) {
            parts.emplace_back();
        }

        parts.back().push_back(s[i]);
    }

    for (auto &p : parts) {
        ll val = stoll(p);
        mx = max(mx, abs(val));
        sum += val;
    }

    return sum;
}

bool is_cor(string &s) {
    if (s[0] == '0' && is_num(s[1])) return false;
    if (is_nana(s[0])) return false;
    if (is_nana(s.back())) return false;

    for (int i = 1; i < s.length(); ++i) {
        if (is_nana(s[i - 1]) && is_nana(s[i])) return false;
    }

    for (int i = 2; i < s.length(); ++i) {
        if (is_nana(s[i - 2]) && s[i - 1] == '0' && is_num(s[i])) return false;
    }

    int eqind = find(s.begin(), s.end(), '=') - s.begin();

    string lefts = s.substr(0, eqind);
    string rights = s.substr(eqind + 1);

    ll mx = 0;

    bool is_eq = eval(lefts, mx) == eval(rights, mx);
    if (mx > 9'999'999'999ll) return false;
    return is_eq;
}

void solve() {
    string s;
    cin >> s;

    if (is_cor(s)) {
        cout << "Correct" << endl;
        return;
    }

    for (int i = 0; i < s.length(); ++i) {
        if (!is_num(s[i])) continue;

        for (int j = 0; j < s.length(); ++j) {
            string h = repl(s, i, j);

            if (is_cor(h)) {
                cout << h << endl;
                return;
            }
        }
    }

    cout << "Impossible" << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
   #endif

    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}