/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("tree-vectorize")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//*/
#include <bits/stdc++.h>

using namespace std;

typedef long long int ll;
typedef long double ld;
typedef pair<ll, ll> pll;

#define f first 
#define s second
#define x first 
#define y second

ll n, m;
const ll MAXN = 1e5 + 10;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    
    vector<pair<ll, ll>> tasks(n);

    ll lbord = 0;

    for (int i = 0 ; i < n; ++i) {
        cin >> tasks[i].second;
        lbord += tasks[i].second;
    }

    for (int i = 0; i < n; ++i) {
        cin >> tasks[i].first;
    }

    sort(tasks.begin(), tasks.end());

    map<ll, int> ep_cnt;

    ll ep_len_sum = 0;
    for (int i =0; i < m; ++i) {
        ll epl;
        cin >> epl;
        ep_len_sum += epl;
        ep_cnt[ep_len_sum] = i + 1;
    }

    vector<pair<ll, int>> queries(q);
    for (int i = 0; i < q; ++i) {
        ll t;
        cin >> t;

        queries[i] = make_pair(t, i);
    }

    sort(queries.rbegin(), queries.rend());

    ll rbord = 1e18;

    vector<int> ans(q);

    for (auto [time, index]: queries) {
        while (!tasks.empty()) {
            ll to = min(rbord, tasks.back().first) - tasks.back().second;
            if (to + tasks.back().second > time) {
                rbord = to;
                lbord -= tasks.back().second;
                tasks.pop_back();
                continue;
            } else {
                break;
            }
        }

        ll left_time = min(time, rbord) - lbord;
        auto ptr = ep_cnt.upper_bound(left_time);
        if (ptr == ep_cnt.begin()) {
            ans[index] = 0;
            continue;
        }
        ptr--;
        ans[index] = ptr->second;
    }

    for (auto e: ans) cout << e << ' ';
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
   #endif

    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}