#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

const int N = 2e5 + 7;

int n;
string s[2];
int dp[N][4];

void solve() {
  cin >> n;
  cin >> s[0] >> s[1];
  dp[0][0] = 1;
  for (int i = 0; i < n; ++i) {
    for (int mask = 0; mask < 4; ++mask) {
      if ((mask & 1) && s[0][i] == '#') {
        dp[i + 1][mask] = 0;
      } else if ((mask & 2) && s[1][i] == '#') {
        dp[i + 1][mask] = 0;
      } else {
        dp[i + 1][mask] = 0;
        if (mask == 0 && s[0][i] == '.' && s[1][i] == '.') {
          dp[i + 1][mask] += dp[i][0];
        }
        int nxt = 0;
        if (!(mask & 1) && s[0][i] == '.') {
          nxt |= 1;
        }
        if (!(mask & 2) && s[1][i] == '.') {
          nxt |= 2;
        }
        dp[i + 1][mask] += dp[i][nxt];
        dp[i + 1][mask] = min(dp[i + 1][mask], 2);
      }
    }
  }
  if (dp[n][0] == 0) {
    cout << "None\n";
  } else if (dp[n][0] == 1) {
    cout << "Unique\n";
  } else {
    cout << "Multiple\n";
  }
}

int main() {
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}