#include <bits/stdc++.h>
using namespace std;


using ll = long long;
using ld = long double;
using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

bool bit(int mask, int i){
    return ((mask >> i) & 1) > 0;
}

void update(int i, int mask, vector<string>& s, vvi& dp, int nmask = 0, int j = 0){
    if(j == 2){
        dp[i+1][nmask] += dp[i][mask];
        dp[i+1][nmask] = min(2, dp[i+1][nmask]);
        return;
    }


    if(bit(nmask, j) || s[j][i+1] == '#'){
        if(!bit(mask, j)) return;
        update(i, mask, s, dp, nmask | (1 << j), j+1);
        return;
    }

    if(bit(mask, j)){
        update(i, mask, s, dp, nmask, j+1);
    }

    if(!bit(mask, j)){
        update(i, mask, s, dp, nmask | (1 << j), j+1);
    }

    if(j==0 && bit(mask, j) && bit(mask, j+1) && s[j+1][i+1] != '#'){
        update(i, mask, s, dp, nmask | (1 << j) | (1 << (j+1)), j+2);
    }
}

void solve()
{
    int n; cin >> n;
    vector<string> s(2);
    cin >> s[0] >> s[1];

    vector dp(n, vi(4, 0));
    if(s[0][0] == '#' && s[1][0] == '#') dp[0][3] = 1;
    else if(s[0][0] == '#') dp[0][1] = 1;
    else if(s[0][1] == '#') dp[0][2] = 1;
    else dp[0][0] = dp[0][3] = 1;

    for(int i = 0; i < n-1; i++){
        for(int mask = 0; mask < 4; ++mask){
            update(i, mask, s, dp);
        }
    }
    
    // for(int i = 0; i < n; i++){
    //     for(int j = 0; j < 4; j++){
    //         cout << dp[i][j] << ' ';
    //     }
    //     cout << '\n';
    // }

    if(dp[n-1][3] == 0){
        cout << "None";
    }
    else if(dp[n-1][3] == 1){
        cout << "Unique";
    }
    else{
        cout << "Multiple";
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int T = 1;
    cin >> T;

    while(T--> 0)
    {
        solve();
    }

    return 0;
}