#include <iostream>
#include <vector>
#include <string>
#include <array>
#include <algorithm>
#include <numeric>

using ll = long long;

std::string solve() {
    ll n;
    std::cin >> n;
    std::vector<std::string> v(2);
    int cnt = 0;
    for (auto &s: v) {
        std::cin >> s;
        auto it = std::find(s.begin(), s.end(), '.');
        cnt = it != s.end();
    }
    if (cnt == 0) {
        return "Unique";
    }
    if (n == 1) {
        if (v[0] == "." && v[1] == "." || v[0] == "#" && v[1] == "#") {
            return "Unique";
        } else {
            return "None";
        }
    }
    int ans = 1;
    for (ll i = 0; i < n; ++i) {
        if (i + 1 == n) {
            if (v[0][i] == '.' && v[1][i] == '.') {
                continue;
            }
            if (v[0][i] != '#' || v[1][i] != '#') {
                return "None";
            }
            continue;
        }
        if (v[0][i] == '#') {
            if (v[1][i] == '#') {
                continue;
            } else {
                if (v[1][i + 1] == '.') {
                    v[1][i] = '#';
                    v[1][i + 1] = '#';
                } else {
                    return "None";
                }
            }
        } else if (v[1][i] == '#') {
            // v[0][i] == '.'
            if (v[0][i + 1] == '.') {
                v[0][i] = '#';
                v[0][i + 1] = '#';
            } else {
                return "None";
            }
        } else if (v[0][i + 1] == '#' || v[1][i + 1] == '#') {
            v[0][i] = v[1][i] = '#';
        } else { // все точки
            v[0][i] = v[0][i + 1] = v[1][i] = v[1][i + 1] = '#';
            ans = 2;
        }
    }
    return ans == 1 ? "Unique" : "Multiple";
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    ll t = 0;
    std::cin >> t;

    while (t--) {
        std::cout << solve() << '\n';
    }

    return 0;
}
