def eval(s: str) -> int | None:
    cur_num = "+"
    res = 0
    if len(s) == 0:
        return None
    for c in s:
        if len(cur_num) > 1 and c in "+-":
            if cur_num[1] == "0" and len(cur_num) > 2:
                return None
            if len(cur_num) > 11:
                return None
            res += int(cur_num)
            cur_num = c
        elif c in "1234567890":
            cur_num += c
        else:
            return None
    if len(cur_num) < 2:
        return None
    if cur_num[1] == "0" and len(cur_num) > 2:
        return None
    if len(cur_num) > 11:
        return None
    res += int(cur_num)
    return res

def is_correct(s: str) -> bool:
    lst = s.split('=')
    if len(lst) != 2:
        return False
    lhs, rhs = lst
    lhs_val = eval(lhs)
    rhs_val = eval(rhs)
    if lhs_val is None or rhs_val is None:
        return False
    return lhs_val == rhs_val

s = input()
if is_correct(s):
    print("Correct")
else:
    found = False
    for pos in range(len(s)):
        if s[pos] not in "0123456789":
            continue
        t = s[:pos] + s[pos+1:]
        for to_pos in range(len(t)):
            w = t[:to_pos] + s[pos] + t[to_pos:]
            if is_correct(w):
                print(w)
                found = True
                break
        if found:
            break
    if not found:
        print("Impossible")
                