#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define F first
#define S second
#define endl '\n'

typedef long long ll;

#define int ll

using namespace std;

void solve() {
    int dz_cnt, ser_cnt, calls_cnt;
    cin >> dz_cnt >> ser_cnt >> calls_cnt;

    vector<int> task_time(dz_cnt);
    for(int i = 0; i < dz_cnt; i++) {
        cin >> task_time[i];
    }

    vector<int> deadline(dz_cnt);
    for(int i = 0; i < dz_cnt; i++) {
        cin >> deadline[i];
    }

    vector<int> ser_time(ser_cnt);
    for(int i = 0; i < ser_cnt; i++) {
        cin >> ser_time[i];
    }

    vector<int> call_time(calls_cnt);
    for(int i = 0; i < calls_cnt; i++) {
        cin >> call_time[i];
    }

    vector<pair<int, int>> p(dz_cnt);
    for (int i = 0; i < dz_cnt; i++) {
        p[i] = {deadline[i], task_time[i]};
    }

    sort(all(p));
    reverse(all(p));

    vector<pair<int, int>> v(1, {p[0].F, LLONG_MAX});

    int r = p[0].F;
    for (int i = 0; i < p.size(); i++) {
        if (r - p[i].F > 0) {
            v.emplace_back(p[i].F, r);
            r = p[i].F;
        }
        r -= p[i].S;
    }

    if (r > 0) {
        v.emplace_back(0, r);
    }

    reverse(all(v));

    vector<pair<int, int>> ci(calls_cnt);
    for (int i = 0; i < calls_cnt; i++) ci[i] = {call_time[i], i};
    sort(all(ci));

    int it_ser = 0;

    vector<int> ans(call_time);
    vector<int> mom;

    for (int i = 0; i < v.size(); i++) {
        auto [a, b] = v[i];
        while (it_ser < ser_time.size() && a + ser_time[it_ser] <= b) {
            a += ser_time[it_ser];
            mom.push_back(a);
            it_ser++;
        }
        if (i + 1 < v.size()) v[i + 1].F -= (b - a);
    }

    it_ser = 0;
    for (auto [t, i] : ci) {
        while (it_ser < mom.size() && mom[it_ser] <= t) it_ser++;
        ans[i] = it_ser;
    }

    for (auto e : ans) cout << e << ' ';
    cout << endl;

}

signed main() {
    int tc;
    cin >> tc;

    while(tc--) {
        solve();
    }
}


/*
2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10
 * */