#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>

using ll = long long;

using namespace std;

int main() {
	int t; cin >> t;
	while (t--) {
		int n; cin >> n;
		vector<string> mt(2);
		for (auto& i : mt) {
			cin >> i;
		}
		if (n == 1) {
			string s = mt[0] + mt[1];
			if (s == ".." || s == "##") {
				cout << "Unique";
			}
			else cout << "None";
			cout << '\n';
			continue;
		}
		auto get = [&](int i) {
			return (mt[0][i] == '#') | ((mt[1][i] == '#') << 1);
		};
		vector<vector<ll>> dp(n, vector<ll>(4, 0));
		{
			int a = get(0), b = get(1);
			if (a == 0) {
				if (b == 0) {
					dp[1][0] += 1;
					dp[1][3] += 2;
				}
				else if (b != 3) {
					dp[1][b] += 1;
				} 
				else {
					dp[1][3] = 1;
				}
			}
			else if (a == 3) {
				dp[1][b] += 1;
			}
			else {
				if (a == b) {
					dp[1][3] += 1;
				}
				else if (b == 0) {
					dp[1][3 - a] += 1;
				}
			}
		}
		for (int i = 2; i < n; i++) {
			for (int j = 0; j < 4; j++) {
				int a = j, b = get(i);
				if (a == 0) {
					if (b == 0) {
						dp[i][0] += 1 * dp[i - 1][j];
						dp[i][3] += 2 * dp[i - 1][j];
					}
					else if (b != 3) {
						dp[i][b] += 1 * dp[i - 1][j];
					}
					else
						dp[i][3] += 1 * dp[i - 1][j];
				}
				else if (a == 3) {
					dp[i][b] += 1 * dp[i - 1][j];
				}
				else {
					if (a == b) {
						dp[i][3] += 1 * dp[i - 1][j];
					}
					else if (b == 0) {
						dp[i][3 - a] += 1 * dp[i - 1][j];
					}
				}
			}
			for (int j = 0; j < 4; j++) {
				dp[i][j] = min(dp[i][j], 2ll);
			}
		}
		ll res = dp[n - 1][3] + dp[n - 1][0];
		if (res == 0) cout << "None";
		else if (res == 1) cout << "Unique";
		else cout << "Multiple";
		cout << '\n';
	}
	return 0;
}

/*
1
10
#.......##
##..#.##..
*/