def ev(s):
    try:
        return eval(s)
    except:
        return None


def check_s(s):
    for i in range(len(s) - 1):
        if not s[i].isdigit() and not s[i + 1].isdigit():
            return False
        return True


def check_sub(s: str):
    data = list()
    for ch in s:
        if not ch.isdigit():
            num = ''.join(data)
            if len(num) > 10:
                return False
            data.clear()
        else:
            data.append(ch)
    if data:
        return len(''.join(data)) <= 10
    return True


def check(s):
    if not check_s(s):
        return False
    left, right = s.split('=')
    if not check_sub(left) or not check_sub(right):
        return False
    el = ev(left)
    if el is None:
        return False
    er = ev(right)
    if er is None:
        return False
    return el == er


def main():
    s = input()
    if check(s):
        return print("Correct")
    for i in range(len(s)):
        if not s[i].isdigit():
            continue
        for j in range(i):
            a = s[:j]
            b = s[j:i]
            c = s[i + 1:]
            ss = a + s[i] + b + c
            if check(ss):
                return print(ss)
        for j in range(i + 1, len(s)):
            a = s[:i]
            b = s[i + 1:j]
            c = s[j:]
            ss = a + b + s[i] + c
            if check(ss):
                return print(ss)
    print("Impossible")


main()
# 10000000000
# 9999999999

# 10000000000
# 9999999999
