#include <iostream>
#include <vector>
#include <unordered_set>
#include <set>
#include <algorithm>

using namespace std;

#define int long long

int cmp(pair<int, int>a, pair<int, int> b) {
    if (a.first < b.first) return -1;
    if (a.first > b.first) return 1;
    if (a.second < b.second) return -1;
    if (a.second > b.second) return 1;
    return 0;
}


void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<pair<int, int>> d(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        d[i] = {t, i};
    }
    vector<int> psl(m+1);
    psl[0] = 0;
    for (int i = 0; i < m; i++) {
        int t;
        cin >> t;
        psl[i+1] = psl[i] + t;
    }
    vector<int> delta(n);
    sort(d.begin(), d.end());
    int sum_time = 0;
    for (int i = 0 ; i < n; i++) {
        sum_time += a[d[i].second];
        delta[i] = d[i].first - sum_time;
    }
    vector<int> ost(n+1);
    ost[n] = 1000000000000000000;
    for (int i = n-1; i >= 0; i--) {
        ost[i] = min(ost[i+1], delta[i]);
    }
    int ans;
    for (int i = 0; i < q; i++) {
        int time;
        cin >> time;
        pair<int, int> p = {time, -1ll};
        int ind = std::distance(d.begin(), std::lower_bound(d.begin(), d.end(), p));
        int anss = -1;
        if (ind >= 1) {
            anss = time - d[ind-1].first + delta[ind-1];
        } else {
            anss = time;
        }
        anss = min(anss, ost[ind]);
        ans = std::distance(psl.begin(), std::upper_bound(psl.begin(), psl.end(), anss)) - 1;
        cout << ans << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie();

    int t;
    cin >> t;
    for (int i = 0 ; i< t; i++) {
        solve();
    }

    return 0;
}
