#include <bits/stdc++.h>
#define size(a) (ll)(a).size()
#define int long long

using namespace std;
typedef long double ld;
typedef long long ll;

const int INF = INT_MAX;
const int INF_LL = LLONG_MAX;
const ld EPS = 1e-9;
const ll MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    char mat[2][n];
    for (int i = 0; i < n; ++i) {
        cin >> mat[0][i];
        if (mat[0][i] == '.') {
            mat[0][i] = '#';
        } else {
            mat[0][i] = '.';
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> mat[1][i];
        if (mat[1][i] == '.') {
            mat[1][i] = '#';
        } else {
            mat[1][i] = '.';
        }
    }
    int dp[3][n+1];
    dp[0][0] = 1;
    dp[1][0] = 0;
    dp[2][0] = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 2; j >= 0; --j) {
            dp[j][i] = 0;
            if (j == 0) {
                if (mat[0][i - 1] == mat[1][i - 1]) {
                    dp[j][i] += dp[j][i - 1];
                    if (i != 1 && mat[0][i - 1] == '#' && mat[0][i - 2] == '#' && mat[1][i - 1] == '#' &&
                        mat[1][i - 2] == '#') {
                        dp[j][i] += dp[j][i - 2];
                    }
                } else {
                    if (mat[0][i - 1] == '.') {
                        dp[j][i] = dp[1][i - 1];
                    } else {
                        dp[j][i] = dp[2][i - 1];
                    }
                }
            } else {
                if (mat[j - 1][i - 1] == '.') {
                    dp[j][i] = dp[0][i - 1];
                } else if ((i == 1) || (mat[j - 1][i - 2] == '.')) {
                    dp[j][i] = 0;
                } else {
                    dp[j][i] = dp[3 - j][i - 1];
                }
            }
            dp[j][i] = min(2ll, dp[j][i]);
//            cout << j << " " << i << " " << dp[j][i] << endl;
        }
    }
    if (dp[0][n] == 0) {
        cout << "None" << endl;
    } else if (dp[0][n] == 1) {
        cout << "Unique" << endl;
    } else {
        cout << "Multiple" << endl;
    }
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    cout.precision(20);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
