#include <bits/stdc++.h>
#define size(a) (ll)(a).size()
#define int long long
#define x first
#define y second

using namespace std;
typedef long double ld;
typedef long long ll;

const int INF = INT_MAX;
const int INF_LL = LLONG_MAX;
const ld EPS = 1e-9;
const ll MOD = 1e9 + 7;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<pair<int,int>> hw(n);
    vector<int> ep(m);
    vector<pair<int, int>> calls(q);
    for(int i = 0;i < n; ++i){
        cin >> hw[i].y;
    }
    for(int i = 0;i < n; ++i){
        cin >> hw[i].x;
    }
    for(int i = 0;i < m; ++i){
        cin >> ep[i];
    }
    for(int i = 0;i < q; ++i){
        cin >> calls[i].x;
        calls[i].y = i;
    }
    sort(hw.begin(),  hw.end());
    sort(calls.begin(),  calls.end());

    vector<int>pref_a(n + 1);
    pref_a[0] = 0;

    for(int i = 0;i < n; ++i) {
        pref_a[i + 1] = hw[i].y + pref_a[i];
    }

    vector<int> pref_ep(m + 1);
    for(int i = 0; i < m; ++i) {
        pref_ep[i + 1] = ep[i] + pref_ep[i];
    }

    vector<int> b(n);
    b[n - 1] = hw[n - 1].x - hw[n - 1].y;

    for (int i = n - 2; i >= 0; --i) {
        b[i] = min(hw[i].x, b[i + 1]) - hw[i].y;
    }

    vector<int> ans(q);

    int curr_max_ans = 0;
    int curr_max_hw_k = 0;
    int right = 0;
    for (int qq = 0; qq < q; ++qq) {
        while(curr_max_hw_k < n and hw[curr_max_hw_k].x < calls[qq].x) {
            ++curr_max_hw_k;
        }
        if (curr_max_hw_k == n) {
            right = calls[qq].x;
        } else {
//            right = b[curr_max_hw_k];
            right = min(b[curr_max_hw_k], calls[qq].x);
        }
        while(curr_max_ans < m and pref_ep[curr_max_ans + 1] <= (right - pref_a[curr_max_hw_k])) {
            ++curr_max_ans;
        }
        ans[calls[qq].y] = curr_max_ans;
    }

    for (int qq = 0; qq < q; ++qq) {
        cout << ans[qq] << " ";
    }
    cout << "\n";
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    cout.precision(20);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
