#include <iostream>
#include <vector>

using namespace std;

void solv()
{
	int n; cin >> n;
	vector<vector<bool>> v(2, vector<bool>(n));
	for (int i = 0; i < 2; ++i)
	{
		char ch;
		for (int j = 0; j < n; ++j) {
			cin >> ch;
			v[i][j] = (ch == '#');
		}
	}
	v[0].push_back('#');
	v[1].push_back('#');

	bool multiple = false;
	for (int i = 0; i < n; i++) {
		int cnt = v[0][i] + v[1][i] + v[0][i + 1] + v[1][i + 1];
		if (cnt == 0) {
			multiple = true;
		}
		else if (cnt == 1) {
			if (v[0][i]) {
				v[1][i + 1] = 1;
			}
			else if (v[1][i]) {
				v[0][i + 1] = 1;
			}
		}
		else if (cnt == 2) {
			if (v[0][i] == v[1][i + 1]) {
				cout << "None" << endl;
				return;
			}
			else {
				v[0][i] = v[1][i] = v[0][i + 1] = v[1][i + 1] = 1;
			}
		}
		else if (cnt == 3) {
			if (!v[0][i] || !v[1][i]) {
				cout << "None" << endl;
				return;
			}
		}
	}
	if (multiple) cout << "Multiple" << endl;
	else cout << "Unique" << endl;
}




int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t = 1;
	cin >> t;
	while (t--) solv();

}
