#include <bits/stdc++.h>

using namespace std;

int n;
string s[2];
int b, w;

bool bfs(int i, int j, char c) {
    b = 0; w = 0;
    // cout << i << " " << j << " ";
    queue<pair<int, int> > q;
    q.push({i, j});
    while (!q.empty()) {
        i = q.front().first;
        j = q.front().second;
        q.pop();
        
        if ((i != 0 && i != 1) || (j < 0 || j >= n)) continue;
        if (s[i][j] == '#' || s[i][j] == c) continue;
        s[i][j] = c;

        if ((i + j) % 2) b++; else w++;

        q.push({i + 1, j});
        q.push({i - 1, j});
        q.push({i, j + 1});
        q.push({i, j - 1});
    }

    // cout << b << " " << w << endl;
    return b == w;
}

int fi_neig(int i, int j) {
    int cnt = 0;

    if (i - 1 == 0) cnt += s[i - 1][j] == ',';
    else cnt += s[i + 1][j] == ',';

    if (j - 1 >= 0) cnt += s[i][j - 1] == ',';
    if (j + 1 < n)  cnt += s[i][j + 1] == ',';

    return cnt;
}

void solve() {
    cin >> n;
    cin >> s[0] >> s[1];

    bool ok = true;
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            if (s[i][j] == '.') {
                ok &= bfs(i, j, ',');
            }
        }
    }

    if (!ok) {
        cout << "None" << endl;
        return;
    }

    queue<pair<int, int> > q;
    int neig[2][n];
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            if (s[i][j] == ',') neig[i][j] = fi_neig(i, j);
            else neig[i][j] = -1;

            if (neig[i][j] == 1) q.push({i, j});
        }
    }

    while (!q.empty()) {
        int i = q.front().first;
        int j = q.front().second;
        q.pop();
        
        if ((i != 0 && i != 1) || (j < 0 || j >= n)) continue;
        if (s[i][j] == '#') continue;

        if (fi_neig(i, j) != 1) continue;

        if (s[i][j] != 'x') {
            if (i - 1 == 0 && s[i - 1][j] == ',') s[i - 1][j] = 'x';
            if (i + 1 == 1 && s[i + 1][j] == ',') s[i + 1][j] = 'x';
            if (j - 1 >= 0 && s[i][j - 1] == ',') s[i][j - 1] = 'x';
            if (j + 1 <  n && s[i][j + 1] == ',') s[i][j + 1] = 'x';
        }
        s[i][j] = '#';


        q.push({i + 1, j});
        q.push({i - 1, j});
        q.push({i, j + 1});
        q.push({i, j - 1});
    }

    // cout << s[0] << '\n' << s[1] << endl;

    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < n; j++) {
            if (s[i][j] == ',') {
                cout << "Multiple" << endl;
                return;
            }
        }
    }

    cout << "Unique" << endl;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}