#include <bits/stdc++.h>
using namespace std;
#define m_p make_pair
#define fi first
#define se second
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(),(x).end()
typedef long long ll;
const int N = 200005;

int n;
int a[N];
pair<int, int> aa[N];
vector<int> g[N];

int dp[N][2];
int hh[N];
void dfs(int x, int p)
{
    dp[x][0] = 0;
    dp[x][1] = -N;
    for (int i = 0; i < g[x].size(); ++i)
    {
        int h = g[x][i];
        if (h == p)
            continue;
        dfs(h, x);
        dp[x][0] += max(dp[h][0], dp[h][1]);
    }
    for (int i = 0; i < g[x].size(); ++i)
    {
        int h = g[x][i];
        if (h == p)
            continue;
        dp[x][0] -= max(dp[h][0], dp[h][1]);
        if (dp[x][0] + dp[h][0] + 1 > dp[x][1])
        {
            dp[x][1] = dp[x][0] + dp[h][0] + 1;
            hh[x] = h;
        }
        dp[x][0] += max(dp[h][0], dp[h][1]);
    }
}

void dfsm(int x, int p, int z, vector<pair<int, int> >& v)
{
    if (z == 0)
    {
        for (int i = 0; i < g[x].size(); ++i)
        {
            int h = g[x][i];
            if (h == p)
                continue;
            if (dp[h][0] > dp[h][1])
                dfsm(h, x, 0, v);
            else
                dfsm(h, x, 1, v);
        }
    }
    else
    {
        for (int i = 0; i < g[x].size(); ++i)
        {
            int h = g[x][i];
            if (h == p)
                continue;
            if (h == hh[x])
            {
                v.push_back(m_p(x, h));
                dfsm(h, x, 0, v);
            }
            else
            {
                if (dp[h][0] > dp[h][1])
                    dfsm(h, x, 0, v);
                else
                    dfsm(h, x, 1, v);
            }
        }
    }
}

int u[N], uu[N];
bool c[N];

void solvv(const vector<pair<int, int> >& v, vector<pair<int, int> >& ans)
{
    for (int i = 0; i < sz(v); ++i)
    {
        int j = sz(v) - 1 - i;
        if (i < j)
        {
            ans.push_back(m_p(v[i].fi, v[j].fi));
        }
    }
    for (int i = 0; i < sz(v); ++i)
    {
        int j = sz(v) - 2 - i;
        if (i < j)
        {
            ans.push_back(m_p(v[i].se, v[j].se));
        }
    }
}

void solv()
{
    cin >> n;

    for (int i = 0; i <= n * 2 + 1; ++i)
    {
        g[i].clear();
        u[i] = uu[i] = 0;
        aa[i] = m_p(0, 0);
        c[i] = false;
    }

    for (int i = 1; i <= n * 2; ++i)
        cin >> a[i];
    for (int i = 1; i <= n * 2; ++i)
    {
        if (aa[a[i]].fi == 0)
            aa[a[i]].fi = i;
        else
            aa[a[i]].se = i;
    }
    for (int i = 1; i <= n; ++i)
    {
        u[aa[i].fi] = aa[i].se;
        u[aa[i].se] = aa[i].fi;
    }
    for (int i = 0; i < n * 2 - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    dfs(1, 1);
    vector<pair<int, int> > v;
    if (dp[1][0] > dp[1][1])
        dfsm(1, 1, 0, v);
    else
        dfsm(1, 1, 1, v);

    /*for (int i = 0; i < sz(v); ++i)
        cout << v[i].fi << ' ' << v[i].se << "\n";
    cout << "\n";*/

    for (int i = 0; i < sz(v); ++i)
    {
        int x, y;
        x = v[i].fi;
        y = v[i].se;
        uu[x] = y;
        uu[y] = x;
    }

    vector<pair<int, int> > ans;
    for (int x = 1; x <= n * 2; ++x)
    {
        if (!uu[x])
            continue;
        if (c[x])
            continue;
        if (uu[u[x]])
            continue;
        vector<pair<int, int> > v;
        int y = x;
        while (uu[y])
        {
            v.push_back(m_p(y, uu[y]));
            c[y] = true;
            c[uu[y]] = true;
            y = u[uu[y]];
        }
        assert(uu[u[v.back().se]] == 0);
        ans.push_back(m_p(v.back().se, u[x]));
        solvv(v, ans);
    }
    for (int x = 1; x <= n * 2; ++x)
    {
        if (!uu[x])
            continue;
        if (c[x])
            continue;
        assert(uu[u[x]]);
        vector<pair<int, int> > v;
        int y = x;
        while (!c[y])
        {
            v.push_back(m_p(y, uu[y]));
            c[y] = true;
            c[uu[y]] = true;
            y = u[uu[y]];
        }
        //for (int i = 0; i < sz(v); ++i)
        //    cout << v[i].fi << ' ' << v[i].se << "\n";
        solvv(v, ans);
    }

    cout << sz(ans) << "\n";
    for (int i = 0; i < sz(ans); ++i)
        cout << ans[i].fi << ' ' << ans[i].se << "\n";
}

int main()
{
    #ifdef KNIGHT
    freopen("input.txt", "r", stdin);
    #endif // KNIGHT
    ios::sync_with_stdio(0);
    cin.tie(0);

    int tt = 1;
    cin >> tt;
    while (tt--)
    {
        solv();
    }
    return 0;
}
