#include <iostream>
#include <vector>
#include <utility>
#include <array>
#include <algorithm>
#include <set>
#define pii pair<int, int>
#define int long long

using namespace std;

const int oo = 1e18;



const int MAX = 1e6 + 100;

void solve(){
    int n, m, q; cin >> n >> m >> q;
    vector<pair<int, int>> v(n + 1);
    for(int i = 1; i <= n; ++i){
        cin >> v[i].second;
    }
    for(int i = 1; i <= n; ++i){
        cin >> v[i].first;
    }
    vector<int> pre(m + 1);
    vector<int> tmp;
    for(int i = 1; i <= m; ++i){
        int a; cin >> a;
        tmp.push_back(a);
    }
    for(int i = 1; i <= m; ++i){
        pre[i] = pre[i - 1] + tmp[i - 1];
    }
    sort(v.begin() + 1, v.end());
    vector<int> suf(n + 2, (int)oo);
    vector<int> p(n + 2, 0);
    for(int i = 1; i <= n; ++i){
        p[i] = p[i - 1] + v[i].second;
    }
    for(int i = n; i >= 1; --i){
        suf[i] = min(suf[i + 1], v[i].first - v[i].second + 1);
    }
    while(q--){
        int t; cin >> t;
        int idx = upper_bound(v.begin() + 1, v.end(), make_pair(t, oo)) - v.begin() - 1;
        int s = t - p[idx];
        if(idx != n){
            s -= (t - suf[idx + 1] + 1);
        }
        cout << upper_bound(pre.begin(), pre.end(), s) - pre.begin() - 1 << ' ';
    }
    cout << '\n';
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}