#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define sz(x) ((int)((x).size()))
using namespace std;
 
const int N = 200005;
int n, m, a[N], dp[N][2], dpa[N][2], re[N], rw[N][2];
vector<int> v[N];
vector<pair<int, int> > fp;
 
void dpfs(int x, int y = 0) {
    int bignig = 0, bigval = 0;
    for(int z : v[x]) {
        if(z == y) continue;
        dpfs(z, x);
        dp[x][1] += dp[z][0];
        if(dp[z][1] - dp[z][0] > bigval) {
            bigval = dp[z][1] - dp[z][0];
            bignig = z;
        }
    }
    dp[x][0] = dp[x][1] + bigval;
    dp[x][1] += 1;
    dpa[x][1] = y;
    dpa[x][0] = bignig;
}
 
set<pair<int, int> > wibs;
void gimewibs(int x, int r, int y = 0) {
    // cout << x << " " << r << " " << y << " " << dpa[x][r] << endl;
    if(r) {
        if(x < y) wibs.insert({x, y});
        else wibs.insert({y, x});
        re[x] = y;
        re[y] = x;
    }
    for(int z : v[x]) {
        if(z == y) continue;
        int nr = 0;
        if(dpa[x][r] == z) {
            nr = 1;
        }
        gimewibs(z, nr, x);
    }
}
 
void doaswap(int x, int y) {
    fp.push_back({x, y});
    int xi = 0, yi = 0;
    if(rw[a[x]][1] == x) xi = 1;
    if(rw[a[y]][1] == y) yi = 1;
    swap(rw[a[x]][xi], rw[a[y]][yi]);
    swap(a[x], a[y]);
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        wibs.clear();
        fp.clear();
        cin >> n;
        m = n;
        n *= 2;
        for(int i = 1; i <= n; i++) {
            v[i].clear();
            dp[i][0] = dp[i][1] = 0;
            dpa[i][0] = dpa[i][1] = 0;
            re[i] = 0;
            rw[i][0] = rw[i][1] = 0;
        }
        for(int i = 1; i <= n; i++) {
            cin >> a[i];
            if(rw[a[i]][0]) rw[a[i]][1] = i;
            else rw[a[i]][0] = i;
        }
        for(int i = 1; i < n; i++) {
            int x, y;
            cin >> x >> y;
            v[x].push_back(y);
            v[y].push_back(x);
        }
        dpfs(1);
        gimewibs(1, 0);
        int fixed = 0;
        while(wibs.size()) {
            if(!fixed || !re[fixed]) fixed = (*wibs.begin()).first;
            int fir = fixed;
            int sec = re[fixed];
            int notfixed = sec;
            if(fir > sec) swap(fir, sec);
            wibs.erase(wibs.find({fir, sec}));
            int alien = rw[a[fixed]][0];
            if(rw[a[fixed]][0] == fixed) alien = rw[a[fixed]][1];
            if(notfixed == alien) fixed = 0;
            else {
                doaswap(notfixed, alien);
                fixed = alien;
            }
        }
        cout << fp.size() << "\n";
        for(pair<int, int> x : fp) {
            cout << x.first << " " << x.second << "\n";
        }
    }
    cout << endl;
    return 0;
}