#include <bits/stdc++.h>
using namespace std;

#define int long long

bool isnum(char ch){
    return ch >= '0' && ch <= '9';
}

int strtoint(string str){
    int res = 0;
    for(int i = 0; i < str.length(); i++){
        res = res * 10 + (str[i] - '0');
    }
    return res;
}



int readnum(string &str, int &i){
    int start = i;
    while(true){
        if(!(str[i] >= '0' && str[i] <= '9')) break;
        i++;
    }
    // cout << "stoi: " << str.substr(start, i - start) << endl;
    return strtoint(str.substr(start, i - start));
}

int len(string &str, int &i){
    if(!isnum(str[i])) return 20;
    int start = i;
    while(true){
        if(!(str[i] >= '0' && str[i] <= '9')) break;
        i++;
    }
    return i - start;
}

bool valid(string &str){
    // cout << str << endl;
    int n = str.length();
    if(!isnum(str[0])) return false;
    for(int i = 0; i < n; i++){
        // cout << str[i] << " ";
        if(!isnum(str[i]) && i + 1 < n && !isnum(str[i + 1])) return false;
        int s = i;
        int leng = len(str, i);
        if(leng > 1 && str[s] == '0') return false;
        if(leng > 10) return false;
    }
    // cout << endl;
    // cout << str << endl;
    return true;
}

bool check(string &str){
    // cout << str << endl;
    int i = 0;
    int left = readnum(str, i);
    
    while(true){
        char ch = str[i];
        if(ch == '+'){
            i++;
            int second = readnum(str, i);
            left += second;
        }else if(ch == '-'){
            i++;
            int second = readnum(str, i);
            left -= second;
        }else{
            break;
        }
    }
    // cout << left << endl;
    // cout << str << endl;

    i++;
    int right = readnum(str, i);
    while(true){
        char ch = str[i];
        if(ch == '+'){
            i++;
            int second = readnum(str, i);
            right += second;
        }else if(ch == '-'){
            i++;
            int second = readnum(str, i);
            right -= second;
        }else{
            break;
        }
    }
    // cout << "movida" << endl;
    // cout << right << endl;
    // cout << str << endl;

    return left == right;
}

void solve(){
    string str; cin >> str;
    int n = str.length();

    if(valid(str) && check(str)){
        cout << "Correct" << endl;
        return;
    }

    for(int i = 0; i < n; i++){

        for(int j = 0; j <= n; j++){
            if(i == j) continue;
            if(str[i] == '+' || str[i] == '-' || str[i] == '=') continue;
            string newstr;
            if(i > j){
                newstr = str.substr(0, j) + str[i] + str.substr(j, i - j) + str.substr(i + 1);
            }else{
                newstr = str.substr(0, i) + str.substr(i + 1, j - i - 1) + str[i] + str.substr(j); 
            }
            if(valid(newstr) && check(newstr)){
                cout << newstr << endl;
                return;
            }
        }

    }
    
    cout << "Impossible" << endl;
}


signed main(){
    int t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
}