import java.io.*;
import java.util.Arrays;
import java.util.stream.IntStream;

public class A {

    private static final BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    private static int count = 0;

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(reader.readLine());
        StringBuilder result = new StringBuilder();
        int[] arr = Arrays.stream(reader.readLine().split(" ")).mapToInt(Integer::parseInt).toArray();

        StringBuilder a1 = method1(n);
        StringBuilder a2 = method2(arr);
        System.out.println(count);
        System.out.println(a1.toString().trim());
        System.out.println(a2.reverse().toString().trim());

    }

    public static StringBuilder method1(int n) {
        StringBuilder result = new StringBuilder();
        int[] arr = IntStream.range(1, n + 1).toArray();
        for (int i = 0; i < arr.length; i++) {
            for (int j = 1; j < arr.length - i; j++) {
                int temp = arr[j];
                arr[j] = arr[j - 1];
                arr[j - 1] = temp;

                count++;
                result.append(arr[j-1]).append(" ").append(arr[j]).append('\n');
            }
        }
        return result;
    }

    public static StringBuilder method2(int[] arr){
        StringBuilder result = new StringBuilder();
        for (int i = 0; i < arr.length - 1; i++) {
            for (int j = 0; j < arr.length - 1 - i; j++) {
                if (arr[j] > arr[j + 1]) continue;

                int temp = arr[j];
                arr[j] = arr[j + 1];
                arr[j + 1] = temp;
                count++;
                result.append(arr[j]).append(" ").append(arr[j + 1]).append("\n");
            }
        }
        return result;
    }

}