#include <bits/stdc++.h>

using namespace std;

#ifdef DBG
#define debugf(s, ...) do { fprintf(stderr, "(" #__VA_ARGS__ "): "); \
                            fprintf(stderr, s, __VA_ARGS__);         \
                            fprintf(stderr, "\n");} while (false)
#define debugv(c, v) do { fprintf(stderr, "("#v"):\n"); int idx = 0; for (auto elem: (v)) {fprintf(stderr, "\t");debugf("%d " c, idx, elem); ++idx;}} while (false)
#else
#define debugf(...) do {} while (false)
#define debugv(...) do {} while (false)
#endif

using i64 = int64_t;

constexpr int mod = 998'244'353;

#define CE constexpr
#define all(x) x.begin(), x.end()
#define int long long
typedef long double ld;
struct element {
    int l0, r0;
    int l, r;
    ld prob;
    void recalcpr(int c) {
        ld cv = (r0-l0+1);
        cv /= (r-l+1);
        if (c == 0) {
            prob *= cv;
        } else {
            prob *= (1-cv);
        }
    }
};
ld eps = 1e-20;
vector<element> recalcpr(element &a, int c) {
    auto [l0, r0, l, r, prob] = a;
    if (c == 0) {
        ld cv = (r0-l0+1);
        cv /= (r-l+1);
        a.prob *= cv;
        vector<element> t;
        t.push_back(a);
        return t;
    } else {
        vector<element> t;
        ld lftst = ((ld)l0-l)/(r-l+1);
        ld rgtst = ((ld)r-r0)/(r-l+1);
        lftst *= prob;
        rgtst *= prob;
        t.push_back({l0, r0, l0, r, lftst});
        t.push_back({l0, r0, l, r0, rgtst});
        return t;
    }
}
int n;
void solve(int tcc) {
    vector<element> nw;
    nw.push_back({1, n, 1, n, 1});
    while (1) {
        int p = 0;
        for (int i = 0; i < nw.size(); ++i) {
            if (nw[i].prob > nw[p].prob)
                p = i;
        }
        if (nw.empty())
            exit(1);
        int m0 = nw[p].l0 + nw[p].r0 >> 1;
        vector<element> nw2;
        for (auto i : nw) {
            if (i.l0 <= m0 and m0 <= i.r0) {
                int l0 = i.l0, r0 = i.r0;
                int l = i.l, r = i.r;
                ld prb = i.prob;
                ld pl = prb * (m0 - l0) / (r0 - l0 + 1);
                ld pr = prb * (r0 - m0) / (r0 - l0 + 1);
                if (l0 < m0) {
                    nw2.push_back({l0, m0 - 1, l, r, pl});
                }
                if (m0 < r0) {
                    nw2.push_back({m0 + 1, r0, l, r, pr});
                }
            } else {
                if (i.l < m0 and m0 < i.l0) {
                    i.l = m0;
                }
                if (i.r0 < m0 and m0 < i.r) {
                    i.r = m0;
                }
                nw2.push_back(i);
            }
        }
        nw = nw2;
        cout << m0 << endl;
        int t;
        cin >> t;
        if (t == -1)
            exit(0);
        if (t == 2)
            return;
        if (t == 3)
            exit(0);
        vector<element> nw3;
        for (auto i : nw) {
            for (auto j : recalcpr(i, t))
                nw3.push_back(j);
        }
        ld sm = 0;
        for (auto &i : nw3)
            sm += i.prob;
        //cerr << sm << endl;
        for (auto &i : nw3)
            i.prob /= sm;
        sm = 0;
        for (auto &i : nw3)
            sm += i.prob;
        vector<element> nw4;
        for (auto i : nw3) {
            if (i.prob > eps)
                nw4.push_back(i);
        }
        //cerr << sm << endl;
        nw = nw4;
    }
}

signed main() {
#ifndef DBG
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
#endif


    int t = 1;
    cin >> n >> t;
    while (1) solve(0);
}