#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 5e5 + 100, INF = 1e18;
vector<array<int, 2>> g[MAXN];
vector<array<int, 2>> grev[MAXN];
int dist[MAXN];
int tier[MAXN], used[MAXN];
int cnt[MAXN];

void solve_() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({v, w});
        grev[v].push_back({u, w});
    }
    fill(dist, dist + n, INF);
    dist[n - 1] = 0;
    set<array<int, 2>> st;
    st.insert({0, n - 1});
    while (!st.empty()) {
        int v = (*st.begin())[1];
        st.erase(st.begin());
        for (auto e : grev[v]) {
            int u = e[0], w = e[1];
            if (dist[u] > dist[v] + w) {
                st.erase({dist[u], u});
                dist[u] = dist[v] + w;
                st.insert({dist[u], u});
            }
        }
    }
    deque<int> q;
    fill(tier, tier + n, n + 1);
    for (int i = 0; i < n; ++i) {
        if (dist[i] == INF) {
            tier[i] = 0;
            q.push_back(i);
        }
        for (auto e : g[i]) {
            int u = e[0], w = e[1];
            if (dist[i] == dist[u] + w) ++cnt[i];
        }
    }
    used[n - 1] = true;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        if (used[v]) continue;
        used[v] = true;
        for (auto e : grev[v]) {
            int u = e[0], w = e[1];
            if (dist[u] == dist[v] + w) {
                --cnt[u];
                if (cnt[u] == 0 && tier[u] > tier[v]) {
                    tier[u] = tier[v];
                    q.push_front(u);
                }
            }
            if (tier[u] > tier[v] + 1) {
                tier[u] = tier[v] + 1;
                q.push_back(u);
            }
        }
    }
    cout << tier[0] - 1 << "\n";
}

/// #define MULTITEST

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    int tst = 1;
#ifdef MULTITEST
    cin >> tst;
#endif // MULTITEST
    while (tst--) {
        solve_();
    }
    return 0;
}