#include <bits/stdc++.h>
using namespace std;
#ifndef DEBUG
#define cerr if (false) cerr
#endif

#define F first
#define S second


typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

const int MAXN = 4e5 + 10;

int n;
vector<int> w;
vector<vector<int>> e;
vector<vector<int>> e2;
map<pii, set<pii>> mp;
vector<set<int>> wh;
void read() {
    cin >> n;
    n *= 2;

    w.resize(n);
    for (auto &i : w)
        cin >> i, i--;

    wh.assign(n, {});
    for (int i = 0; i < w.size(); i++) {
        wh[w[i]].insert(i);
    }

    e.assign(n, {});
    e2.assign(n, {});
    mp.clear();
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        e[a].push_back(b);
        e[b].push_back(a);
    }
}

vector<bool> used;
vector<int> c;
vector<int> p;
void DFS(int v) {
    cerr << "DFS( " << v << ") " << e.size() << endl;
    c[v] = 1;
    for (auto u : e[v]) {
        if (c[u] == -1) {
            p[u] = v;
            DFS(u);
        }
    }
    if (!used[v] && p[v] != -1 && !used[p[v]]) {
        int u = p[v];
        e2[w[v]].push_back(w[u]);
        e2[w[u]].push_back(w[v]);
        mp[{w[v], w[u]}].insert({v, u});
        mp[{w[u], w[v]}].insert({u, v});

        used[v] = true;
        used[u] = true;
        cerr << "GUYYYYYS " << v << ' ' << u << " vals " << w[v] << ' ' << w[u] << endl;
    }
}

void do_dfs() {
    used.assign(n, false);
    c.assign(n, -1);
    p.assign(n, -1);
    DFS(0);
}

vector<int> g;
void solver(int v, vector<int> &res) {
    res.push_back(v);
    g[v] = true;
    for (auto u : e2[v]) {
        if (!g[u])
            solver(u, res);
    }
}

set<pii> ans;
void do_swap(int a, int b) {
    ans.insert({a, b});
}

void printer() {
    cout << ans.size() << '\n';
    for (auto [a, b] : ans) {
        cout << a + 1 << ' ';
        cout << b + 1 << '\n';
    }
}

void solver() {
    g.assign(n, false);
    ans.clear();
    for (int t = 0; t < n; t++) {
        if (!g[t]) {
            vector<int> res;
            solver(t, res);

            for (auto u : res)
                g[u] = 0;
            int ii = res.back();
            res.clear();
            solver(ii, res);

            if (res.size() == 1)
                continue;

            cerr << "res = ";
            for (auto i : res)
                cerr << i << ' ';
            cerr << endl;

            vector<int> p1(res.size() - 1);
            vector<int> p2(res.size() - 1);
            for (int i = 1; i < res.size(); i++) {
                int u, v;
                u = res[i - 1];
                v = res[i];
                int sz = mp[{u, v}].size();
                assert(sz);
                auto pp = *mp[{u, v}].begin();
                mp[{u, v}].erase(pp);
                mp[{v, u}].erase({pp.S, pp.F});
                p1[i - 1] = pp.F;
                p2[i - 1] = pp.S;
            }

            cerr << "p1 = ";
            for (auto i : p1)
                cerr << i << ' ';
            cerr << endl;
            cerr << "p2 = ";
            for (auto i : p2)
                cerr << i << ' ';
            cerr << endl;
            int u = res.back();
            int v = res[0];
            reverse(p1.begin(), p1.end());
            reverse(p2.begin(), p2.end());
            if (mp.count({u, v}) && mp[{u, v}].size()) {
                int sz = mp[{u, v}].size();
                assert(sz);
                auto pp = *mp[{u, v}].begin();
                mp[{u, v}].erase(pp);
                mp[{v, u}].erase({pp.S, pp.F});
                p1.push_back(pp.F);
                p2.push_back(pp.S);
            } else {
                auto s = wh[v];
                s.erase(p1.back());
                assert(s.size() == 1);
                auto np = *s.begin();

                p1.push_back(-1);
                p2.push_back(np);
            }
            reverse(p1.begin(), p1.end());
            reverse(p2.begin(), p2.end());

            cerr << "p1 = ";
            for (auto i : p1)
                cerr << i << ' ';
            cerr << endl;
            cerr << "p2 = ";
            for (auto i : p2)
                cerr << i << ' ';
            cerr << endl;


            int l = 0;
            int r = p1.size() - 1;
            int cnt = 0;
            while (l < r) {
                if (cnt == 0) {
                    do_swap(p2[l], p2[r]);
                    l++;
                } else {
                    do_swap(p1[l], p1[r]);
                    r--;
                }
                cnt ^= 1;
            }
        }
    }
}

void solve() {
    read();
    do_dfs();
    solver();
    printer();
}

signed main() {
    #ifdef DEBUG
        freopen("input.in", "r", stdin);
        // freopen("output.out", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
}