#include <bits/stdc++.h>
using namespace std;

#define nl '\n'
#define ll long long

string next_after(const string &s, int i, int j) {
    string x = s.substr(0, i);
    // cout << s.substr(0, i) << ' ';
    x += s.substr(i+1, j-i-1);
    // cout << s.substr(i+1, j-i-1) << ' ';
    x += s[i];
    // cout << s[i] << ' ';
    x += s.substr(j); // todo
    // cout << s.substr(j) << '\n';
    return x;
}

string next_before(const string &s, int i, int j) {
    string x = s.substr(0, j);
    // cout << s.substr(0, j) << ' ';
    x += s[i];
    // cout << s[i] << ' ';
    x += s.substr(j, i-j);
    // cout << s.substr(j, i-j) << ' ';

    x += s.substr(i+1); // todo
    // cout << s.substr(i+1) << '\n';
    return x;
}

ll binpow(ll a, ll b) {
    ll r = 1;
    for (int i=0; i<b; i++)
        r *= 10;
    return r;
}

ll get(const string &s) {
    // if(s=="123456789+987654321") cout<<s<<nl;

    ll num = 0, res = 0;
    int n = s.length();
    int p = 0;

    int sign = 1;

    for (int i=0; i<n; i++) {
        if (s[i] != '+' && s[i] != '-') {
            num = num * 10 + (s[i] - '0');
            p++;
            continue;
        }

        if (p > 10 || num < binpow(10, p-1)) {
            return LLONG_MAX;
        }

        res += sign * num;

        if (s[i] == '+')
            sign = 1;

        if (s[i] == '-')
            sign = -1;

        num = 0; p = 0;
    }

    if (p > 10 || num < binpow(10, p-1)) {
        return LLONG_MAX;
    }

    res += sign * num;

    return res;
}

bool check(const string &s) {
    int x = -1;
    for (int i=0; i<s.length(); i++) {
        if (s[i] == '=') {
            x = i;
            break;
        }
    }

    string s1 = s.substr(0, x);
    string s2 = s.substr(x+1);

    // if(s=="123456789+987654321=1111111100+11-1") cout<<s1 << ' ' <<s2<<nl;
    // cout << s1 << " ?= " << s2 << '\n';
    ll a1 = get(s1);
    ll a2 = get(s2);
    if (a1 == LLONG_MAX || a2 == LLONG_MAX)
        return 0;

    return get(s1) == get(s2);
}

void solve() {
    string s;
    cin >> s;

    int n = s.length();

    if (check(s)) {
        cout << "Correct";
        return;
    }

    for (int i=0; i<n; i++) {
        if (s[i] == '+' or s[i] == '-' or s[i] == '=') continue;
        if(i==0 and (s[i+1]=='+' or s[i+1]=='-' or s[i+1]=='=')) continue;
        if(i==n-1 and (s[i-1]=='+' or s[i-1]=='-' or s[i-1]=='=')) continue;
        if((s[i-1]=='+' or s[i-1]=='-' or s[i-1]=='=') and (s[i+1]=='+' or s[i+1]=='-' or s[i+1]=='=')) continue;

        for (int j=0; j<n; j++) {
            if (j == i) continue; // todo
            // cout << "Trying " << i << " -> " << j << ": ";
            string x;
            if (j < i) {
                x = next_before(s, i, j);
            } else {
                x = next_after(s, i, j);
            }

            // cout << x << nl;

            if (check(x)) {
                cout << x;
                return;
            }
        }
    }

    cout << "Impossible";
}

int main() {
    // freopen("input.txt", "r", stdin);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << nl;
    }

    return 0;
}
