#include<bits/stdc++.h>

#define DEBUGSTR_WNAME(os, name, a) \
    do { (os) << (name) << " = " << (a) << std::endl; } while(false)

#define DEBUGSTR(os, a) DEBUGSTR_WNAME((os), #a, (a))
#define DEBUG(a) DEBUGSTR_WNAME(std::cout, #a, (a))

#define ll long long
#define ld long double

#define pii pair<int, int>
#define vi vector<int>
#define vl vector<ll>

#define all(x) x.begin(), x.end()
#define sz(x)  (int)x.size()
#define pb push_back
#define fi first
#define se second

using namespace std;

const int N = (int)2e5 + 2000;
const int M = (int)1e7 + 200;
const ll mod = (ll)1e9+7;
const ll inf = (ll)1e18 + 7;
const char nl = '\n';

bool isDigit(char x) {
    return ('0' <= x && x <= '9');
}

bool bad = false;

ll calc(string &s) {
    ll sum = 0;
    vector<int> vals;
    int sign = 1, n = sz(s);
    if (s[0] == '+') {
        bad = true;
    }
    for (int i = 0; i < n; ++i) {
        if (s[i] == '+' || s[i] == '-') {
            if (i == n - 1) {
                bad = true;
            }
            if (s[i] == '+') sign = 1;
            else sign = -1;
            continue;
        }
        int j = i;
        ll cur = 0;
        if (s[i] == '0' && i + 1 < n && isDigit(s[i + 1])) {
            bad = true;
            break;
        }
        int len = 0;
        while (j < n && isDigit(s[j])) {
            cur = (cur * 10) + (int)(s[j] - '0');
            ++j;
            ++len;
        }
        if (len > 10) {
            bad = true;
            break;
        }
        sum += sign * cur;
        i = j - 1;
    }
    return sum;
}

bool ok(string &s) {
    bad = false;
    ll lSum = 0, rSum = 0;
    bool isLeft = true;
    int n = sz(s);
    string L, R;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '=') {
            isLeft = false;
            continue;
        }
        if (isLeft) L += s[i];
        else R += s[i];
    }
    lSum = calc(L);
    rSum = calc(R);
    if (bad) {
        return false;
    }
    return (lSum == rSum);
}

void solve() {
    string s; cin >> s;

    if (ok(s)) {
        cout << "Correct";
        return;
    }

    int n = sz(s);
    for (int i = 0; i < n; ++i) {
        if (!isDigit(s[i])) continue;
        string nxt;
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            nxt += s[j];
        }
        for (int j = 0; j < sz(nxt); ++j) {
            string nxt2;
            for (int k = 0; k < sz(nxt); ++k) {
                nxt2 += nxt[k];
                if (j == k) {
                    nxt2 += s[i];
                }
            }
            if (ok(nxt2)) {
                cout << nxt2;
                return;
            }
        }
        nxt = s[i] + nxt;
        if (ok(nxt)) {
            cout << nxt << "\n";
            return;
        }
    }

    cout << "Impossible";
}

int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int test = 1;
    // cin >> test;
    while(test--) {
        solve();
        cout << nl;
    }
}
