//
// Created by nef on 15.12.2024.
//

#include <bits/stdc++.h>
#define ll long long
const int mod = 1e9 + 7;

using namespace std;

const int N = 1000 + 11;

int a[N];
int p[N];
int used[N][N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        p[i] = i;
    }
    vector<pair<int, int>> ans;
    for (int i = 1; i <= n; i++) {
        int pos1 = -1;
        for (int j = 1; j <= n; j++) {
            if (i == p[j]) {
                pos1 = j;
                break;
            }
        }
        int pos2 = -1;
        for (int j = 1; j <= n; j++) {
            if (i == a[j]) {
                pos2 = j;
                break;
            }
        }
        assert(pos1 <= pos2);
        for (int j = pos1; j < pos2; j++) {
            ans.emplace_back(p[j + 1], p[j]);
            swap(p[j], p[j + 1]);
        }
    }
    for (int i = 1; i <= n; i++) {
        int j = i;
        while (j < n && a[j] < a[j + 1]) {
            j++;
        }
        for (int k = i + 1; k <= j; k++) {
            ans.emplace_back(p[k], p[i]);
        }
        for (int k = j; k > i; k--) {
            ans.emplace_back(p[i], p[k]);
        }
    }
    cout << ans.size() << "\n";
    for (auto pr : ans) {
        cout << pr.first << " "  << pr.second << "\n";
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int T = 1;
    //cin >> T;

    while(T--) solve();

    return 0;
}