//
// Created by nef on 15.12.2024.
//

#include <bits/stdc++.h>
#define ll long long
const int mod = 1e9 + 7;

using namespace std;

int dig(string s, int i) {
    if (i < 0 || i >= s.size()) return 0;
    if (s[i] >= '0' && s[i] <= '9') return 1;
    return 0;
}

bool check(string s) {
    int n = s.size();
//    cout << " ---- " << endl;
//    cout << s << endl;
    if (s[0] == '=' || s[0] == '-' || s[0] == '+') return 0;
    if (s[s.size() - 1] == '=' || s[s.size() - 1] == '-' || s[s.size() - 1] == '+') return 0;
    ll sum = 0;
    ll last = 0;
    int prik = 1;
    int sgn = 1;
    int cnt = 0;
    for (int i = 0 ; i < n ; ++ i) {
        if (!dig(s, i - 1) && dig(s, i + 1) && s[i] == '0') return 0;
        if (s[i] == '+' || s[i] == '-' || s[i] == '=') {
            if (cnt > 10) return 0;
            sum += last * sgn;
            last = 0;
            cnt = 0;
            if (s[i] == '=') {
                prik = -1;
                sgn = -1;
            }
            if (s[i] == '+') {
                sgn = prik;
            }
            if (s[i] == '-') {
                sgn = -prik;
            }
        } else {
            cnt++;
            int d = s[i] - '0';
            last = last * 10 + d;
        }
//        cout << s[i] << " " << sum << " " << last << " " << prik << " " << sgn << endl;
    }
    if (cnt > 10) return 0;
    sum += last * sgn;
    return sum == 0;
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    if (check(s)) {
        cout << "Correct";
        return;
    }
    for (int i = 0 ; i < n ; ++ i) {
        for (int j = 0 ; j <= n ; ++ j) {
            if (dig(s, i) == 0) continue;
            string t;
            if (i < j){
                for (int k = 0; k < i ; ++ k) t += s[k];
                for (int k = i + 1 ; k < j ; ++ k) t += s[k];
                t += s[i];
                for (int k = j ; k < n ; ++ k) t += s[k];
            } else {
                for (int k = 0; k < j ; ++ k) t += s[k];
                t += s[i];
                for (int k = j ; k < i ; ++ k) t += s[k];
                for (int k = i + 1 ; k < n ; ++ k) t += s[k];
            }
            assert(s.size() == t.size());
            if (check(t)) {
                cout << t;
                return;
            }
        }

    }
    cout << "Impossible";
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int T = 1;
//    cin >> T;

    while(T--) solve();

    return 0;
}