//
// Created by nef on 15.12.2024.
//

#include <bits/stdc++.h>
#define ll long long
const int mod = 1e9 + 7;

using namespace std;

int dig(string s, int i) {
    if (i < 0 || i >= s.size()) return 0;
    if (s[i] >= '0' && s[i] <= '9') return 1;
    return 0;
}

bool check(string s) {
    int n = s.size();
//    cout << " ---- " << endl;
//    cout << s << endl;
    if (s[0] == '=' || s[0] == '-' || s[0] == '+') return 0;
    if (s[s.size() - 1] == '=' || s[s.size() - 1] == '-' || s[s.size() - 1] == '+') return 0;
    ll sum = 0;
    ll last = 0;
    int prik = 1;
    int sgn = 1;
    int cnt = 0;
    for (int i = 0 ; i < n ; ++ i) {
        if (!dig(s, i - 1) && dig(s, i + 1) && s[i] == '0') return 0;
        if (s[i] == '+' || s[i] == '-' || s[i] == '=') {
            if (cnt > 10) return 0;
            sum += last * sgn;
            last = 0;
            cnt = 0;
            if (s[i] == '=') {
                prik = -1;
                sgn = -1;
            }
            if (s[i] == '+') {
                sgn = prik;
            }
            if (s[i] == '-') {
                sgn = -prik;
            }
        } else {
            cnt++;
            int d = s[i] - '0';
            last = last * 10 + d;
        }
//        cout << s[i] << " " << sum << " " << last << " " << prik << " " << sgn << endl;
    }
    if (cnt > 10) return 0;
    sum += last * sgn;
    return sum == 0;
}

const ll MAX = 9999999999;

bool calc(string s) {
    int n = s.size();
    if (!isdigit(s[0])) return false;
    int sgn = 1;
    vector<ll> sums = {0, 0};
    int side = 0;
    int need = 1;
    for (int i = 0; i < n; i++) {
        if (s[i] == '+') {
            if (need) return false;
            sgn = 1;
            need = 1;
        } else if (s[i] == '-') {
            if (need) return false;
            sgn = -1;
            need = 1;
        } else if (s[i] == '=') {
            if (need) return false;
            side++;
            if (side > 1) return false;
            need = 1;
        } else {
            int j = i;
            while (j < n - 1 && isdigit(s[j + 1])) {
                j++;
            }
            string sval = s.substr(i, j - i + 1);
            if (sval.size() > 1 && sval[0] == '0') return false;
            ll val = stoll(sval);
            if (val > MAX) return false;
            sums[side] += sgn * val;
            need = 0;
            i = j;
        }
    }

    if (need) return false;

    return sums[0] == sums[1];
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    if (calc(s)) {
        cout << "Correct";
        return ;
    }
    for (int i = 0; i < n; i++) {
        if (isdigit(s[i])) {
            for (int j = 0; j < n + 1; j++) {
                string t = "";
                for (int k = 0; k < n; k++) {
                    if (k == j) {
                        t += s[i];
                    }
                    if (k == i) continue;
                    t += s[k];
                }
                if (j == n) t += s[i];
                if (calc(t)) {
                    cout << t;
                    return ;
                }
            }
        }
    }
    cout << "Impossible";
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int T = 1;
//    cin >> T;

    while(T--) solve();

    return 0;
}