#include <iostream>
#include <vector>

using namespace std;

string testCase()
{
    int n;
    cin >> n;
    // 0 - #; 1 - .; 2 - marked
    string mat[2];
    cin >> mat[0] >> mat[1];

    int markCnt = 0;
    int flag = 0;
    while (flag < 100)
    {
        for (int row = 0; row < 2; ++row)
        {
            for (int i = 0; i < n; ++i)
            { // for each char
                if (mat[row][i] == '#')
                    continue;
                if (mat[row][i] == '@' && flag == 99)
                {
                    if (markCnt % 2 == 0)
                        return "Multiple";
                    else return "None";
                }

                vector<pair<int, int>> neighbors;

                if (i > 0) // check left
                {
                    if (mat[row][i - 1] == '.' || mat[row][i - 1] == '@')
                    {
                        neighbors.push_back({row, i - 1});
                    }
                }
                if (i < n - 1) // check right
                {
                    if (mat[row][i + 1] == '.' || mat[row][i + 1] == '@')
                    {
                        neighbors.push_back({row, i + 1});
                    }
                }
                if (mat[(row + 1) % 2][i] == '.' || mat[(row + 1) % 2][i] == '@') // check bottom/top
                {
                    neighbors.push_back({(row + 1) % 2, i});
                }

                if (neighbors.size() == 0)
                {
                    return "None";
                }
                if (neighbors.size() == 1)
                {
                    mat[row][i] = '#';
                    mat[neighbors[0].first][neighbors[0].second] = '#';
                    continue;
                }
                mat[row][i] = '@';
                ++markCnt;
            }
        }
        ++flag;
    }
    return "Unique";
}

int main()
{
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    for (int ti = 0; ti < t; ++ti)
    {
        cout << testCase() << '\n';
    }

    cout << flush;

    return 0;
}