#include<bits/stdc++.h>
#define ll long long

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()

template<typename T>
int len(T &a){
    return a.size();
}

struct Point{
    ll x=0,y=0,xd=0,yd=0;

    void move(ll rot, ll u){
        if(rot==0)x+=u;
        else if(rot==90)y+=u;
        else if(rot==180)x-=u;
        else if(rot==270)y-=u;
        else if(rot==45){
            x+=u;
            y+=u;
        }
        else if(rot==135){
            x-=u;
            y+=u;
        }
        else if(rot==225){
            x-=u;
            y-=u;
        }
        else if(rot==315){
            x+=y;
            y-=u;
        }
    }

    void a(Point p){
        x=p.x;
        y=p.y;
        xd=p.xd;
        yd=p.yd;
    }

    void sub(Point a){
        x-=a.x;
        y-=a.y;
        xd-=a.xd;
        yd-=a.yd;
    }

    bool operator < (const Point &op){
        return make_tuple(x, y,xd, yd) < make_tuple(op.x, op.y, op.xd, op.yd);
    }
    bool operator <= (const Point &op){
        return make_tuple(x, y,xd, yd) <= make_tuple(op.x, op.y, op.xd, op.yd);
    }
    bool operator == (const Point &op){
        return make_tuple(x, y,xd, yd) == make_tuple(op.x, op.y, op.xd, op.yd);
    }
};


struct Seg{
    Point b,e;

    
    bool operator < (const Seg &op){
        if(b<op.b){
            return 1;
        }
        else if(b==op.b){
            if(e<=op.e){
                return 1;
            }
        }
        return 0;
    }
};

struct Move{
    string t;
    ll u;
};

bool check(vector<Seg>org,vector<Seg>seg){
    Point p=org[0].b;
    p.sub(seg[0].b);
    for(int i=0;i<len(org);i++){
        Point cur=org[i].b;
        cur.sub(seg[i].b);
        if(!(p==cur))return 0;
    }
    for(int i=0;i<len(org);i++){
        Point cur=org[i].e;
        cur.sub(seg[i].e);
        if(!(p==cur))return 0;
    }
    return 1;
}


vector<Move>moves(){
    int n;
    cin>>n;
    vector<Move>m;
    for(int i=0;i<n;i++){
        string s;ll u;cin>>s>>u;
        if(s=="draw"){
            if(m.size()){
                if(m.back().t==s){
                    m.back().u+=u;
                }
                else{
                    m.push_back({s,u}); 
                }
            }
            else{
                m.push_back({s,u});
            }
        }
        else if(m.size()){
            if(m.back().t==s){
                m.back().u+=u;
            }
            else{
                m.push_back({s,u}); 
            }
        }
    }
    // cout<<"Moves\n";
    // for(Move mo:m){
    //     cout<<mo.t<<" "<<mo.u<<"\n";
    // }
    return m;
}

// vector<Point>points(vector<Seg>segs){
//     set<Point>p;
//     for(Seg seg:segs){
//         p.insert(seg.e);
//         p.insert(seg.b);
//     }
//     vector<Point>p1;
//     for(Point p2:p)p1.push_back(p2);
//     return p1;
// }

vector<Seg>segs(int rot,vector<Move>moves){
    // cout<<"Segs "<<rot<<":\n";
    Point p;
    vector<Seg>seg;
    for(Move move:moves){
        if(move.t=="draw"){
            Point p1,p2;
            p1.a(p);
            p2.a(p);
            p2.move(rot,move.u);
            if(p1<p2){
                seg.push_back({p1,p2});
            }
            else{
                seg.push_back({p2,p1});
            }
            p.a(p2);
        }
        else if(move.t=="move"){
            p.move(rot,move.u);
        }
        else{
            rot+=move.u;
            rot%=360;
        }

    }
    sort(seg.begin(),seg.end());
    // for(Seg s:seg){
    //     cout<<s.b.x<<" "<<s.b.y<<" "<<s.b.xd<<" "<<s.b.yd<<" -> ";
    //     cout<<s.e.x<<" "<<s.e.y<<" "<<s.e.xd<<" "<<s.e.yd<<"\n";
    // }
    return seg;
}



void solve(){
    vector<Move>m=moves();
    vector<Seg>org=segs(0,m);
    if(check(org,segs(45,m)))cout<<45;
    else if(check(org,segs(90,m)))cout<<90;
    else if(check(org,segs(135,m)))cout<<135;
    else if(check(org,segs(180,m)))cout<<180;
    else if(check(org,segs(225,m)))cout<<225;
    else if(check(org,segs(270,m)))cout<<270;
    else if(check(org,segs(315,m)))cout<<315;
    else cout<<360;
}   

int main(){
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);


    int testcases = 1;
    // cin >> testcases;
    while(testcases --){
        solve();
        if(testcases) cout << '\n';
    }
}