#include <iostream>
#include <vector>
#include <string>

using namespace std;

void solveA()
{
    int n;

    cin >> n;

    vector<int> arr(n);

    for (int i = 0; i < n; i++)
        cin >> arr[i];

    cout << (n - 1) * 2 << endl;

    for (int i = n - 1; i >= 0; i--)
    {
        for (int l = arr[i], r = i + 1; l < r; l++)
        {
            cout << l + 1 << ' ' << arr[i] << endl;
        }
    }

    for (int i = 0; i < n - 1; i++)
    {
        if (arr[i] < arr[i + 1])
        {
            cout << arr[i + 1] << ' ' << arr[i] << endl;
            cout << arr[i] << ' ' << arr[i + 1] << endl;
        }
    }
}

void solveF()
{
    int n;
    cin >> n;

    string up, down;
    cin >> up >> down;

    bool uniq = true;
    bool valid = true;

    for (int i = 0; i < n; i += 1)
    {
        if (up[i] == '.' && down[i] == '.' &&
            up[i + 1] == '.' && down[i + 1] == '.')
            uniq = false;

        if (up[i] == '.' && down[i] == '.')
        {
            up[i] = '#';
            down[i] = '#';
            continue;
        }
        
        if (up[i] == '.' && up[i + 1] == '.' && i != n - 1)
        {
            up[i] = '#';
            up[i + 1] = '#';
            continue;
        }

        if (down[i] == '.' && down[i + 1] == '.' && i != n - 1)
        {
            down[i] = '#';
            down[i + 1] = '#';
            continue;
        }
        if (up[i] != '#' && down[i] == '#')
            valid = false;
        break;
    }
    if (valid)
    {
        if (uniq)
            cout << "Unique" << endl;
        else
            cout << "Multiple" << endl;
    }
    else
        cout << "None" << endl;
}

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout.precision(100);

    int n;
    //cin >> n;

    //while (n--)
        solveA();

    return 0;
}