#pragma GCC optimize("Ofast", "fast-math", "uroll-loops")


#include <bits/stdc++.h>

using ll = long long;
using namespace std;

void solve() {
    ll n, m, q;
    cin >> n >> m >> q;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].second;
    for (int i = 0; i < n; ++i) cin >> a[i].first;
    vector<ll> b(m);
    for (int i = 0; i < m; ++i) cin >> b[i];
    sort(a.begin(), a.end());
    vector<ll> p(n);
    p[n - 1] = a[n - 1].first - a[n - 1].second;
    for (int i = n - 2; i >= 0; --i) {
        p[i] = min(p[i + 1], a[i].first) - a[i].second;
    }
    vector<ll> bp(m + 1, 0);
    for (int i = 1; i <= m; ++i) {
        bp[i] = bp[i - 1] + b[i - 1];
    }
    vector<ll> ap(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        ap[i] = ap[i - 1] + a[i - 1].second;
    }
    while (q--) {
        ll t;
        cin >> t;
        ll l = 0, r = m + 1;
        while (r - l > 1) {
            ll mid = (r + l) >> 1;
            ll li = 0, ri = n + 1;
            while (ri - li > 1) {
                ll midi = (li + ri) >> 1;
                if (a[midi - 1].first > t) {
                    ri = midi;
                } else {
                    li = midi;
                }
            }
            ll sum = bp[mid] + ap[li];
            if (sum > t || (li != n && sum > p[li])) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << l << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
