#include <iostream>
#include <vector>

using namespace std;

string fixFloodedFloor(int length, string top, string bottom) {
    string output = "Unique";
    for (int i = 0; i < length - 1; i++) {
        if (top[i] == '.') {
            if (bottom[i] == '.' && bottom[i + 1] == '.' && top[i + 1] == '.') {
                output = "Multiple";
                top[i] = '#';
                top[i + 1] = '#';
                bottom[i] = '#';
                bottom[i + 1] = '#';
                continue;
            }

            if (bottom[i] == '.') {
                top[i] = '#';
                bottom[i] = '#';
            } else if (top[i + 1] == '.') {
                top[i] = '#';
                top[i + 1] = '#';
            } else {
                return "None";
            }
        }

        if (bottom[i] == '.') {
            if (bottom[i] == '.') {
                bottom[i + 1] = '#';
            } else {
                return "None";
            }
        }
    }

    if (top[length - 1] == '.') {
        if (bottom[length - 1] == '.') {
            top[length - 1] = '#';
            bottom[length - 1] = '#';
        } else {
            return "None";
        }
    }

    if (bottom[length - 1] == '.') {
        return "None";
    }

    return output;
}

int main() {
    string output;
    int t;
    cin >> t;
    string top, bottom;
    vector<string> answers;
    for (int i = 0; i < t; i++) {
        int length;
        cin >> length;
        cin >> top;
        cin >> bottom;
        answers.push_back(fixFloodedFloor(length, top, bottom));
    }
    for (int i = 0; i < t; i++) {
        cout << answers[i] << endl;
    }
//    cout << fixFloodedFloor(10, "#.......##", "##..#.##..") << endl;
//    cout << fixFloodedFloor(6, "...#..", "..#...")  << endl;
//    cout << fixFloodedFloor(8, "........", "........")  << endl;
//    cout << fixFloodedFloor(3, "###", "###")  << endl;
//    cout << fixFloodedFloor(1, ".", "#") << endl;
//    cout << fixFloodedFloor(1, ".", ".") << endl;
//    cout << fixFloodedFloor(6, "#.#..#", "#...##") << endl;
    return 0;
}
