#include <bits/stdc++.h>

#define ll long long

using namespace std;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  ll t;
  cin >> t;
  while (t--) {
    ll n, m, q;
    cin >> n >> m >> q;
    vector<array<ll, 2>> a(n);
    for (auto &[e1, e2] : a) {
      cin >> e2;
    }
    for (auto &[e1, e2] : a) {
      cin >> e1;
    }
    sort(a.begin(), a.end());
    vector<ll> pr(m + 1);
    for (ll i = 1; i <= m; ++i) {
      cin >> pr[i];
      pr[i] += pr[i - 1];
    }
    ll s = 0;
    vector<ll> ft(n);
    for (ll i = 0; i < n; ++i) {
      s += a[i][1];
      ft[i] = a[i][0] - s;
    }
    vector<ll> suf(n);
    suf[n - 1] = ft[n - 1];
    for (ll i = n - 2; 0 <= i; --i) {
      suf[i] = min(ft[i], suf[i + 1]);
    }
    while (q--) {
      ll x;
      cin >> x;
      array<ll, 2> tmp = {x, 0};
      ll i = upper_bound(a.begin(), a.end(), tmp) - a.begin();
      if (i == 0) {
        cout << upper_bound(pr.begin(), pr.end(), min(suf[0], x)) - pr.begin() - 1 << ' ';
      } else if (i == n) {
        cout << upper_bound(pr.begin(), pr.end(), ft.back() + x - a.back()[0]) - pr.begin() - 1 << ' ';
      } else {
        --i;
        if (suf[i + 1] <= ft[i]) {
          cout << upper_bound(pr.begin(), pr.end(), suf[i + 1]) - pr.begin() - 1 << ' ';
        } else {
          cout << upper_bound(pr.begin(), pr.end(), ft[i] + min(x - a[i][0], suf[i + 1] - ft[i])) - pr.begin() - 1 << ' ';
        }
      }
    }
    cout << '\n';
  }
  return 0;
}
