#include <bits/stdc++.h>

using namespace std;

template<typename T>
bool mini(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


template<typename T>
bool maxi(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<ranges::input_range R>
requires (!is_same_v<string, R>)
ostream &operator<<(ostream &out, const R &v) {
    string space = "\n";
    if constexpr (is_scalar_v<typename R::value_type>) {
        space = " ";
    }
    for (const auto &a: v) {
        out << a << space;
    }
    return out;
}


template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &a: v) {
        in >> a;
    }
    return in;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
    out << v.first << ' ' << v.second;
    return out;
}

template<typename T, typename U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.first >> v.second;
    return in;
}

using ll = long long;
/*
 *
 */

size_t new_ind = 0;

struct IndInt {
    ll x, id;

    IndInt(int x, int id) : x(x), id(id) {

    }

    explicit IndInt() = default;


    friend istream &operator>>(istream &in, IndInt &i) {
        in >> i.x;
        i.id = new_ind++;
        return in;
    }

    friend bool operator<(const IndInt &a, const IndInt &b) {
        if (a.x != b.x)
            return a.x < b.x;
        return a.id < b.id;
    }
};

struct Task {
    ll a, d, id;

    Task(ll a, ll d, ll id) : a(a), d(d), id(id) {

    }

    Task() = default;
};

void solve() {
    int x;
    cin >> x;
    for (int i = 0; i < 16; ++i) {
        printf("%04x %04x %04x %04x  ", (1 << 16) - 16 + i, 16*16*i + 32 + 2, 16*i + 8, 0);
        printf("%04x %04x %04x %04x  ", 0, 0, 0, 0);
        if (x & (1 << i)) {
            printf("%04x %04x %04x %04x  ", 0, 0, 16*16 + 3, 0);
            printf("%04x %04x %04x %04x\n", 0, 0, 16*i + 16, 0);
        }
        else {
            printf("%04x %04x %04x %04x  ", 0, 0, 16*i + 16, 0);
            printf("%04x %04x %04x %04x\n", 0, 0, 16*16 + 3, 0);
        }
    }
    printf("%04x %04x %04x  ", 16*16*16 + 2*3*16 + 1, (1 << 16) - 16, 1 << 12);
    printf("%04x %04x %04x  ", 16*16*16 + 2*3*16, (1 << 16) - 16, 1 << 12);
    printf("%04x\n", 2);
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
#ifdef BOBRY
    freopen("./../bobry.txt", "r", stdin);
    freopen("./../bober.txt", "w", stdout);
    cin >> test;
#endif

    while (test--) {
        solve();
        cout << '\n';
    }
}