#include <bits/stdc++.h>

using namespace  std;

#define int long long

int to_mask(char a, char b) {

    int first = (a == '.');
    int second = (b == '.');

    return first * 2 + second;
}

void to_small(int &val) {
    if (val > 2) {
        val = 2;
    }
}

void solve() {
    int n;
    cin >> n;
    string s, s1;
    cin >> s >> s1;

    vector <vector<int>> dp(n, vector<int> (4, 0));


    dp[0][to_mask(s[0], s1[0])] = 1;

    if (s[0] == '.' && s1[0] == '.') {
        dp[0][to_mask('#', '#')] = 1;
    }

    for (int i = 1; i < n; i++) {
        for (int lmask = 0; lmask < (1 << 2); lmask++) {
            if (lmask == 2 && s[i] == '.') {
                dp[i][to_mask('#', s1[i])] += dp[i - 1][lmask];
                to_small(dp[i][to_mask('#', s1[i])]);
            }

            if (lmask == 1 && s1[i] == '.') {
                dp[i][to_mask(s[i], '#')] += dp[i - 1][lmask];
                to_small(dp[i][to_mask(s[i], '#')]);
            }

            if (lmask == 3 && s[i] == '.' && s1[i] == '.') {
                dp[i][to_mask('#', '#')] += 2 * dp[i - 1][lmask];
                to_small(dp[i][to_mask('#', '#')]);
            }

            if (lmask == 0 && s[i] == '.' && s1[i] == '.') {
                dp[i][to_mask('#', '#')] += dp[i - 1][lmask];
                to_small(dp[i][to_mask('#', '#')]);
            }

            if (lmask == 0) {
                dp[i][to_mask(s[i], s1[i])] += dp[i - 1][lmask];
                to_small(dp[i][to_mask(s[i], s1[i])]);
            }

        }
    }

    int end_val = dp[n - 1][to_mask('#', '#')];
    if (end_val == 0) {
        cout << "None" << '\n';
    } else if (end_val == 1) {
        cout << "Unique" << '\n';
    } else {
        cout << "Multiple" << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    for (int q = 0; q < t; q++) {
        solve();
    }
    return 0;
}
