#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

using namespace std;

int tm = 0;
vector<vector<int>> gr, bgr;
vector<pair<int, int>> srt;
vector<bool> vis;
vector<int> l, r;
vector<pair<bool, bool>> a;
int tr, fs;

void dfs(int v)
{
    vis[v] = true;
    for (auto i: gr[v])
    {
        if (!vis[i]) dfs(i);
    }
    srt[v] = {tm, v};
    tm++;
    return;
}
void dfs2(int v)
{
    vis[v] = true;
    if (!a[v].first && v != fs && v != tr) r.push_back((v));
    for (auto i: gr[v]) if (!vis[i]) dfs2(i);
}

void dfs3(int v)
{
    vis[v] = true;
    if (!a[v].first && v != fs && v != tr) l.push_back((v));
    for (auto i: bgr[v]) if (!vis[i]) dfs3(i);
}


int main()
{
    int n;
    cin >> n;
    int str = 0, utr = 0;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        string s1, s2;
        cin >> s1 >> s2;
        if (s1[0] == 's') a[i].first = true;
        if (s2[0] == 't')
        {
            a[i].second = true;
            if (s1[0] == 's') str++;
            else utr++;
        }
    }
    if (str > 1 || utr > 1 || (utr == 1 && str == 0))
    {
        int m;
        cin >> m;
        for (int i = 0; i < m; i++)
        {
            int x, y;
            cin >> x >> y;
        }
        cout << -1;
        return 0;
    }
    if (str == 0)
    {
        for (int i = 0; i < n; i++)
        {
            if (a[i].first)
            {
                int m;
                cin >> m;
                for (int i = 0; i < m; i++)
                {
                    int x, y;
                    cin >> x >> y;
                }
                cout << -1;
                return 0;
            }
        }
        int m;
        cin >> m;
        gr.resize(n);
        srt.resize(n);
        vis.resize(n);
        for (int i = 0; i < m; i++)
        {
            int x, y;
            cin >> x >> y;
            x--, y--;
            gr[x].push_back(y);
        }
        for (int i = 0; i < n; i++) if (!vis[i]) dfs(i);
        for (int i = 0; i < n; i++)
        {
            for (auto j:gr[i]) if (srt[i].first < srt[j].first)
                {
                    cout << -1;
                    return 0;
                }
        }
        sort(srt.rbegin(), srt.rend());
        for (auto i:srt) cout << i.second + 1 << " ";
    }







    else if (utr == 0)
    {
        int m;
        cin >> m;
        gr.resize(n);
        srt.resize(n);
        vis.resize(n);
        for (int i = 0; i < m; i++)
        {
            int x, y;
            cin >> x >> y;
            x--, y--;
            gr[x].push_back(y);
        }
        for (int i = 0; i < n; i++) if (a[i].second)
            {
                tr = i;
                break;
            }
        for (int i = 0; i < n; i++) if (i != tr)
            {
                if (a[i].first) gr[tr].push_back(i);
                else gr[i].push_back(tr);
            }
        for (int i = 0; i < n; i++) if (!vis[i]) dfs(i);
        for (int i = 0; i < n; i++)
        {
            for (auto j:gr[i]) if (srt[i].first < srt[j].first)
                {
                    cout << -1;
                    return 0;
                }
        }
        sort(srt.rbegin(), srt.rend());
        for (auto i:srt) cout << i.second + 1 << " ";
    }






    else
    {
        int m;
        cin >> m;
        gr.resize(n);
        bgr.resize(n);
        srt.resize(n);
        vis.resize(n);
        for (int i = 0; i < m; i++)
        {
            int x, y;
            cin >> x >> y;
            x--, y--;
            gr[x].push_back(y);
            bgr[y].push_back(x);
        }
        for (int i = 0; i < n; i++) if (a[i].second)
        {
            if (a[i].first) tr = i;
            else fs = i;
        }
        gr[tr].push_back(fs);
        for (int i = 0; i < n; i++) if (i != tr && i != fs)
        {
            if (a[i].first) gr[tr].push_back(i), gr[i].push_back(fs), bgr[i].push_back(tr), bgr[fs].push_back(i);
        }
        for (int i = 0; i < n; i++) if (!vis[i]) dfs(i);
        for (int i = 0; i < n; i++)
        {
            for (auto j:gr[i]) if (srt[i].first < srt[j].first)
                {
                    cout << -1;
                    return 0;
                }
        }
        for (int i = 0; i < n; i++) vis[i] = false;
        for (int i = 0; i < n; i++) if ((a[i].first || i == tr || i == fs) && !vis[i]) dfs2(i);
        for (int i = 0; i < n; i++) vis[i] = false;
        for (int i = 0; i < n; i++) if ((a[i].first || i == tr || i == fs) && !vis[i]) dfs3(i);
        for (auto i:l) gr[i].push_back(tr);
        for (auto i:r) gr[fs].push_back(i);
        unordered_set<int> z;
        for (auto i:l) z.insert(i);
        for (auto i:r) z.insert(i);
        for (int i = 0; i < n; i++) if (z.find(i) == z.end() && i != fs && i != tr && !a[i].first) gr[fs].push_back(i);
        for (int i = 0; i < n; i++) vis[i] = false;
        for (int i = 0; i < n; i++) srt[i] = {0, 0};
        for (int i = 0; i < n; i++) if (!vis[i]) dfs(i);
        for (int i = 0; i < n; i++)
        {
            for (auto j:gr[i]) if (srt[i].first < srt[j].first)
                {
                    cout << -1;
                    return 0;
                }
        }
        sort(srt.rbegin(), srt.rend());
        for (auto i:srt) cout << i.second + 1 << " ";
        //cout << "\n";
        //for (int i = 0; i < n; i++) for (auto j :gr[i]) cout << i + 1 << " " << j + 1 << "\n";
    }
}