#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;
using ll = long long;
using vi = vector<int>;
using vl = vector<ll>;

const ll INF = 2e18;

using ld = long double;
using pt = pair<ld, ld>;

const int N = 1e5 + 5;
vector<pair<int,int>> g[N];
int used[N];

vector<pair<int,int>> gt[N];
int col[N];
int add[N];
int is_up[N];

pair<int,int> cur_dfs[N];
vi ins[N];

void Add(int u, int x) {
    add[u] += x;
    col[is_up[u]] += x;
}

void dfs3(int v, int p, int addc) {
    addc += add[v];
    if (p != -1) {
        cerr << p << ' ' << addc + col[p] - N << endl;
    }
    for(auto &[u, i] : gt[v]) {
        dfs3(u,i, addc);
    }
}

pair<int,int> fup[N];

pair<int, int> dfs(int v, int p) {
    used[v] = 1;
    vector<ar<int, 3>> go;
    bool is_down = false;
    pair<int, int> my = {-1, -1};

    int tt = -1;
    int start = N;

    int myne = -1;

//    if (v == 4) {
//        cout << "KEK\n";
//    }

    for(auto &[u, i] : g[v]) {
        if (i == p) continue;
        if (used[u]) {
            if (used[u] != 1) continue;
            assert(cur_dfs[u].first != -1);
            int to = cur_dfs[u].first;
            is_up[to] = i;
            assert(!is_down);
            is_down = true;
            fup[v] = make_pair(i, u);
            ins[u].push_back(i);
            tt = i;
            continue;
        }
        gt[v].emplace_back(u, i);
        cur_dfs[v] = make_pair(u, i);
        auto nx = dfs(u, i);
        if (is_up[u] != -1) {
            assert(nx.first != nx.second);
            if (nx.first + 1 == nx.second) {
                Add(u, start - nx.first);
                start += 2;
                continue;
            }
            assert(nx.first + 2 == nx.second);
            go.push_back({nx.first, nx.second, u});
        } else {
            assert(my.first == -1);
            my = nx;
            myne = u;
            fup[v] = fup[u];
        }
    }
    used[v] = 2;

//    if (v == 4) {
//        cerr << "KEK\n";
//        dfs3(5, 6, 0);
//        cerr << "--------\n";
//    }

    cur_dfs[v] = make_pair(-1, -1);
    while(go.size() >= 2) {
        auto F = go.back();
        go.pop_back();
        auto S = go.back();
        go.pop_back();
        Add(F[2], start - F[0]);
        Add(S[2], start + 1 - S[0]);
        start += 4;
    }

    if (go.empty()) {
        if (is_down) {
            assert(my.first == -1);
            assert(p != -1);
            col[p] = start;
            col[tt] = start + 1;
            return make_pair(start, start + 1);
        }
        if (p == -1) {
            assert(my.first == -1);
            return {0, 0};
        }
        assert(my.first != -1);
        {
            int x = start - my.first;
            add[myne] += x;
            col[fup[v].first] += x;
            my.first += x;
            my.second += x;
            assert(my.second == col[fup[v].first]);
        }
        assert(my.first < my.second);
        if (my.first + 1 < my.second) {
            col[p] = my.first + 1;
        } else {
            col[p] = my.first - 1;
        }
        assert(col[p] > 0);
        return make_pair(col[p], my.second);
    }
    assert(go.size() == 1);
    if (p == -1) {
        cout << "NO\n";
        exit(0);
        return {0, 0};
    }

    auto F = go[0];
    if (is_down) {
        assert(my.first == -1);
        assert(p != -1);
        Add(F[2], start - F[0]);
        col[p] = start + 1;
        col[tt] = start + 3;
        return make_pair(start + 1, start + 3);
    }
    assert(my.first != -1);
    Add(F[2], start - F[0]);
    start++;
    {
        int x = start - my.first;
        add[myne] += x;
        col[fup[v].first] += x;
        my.first += x;
        my.second += x;
        assert(my.second == col[fup[v].first]);
    }
    assert(my.first < my.second);
    if (my.first + 1 < my.second) {
        col[p] = my.first + 1;
    } else {
        col[p] = my.first - 1;
    }
    assert(col[p] > 0);
    return make_pair(col[p], my.second);
}

void dfs2(int v, int p) {
    if (add[v] != 0) {
        assert(p != -1);
        col[p] += add[v];
    }
    for(auto &t : ins[v]) {
        col[t] += add[v];
    }
    for(auto &[u, i] : gt[v]) {
        add[u] += add[v];
        dfs2(u,i);
    }
}

void solve() {
    int n; cin >> n;
    int m; cin >> m;
    rep(_, m) {
        int u, v; cin >> u >> v;
        u--;v--;
        g[u].push_back({v, _});
        g[v].push_back({u, _});
    }

    rep(i, n) is_up[i] = -1;
    rep(i, n) cur_dfs[i] = {-1, -1};

    dfs(0, -1);
    dfs2(0, -1);

    rep(i, n) {
        vi kek;
        for(auto &[u, e] : g[i]) {
            kek.push_back(col[e]);
        }
        sort(all(kek));
        rep(j, kek.size()) {
            assert(kek[j] == j + kek[0]);
        }
    }

    vi result(m);
    rep(i, m) result[i] = col[i];
    int mn = *min_element(all(result));
    mn--;
    rep(i, m) result[i] -= mn;

    cout << "YES\n";
    cout << *max_element(all(result)) << '\n';
    for(auto &x : result) cout << x << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}