#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define allr(x) rbegin(x), rend(x)
#define sz(x) (int) (x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const char nl = '\n';

const int maxn = 200'000;

ll t[maxn * 2], n;

void build() {
    for (int i = n - 1; i > 0; i--) t[i] = min(t[i << 1], t[i << 1 ^ 1]);
}

ll query(int l, int r) {
    ll res = 1e18;
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) res = min(res, t[l++]);
        if (r & 1) res = min(res, t[--r]);
    }
    return res;
}

void solve() {
    cin >> n;

    int m, q;
    cin >> m >> q;

    vector<array<ll, 2>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i][1];
    for (int i = 0; i < n; i++) cin >> a[i][0];

    sort(all(a));
    for (int i = 1; i < n; i++) {
        a[i][1] += a[i - 1][1]; 
    }

    for (int i = 0; i < n; i++) t[i + n] = a[i][0] - a[i][1];
    build();

    vector<ll> a2(n);
    for (int i = 0; i < n; i++) a2[i] = a[i][0];

    vector<ll> l(m);
    for (auto &x: l) cin >> x;
    for (int i = 1; i < m; i++) l[i] += l[i - 1];

    while (q--) {
        ll tt;
        cin >> tt;

        auto ind = lower_bound(all(a2), tt) - a2.begin();

        ll mi1 = query(0, ind);
        ll mi2 = query(ind, n);

        ll lb = 1, ub = m, ans = 0;
        while (lb <= ub) {
            ll tm = (lb + ub) / 2;
            if (mi1 >= 0 && mi2 - l[tm - 1] >= 0) {
                ans = tm;
                lb = tm + 1;
            } else {
                ub = tm - 1;
            }
        }
        cout << ans << ' ';
    }
    cout << nl;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);

    int T;
    cin >> T;
    while (T--) solve();
}