#include <bits/stdc++.h>
#define int long long
using namespace std;

bool is_digit(char c)
{
    return (c >= '0' && c <= '9');
}

bool check(const string& s)
{
    int n = s.size();
    if(!is_digit(s[0]) || !is_digit(s[n - 1]))
    {
        return 0;
    }
    int cur = 1;
    for(int i = 1; i < s.size(); i ++)
    {
        if(is_digit(s[i]))
        {
            cur ++;
            if(cur > 10)
                return 0;
        }
        else
        {
            cur = 0;
        }
    }
    for(int i = 1; i < s.size(); i ++)
    {
        if(!is_digit(s[i - 1]) && !is_digit(s[i]))
        {
//          /*  if(s[i - 1] == '=' && s[i] == '-')
//          */      continue;
            return 0;
        }
    }
    if(s[0] == '0' && is_digit(s[1]))
        return 0;
    for(int i = 1; i < s.size() - 1; i ++)
    {
        if(!is_digit(s[i - 1]) && s[i] == '0' && is_digit(s[i + 1]))
        {
            return 0;
        }
    }
    int left = 0;
    int right = 0;
    bool eq = 0;
    cur = 0;
    bool sign = 0;
    for(int i = 0; i < s.size(); i ++)
    {
        if(is_digit(s[i]))
        {
            cur = cur * 10 + (s[i] - '0');
            continue;
        }
        else
        {
            if(eq) {
                if (sign)
                {
                    right -= cur;
                }
                else
                {
                    left -= cur;
                }
            }
            else
            {
                if (sign)
                {
                    right += cur;
                }
                else
                {
                    left += cur;
                }
            }
            cur = 0;
            sign = 0;
            if(s[i] == '+')
            {
                continue;
            }
            if(s[i] == '-')
            {
                sign = 1;
                continue;
            }
            if(s[i] == '=')
            {
                sign = 0;
                eq = 1;
                continue;
            }
        }
    }
    if(eq) {
        if (sign)
        {
            right -= cur;
        }
        else
        {
            left -= cur;
        }
    }
    else
    {
        if (sign)
        {
            right -= cur;
        }
        else
        {
            left -= cur;
        }
    }
    return left == right;
}

int32_t main()
{
//    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    string s;
    cin >> s;

    if(check(s))
    {
        cout << "Correct";
        return 0;
    }
    for(int i = 0; i < s.size(); i ++)
    {
        string c;
        c += s[i];
        if(!is_digit(s[i]))
            continue;
        for(int j = 0; j < i; j ++) {
            string t = s;
            t.erase(i, 1);
            t.insert(j, c);
            if(check(t))
            {
                cout << t;
                return 0;
            }
        }
        for(int j = i + 1; j < s.size(); j ++)
        {
            string t = s;
            t.insert(j, c);
            t.erase(i, 1);
            if(check(t))
            {
                cout << t;
                return 0;
            }
        }
    }
    cout << "Impossible";
}
