#include <bits/stdc++.h>

#define f first
#define s second
#define int li

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;



signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector <int> s(n), ch(n);

    for(int i = 0; i < n; i++)
    {
        string x, y;
        cin >> x >> y;

        if(y == "true")
            ch[i] = 1;
        else ch[i] = 0;

        if(x == "set")
            s[i] = ch[i] ^ 1;
        else s[i] = ch[i];
    }

    int m;
    cin >> m;

    vector <int> g[n];
    vector <int> deg(n, 0);

    for(int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;

        u--;
        v--;

        g[u].push_back(v);
        deg[v]++;
    }

//    for(int i = 0; i < n; i++)
//        cout << s[i] << ' ' << ch[i] << endl;

    queue <int> q0[2], q1[2];

    for(int i = 0; i < n; i++)
        if(deg[i] == 0)
        {
            if(ch[i] == 0)
                q0[s[i]].push(i);
            else q1[s[i]].push(i);
        }

    int cur = 0;
    vector <int> ans;

    while(!q0[cur].empty() || !q1[cur].empty())
    {
        int v;

        if(!q0[cur].empty())
        {
            v = q0[cur].front();
            q0[cur].pop();
        }
        else
        {
            v = q1[cur].front();
            q1[cur].pop();
            cur ^= 1;
        }

        ans.push_back(v);

        for(auto to:g[v])
        {
            deg[to]--;

            if(deg[to] == 0)
            {
                if(ch[to] == 0)
                    q0[s[to]].push(to);
                else q1[s[to]].push(to);
            }
        }
    }

    if(ans.size() < n)
        cout << -1;
    else
    {
        for(auto x:ans)
            cout << x + 1 << ' ';
    }

//    int t;
//    cin >> t;
//
//    while(t--)
//        solve();
}

