#include <bits/stdc++.h>

#define f first
#define s second
#define int li

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;

const int N = 2e5 + 5;

int used[N], dp[N];
vector <int> g[N];
vector <pii> M;

void dfs1(int v)
{
    used[v] = 1;

    for(auto to:g[v])
        if(used[to] == 0)
        {
            dfs1(to);

            if(dp[to] == 0 && dp[v] == 0)
            {
                dp[v] = 1;
                M.push_back({v, to});
            }
        }
}

vector <int> ord;

void dfs2(int v)
{
    used[v] = 1;
    ord.push_back(v);

    for(auto to:g[v])
        if(used[to] == 0)
            dfs2(to);
}

void solve() {
    int n;
    cin >> n;

    int m = n;
    n *= 2;

    vector <int> a(n);

    for(int i = 0; i < n; i++)
        cin >> a[i], a[i]--;

    for(int i = 0; i < n; i++)
    {
        used[i] = dp[i] = 0;
        g[i].clear();
    }

    M.clear();
    ord.clear();

    for(int i = 0; i < n - 1; i++)
    {
        int u, v;
        cin >> u >> v;

        u--;
        v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs1(0);

    for(int i = 0; i < n; i++)
        g[i].clear();

    for(auto p:M)
    {
        g[p.f].push_back(p.s);
        g[p.s].push_back(p.f);
    }

//    cout << m << endl;

    vector <int> u[m];

    for(int i = 0; i < n; i++)
    {
       u[a[i]].push_back(i);
    }

    for(int i = 0; i < m; i++)
    {
        g[u[i][0]].push_back(u[i][1]);
        g[u[i][1]].push_back(u[i][0]);
    }

//    return;

    for(int i = 0; i < n; i++)
        used[i] = 0;

    vector <pii> ans;

    for(int i = 0; i < n; i++)
    {
        if(used[i] == 0 && g[i].size() == 1)
        {
            ord.clear();
            dfs2(i);

            int L = 1, R = (int)ord.size() - 1;

            while(R > L)
            {
                ans.push_back({ord[L], ord[R]});
                L++;
                R--;
            }
        }
    }

    for(int i = 0; i < n; i++)
    {
        if(used[i] == 0)
        {
            ord.clear();
            dfs2(i);

            int L = 1, R = (int)ord.size() - 1;

            while(R > L)
            {
                ans.push_back({ord[L], ord[R]});
                L++;
                R--;
            }
        }
    }

    for(auto x:ans)
        swap(a[x.f], a[x.s]);

    for(auto x:M)
        assert(a[x.f] == a[x.s]);

    cout << ans.size() << "\n";

    for(auto x:ans)
        cout << x.f + 1 << ' ' << x.s + 1 << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);



    int t;
    cin >> t;

    while(t--)
        solve();
}

