#pragma optimize("SEX_ON_THE_BEACH")
 
#pragma GCC optimize("O3")
 
#include <bits/stdc++.h>
 
using namespace std;
 
using ll = long long int;
using ull = unsigned long long int;
using dd = double;
using ldd = long double;
 
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define sz(x) (x).size()
 
#ifdef HOME
    #define debug(...) { cerr << #__VA_ARGS__ << " " << __VA_ARGS__ << endl; }
    #define say(...) { cerr << __VA_ARGS__ << endl; }
#else
    #define debug(...) 0;
    #define say(...) 0;
#endif
 
vector<int> arr;
vector<vector<int>> gr;
vector<int> de;
vector<int> pre;
 
void dfs(int v, int p = -1, int d = 0) {
    de[v] = d;
    pre[v] = p;
    for (int to : gr[v]) if (to != p) dfs(to, v, d + 1);
}
 
void solve(int test = 0) {
    arr.clear();
    gr.clear();
    de.clear();
    pre.clear();
    int n;
    cin >> n;
    arr.resize(n * 2);    
    gr.resize(n * 2);
    for (int i = 0; i < n * 2; ++i) {
        cin >> arr[i];
        --arr[i];
    }
    for (int i = 1; i < n * 2; ++i) {
        int a, b;
        cin >> a >> b;
        gr[a - 1].push_back(b - 1);
        gr[b - 1].push_back(a - 1);
    }
    de.resize(n * 2);
    pre.resize(n * 2);
    dfs(0);
    vector<int> tos(n * 2);
    iota(all(tos), 0);
    sort(all(tos), [&](int a, int b) { return de[a] > de[b]; });
    vector<pair<int, int>> mm;
    vector<bool> was(n * 2);
    for (int i = 0; i < tos.size(); ++i) {
        int v = tos[i];
        if (was[v]) continue;
        was[v] = 1;
        int to = pre[v];
        if (to == -1) continue;
        if (was[to]) continue;
        mm.push_back({v, to});
        was[to] = true;
    }
    vector<vector<int>> ing(n);
    for (int i = 0; i < arr.size(); ++i) {
        ing[arr[i]].push_back(i);
    }
    vector<vector<int>> inmm(n * 2);
    for (int i = 0; i < mm.size(); ++i) {
        inmm[mm[i].ff].push_back(i);
        inmm[mm[i].ss].push_back(i);
    }
    was.assign(mm.size(), 0);
    vector<pair<int, int>> ans;
    for (int i = 0; i < mm.size(); ++i) {
        debug(i);
        if (was[i]) continue;
        //was[i] = 1;
        debug(mm[i].ff);
        debug(mm[i].ss);
        if (arr[mm[i].ff] == arr[mm[i].ss]) {
            was[i] = 1;
            continue;
        }
        int x = arr[mm[i].ff];
        int to = ing[x][0] ^ ing[x][1] ^ mm[i].ff;
        if (inmm[to].empty()) {
            swap(mm[i].ff, mm[i].ss);
        }
        int v = i;
        while (!was[v]) {
            was[v] = 1;
            if (arr[mm[v].ff] == arr[mm[v].ss]) break;
            int vx = mm[v].ff;
            int x = arr[mm[v].ff];
            int fr = mm[v].ss;
            int to = ing[x][0] ^ ing[x][1] ^ vx;
            ans.push_back({fr, to});
            if (inmm[to].empty()) {
                int frx = arr[fr];
                int frto = ing[frx][0] ^ ing[frx][1] ^ fr;
                if (inmm[frto].empty()) {
                    break;
                }
                int tomm = inmm[frto][0];
                if (mm[tomm].ff == frto) swap(mm[tomm].ff, mm[tomm].ss);
                v = tomm;
            } else {
                int tomm = inmm[to][0];
                if (mm[tomm].ff != to) swap(mm[tomm].ff, mm[tomm].ss);
                mm[tomm].ff = mm[v].ss;
                v = tomm;
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) cout << i.ff + 1 << " " << i.ss + 1 << '\n';
}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
 
    int t = 1;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << '\n';
        say("=================================================");
    }
}