#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#define F first
#define S second
// #include <bits/stdc++.h>

using namespace std;
using ll = long long;

bool check_str(string s)
{
    vector <vector <ll>> eq(2);
    int idx = 0;
    ll cur = 0;
    int sgn = 1;
    for (int i = 0; i < s.length(); i++)
    {
        if (s[i] == '=')
        {
            eq[idx].push_back(sgn * cur);
            idx++;
            cur = 0;
            sgn = 1;
            continue;
        }
        if (s[i] == '+')
        {
            eq[idx].push_back(sgn * cur);
            cur = 0;
            sgn = 1;
            continue;
        }
        if (s[i] == '-')
        {
            eq[idx].push_back(sgn * cur);
            cur = 0;
            sgn = -1;
            continue;
        }
        if (cur == 0 && s[i] == '0')
            return false;
        cur = cur * 10 + s[i] - '0';
        if (cur > 1e10 - 1)
            return false;
    }
    eq[idx].push_back(sgn * cur);
    vector <ll> sum(2, 0);
    for (int i = 0; i < 2; i++)
    {
        for (int j = 0; j < eq[i].size(); j++)
        {
            // cout << eq[i][j] << ' ';
            sum[i] += eq[i][j];
        }
        // cout << '\n';
    }
    return sum[0] == sum[1];
}

string move_dgt(int a, int b, string s)
{
    if (a == b)
        return s;
    if (a < b)
    {
        string s1 = s.substr(0, a);
        string s2 = s.substr(a + 1, b - a);
        string s3 = s.substr(b + 1, s.length() - b);
        return s1 + s2 + s[a] + s3;
    }
    string s1 = s.substr(0, b);
    string s2 = s.substr(b, a - b);
    string s3 = s.substr(a + 1, s.length() - a);
    return s1 + s[a] + s2 + s3;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    string s;
    cin >> s;
    if (check_str(s))
    {
        cout << "Correct";
        return 0;
    }
    for (int i = 0; i < s.length(); i++)
    {
        if (s[i] < '0' || s[i] > '9')
            continue;
        for (int j = 0; j < s.length(); j++)
        {
            string eq = move_dgt(i, j, s);
            if (check_str(eq))
            {
                cout << eq;
                return 0;
            }
        }
    }
    cout << "Impossible";
}