#include <iostream>
#include <vector>
#include <list>
#include <string>

using namespace std;
typedef long long ll;
vector<bool> used;
vector<vector<ll>> graph;

bool has_child(ll node, ll parrent){
    if (!used[node] && parrent != node)
        return true;
    for (ll x : graph[node]){
        if (has_child(x, node))
            return true;
    }
    return false;
}

int main()
{
    ll n;
    cin >> n;
    vector<ll> orper(++n);
    vector<ll> ff, ft, tt, tf;
    graph.resize(n, vector<ll>());
    used.resize(n, false);
    vector<ll> path;
    for (ll i = 1; i < n; ++i){
        string s, r;
        cin >> s >> r;

        if (s[0] == 's' && r[0] == 'f'){
            tt.push_back(i);
        } else if(s[0] == 's' && r[0] == 't') {
            ft.push_back(i);
        } else if (s[0] == 'u' && r[0] == 'f'){
            ff.push_back(i);
        } else if (s[0] == 'u' && r[0] == 't'){
            tf.push_back(i);
        }
    }
    ll m;
    cin >> m;
    for (ll i =0; i < m; ++i){
        ll a, b;
        cin >> a >> b;
        graph[b].push_back(a);
    }

    bool win = false;
    for (ll i = 1; i < n; ++i){
        if (win)
            break;

        for (ll j = 0; j < n; ++j){
            used[j] = false;
        }
        path.clear();
        path.push_back(i);
        used[i] = true;

        if (has_child(i, i)){
            continue;
        }


        bool last = false;
        for (ll z : ft){
            if (z == i) {
                last = true;
                break;
            }
        }
        bool cant = false;
        for (ll z : tf){
            if (z == i){
                cant = true;
                break;
            }
        }
        if (!cant){
            for (ll z : tt){
                if (z == i){
                    cant = true;
                    break;
                }
            }
        }

        if (cant) {
            continue;
        }

        for (ll x : ff){
            if (!used[x] && !last && !has_child(x, x)){
                used[x] = true;
                path.push_back(x);
            }
        }

        for (ll x : ft){
            if (!used[x]){
                if (!last){
                    if (!has_child(x, x)) {
                        used[x] = true;
                        path.push_back(x);
                        last = true;
                    }
                }
            }
//            if (!used[x] && !last && !has_child(x, x)){
//
//            }
        }

        for (ll x : tt){
            if (!used[x] && last && !has_child(x, x)){
                used[x] = true;
                path.push_back(x);
            }
        }

        for (ll x : tf) {
            if (!used[x] && last && !has_child(x, x)){
                used[x] = true;
                path.push_back(x);
                last = false;
            }
        }

        for (ll x : ff){
            if (!used[x] && !last && !has_child(x, x)){
                used[x] = true;
                path.push_back(x);
            }
        }

        if (path.size() == n - 1) {
            win = true;
        }

    }


    if (!win){
        cout << -1;
    } else {
        for (ll x : path){
            cout << x << ' ';
        }
    }

    return 0;
}
