#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()



void solve() {
	int n, m, q; cin >> n >> m >> q;
	vector<int> A(n+1), D(n+1);
	for (int i = 0; i < n; i++)cin >> A[i];
	for (int i = 0; i < n; i++)cin >> D[i];
	vector<int> L(m);
	for (int i = 0; i < m; i++)cin >> L[i];
	vector<int> Q(q);
	for (int i = 0; i < q; i++)cin >> Q[i];
	vector<pair<int, int>> W(n);
	for (int i = 0; i < n; i++)
	{
		W[i] = { D[i],A[i] };
	}sort(all(W));
	W.push_back({ 1e18,0 });
	n++;
	for (int i = 0; i < n; i++)
	{
		auto [d, a] = W[i];
		A[i] = a, D[i] = d;
	}
	vector<int> MASS(n);
	int s = 0;
	for (int i = 0; i < n; i++)
	{
		s += A[i];
		MASS[i] = D[i] - s;
	}
	vector<int> mx(n);
	mx[n - 1] = MASS[n - 1];
	for (int i = n - 2; i >= 0; i--)
	{
		mx[i] = min(mx[i + 1], MASS[i]);
	}
	vector<int> pref(n);
	for (int i = 0; i < n; i++)
	{
		pref[i] = A[i] + (i != 0 ? pref[i - 1] : 0LL);
	}
	vector<int> fff(n);
	for (int i = 0; i < n; i++)
	{
		fff[i] = mx[i] + (i != 0 ? pref[i - 1] : 0LL);
	}
	vector<int> TIME(q);
	for (int i=0;i<q;i++)
	{
		int t = Q[i];
		pair<int, int> qwer = { t,(int)1e18 };
		auto it = lower_bound(all(W), qwer);
		int index = it - W.begin();
		/*int fir = (index != 0 ? pref[index - 1] : 0LL);
		int sec = max(0LL, fff[index]  + t);
		TIME[i] = t - fir - sec;*/
		TIME[i] = t - (index != 0 ? pref[index - 1] : 0LL);
		TIME[i] = min(TIME[i], mx[index]);
	}
	vector<int> pref2(m);
	for (int i = 0; i < m; i++)
	{
		pref2[i] = L[i] + (i != 0 ? pref2[i - 1] : 0LL);
	}
	for (auto t : TIME)
	{
		auto it = upper_bound(all(pref2), t);
		if (it == pref2.begin())
		{
			cout << 0 << " "; continue;
		}
		--it;
		cout << (it - pref2.begin())+1 << " ";
	}
	cout << endl;


}

signed main()
{
	ios::sync_with_stdio(false); cin.tie(0);
	int t; cin >> t;
	for (int i = 0; i < t; i++)solve();

	return 0;
}