#include <bits/stdc++.h>
#define int long long
using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1;
const int MOD = 998244353;
const int INF = 1e9;
const ll INFLL = 1e18;

void solve() {
    int n;
    cin >> n;
    string s[2];
    cin >> s[0] >> s[1];
    int dp[n][2][2];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 2; j++) for (int k = 0; k < 2; k++) dp[i][j][k] = 0;
    }

    dp[0][1][0] = s[0][0] == '#' && s[1][0] == '.';
    dp[0][0][0] = s[0][0] == '.' && s[1][0] == '.';
    dp[0][0][1] = s[0][0] == '.' && s[1][0] == '#';
    dp[0][1][1] = s[0][0] == '#' && s[1][0] == '#' || s[0][0] == '.' && s[1][0] == '.';;
    for (int i = 1; i < n; i++) {
        if (s[0][i] == '#' && s[1][i] == '#') {
            dp[i][1][1] = dp[i - 1][1][1];
        } else if (s[0][i] == '.' && s[1][i] == '#') {
            dp[i][1][1] = dp[i - 1][0][1];
            dp[i][0][1] = dp[i - 1][1][1];
        } else if  (s[0][i] == '#' && s[1][i] == '.') {
            dp[i][1][1] = dp[i - 1][1][0];
            dp[i][1][0] = dp[i - 1][1][1];
        } else {
            dp[i][1][0] = dp[i - 1][0][1];
            dp[i][0][1] = dp[i - 1][1][0];
            dp[i][0][0] = dp[i - 1][1][1];
            dp[i][1][1] = dp[i - 1][1][1] + dp[i - 1][0][0];
        }
        for (int k = 0; k < 2; ++k) {
            for (int m = 0; m < 2; ++m) {
                dp[i][k][m] = min(2ll, dp[i][k][m]);
                //cout << i << " " << k << " " << m << " " << dp[i][k][m] << "\n";
            }
        }
        //cout << "\n";
    }
    if (dp[n - 1][1][1] == 0) {
        cout << "None\n";
    } else {
        cout << (dp[n - 1][1][1] == 1 ? "Unique" : "Multiple") << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int tests = 1;
    cin >> tests;
    while (tests--) solve();
    return 0;
}
/*
4
10
#.......##
##..#.##..
6
...#..
..#...
8
........
........
3
###
###
 */