#include <bits/stdc++.h>
#define int long long
using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1;
const int MOD = 998244353;
const int INF = 1e9;
const ll INFLL = 1e18;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    pair <ll, int> task[n];
    ll S = 0;
    for (int i = 0; i < n; ++i) {
        cin >> task[i].second;
    }
    for (int i = 0; i < n; ++i) {
        cin >> task[i].first;
    }
    sort(task, task + n);
    ll delta[n], mindelta[n];
    for (int i = 0; i < n; ++i) {
        S += task[i].second;
        delta[i] = task[i].first - S;
    }
    mindelta[n - 1] = n - 1;
    for (int i = n - 2; i >= 0; --i) {
        if (delta[i] < delta[mindelta[i + 1]]) {
            mindelta[i] = i;
        } else {
            mindelta[i] = mindelta[i + 1];
        }
    }

    int l[m];
    int indtask = 0;
    for (int i = 0; i < m; ++i) {
        cin >> l[i];
    }

    vector <pair <int, int>> actions;
    ll prefactions[n + m];

    int i = 0;
    ll taken = 0;

    while (i < n) {
        int ind = mindelta[i];
        ll here = delta[ind];
        while (indtask != m && taken + l[indtask] <= here) {
            actions.emplace_back(l[indtask], 1);
            taken += l[indtask];
            indtask++;
        }
        for (int l = i; l <= ind; ++l) {
            actions.emplace_back(task[l].second, 0);
        }
        i = ind + 1;
    }

    while (indtask < m) {
        actions.emplace_back(l[indtask], 1);
        indtask++;
    }

    ll preftasks[n + m];
    preftasks[0] = actions[0].second;
    prefactions[0] = actions[0].first;
    for (int i = 1; i < n + m; ++i) {
        prefactions[i] = prefactions[i - 1] + actions[i].first;
        preftasks[i] = preftasks[i - 1] + actions[i].second;
    }

    while (q--) {
        ll t;
        cin >> t;
        int j = upper_bound(prefactions, prefactions + n + m, t) - prefactions;
        if (j == n + m) {
            cout << m << " ";
            continue;
        }
        if (j == 0) {
            cout << actions[j].second << " ";
            continue;
        }
        cout << preftasks[j - 1] + (actions[j].second) * ((j ? prefactions[j - 1] : 0) > t) << " ";
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    int tests = 1;
    cin >> tests;
    while (tests--) solve();
    return 0;
}
/*
2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32
1 1
9 200 51 50 10
*/