
#include <iostream>
#include <vector>
#include <set>
#include <numeric>
#include <algorithm>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <string>
#include <cstring>
#include <cassert>


#define forn(i, n) for(int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
	int n;
	cin >> n;
	vector<string> a(2);
	for (auto& x : a) {
		cin >> x;
	}
	a[0] = a[0] + "#";
	a[1] = a[1] + "#";
	++n;
	bool multiple = false;
	int first = a[0][0] == '.', second = a[1][0] == '.';
	for (int i = 1; i < n; ++i) {
		int now_first = a[0][i] == '.';
		int now_second = a[1][i] == '.';
		if (first && second) {
			first = now_first;
			second = now_second;
			if (now_first && now_second) {
				multiple = true;
				first = 0;
				second = 0;
			}
		}
		else if (!first && !second) {
			first = now_first;
			second = now_second;
		}
		else if (first && !second) {
			if (!now_first) {
				cout << "None\n";
				return;
			}
			first = 0;
			second = now_second;
		}
		else {
			if (!now_second) {
				cout << "None\n";
				return;
			}
			first = now_first;
			second = 0;
		}
	}
	cout << (multiple ? "Multiple\n" : "Unique\n");
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);

	int t = 1;
	cin >> t;
	forn(tt, t) solve();
}