#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <utility>
#include <cmath>
#include <stack>
#include <deque>
#include <bitset>
#include <fstream>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <cstdint>

#define int long long

using namespace std;

const int MOD7 = (int)1e9 + 7;
const int MOD9 = (int)1e9 + 7;

int gcd(int a, int b) {
	return (b == 0 ? a : gcd(b, a % b));
}

int binPow(int x, int y) {
	if (y == 0) {
		return 1;
	}

	if (y % 2 == 0) {
		int t = binPow(x, y / 2);
		return t * t;
	}

	return x * binPow(x, y - 1);
}

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	
	ll n;
	cin >> n;

	vector<string> v(n);
	map<string, ll> cnt;
	vector<string> val(n + 1);

	for (int i = 0; i < n; ++i) {
		string s1, s2;
		cin >> s1 >> s2;

		if (s1 == "set") {
			v[i].push_back('1');
		}
		else {
			v[i].push_back('0');
		}

		if (s2 == "true") {
			v[i].push_back('1');
		}
		else {
			v[i].push_back('0');
		}

		val[i + 1] = v[i];
		++cnt[v[i]];
	}

	ll m;
	cin >> m;

	vector<vll> gr(n + 1);
	vll p(n + 1);

	for (int i = 0; i < m; ++i) {
		ll u, v;
		cin >> u >> v;
		gr[u].push_back(v);
		++p[v];
	}

	map<string, queue<ll>> q;

	for (int i = 1; i <= n; ++i) {
		if (p[i] == 0) {
			q[val[i]].push(i);
		}
	}

	ll all = n;
	ll status = 0;
	vll ans;

	while (q["00"].size() > 0 || q["01"].size() > 0 || q["10"].size() > 0 || q["11"].size() > 0) {
		ll cur;

		if (!status) {
			if (q["00"].size() > 0) {
				--all;
				--cnt["00"];
				cur = q["00"].front();
				q["00"].pop();
			}
			else if (q["11"].size() > 0) {
				--all;
				--cnt["11"];
				cur = q["11"].front();
				q["11"].pop();
				status = 1;
			}
			else {
				cout << -1;
				return 0;
			}
		}
		else {
			if (q["10"].size() > 0) {
				--cnt["10"];
				--all;
				cur = q["10"].front();
				q["10"].pop();
			}
			else if (q["01"].size() > 0) {
				--cnt["01"];
				--all;
				cur = q["01"].front();
				q["01"].pop();
				status = 0;
			}
			else {
				cout << -1;
				return 0;
			}
		}

		ans.push_back(cur);

		for (ll u: gr[cur]) {
			--p[u];

			if (p[u] == 0) {
				q[val[u]].push(u);
			}
		}
	}

	if (ans.size() < n) {
		cout << -1;
		return 0;
	}

	for (int elem: ans) {
		cout << elem << ' ';
	}
}