#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <utility>
#include <cmath>
#include <stack>
#include <deque>
#include <bitset>
#include <fstream>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <cstdint>

#define int long long

using namespace std;

const int MOD7 = (int)1e9 + 7;
const int MOD9 = (int)1e9 + 7;

int gcd(int a, int b) {
	return (b == 0 ? a : gcd(b, a % b));
}

int binPow(int x, int y) {
	if (y == 0) {
		return 1;
	}

	if (y % 2 == 0) {
		int t = binPow(x, y / 2);
		return t * t;
	}

	return x * binPow(x, y - 1);
}

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
pair<pair<int, int>, pair<int, int>> rot(pair<pair<int, int>, pair<int, int>> gl_cur, int p) {
	if (p == 0)
		return gl_cur;
	pair<pair<int, int>, pair<int, int>> buf;
	buf = gl_cur;
	gl_cur.second.first = buf.first.first;
	gl_cur.first.second = buf.second.first;
	gl_cur.second.second = buf.first.second;
	gl_cur.first.first = -buf.second.second;
	return rot(gl_cur, p - 1);
}
int ch(pair<pair<int, int>, pair<int, int>>  a, pair<pair<int, int>, pair<int, int>> b) {
	int aa = min(a.second.first, a.second.second), bb = min(b.second.second, b.second.first);
	
	if (a == b)
		return 1;
	else
		return 0;
}
int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	
	int n;
	cin >> n;
	vector < pair<pair<int,int>, pair<pair<int, int>, pair<int, int>>>> v,t2;
	int angle = 0, gl_a = 0;
	pair<pair<int, int>, pair<int, int>>  cur = { {0,0},{0,0} },buf,gl_cur;
	gl_cur = cur;
	int qq = 1;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		int x;
		cin >> x;
		if (qq == 1 && s != "draw")
			continue;
		else
			qq = 0;
		if (s == "rotate")
		{
			angle = (angle + x) % 360;
			gl_a = angle;
			gl_cur = rot(gl_cur, angle % 360 / 45);
		}else
		if (s == "move") {
			if (angle == 0) {
				cur.first.first += x;
				gl_cur.first.first += x;
			}
			if (angle == 90) {
				cur.first.second += x;
				gl_cur.first.second += x;
			}
			if (angle == 180) {
				cur.first.first -= x;
				gl_cur.first.first -= x;
			}
			if (angle == 270) {
				cur.first.second -= x;
				gl_cur.first.second -= x;
			}
			if (angle == 0 + 45) {
				cur.second.first += x;
				gl_cur.second.first += x;
			}
			if (angle == 90 + 45) {
				cur.second.second += x;
				gl_cur.second.second += x;
			}
			if (angle == 180 + 45) {
				cur.second.first -= x;
				gl_cur.second.first -= x;
			}
			if (angle == 270 + 45) {
				cur.second.second -= x;
				gl_cur.second.second -= x;
			}
		}
		else {
			v.push_back({ {x,angle}, cur });
			angle = 0;
			cur = { {0,0},{0,0} };
		}
	}
	v[0].second = gl_cur;
	v[0].first.second = gl_a;
	int res = 360;
	n = v.size();
	if (n == 1) {
		cout << 180;
		return 0;
	}
	for (int i = 0; i < n; i++) {
		int fl = 1;
		for(int j=0;j<n;j++)
			if (v[j].first.first != v[(i+j)%n].first.first || v[j].first.second != v[(i + j) % n].first.second || !ch(v[j].second, rot(v[(i + j) % n].second, (360-v[i].first.second)/45)))
			{
				fl = 0;
				break;
			}
		if (fl == 1) {
			if (v[i].first.second != 0)
				res = min(res, v[i].first.second);
		}
	}
	t2 = v;
	gl_cur = t2[0].second;
	gl_a = t2[0].first.second;
	for (int i = 0; i < n; i++) {
		t2[i].first.second = (360- t2[(i+1)%n].first.second) % 360;
		t2[i].second = t2[(i + 1) % n].second;
	}
	t2[n - 1].second = gl_cur;
	t2[n - 1].first.second = gl_a;
	for (int i = 0; i < n; i++) {
		int fl = 1;
		for (int j = 0; j < n; j++)
			if (v[j].first.first != t2[(i + j) % n].first.first || v[j].first.second != t2[(i + j) % n].first.second || !ch(v[j].second, rot(t2[(i + j) % n].second,(360-t2[i].first.second)/45)))
			{
				fl = 0;
				break;
			}
		if (fl == 1) {
			if (t2[i].first.second != 180)
				res = min(res,( t2[i].first.second+180)%360);
		}
	}
	cout << res;
}