#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <bitset>
#include <deque>
#include <string>
#include <numeric>
#include <cstring>


using namespace std;
//#define LOCAL
#define int long long

using ld = long double;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using ii = pair<int, int>;
using pii = pair<int, int>;
using vii = vector<pair<int, int>>;

#define fore(i, b, e) for (int i = (b); i < (e); ++i)
#define foree(i, b, e) for (int i = (b); i <= (e); ++i)
#define ford(i, b, e) for (int i = (e) - 1; i >= (b); --i)
#define fordd(i, b, e) for (int i = (e); i >= (b); --i)
#define pb push_back
#define ff first
#define ss second

#define all(x) (x).begin(), (x).end()



using namespace std;

void precalc();
void solve();


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	cin >> t;
	precalc();
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", 'w', stdout);
#endif

	while (t--) {
		solve();
	}

}

void precalc() {

}


void solve() {
	
	int N, M, q;
	cin >> N >> M >> q;

	vii tasks(N + 1);
	for (int i = 1; i <= N; i++) {
		cin >> tasks[i].second;
	}

	for (int i = 1; i <= N; i++) {
		cin >> tasks[i].first;
	}

	vi series(M + 1);
	for (int i = 1; i <= M; i++) {
		cin >> series[i];
	}

	vi times(q + 1);
	for (int i = 1; i <= q; i++) {
		cin >> times[i];
	}

	sort(all(tasks));

	vi prefs_tasks_time(N + 1, 0);
	for (int i = 1; i <= N; i++) {
		prefs_tasks_time[i] = prefs_tasks_time[i - 1] + tasks[i].second;
	}

	vi suffs_tasks_starts(N + 2, 2e18);
	suffs_tasks_starts[N] = tasks[N].first - tasks[N].second;

	for (int i = N - 1; i >= 1; i--) {
		suffs_tasks_starts[i] = min(suffs_tasks_starts[i + 1], tasks[i].first) - tasks[i].second;
	}

	vi prefs_series(M + 1, 0);
	for (int i = 1; i <= M; i++) {
		prefs_series[i] = prefs_series[i - 1] + series[i];
	}

	for (int i = 1; i <= q; i++) {

		int time = times[i];

		int l1 = 0;
		int r1 = N;

		if (tasks[r1].first <= time) {
			l1 = N;
		}

		while (r1 - l1 > 1) {
			int m = (l1 + r1) / 2;
			if (tasks[m].first <= time) {
				l1 = m;
			}
			else {
				r1 = m;
			}
		}

		int last_dead = l1;

		int start_time = prefs_tasks_time[last_dead];
		int best_end_time = min(suffs_tasks_starts[last_dead + 1], time);

		int d = best_end_time - start_time;

		int l2 = 0;
		int r2 = M;

		if (prefs_series[M] <= d) {
			l2 = M;
		}

		while (r2 - l2 > 1) {
			int m = (l2 + r2) / 2;
			if (prefs_series[m] <= d) {
				l2 = m;
			}
			else {
				r2 = m;
			}
		}

		cout << l2 << " ";


	}
	cout << "\n";
}