#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <bitset>
#include <deque>
#include <string>
#include <numeric>
#include <cstring>


using namespace std;
//#define LOCAL
#define int long long

using ld = long double;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using ii = pair<int, int>;
using pii = pair<int, int>;
using vii = vector<pair<int, int>>;

#define fore(i, b, e) for (int i = (b); i < (e); ++i)
#define foree(i, b, e) for (int i = (b); i <= (e); ++i)
#define ford(i, b, e) for (int i = (e) - 1; i >= (b); --i)
#define fordd(i, b, e) for (int i = (e); i >= (b); --i)
#define pb push_back
#define ff first
#define ss second

#define all(x) (x).begin(), (x).end()



using namespace std;

void precalc();
void solve();


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	cin >> t;
	precalc();
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", 'w', stdout);
#endif

	while (t--) {
		solve();
	}

}

void precalc() {

}

int N;
vvi g;


void dfs(int curr_V, int last_V, vvi& dp, vi& taked) {
	bool flag = true;
	for (int next_V : g[curr_V]) {
		if (next_V == last_V) continue;
		flag = false;
		dfs(next_V, curr_V, dp, taked);
	}

	if (flag) {
		dp[curr_V][0] = 0;
		return;
	}

	int total_sum = 0;
	for (int next_V : g[curr_V]) {
		if (next_V == last_V) continue;
		total_sum += max(dp[next_V][0], dp[next_V][1]);
	}

	dp[curr_V][0] = total_sum;
	dp[curr_V][1] = -1;
	for (int next_V : g[curr_V]) {
		if (next_V == last_V) continue;
		total_sum -= max(dp[next_V][0], dp[next_V][1]);
		total_sum += dp[next_V][0];
		if (total_sum + 1 > dp[curr_V][1]) {
			dp[curr_V][1] = total_sum + 1;
			taked[curr_V] = next_V;
		}
		total_sum -= dp[next_V][0];
		total_sum += max(dp[next_V][0], dp[next_V][1]);
	}

}

vii pars(0);

void get(int curr_V, int last_V, int must_be_taked, const vvi& dp, const vi& taked) {
	if (must_be_taked) {
		for (int next_V : g[curr_V]) {
			if (next_V == last_V) continue;
			get(next_V, curr_V, 0, dp, taked);
		}
		return;
	}
	if (dp[curr_V][0] >= dp[curr_V][1]) {
		for (int next_V : g[curr_V]) {
			if (next_V == last_V) continue;
			get(next_V, curr_V, 0, dp, taked);
		}
	}
	else {
		pars.push_back({ curr_V, taked[curr_V] });
		for (int next_V : g[curr_V]) {
			if (next_V == last_V) {
				continue;
			}
			if (next_V == taked[curr_V]) {
				get(next_V, curr_V, 1, dp, taked);
			}
			else {
				get(next_V, curr_V, 0, dp, taked);
			}
		}
	}
}

vvi clr;

void solve() {
	cin >> N;
	g.assign(2 * N, vi());
	vi a(2 * N);
	clr.clear();
	clr.resize(N + 1);
	pars.clear();
	for (int i = 0; i < 2 * N; ++i) {
		cin >> a[i];
		clr[a[i]].pb(i);
	}

	for (int i = 0; i < 2 * N - 1; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].pb(v);
		g[v].pb(u);
	}

	int M = 2 * N;

	vvi dp(M, vi(2, -1));
	vi taked(M, -1);

	dfs(0, 0, dp, taked);
	get(0, 0, 0, dp, taked);
	vii ans;

	for (auto [u, v] : pars) {
		if (a[u] == a[v]) continue;
		
		int need_color = a[u];

		int i = 0;
		if (clr[need_color][i] == u) {
			i++;
		}

		int v_color = a[v];

		int iv = 0;
		if (clr[v_color][iv] == v) {
			iv++;
		}

		swap(a[v], a[clr[need_color][i]]);
		ans.push_back({ clr[need_color][i], v });
		swap(clr[need_color][i], clr[v_color][iv]);

	}
	cout << ans.size() << "\n";
	for (auto [x, y] : ans) {
		cout << x + 1 << " " << y + 1 << '\n';
	}

}