// #pragma GCC optimize("O2")
// #pragma GCC optimize("unroll-loops")
 
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
 
using namespace std;
 
int n;
vector <string> s(2);
vector <vector <int>> l(2);
vector <vector <bool>> used(2); 
vector <int> tek;
 
void dfs(int i, int j) {
    used[i][j] = true;
    if (i % 2 != j % 2) --tek[tek.size() - 1];
    else ++tek[tek.size() - 1];
    for (int k = fmax(0, j-1); k <= fmin(n - 1, j+1); ++k) {
        if (k == j) {
            if (l[1-i][k] == 0 && !used[1-i][k]) dfs(1-i, k);
        } else {
            if (l[i][k] == 0 && !used[i][k]) dfs(i, k);
        }
    }
}
 
void solve() {
    cin >> n;
    s[0].resize(n);
    s[1].resize(n);
    l[0].resize(n);
    l[1].resize(n);
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> s[i][j];
            if (s[i][j] == '#') l[i][j] = 1;
            else l[i][j] = 0;
        }
    }
    int cnt;
    queue<pair<int, int>> q;
    vector <vector<int>> g(2, vector<int> (n, 0));
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            cnt = 0;
            for (int k = fmax(0, j-1); k <= min(n - 1, j+1); ++k) {
                ++cnt;
                if (k == j) {
                    cnt -= l[1-i][k];
                } else {
                    cnt -= l[i][k];
                }
            }
            g[i][j] = cnt;
            if (cnt == 1 && l[i][j] == 0) q.push(make_pair(i, j));
            // if (cnt == 1) {
            //     // cout << i+1 << ' ' << j+1 << '\n';
            //     for (int k = fmax(0, j-1); k <= min(n - 1, j+1); ++k) {
            //         if (k == j && l[1-i][k] == 0) {
            //             l[i][j] = l[1-i][k] = 1;
            //         } else if (l[i][k] == 0) {
            //             l[i][j] = l[i][k] = 1;
            //         }
            //     }
            // }
        }
    }
    while (q.size() > 0) {
        pair <int, int> it = q.front();
        q.pop();
        int i = it.first, j = it.second, I, J;
        if (l[i][j] == 1 || g[i][j] != 1) continue;
        // cout << '+' << i << ' ' << j << '\n';
        for (int k = fmax(0, j-1); k <= min(n - 1, j+1); ++k) {
            if (k == j && l[1-i][k] == 0) {
                l[i][j] = l[1-i][k] = 1;
                I = 1-i; J = k;
                // cnt = 0;
                // for (int O = 0; O <= 4; ++O) q.erase(make_pair(O, i*n + j));
                // for (int k = fmax(0, j-1); k <= min(n - 1, j+1); ++k) {
                //     ++cnt;
                //     if (k == j) {
                //         cnt -= l[1-i][k];
                //     } else {
                //         cnt -= l[i][k];
                //     }
                // }
                // if (cnt != 0) q.insert(make_pair(cnt, i*n + j));
                // break;
            } else if (l[i][k] == 0) {
                l[i][j] = l[i][k] = 1;
                I = i; J = k;
                // cnt = 0;
                // for (int O = 0; O < 4; ++O) q.erase(make_pair(O, i*n + j));
                // for (int k = fmax(0, j-1); k <= min(n - 1, j+1); ++k) {
                //     ++cnt;
                //     if (k == j) {
                //         cnt -= l[1-i][k];
                //     } else {
                //         cnt -= l[i][k];
                //     }
                // }
                // if (cnt != 0)
                // q.insert(make_pair(cnt, i*n + j));
                // break;
            }
        }
        l[i][j] = l[I][J] = 1;
        for (int i = max(0, min(i, I) - 4); i <= min(1, max(i, I) + 4); ++i) {
            for (int j = max(0, min(j, J) - 4); j <= min(n-1, max(j, J) + 4); ++j) {
                cnt = 0;
                for (int k = fmax(0, j-1); k <= min(n - 1, j+1); ++k) {
                    ++cnt;
                    if (k == j) {
                        cnt -= l[1-i][k];
                    } else {
                        cnt -= l[i][k];
                    }
                }
                g[i][j] = cnt;
                if (cnt == 1 && l[i][j] == 0) q.push(make_pair(i, j));
            }
        }
    }
    tek.resize(0);
    used[0].assign(n, false);
    used[1].assign(n, false);
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            if (l[i][j] == 0 && !used[i][j]) tek.push_back(0), dfs(i, j);
        }
    }
    if (tek.size() == 0) {
        cout << "Unique\n";
    } else {
        string ans = "Multiple\n";
        for (auto it : tek) {
            if (it != 0) {
                ans = "None\n";
                break;
            } 
        }
        cout << ans;
    }
}
 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(); cout.tie();
    int t; cin >> t;
    for (; t; --t) {
        solve();
    }
}