#include<bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define int ll

bool validate(const string& s) {
    vector <ll> left, right;
    vector <pair <char, int>> symbs;
    symbs.pb({0, -1});
    for (int i = 0; i < s.size(); i++) {
        if (!isdigit(s[i])) symbs.pb({s[i], i});
    }
    // leading zeros:
    for (auto [ch, pos] : symbs) {
        if (pos + 2 < s.size() && s[pos + 1] == '0' && isdigit(s[pos + 2])) return false;
    }
    symbs.pb({0, s.size()});
    // calc
    vector <ll> words;
    for (int i = 1; i < symbs.size(); i++) {
        std::string tmp(s.begin() + symbs[i - 1].second + 1, s.begin() + symbs[i].second);
        if (tmp.empty() || tmp.size() > 10) return false;
        ll res = stoll(tmp);
        if (symbs[i - 1].first == '-') res *= -1ll;
        words.pb(res);
    }
//    for (auto &i : words) {
//        cout << i << ' ';
//    }
//    cout << endl;
    if (reduce(all(words), 0ll) == 0) return true;
    return false;
}

void solve() {
    string s;
    cin >> s;
    int swp_cnt = 0;
    for (int i = s.size() - 1; i >= 0; i--) {
        if (isdigit(s[i])) continue;
        swp_cnt++;
        if (s[i] == '+') s[i] = '-';
        else if (s[i] == '-') s[i] = '+';
        else if (s[i] == '=') {
            s[i] = '-';
            break;
        }
    }
    if (validate(s)) {
        cout << "Correct" << endl;
        return;
    }
    string res;
    for (int i = 0; i < s.size(); i++) {
        if (!isdigit(s[i])) continue;
        auto tmp = s;
        for (int j = i; j < s.size() - 1; j++) {
            swap(tmp[j], tmp[j + 1]);
//            if (i == 19) cout << tmp << endl;
            if (validate(tmp)) res = tmp;
        }
        tmp = s;
        for (int j = i; j > 0; j--) {
            swap(tmp[j], tmp[j - 1]);
//            if (i == 19) cout << tmp << endl;
            if (validate(tmp)) res = tmp;
        }
    }
    if (res.empty()) {
        cout << "Impossible" << endl;
        return;
    }
    for (int i = res.size() - 1; i >= 0 && swp_cnt > 0; i--) {
        if (isdigit(res[i])) continue;
        swp_cnt--;
        if (swp_cnt == 0) res[i] = '=';
        else if (res[i] == '-') res[i] = '+';
        else if (res[i] == '+') res[i] = '-';
    }
    cout << res << endl;
}


signed main() {
    int t = 1;
    // cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}