#include <bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()

using ll = long long;
using pll = pair<ll, ll>;

void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    
    vector<pll> a(n);
    vector<ll> l(m);
    for (int i = 0; i < n; i++) cin >> a[i].ss;
    for (int i = 0; i < n; i++) cin >> a[i].ff;
    for (int i = 0; i < m; i++) cin >> l[i];

    sort(all(a));

    vector<ll> last(n);
    last.back() = a.back().ff - a.back().ss;

    for (int i = n - 2; i >= 0; i--) {
        last[i] = min(a[i].ff, last[i + 1]) - a[i].ss;
    }

    vector<ll> psa(n + 1), psl(m + 1);
    for (int i = 0; i < n; i++) {
        psa[i + 1] = psa[i] + a[i].ss;
    }
    for (int i = 0; i < m; i++) {
        psl[i + 1] = psl[i] + l[i];
    }

    for (int ttt = 0; ttt < q; ttt++) {
        ll t;
        cin >> t;

        int i = upper_bound(last.begin(), last.end(), t) - last.begin() - 1;
        t = max(t, last[i] + a[i].ss);
        ll frt = t - psa[i + 1];

        int ans = upper_bound(psl.begin(), psl.end(), frt) - psl.begin() - 1;
        cout << ans << ' ';
    }

    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;
    cin >> t;
    while(t--) solve();
    return 0;
}