#include <bits/stdc++.h>
#define int long long
using namespace std;

vector<int> apply_ord(vector<int> a, vector<int> ord) {
    vector<int> res(a.size());
    for (int i = 0; i < a.size(); ++i) {
        res[i] = a[ord[i]];
    }
    return res;
}

void solve() {
    int n, m, q; cin >> n >> m >> q;
    vector<int> a(n), d(n), l(m), t(q);
    for (int& x : a) cin >> x;
    for (int& x : d) cin >> x;
    for (int& x : l) cin >> x;
    for (int& x : t) cin >> x;
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return d[i] < d[j];
    });
    a = apply_ord(a, ord);
    d = apply_ord(d, ord);

    vector<int> pref_films(m), pref_a(n);
    pref_films[0] = l[0];
    for (int i = 1; i < m; ++i) pref_films[i] = pref_films[i - 1] + l[i];
    pref_a[0] = a[0];
    for (int i = 1; i < n; ++i) pref_a[i] = pref_a[i - 1] + a[i];
    vector<int> suf_min(n);
    suf_min[n - 1] = d[n - 1] - pref_a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        suf_min[i] = min(suf_min[i + 1], d[i] - pref_a[i]);
    }

    for (int w = 0; w < q; ++w) {
        int l = 0, r = m + 1;
        int idx = lower_bound(d.begin(), d.end(), t[w]) - d.begin() - 1;

        auto ok = [&](int p) {
            int pref_sum = (idx < 0 ? 0 : pref_a[idx]);
            if (pref_sum + pref_films[p - 1] > t[w])
                return false;
            int s = pref_sum + pref_films[p - 1];
            if (idx + 1 < suf_min.size() && suf_min[idx + 1] < s - pref_sum)
                return false;
            return true;
        };

        while (r - l > 1) {
            int mid = l + r >> 1;
            if (ok(mid)) l = mid;
            else r = mid;
        }
        cout << l << " ";
    }
    cout << "\n";
}

int32_t main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int T; cin >> T;
    while (T--)
        solve();
    return 0;
}
