#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <sstream>
#include <cstring>
#include <numeric>
#include <ctime>

using namespace std;



void solve() {
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	vector<pair<int, int>> ans;
	map<int, int> pos, now;
	map<pair<int, int>, int > m;

	for (int i = 0; i < n; i++)
	{
		pos[v[i]] = v[i] - 1;
		now[i] = i + 1;
	}



	for (int i = 0; i < n; i++)
	{
		while (pos[v[i]] != i)
		{
			int position = pos[v[i]];
			ans.push_back({ v[i], now[position - 1]});

			m[{ v[i], now[position - 1]}] = 1;

			int num = now[position - 1];
			swap(now[position], now[position - 1]);
			swap(pos[v[i]], pos[num]);

		}
	}

	for (int i = 0; i < n - 1; i++)
	{
		if (m.find({ now[i], now[i + 1] }) == m.end() && m.find({ now[i + 1], now[i] }) == m.end())
		{
			ans.push_back({ now[i + 1], now[i] });
			ans.push_back({ now[i], now[i + 1] });
		}
	}

	cout << ans.size() << "\n";
	for (auto e : ans)
		cout << e.first << ' ' << e.second << "\n";
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}

