#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <sstream>
#include <cstring>
#include <numeric>
#include <ctime>
#include <unordered_map>
#include <unordered_set>

using namespace std;

vector<int> p;
int n;
vector < pair<int, int>> ans;
void not_doing(int a, int b) {
	if (a == b) {
		return;
	}
	for (int i = b; i > a; i--) {
		for (int j = i - 1; j >= a; j--) {
			ans.push_back({ p[i], p[j] });
		}
		for (int j = a; j < i; j++) {
			ans.push_back({ p[j], p[i] });
		}
	}
}

void solve() {
	int n;
	cin >> n;
	unordered_map<int, unordered_set<int>> was;
	vector<int> curr;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		p.push_back(t);
		curr.push_back(i+1);
	}
	int i = 0;
	while (i < n) {
		if (curr[i] == p[i]) {
			i++;
		}
		if (i == n)
			break;
		int j = i;
		while (curr[j] != p[j]) {
			swap(curr[j], curr[j + 1]);
			ans.push_back({ curr[j], curr[j+1] });
			was[curr[j]].insert(curr[j+1]);
			j++;
		}
	}
	int l = 0;
	while (l < n) {
		int l_copy = l;
		for (int j = l + 1; j < n; j++) {
			bool f = true;
			for (int a = l; a < j; a++) {
				for (int b = a + 1; b <= j; b++) {
					if (was[p[b]].count(p[a]) != 0 || was[p[a]].count(p[b]) != 0) {
						f = false;
						break;
					}
				}
				if (!f) {
					break;
				}
			}
			if (!f) {
				not_doing(l, j - 1);
				l = j;
			}
		}
		if (l == l_copy) {
			not_doing(l, n - 1);
			l = n;
		}
	}
	cout << ans.size() <<"\n";
	for (auto x : ans) {
		cout << x.first << " " << x.second <<"\n";
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}

