#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <sstream>
#include <cstring>
#include <numeric>
#include <ctime>
#include <unordered_map>
#include <unordered_set>

using namespace std;

vector<int> p;
int n;
vector < pair<int, int>> ans;
void not_doing(int a, int b) {
	if (a == b) {
		return;
	}
	for (int i = a + 1; i <= b; i++) {
		ans.push_back({ p[i], p[a] });
	}
	for (int i = b; i > a; i--) {
		ans.push_back({ p[a], p[i] });
	}
}

void solve() {
	int n;
	cin >> n;
	unordered_map<int, unordered_set<int>> was;
	vector<int> curr;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		p.push_back(t);
		curr.push_back(i + 1);
	}
	
	for (int i = 0; i < n; i++)
	{
		int pos = 0;
		for (int j = 0; j < n; j++) {
			if (curr[j] == p[i]) {
				pos = j;
				break;
			}
		}
		for (int j = pos + 1; j < n; j++) {
			ans.push_back({ curr[j], p[i] });
		}
		for (int j = n - 1; j > pos; j--) {
			ans.push_back({ p[i], curr[j] });
		}
		for (int j = pos - 1; j >= i; j--) {
			ans.push_back({ curr[j + 1], curr[j] });
			swap(curr[j+1], curr[j]);
		}
	}
	cout << ans.size() << "\n";
	for (auto x : ans) {
		cout << x.first << " " << x.second << "\n";
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}