#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <sstream>
#include <cstring>
#include <numeric>
#include <ctime>

using namespace std;

map<string, vector<int>> m;
vector<int> v[200005];
string str[200005];
vector<int> ans;
vector<int> res;
int was[200005];

void dfs(int x)
{
	was[x] = 1;
	for (auto e : v[x])
	{
		if (was[e] == -1)
		{
			dfs(e);
		}
	}

	ans.push_back(x);
}


void solve() {
	int n;
	cin >> n;

	bool f = true;
	for (int i = 0; i < n; i++)
	{
		string s1, s2;
		cin >> s1 >> s2;
		m[s1 + s2].push_back(i);

		str[i] = s1 + s2;
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		int x, y;
		cin >> x >> y;

		--x; --y;
		//if (str[x] == "settrue" && (str[y] == "unsetflase")) f = false;
		//if (str[x] == "setfalse" && (str[y] == "unsetflase" || str[y] == "settrue")) f = false;

		//if (str[x] == "unsetfalse" && (str[y] == "unsetflase" || str[y] == "settrue" || str[y] == "setfalse")) f = false;

		v[y].push_back(x);
	}

	if (m["settrue"].size() == 0 && (m["unsettrue"].size() != 0 || m["setfalse"].size() > 0)) f = false;

	if (f == false)
	{
		cout << "-1";
		return;
	}

	for (int i = 0; i <= n; i++) was[i] = -1;

	vector<int> dop;
	bool now = false;
	for (auto e : m["unsetfalse"])
		if (was[e] == -1) {
			dfs(e);
			bool fl = false;
			for (auto e : ans) if (str[e] != "unsetfalse")
				fl = true;

			if (fl == false) for (auto e : ans) res.push_back(e);
			else for (auto e : ans) dop.push_back(e);
			ans.clear();
		}

	for (auto e : dop)
		was[e] = -1;
	dop.clear();

	for (auto e : m["settrue"])
		if (was[e] == -1) {
			dfs(e);

			now = true;
			if (ans.size() > 1) f = false;
			for (auto e : ans) res.push_back(e);

			ans.clear();
		}
	for (auto e : m["setfalse"])
		if (was[e] == -1) {
			dfs(e);

			if (now == false) f = false;
			bool fl = false;
			for (auto e : ans) if (str[e] != "setfalse")
				f = false;

			for (auto e : ans) res.push_back(e);
			ans.clear();
		}
	for (auto e : m["unsettrue"])
		if (was[e] == -1) {
			dfs(e);
			now = false;
			//if (now == true) f = false;
			if (ans.size() > 1) f = false;

			for (auto e : ans) res.push_back(e);
			ans.clear();
		}

	for (auto e : m["unsetfalse"])
		if (was[e] == -1) {
			dfs(e);
			if (now == true) f = false;
			for (auto e : ans) {
				if (str[e] != "unsetfalse") f = false;
				res.push_back(e);
			}
			ans.clear();
		}

	if (f == false)
	{
		cout << "-1";
		return;
	}

	for (auto e : res) cout << e + 1 << " ";

}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}