#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <sstream>
#include <cstring>
#include <numeric>
#include <ctime>

using namespace std;

string st;
bool is_corr(string& s) {
	long long left = 0, right = 0, cur = 0;
	char op = '+', p = 'l';
	int n = s.size();
	for (int i = 0; i < n; i++) {
		if (s[i] == '+' || s[i] == '-' || s[i] == '=') {
			if (p == 'l') {
				if (op == '+') {
					left += cur;
				}
				if (op == '-') {
					left -= cur;
				}
				cur = 0;
			}
			if (p == 'r') {
				if (op == '+') {
					right += cur;
				}
				if (op == '-') {
					right -= cur;
				}
				cur = 0;
			}
			if (s[i] == '-') {
				op = '-';
			}
			if (s[i] == '+')
				op = '+';
			if (s[i] == '=') {
				op = '+';
				p = 'r';
			}
		}
		else {
			if (cur == 0 && s[i] == '0') {
				if (i == n - 1 || s[i + 1] == '+' || s[i + 1] == '-' || s[i + 1] == '=') {
					continue;
				}
				else
					return false;
			}
			cur *= 10;
			cur += s[i] - '0';
			if (cur >= 10000000000) {
				return false;
			}
		}
	}
	if (op == '+') {
		right += cur;
	}
	if (op == '-') {
		right -= cur;
	}
	cur = 0;
	if (left == right) {
		return true;
	}
	else {
		return false;
	}
}


void solve() {
	cin >> st;
	if (is_corr(st)) {
		cout << "Correct";
		return;
	}
	int n = st.size();
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (st[i] != '+' && st[i] != '-' && st[i] != '=') {
				if (i == j)
					continue;
				string t;
				int d = 0;
				for (int z = 0; z < n; z++) {
					if (z == j) {
						t += st[i];
						t += st[z];
					}
					else if (z == i) {
						continue;
					}
					else {
						t += st[z];
					}
				}
				if (is_corr(t)) {
					cout << t;
					return;
				}
			}
		}
	}
	cout << "Impossible";
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}

