#include <iostream>
#include <vector>
using namespace std;

void solve() {
    int n;
    cin >> n;
    string row1, row2;
    cin >> row1 >> row2;
    vector<vector<long long>> dp(n, vector<long long>(4));
    if (row1[0]== '#' && row2[0] == '#') {
        dp[0][3] = 1;
    }
    else if (row1[0] == '#') {
        dp[0][2] = 1;
    }
    else if (row2[0] == '#') {
        dp[0][1] = 1;
    }
    else {
        dp[0][0] = 1;
        dp[0][3] = 1;
    }
    for (int i = 1; i < n; ++i) {
        /*
        0 - 0
            0
        1 - 0
            1
        2 - 1
            0
        3 - 1
            1
        */
        if (row1[i]== '#' && row2[i] == '#') {
            dp[i][3] = dp[i - 1][3];
        }
        else if (row1[i] == '#') {
            dp[i][3] = dp[i - 1][2];
            dp[i][2] = dp[i - 1][3];
        }
        else if (row2[i] == '#') {
            dp[i][3] = dp[i - 1][1];
            dp[i][1] = dp[i - 1][3];
        }
        else {
            dp[i][3] = dp[i - 1][0] + dp[i - 1][3];
            dp[i][1] = dp[i - 1][2];
            dp[i][2] = dp[i - 1][1];
            dp[i][0] = dp[i - 1][3];
        }
    }
    if (dp[n - 1][3] != 1 && dp[n-1][3] != 0) {
        cout << "Multiple\n";
    }
    else if (dp[n - 1][3] == 1) {
        cout << "Unique\n";
    }
    else {
        cout << "None\n";
    }
}

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}
