#include <bits/stdc++.h>

#define i4 int32_t
#define u4 uint32_t
#define i8 int64_t
#define u8 int64_t

#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front

using namespace std;

template<class T>
using Vec = vector<T>;

template<class T, class V>
using Pair = pair<T, V>;


void Solve() {
    i4 n;
    cin >> n;

    Vec<char> a[2];

    a[0].resize(n);
    a[1].resize(n);

    for (i4 j = 0; j < 2; ++j)
    for (i4 i = 0; i < n; ++i) {
        cin >> a[j][i];
    }

    Vec<i4> dp[4];
    dp[0].resize(n);
    dp[1].resize(n);
    dp[2].resize(n);
    dp[3].resize(n);

    i4 st = 0;
    if (a[0][0] == '#') {
        st += 1;
    }
    if (a[1][0] == '#') {
        st += 2;
    }

    dp[st][0] = 1;

    auto can = [&a](i4 i, i4 from, i4 to) -> i4{
        if (a[0][i + 1] == '#') {
            assert(to % 2 == 1);
            to -= 1;
        }

        if (a[1][i + 1] == '#') {
            assert(to / 2 == 1);
            to -= 2;
        }

        if (from == 3) {
            if (to == 0) {
                return 1;
            }
            return 0;
        }

        if (from == 0) {
            if (to == 3) {
                return 2;
            }
            if (to == 0) {
                return 1;
            }
            return 0;
        }

        if ((from & (1 << 0)) == 0 && (to & (1 << 0)) == 0) {
            return 0;
        }

        if ((from & (1 << 0)) != 0 && (to & (1 << 0)) != 0) {
            return 0;
        }

        if ((from & (1 << 1)) == 0 && (to & (1 << 1)) == 0) {
            return 0;
        }

        if ((from & (1 << 1)) != 0 && (to & (1 << 1)) != 0) {
            return 0;
        }

        return 1;
    };

    for (i4 i = 0; i < n - 1; ++i) {
        for (i4 msk = 0; msk < 4; ++msk) {
            if (a[0][i] == '#' && (msk & (1 << 0)) == 0) {
                continue;
            }

            if (a[1][i] == '#' && (msk & (1 << 1)) == 0) {
                continue;
            }

            for (i4 to = 0; to < 4; ++ to) {
                if (a[0][i + 1] == '#' && (to & (1 << 0)) == 0) {
                    continue;
                }

                if (a[1][i + 1] == '#' && (to & (1 << 1)) == 0) {
                    continue;
                }

                dp[to][i + 1] = min(2, dp[to][i + 1] + dp[msk][i] * can(i, msk, to));
            }
        }
    }

    if (dp[3][n - 1] == 0) {
        cout << "None" << '\n';
    }

    if (dp[3][n - 1] == 1) {
        cout << "Unique" << '\n';
    }

    if (dp[3][n - 1] == 2) {
        cout << "Multiple" << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    i4 t = 1;
    cin >> t;

    for (i4 iter = 0; iter < t; ++iter) {
        Solve();
    }
}

