#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <cstdint>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i,n) for(int i = 0; i < int(n); i++)
#define fore(i,l,n) for(int i = l; i < int(n); i++)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define endl '\n'


int bitcheck(ll mask, ll k) {
	return (mask >> k) & 1ll;
}


const int N = 2e5 + 10;

int dp[N][4];


void init(int n) {
	forn(i, n + 1) forn(k, 4) dp[i][k] = 0;
}

void solve()
{
	int n; cin >> n;
	init(n);
	vector<string>a(2);
	forn(i, 2) cin >> a[i];

	dp[0][3] = 1;

	forn(i, n) forn(mask, 4) {
		int nmask = (a[0][i] == '#') + (a[1][i] == '#') * 2;
		if (mask == 3) {
			dp[i + 1][nmask] = min(2, dp[i + 1][nmask] + dp[i][mask]);
		}
		if (mask == 0) {
			dp[i + 1][nmask] = min(2, dp[i + 1][nmask] + dp[i][mask]);
			if (nmask == 0)
				dp[i + 1][3] = min(2, dp[i + 1][3] + dp[i][mask]);
		}
		if (mask == 1) {
			if (!bitcheck(nmask, 1)) {
				int nm = nmask ^ (1 << 1);
				dp[i + 1][nm] = min(2, dp[i + 1][nm] + dp[i][mask]);
			}
		}
		if (mask == 2) {
			if (!bitcheck(nmask, 0)) {
				int nm = nmask ^ 1;
				dp[i + 1][nm] = min(2, dp[i + 1][nm] + dp[i][mask]);
			}
		}
	}
	if (dp[n][0]) {
		dp[n][3] = min(2, dp[n][3] + dp[n][0]);
	}
	vector<string> ans = {
		"None", "Unique", "Multiple"
	};
	cout << ans[dp[n][3]] << endl;
}
bool multitest = 1;


int32_t main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	int tests = 1;
	if (multitest)
		cin >> tests;

	while (tests--)
		solve();
}