s = input()

if s.count("=") != 1:
    print("Impossible")
    exit(0)

def isdigit(x):
    return all(ord("0") <= ord(y) <= ord("9") for y in x)

def get_nums(x):
    p = x[:]
    p = p.replace("-", "+").replace("=", "+")
    return p.split("+")

def is_valid(x):
    numbers = get_nums(x)
    for number in numbers:
        if not 0 < len(number) < 11 or not isdigit(number):
            return False
        if str(int(number)) != number:
            return False
    return True

def try_ans(x):
    if not is_valid(x):
        return False
    l, r = x.split("=")
    try:
        lv = eval(l)
        rv = eval(r)
    except:
        return False

    return lv == rv

if try_ans(s):
    print("Correct")
    exit(0)

for i in range(len(s)):
    if not isdigit(s[i]):
        continue
    t = s[i] + s[:i] + s[i + 1:]
    try_ans(t)
    it = 1
    while it < len(s):
        t = t[:it - 1] + t[it] + t[it - 1] + t[it + 1:]
        if try_ans(t):
            print(t)
            exit(0)
        it += 1

print("Impossible")
