#include <bits/stdc++.h>

using namespace std;

#define SP ' '
#define LF '\n'
#define rep(i, a, b) for(ll i = (a); i < (b); i++)
#define all(x) (x).begin(), (x).end()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr int INF = 10000;

void solve() {
	int n;
	cin >> n;

	vector<string> a(2);
	cin >> a[0] >> a[1];

	vector<vector<int>> dp(4, vector<int>(n, 0));

	bitset<2> res = 0;
	res[0] = a[0][0] == '#';
	res[1] = a[1][0] == '#';

	// cout << "dbg: " << res.to_ulong() << endl;

	dp[res.to_ulong()][0] = 1;
	if (res.to_ulong() == 0) {
		dp[3][0] = 1;
		// cout << "aboba" << endl;
	}

	rep(i, 1, n) {
		bitset<2> res = 0;
		res[0] = a[0][i] == '#';
		res[1] = a[1][i] == '#';

		// cout << "dbg: " << i << SP << res.to_ulong() << endl;

		rep(m1, 0, 4) {
			int need = 0;
			if (m1 % 2 == 0) {
				if (res[0]) continue;
				need |= 1;
			}
			if (m1 / 2 % 2 == 0) {
				if (res[1]) continue;
				need |= 2;
			}
			if (need == 3) {
				// cout << "aboba 1" << endl;
				if (res.to_ulong() != 0) continue;
				// cout << "aboba 2" << endl;
				dp[3][i] += dp[m1][i - 1];
				continue;
			}
			rep(m2, 0, 4) {
				if ((m2 & need) != need) continue;
				dp[m2][i] += dp[m1][i - 1];
			}
		}
	}

	int ans = dp[3].back();
	if (ans == 0) {
		cout << "None" << LF;
	} else if (ans == 1) {
		cout << "Unique" << LF;
	} else if (ans > 1) {
		cout << "Multiple" << LF;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	rep(i, 0, t) {
		solve();
	}
}
