from idlelib.run import flush_stdout


def toNumb(num):
    if num == '':
        return 0
    if len(num) > 10 or num[0] == '0':
        return None
    return int(num)
def calcSub(string: str):
    nums = string.split('-')
    nums = [toNumb(e) for e in nums]
    for i in nums:
        if i is None:
            return None
    res = nums[0]
    for i in range(1, len(nums)):
        res -= nums[i]
    return res

def calcSum(string):
    subs = string.split('+')
    nums = [calcSub(i) for i in subs]
    for i in nums:
        if i is None:
            return None
    res = 0
    for num in nums:
        res += num
    return res

def isCorrect(string):
    strs = string.split('=')
    res = [calcSum(st) for st in strs]
    for i in res:
        if i is None:
            return False
    return res[0] == res[1]

s = input()
if isCorrect(s):
    print("Correct")
    exit()
for i in range(len(s)):
    for j in range(len(s) - 1):
        if not (s[i] >= '0' and s[i] <= '9'):
            continue
        changed = s[0:i] + s[i+1:]
        changed = changed[0:j] + s[i] + changed[j:]
        if isCorrect(changed):
            print(changed)
            exit()
print("Impossible")