from itertools import permutations, combinations


def foo(index, n, original, pairs, moves):
    if index + 1 < n:
        key = min(original[index], original[index + 1]), max(original[index], original[index + 1])
        if pairs[key] == 2:
            moves.append((original[index + 1], original[index]))
            original[index + 1], original[index] = original[index], original[index + 1]
            pairs[key] -= 1

            foo(index + 1, n, original, pairs, moves)
            moves.append((original[index + 1], original[index]))
            original[index], original[index + 1] = original[index + 1], original[index]
            pairs[key] -= 1


def main():
    n = int(input())
    original = list(range(1, n + 1))
    order = list(map(int, input().split()))

    pairs = {pair: 2 for pair in combinations(original, 2)}
    current_positions = {i + 1: i for i in range(n)}
    ordered_positions = {val: i for i, val in enumerate(order)}

    moves = []
    for val in current_positions:
        while ordered_positions[val] != current_positions[val]:
            left = val
            right = original[current_positions[val] + 1]
            moves.append((right, left))
            pairs[(left, right) if left < right else (right, left)] -= 1
            original[current_positions[val]], original[current_positions[val] + 1] = original[
                current_positions[val] + 1], original[current_positions[val]]

            current_positions[left] += 1
            current_positions[right] -= 1

    for i in range(n - 1):
        foo(i, n, original, pairs, moves)

    print(len(moves))
    for t in moves:
        print(*t)


if __name__ == '__main__':
    main()
