#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(v) v.begin(), v.end()

mt19937_64 rnd(228);

vector<bool> used;
ll n;
vector<vector<ll>> graph;

vector<ll> value;
ll ans = 0;
void dfs(ll v){
    used[v] = true;

    ans += value[v];

    for(auto &to : graph[v]){
        if(!used[to]){
            dfs(to);
        }
    }
}
ll node(ll i,ll j){
    return i * n + j;
}
void solve() {

    cin >> n;

    used.assign(n*2, false);
    graph.assign(n*2,{});
    value.assign(n*2,0);
    vector<vector<char>> a(2,vector<char>(n));
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];

            if(a[i][j] == '#'){
                continue;
            }


            ll v = node(i,j);

            value[v] = ((i + j) % 2 == 0 ? 1 : -1);


            if(i > 0 && a[i-1][j] == '.'){
                ll to = node(i-1,j);

                graph[v].push_back(to);
                graph[to].push_back(v);
            }
            if(j > 0 && a[i][j-1] == '.'){
                ll to = node(i,j-1);

                graph[v].push_back(to);
                graph[to].push_back(v);
            }
        }
    }

    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            ll v = node(i,j);
            if(a[i][j] == '#' || used[v]){
                continue;
            }

            ans = 0;
            dfs(v);

            if(ans != 0){
                cout << "None" << "\n";
                return;
            }
        }
    }

    ll l = 0;

    ll r = l + 1;

    a[0].insert(a[0].begin(),'#');
    a[0].push_back('#');

    a[1].insert(a[1].begin(),'#');
    a[1].push_back('#');

    n += 2;

    bool found = false;

    while (r < n){
        while (r < n && !(a[0][r] == '#' && a[1][r] == '#')){
            if(a[0][r] == '#'){
                found = true;
            }
            if(a[1][r] == '#'){
                found = true;
            }
            r++;
        }
        if(r < n){
            if(!found && (r-l > 1)){
                cout << "Multiple" << "\n";
                return;
            }
        }
        l = r;
        r++;
        found = false;
    }
    cout << "Unique" << "\n";

}

int main() {
    ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);

    int t;
    cin >> t;

    for (int i = 0; i != t; ++i) {
        solve();
    }

    return 0;
}
