#include <bits/stdc++.h>

using namespace std;

#define int long long

int get(string s) {
    int ans = 0;
    int op = 1, x = 0;
    for (auto c : s) {
        if ('0' <= c && c <= '9') x = x * 10 + c - '0';
        else {
            if (op) ans += x;
            else ans -= x;
            if (c == '+') op = 1;
            else op = 0;
            x = 0;
        }
    }
    if (op) ans += x;
    else ans -= x;
    return ans;
}

int func(string s) {
    if (s.empty()) return 1;
    if (s[0] == '0' && s.size() > 1) return 0;
    return 1;
}

int check(string s) {
    int len = 0;
    for (int i = 0; i < s.size(); i++) {
        if (i && !('0' <= s[i] && s[i] <= '9') && !('0' <= s[i - 1] && s[i - 1] <= '9')) return 0;
        if ('0' <= s[i] && s[i] <= '9') len++;
        else len = 0;
        if (len > 10) return 0;
    }
    string word = "";
    for (int i = 0; i < s.size(); i++) {
        if ('0' <= s[i] && s[i] <= '9') word += s[i];
        else {
            if (!func(word)) return 0;
            word = "";
        }
    }
    if (!func(word)) return 0;
    string A = "", B = "";
    int ok = 0;
    for (auto c : s) {
        if (c == '=') ok = 1;
        else if (!ok) A += c;
        else B += c;
    }
    if (A.empty() || B.empty()) return 0;
    return get(A) == get(B);
}

main(){
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin >> s;
    if (check(s)) cout << "Correct\n";
    else {
        for (int i = 0; i < s.size(); i++) {
            if (!('0' <= s[i] && s[i] <= '9')) continue;
            string t = "";
            for (int j = 0; j < s.size(); j++) if (i != j) t += s[j];
            for (int j = 0; j <= t.size(); j++) {
                string c = "";
                for (int pref = 0; pref < j; pref++) c += t[pref];
                c += s[i];
                for (int pref = j; pref < t.size(); pref++) c += t[pref];
                if (check(c)) {
                    cout << c << '\n';
                    exit(0);
                }
            }
        }
        cout << "Impossible\n";
    }
    return 0;
}

