#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

double eps = 1e-7;
double pi = atan2(0, -1);

vector < pair < double, double > > get(vector < string > c, vector < int > a, int go) {
    double x = 0, y = 0;
    vector < pair < double, double > > res;
    int i = 0;
    int agl = 45 * go;
    while (i < c.size()) {
        int j = i;
        if (c[j] == "rotate") agl = (agl + a[j]) % 360;
        else {
            double to_x = x + cos(agl / 180.0 * pi) * a[j];
            double to_y = y + sin(agl / 180.0 * pi) * a[j];
            if (c[j] == "draw") res.push_back({x, y}), res.push_back({to_x, to_y});
            x = to_x, y = to_y;
        }
        i++;
    }
    return res;
}

int check(vector < pair < double, double > > A) {
    sort(A.begin(), A.end());
    for (int i = 0; i < A.size(); i++) {
        if (abs(A[i].first + A[A.size() - i - 1].first) > eps) return 0;
        if (abs(A[i].second - A[A.size() - i - 1].second) > eps) return 0;
    }
    return 1;
}

main(){
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, ptr = 1, flag = 0;
    cin >> n;
    vector < string > c;
    vector < int > a;
    for (int i = 0; i < n; i++) {
        string s;
        int d;
        cin >> s >> d;
        if (s == "draw") flag = 1;
        if (flag) {
            c.push_back(s);
            a.push_back(d);
        }
    }
    vector < pair < double, double > > now = get(c, a, 0);
    //for (auto key : now) cout << key.first << " " << key.second << endl;
    double sx = 0, sy = 0;
    for (auto [x, y] : now) sx += x, sy += y;
    sx = sx / now.size();
    sy = sy / now.size();
    int f1 = 0, f2 = 0;
    vector < pair < double, double > > A, B;
    for (auto key : now) {
        A.push_back({key.first - sx, key.second});
        B.push_back({key.second - sy, key.first});
    }
    f1 = check(A);
    f2 = check(B);
    if (f1 && f2) cout << 90 << '\n';
    else if (f1 || f2) cout << 180 << '\n';
    else cout << 360 << '\n';
    return 0;
}

