#include <bits/stdc++.h>

using namespace std;

int main() {

    int n;
    cin >> n;

    vector<pair<int, int>> a(n + 1);

    bool flag1 = 0, flag2 = 0;

    for(int i=1;i<=n;i++) {
        string s, t;
        cin >> s >> t;
        if (s == "set") a[i].first = 1;
        else a[i].first = 2;
        if (t == "false") a[i].second = 0;
        else a[i].second = 1;

        if (a[i] == make_pair(1, 1)) flag1 = 1;
        if (a[i] == make_pair(2, 1)) flag2 = 1;

    }

    if (flag1 + flag2 != 2) {
        cout << "-1\n";
        return 0;
    }

    map<int, vector<int>> g;

    int m;
    cin >> m;

    set<int> op;

    for(int i=1;i<=n;i++)
        op.emplace(i);

    for(int i=0;i<m;i++) {
        int v, u;
        cin >> v >> u;

        g[v].emplace_back(u);
        op.erase(u);
    }

    vector<int> ans;

    function<void(int, pair<int, int>)> dfs = [&] (int x, pair<int, int> tp) {
        if (a[x] == tp) {
            ans.emplace_back(x);
            op.erase(x);
            for (auto to: g[x]) {
                dfs(to, tp);
            }
        }
        else {
            op.emplace(x);
        }
    };

    auto dop = op;
    for(auto x:dop) {
        dfs(x, make_pair(2, 0));
    }

    dop = op;
    for(auto x:dop) {
        dfs(x, make_pair(1, 1));
    }

    dop = op;
    for(auto x:dop) {
        dfs(x, make_pair(1, 0));
    }
    dop = op;
    for(auto x:dop) {
        dfs(x, make_pair(2, 1));
    }
    dop = op;
    for(auto x:dop) {
        dfs(x, make_pair(2, 0));
    }

    if (!op.empty()) {
        cout << "-1\n";
        return 0;
    }

    for(auto x:ans) {
        cout << x << " ";
    }
    cout << endl;

    return 0;
}
