#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <numeric>
#include <set>
#include <string>
#include <map>

using namespace std;

#define int long long
#define all(a) begin(a), end(a)
#define vi vector<int>
#define ve vector
#define pii pair<int,int>
#define rep(i, n) for(int i = 0; i < (n); i++)

void fast() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cout << fixed; cout.precision(10);
}

string s;

bool check(string s) {
    ve<string> v;
    vi type;
    for (char c : s) {
        if (isdigit(c)) {
            if (type.empty() || type.back() != 0) {
                type.push_back(0);
                v.push_back("");
            }
            v.back().push_back(c);
        }
        else {
            if (type.empty() || type.back() != 1) {
                type.push_back(1);
                v.push_back("");
            }
            v.back().push_back(c);
        }
    }
    int n = v.size();
    for (int i = 0; i < n; i++) {
        if (type[i] == 0) {
            if (v[i].size() != 1 && v[i].front() == '0') {
                return false;
            }
            if (v[i].size() > 10) {
                return false;
            }
            if (i - 1 >= 0 && type[i - 1] == 0) {
                return false;
            }
            if (i + 1 < n && type[i + 1] == 0) {
                return false;
            }
        }
        if (type[i] == 1) {
            if (i + 1 >= n) {
                return false;
            }
            if (i - 1 < 0) {
                return false;
            }
            if (type[i - 1] != 0 || type[i + 1] != 0) {
                return false;
            }
        }
    }

    int summ[2]{};
    int was[2]{};
    int f = 0;

    for (int i = 0; i < n; i++) {
        if (v[i] == "=") {
            f = 1;
        }
        else if (type[i] == 0) {
            int temp = stoll(v[i]);
            if (i - 1 >= 0 && v[i - 1] == "-") {
                temp *= -1;
            }
            summ[f] += temp;
            was[f] = 1;
        }
    }

    return summ[0] == summ[1] && was[0] && was[1];

}

void solve() {
    cin >> s;
    if (check(s)) {
        cout << "Correct\n";
        return;
    }
    int n = s.size();
    for (int i = 0; i < n; i++) {
        if (isdigit(s[i])) {
            string temp = s;
            temp.erase(temp.begin() + i);
            for (int j = 0; j <= temp.size(); j++) {
                string temp2 = temp;
                temp2.insert(temp2.begin() + j, s[i]);
                // cout << temp2 << "\n";
                if (check(temp2)) {
                    cout << temp2 << "\n";
                    return;
                }
            }
        }
    }
    cout << "Impossible\n";
}

// 2+2=4
// 123456789+9876543210=111111110+11-1

signed main() {
    fast();
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}