#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int N = 1e5 + 7;

#define int long long
const int INF = 1e18;
const int M = 360;

struct Node {
    int x = 0, y = 0, cr_x = 0, cr_y = 0;
};

int f(int x, int cr) { // 0 - >0 1 - ==0 2 < 0
    if (x > 0 and cr > 0) return 0;
    if (x == 0 and cr > 0) return 0;
    if (x > 0 and cr == 0) return 0;
    if (x == 0 and cr == 0) return 1;
    if (x < 0 and cr < 0) return 2;
    if (x == 0 and cr < 0) return 2;
    if (x < 0 and cr == 0) return 2;
    if (x > 0 and cr < 0) {
        if (2 * (__int128) x * x < cr) {
            return 2;
        }
        if (2 * (__int128) x * x == cr) return 1;
        return 0;
    }
    if (x < 0 and cr > 0) {
        if (2 * (__int128) x * x < cr) {
            return 0;
        }
        if (2 * (__int128) x * x == cr) return 1;
        return 2;
    }
}


bool operator<(Node a, Node b) {
    int del = f(b.x - a.x, b.cr_x - a.cr_x);
    if (del == 0) return 1;
    if (del == 2) return 0;
    del = f(b.y - a.y, b.cr_y - a.cr_y);
    return del == 0;
}

bool operator==(Node a, Node b) {
    return !(a < b) and !(b < a);
}

vector<pair<string, int>> vec;

Node add(Node now, int deg, int cnt) {
    if (deg == 0) {
        now.x += cnt;
    } else if (deg == 45) {
        now.cr_x += cnt;
        now.cr_y -= cnt;
    } else if (deg == 90) {
        now.y -= cnt;
    } else if (deg == 135) {
        now.cr_x -= cnt;
        now.cr_y -= cnt;
    } else if (deg == 180) {
        now.x -= cnt;
    } else if (deg == 225) {
        now.cr_x -= cnt;
        now.cr_y += cnt;
    } else if (deg == 270) {
        now.y += cnt;
    } else if (deg == 315) {
        now.cr_x += cnt;
        now.cr_y += cnt;
    }
    return now;
}

vector<pair<Node, Node>> do_all_oper(int deg) {
    vector<pair<Node, Node>> res;
    Node now;
    bool fl = false;
    for (auto c: vec) {
        Node new_now = add(now, deg, c.second);
        if (c.first == "draw") {
            if (fl) {
                res.back().second = new_now;
            } else {
                res.push_back({now, new_now});
            }
            fl = true;
            now = new_now;
        } else if (c.first == "move") {
            now = new_now;
            fl = false;
        } else {
            fl = false;
            deg += c.second;
            deg %= M;
        }
    }
    return res;
}

bool simpl(vector<pair<Node, Node>> a, vector<pair<Node, Node>> b) {
    for (auto &c: a) {
        if (c.second < c.first) {
            swap(c.first, c.second);
        }
    }
    for (auto &c: b) {
        if (c.second < c.first) {
            swap(c.first, c.second);
        }
    }
    Node min_1 = a[0].first, min_2 = b[0].first;
    for (auto c: a) {
        min_1 = min(min_1, c.first);
    }
    for (auto c: b) {
        min_2 = min(min_2, c.first);
    }
    for (auto &c: b) {
        c.first.cr_x += min_1.cr_x - min_2.cr_x;
        c.first.cr_y += min_1.cr_y - min_2.cr_y;
        c.first.x += min_1.x - min_2.x;
        c.first.y += min_1.y - min_2.y;

        c.second.cr_x += min_1.cr_x - min_2.cr_x;
        c.second.cr_y += min_1.cr_y - min_2.cr_y;
        c.second.x += min_1.x - min_2.x;
        c.second.y += min_1.y - min_2.y;
    }

    for (int i = 0; i < a.size(); ++i) {
        bool fl = false;
        for (auto c: b) {
            if (a[i] == c) {
                fl = true;
            }
        }
        if (!fl) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string s;
        int a;
        cin >> s >> a;
        vec.push_back({s, a % M});
    }
    vector<pair<Node, Node>> vec1 = do_all_oper(0);
    for (int i = 45; i <= 360; i += 45) {
        vector<pair<Node, Node>> vec2 = do_all_oper(i % M);
        if (simpl(vec1, vec2)) {
            cout << i << endl;
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}



