#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <string>

#define ll long long;
#define nl "\n";

using namespace std;

signed main()
{
	std::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<int> finish(n);
	for (int i = 0; i < n; i++) {
		cin >> finish[i];
	}

	vector<int> nums(n);
	for (int i = 0; i < n; i++) {
		nums[i] = i + 1;
	}

	vector<string> ans;
	for (int idx = 0; idx < n - 1; idx++) {
		for (int i = 1; i < n - idx; i++) {
			ans.push_back(to_string(nums[i]) + " " + to_string(nums[i - 1]));
			swap(nums[i], nums[i - 1]);
		}
	}

	for (int idx = 0; idx < n; idx++) {
		if (finish[idx] == nums[idx]) {
			continue;
		}
		else {
			for (int i = n - 1; i >= 0; i--) {
				if (finish[idx] == nums[idx]) {
					break;
				}

				if (nums[i] == finish[idx]) {
					ans.push_back(to_string(nums[i]) + " " + to_string(nums[i - 1]));
					swap(nums[i - 1], nums[i]);
				}
			}
		}
	}

	cout << ans.size() << endl;
	for (auto x : ans) {
		cout << x << endl;
	}

	return 0;
}