#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(x) (x).begin(), (x).end()

bool validate(string s) {
    int n = s.size();
    if (1 < n && s[0] == '0' && ('0' <= s[1] && s[1] <= '9')) {
        return false;
    }
    int eq = s.find('=');
    if (eq + 1 < n && eq + 2 < n && s[eq + 1] == '0' && ('0' <= s[eq + 2] && s[eq + 2] <= '9')) {
        return false;
    }
    for (int i = 0; i < n; i++) {
        if (!('0' <= s[i] && s[i] <= '9')) {
            if (i + 1 < n && s[i + 1] == '0') {
                if (i + 2 < n && '0' <= s[i + 2] && s[i + 2] <= '9') {
                    return false;
                }
            }
        }
    }
    for (int i = 0; i + 1 < n; i++) {
        if (!('0' <= s[i] && s[i] <= '9') && !('0' <= s[i + 1] && s[i + 1] <= '9')) {
            return false;
        }
    }
    if (!('0' <= s.back() && s.back() <= '9')) {
        return false;
    }
    if (!('0' <= s.front() && s.front() <= '9')) {
        return false;
    }
    int good = 1;
    for (int i = 0; i < n; ) {
        if (!('0' <= s[i] && s[i] <= '9')) {
            i++;
            continue;
        }
        int j = i;
        while (j < n && '0' <= s[j] && s[j] <= '9') {
            j++;
        }
        if (j - i > 10) {
            return false;
        }
        i = j;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    int T = 1;
    // cin >> T;
    while (T--) {
        string s;
        cin >> s;
        ll res = 0;
        vector<ll> left;
        vector<int> signs_l;
        vector<ll> right;
        vector<int> signs_r;
        int eq = s.find('=');
        for (int i = 0; i < eq; ) {
            ll sign = 1;
            if (s[i] == '+'){
                i++;
            }
            if (s[i] == '-') {
                sign *= -1;
                i++;
            }
            int j = i;
            ll cur = 0;
            while (j < eq && '0' <= s[j] && s[j] <= '9') {
                cur = 10 * cur + s[j] - '0';
                j++;
            }
            left.push_back(cur * sign);
            i = j;
        }
        int n = s.size();
        for (int i = eq + 1; i < n; ) {
            ll sign = 1;
            if (s[i] == '+'){
                i++;
            }
            if (s[i] == '-') {
                sign *= -1;
                i++;
            }
            int j = i;
            ll cur = 0;
            while (j < n && '0' <= s[j] && s[j] <= '9') {
                cur = 10 * cur + s[j] - '0';
                j++;
            }
            right.push_back(cur * sign);
            i = j;
        }
        if (accumulate(all(left), 0ll) == accumulate(all(right), 0ll)) {
            cout << "Correct\n";
            continue;
        }
        for (int first = 0; first < n; first++) {
            auto tmp_s = s;
            for (int second = 0; second < n; second++, s = tmp_s) {
                if (first == second) {
                    continue;
                }
                if ('0' <= s[first] && s[first] <= '9' && 
                    s[second] != '=') {
                    if (first < second) {
                        s.insert(s.begin() + second, s[first]);
                        s.erase(s.begin() + first);
                    } else {
                        char c = s[first];
                        s.erase(s.begin() + first);
                        s.insert(s.begin() + second, c);
                    }
                    if (!validate(s)) {
                        continue;
                    }
                } else {
                    continue;
                }
                vector<ll> left;
                vector<ll> right;
                int eq = s.find('=');
                for (int i = 0; i < eq; ) {
                    ll sign = 1;
                    if (s[i] == '+'){
                        i++;
                    }
                    if (s[i] == '-') {
                        sign *= -1;
                        i++;
                    }
                    int j = i;
                    ll cur = 0;
                    while (j < eq && '0' <= s[j] && s[j] <= '9') {
                        cur = 10 * cur + s[j] - '0';
                        j++;
                    }
                    left.push_back(cur * sign);
                    i = j;
                }
                int n = s.size();
                for (int i = eq + 1; i < n; ) {
                    ll sign = 1;
                    if (s[i] == '+'){
                        i++;
                    }
                    if (s[i] == '-') {
                        sign *= -1;
                        i++;
                    }
                    int j = i;
                    ll cur = 0;
                    while (j < n && '0' <= s[j] && s[j] <= '9') {
                        cur = 10 * cur + s[j] - '0';
                        j++;
                    }
                    right.push_back(cur * sign);
                    i = j;
                }
                if (validate(s) && accumulate(all(left), 0ll) == accumulate(all(right), 0ll)) {
                    cout << s << "\n";
                    return 0;
                }
                s = tmp_s;
            }
        }
        cout << "Impossible\n";
    }
}
