#include<bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define f(i, a) for(int i = 0; i < (int)a; i++)
#define F(i, b, a) for(int i = b; i <= (int)a; i++)


const int mod = 1e9 + 7;
const double eps = 1e-10;
const double PI = acos(-1);
const int SZ = 1e5 + 5;

void solve(){
	int n;
	cin >> n;
	string s[2];
	cin >> s[0] >> s[1];
	vector<int> x(n);
	for (int i = 0; i < n; i++) {
		int mask = (s[0][i] == '#' ? 1 : 0) * 2 + ((s[1][i] == '#') ? 1 : 0);
		x[i] = mask; 
	}	

	vector<vector<int>> dp(n, vector<int>(4));
	dp[0][x[0]] = 1;
	for (int i = 0; i < n - 1; i++) {
		dp[i + 1][0 | x[i + 1]] += dp[i][0];
		if (x[i + 1] == 0) {
			dp[i + 1][3] += 2 * dp[i][0];
		}

		if (x[i + 1] == 1) {
			dp[i + 1][3] += dp[i][1];
		}

		if (x[i + 1] == 0) {
			dp[i + 1][2] += dp[i][1];
		}

		if (x[i + 1] == 0) {
			dp[i + 1][1] += dp[i][2];
		}
		if (x[i + 1] == 2) {
			dp[i + 1][3] += dp[i][2];
		}
		dp[i + 1][0] += dp[i][3];
		dp[i + 1][x[i + 1]] += dp[i][3];
	}

	if (dp[n - 1][3] == 1 ) {
		cout << "Unique" << endl;
	} else if (dp[n - 1][3] > 1) {
		cout << "Multiple" << endl;
	} else {
		cout << "None" << endl;
	}

}

signed main(){
	#ifdef LOCAL
	freopen("inf", "r", stdin);
	// freopen("out", "w", stdout);
	#endif
	int t = 1;
	cin >> t;
	while(t--){
		solve();
	}

}