#include <iostream>
#include <vector>
#include <array>
#include <string>

using namespace std;

#define int long long

void solveA() {
	int a[1000], b[1000], c[1000];
	int n;

	bool swapped[1000][1000];

	cin >> n;

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	for (int i = 0; i < n; i++) {
		c[a[i] - 1] = i;
	}

	vector<pair<int, int>> v;

	int s = 0;
	for (int i = 0; i < n; ++i) {
		b[i] = i;
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n - 1; ++j) {
			if (c[b[j]] > c[b[j + 1]]) {
				v.push_back({ b[j + 1] + 1, b[j] + 1 });
				swap(b[j], b[j + 1]);
				swapped[b[j]][b[j + 1]] = 1;
				swapped[b[j + 1]][b[j]] = 1;
			}
		}
	}

	for (int i = 1; i < n; ++i) {
		int p = i;
		while (p > 0 && !swapped[b[p]][b[p - 1]]) {
			v.push_back({ b[p] + 1, b[p - 1] + 1 });
			swapped[b[p]][b[p - 1]] = 1;
			swapped[b[p - 1]][b[p]] = 1;
			swap(b[p], b[p - 1]);
			//cout << p << endl;
			--p;
		}

		//cout << endl;

		while (p < i) {
			++p;
			v.push_back({ b[p] + 1, b[p - 1] + 1 });
			swap(b[p], b[p - 1]);
			//cout << p << " " << p - 1 << endl;
		}
	}

	cout << v.size() << endl;
	for (auto& x : v) {
		cout << x.first << " " << x.second << endl;
	}
}

int eval(const string& s, int& p) {
	string num = "";
	int sign = 1;
	int ans = 0;
	while (p < s.size() && s[p] != '=') {
		while (p < s.size() && s[p] >= '0' && s[p] <= '9' && s[p] != '=' ) {
			num += s[p];
			++p;
		}
		ans += sign * stoll(num);
		num = "";
		if (p < s.size() && s[p] != '=') {
			sign = s[p] == '-' ? -1 : 1;
			++p;
		}
	}
	return ans;
}

bool check(const string& s) {
	string num = "";
	int p = 0;
	while (p < s.size() && s[p] != '=') {
		while (p < s.size() && s[p] >= '0' && s[p] <= '9') {
			num += s[p];
			++p;
		}
		if (num.size() > 10 || num.size() == 0 || (num[0] == '0' && num.size() > 1)) {
			return 0;
		}
		num = "";
		if (p < s.size() && s[p] != '=') {
			++p;
			if (p == s.size() || s[p] == '=' || (s[p] == '0' && p + 1 < s.size() && s[p + 1] >= '0' && s[p + 1] <= '9')) {
				return 0;
			}
		}
	}
	if (p >= s.size()) {
		return 0;
	}
	else {
		++p;
	}
	
	while (p < s.size()) {
		while (p < s.size() && s[p] != '=' && s[p] >= '0' && s[p] <= '9') {
			num += s[p];
			++p;
		}
		if (num.size() > 10 || num.size() == 0 || (num[0] == '0' && num.size() > 1)) {
			return 0;
		}
		num = "";
		if (p < s.size() && s[p] != '=') {
			++p;
			if (p == s.size() || s[p] == '=' || (s[p] == '0' && p + 1 < s.size() && (s[p + 1] >= '0' && s[p + 1] <= '9'))) {
				return 0;
			}
		}
	}

	return 1;
}

void solveE() {
	string s;
	cin >> s;

	int p = 0;
	int a = eval(s, p);
	++p;
	int b = eval(s, p);
	if (a == b) {
		cout << "Correct" << endl;
		return;
	}

	for (int i = 0; i < s.size(); i++) {
		char c = s[i];
		if (!(c >= '0' && c <= '9')) {
			continue;
		}
		string u = s;
		u.erase(i, 1);
		for (int j = 0; j <= u.size(); j++) {
			u = u.substr(0, j) + c + u.substr(j);
			//cout << u << " " <<check(u) << endl;
			if (check(u)) {
				int p = 0;
				int a = eval(u, p);
				++p;
				int b = eval(u, p);
				if (a == b) {
					cout << u << endl;
					return;
				}
			}
			u.erase(j, 1);
		}
	}

	cout << "Impossible" << endl;
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	solveE();
}