#include<iostream>
#include<vector>
#include<cassert>

using namespace std;

void solve() {
	int n; cin >> n;
	vector<int> vc(n + 1), a(n + 1), ind(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> vc[i];
		a[i] = i;
		ind[i] = i;
	}
	vector<vector<bool>> ch(n + 1, vector<bool>(n + 1));
	vector<pair<int, int>> ans;
	for (int i = 1; i <= n; i++) {
		while (ind[vc[i]] != i) {
			int z1 = ind[vc[i]];
			int z2 = z1 - 1;
			ans.push_back({ a[z1], a[z2] });
			swap(ind[a[z1]], ind[a[z2]]);
			swap(a[z1], a[z2]);
			ch[a[z1]][a[z2]] = true;
		}
	}
	for (int i = n; i > 1; i--) {
		int z1 = ind[vc[i]];
		int z2 = z1 - 1;
		vector<pair<int, int>> vec;
		while (z2 > 0) {
			if (ch[a[z1]][a[z2]] || ch[a[z2]][a[z1]])
				break;
			vec.push_back({ a[z1], a[z2] });
			ans.push_back({ a[z1], a[z2] });
			ch[a[z1]][a[z2]] = true;
			z2--;
		}
		for (int j = vec.size() - 1; j >= 0; j--)
			ans.push_back({ vec[j].second, vec[j].first });
	}

	cout << ans.size() << '\n';
	for (auto [x, y] : ans)
		cout << x << ' ' << y << '\n';

	for (int i = 1; i <= n; i++)
		assert(a[i] == vc[i]);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}