#include <bits/stdc++.h>

using namespace std;

struct dz{
    long long a;
    long long d;
};

bool operator<(dz a, dz b) {
    return a.d < b.d;
}

void solve() {
    int n,m,q;
    cin >> n >> m >> q;
    vector <dz> ad(n), t(q);
    vector <long long int> l(m), s(n+1);
    vector <long long int> pa, pl; //prefix summ
    for(int i =0; i < n; ++i) {
        cin >> ad[i].a;
    }
    for(int i =0; i < n; ++i) {
        cin >> ad[i].d;
    }
    for(int i =0; i < m; ++i) {
        cin >> l[i];
    }
    for(int i =0; i < q; ++i) {
        cin >> t[i].d;
        t[i].a = i;
    }
    sort(ad.begin(), ad.end());

    pa.push_back(0);
    for(auto i : ad){
        pa.push_back(i.a + pa.back());
    }

    pl.push_back(0);
    for(auto i : l){
        pl.push_back(i + pl.back());
    }

    s[n] = 1000000000000000009;
    for(int i = n-1; i >=0; --i) {
        s[i] = min(s[i+1], ad[i].d) - ad[i].a;
    }

    sort(t.begin(), t.end());
    int film = 0, line = 0;
    for(int i = 0; i < q; ++i) {
        while (line < n && ad[line].d < t[i].d) {
            line++;
        }
        int av_time = min(t[i].d, s[line]) - pa[line];
        while (film < m && pl[film] <= av_time) {
            film++;
        }
        if (pl[film] <= av_time) film++;

        t[i].d = t[i].a;
        t[i].a = film-1;
    }

    sort(t.begin(), t.end());
    for(int i = 0; i < q; ++i) {
        cout << t[i].a << ' ';
    }
    cout << '\n';
}

/*

1
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10

*/

int main(){
    int test;
    cin >> test;
    for(int i =0; i < test; ++i) {
        solve();
    }
}
