#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
using namespace std;

typedef long long ll;

int main()
{
	int n;
	cin >> n;

	vector <int> c(n + 1);
	for (int i = 1; i <= n; i++)
		cin >> c[i];

	if (n == 1)
	{
		cout << 0;
		return 0;
	}

	int max_over = 0;
	vector <int> perm(n + 1);

	for (int i = 1; i <= n; i++)
		perm[i] = i;

	vector <pair<int, int>> swaps(n * n + 13);

	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j < n - i + 1; j++)
		{
			swaps[max_over].first = perm[j + 1];
			swaps[max_over].second = perm[j];
			swap(perm[j], perm[j + 1]);
			max_over++;
		}
	}

	vector <int> pos(n + 1);
	for (int i = 1; i <= n; i++)
		pos[perm[i]] = i;

	for (int i = 1; i <= n; i++)
	{
		int start = pos[c[i]];
		while (start > i)
		{
			swaps[max_over].first = perm[start];
			swaps[max_over].second = perm[start - 1];
			swap(perm[start], perm[start - 1]);
			pos[perm[start]] = start;
			pos[perm[start - 1]] = start - 1;
			max_over++;
			start--;
		}
	}

	cout << max_over << '\n';
	for (int i = 0; i < max_over; i++)
		cout << swaps[i].first << ' ' << swaps[i].second << '\n';


}
