#include <bits/stdc++.h>
using namespace std;
using ll=long long;
using pi=pair<int,int>;

template<typename T>
ostream& operator<<(ostream& ost, vector<T>& v){
    ost<<"[";
    for(auto x : v)
        ost<<x<<" ";
    return ost<<"]\n";
}

vector<vector<int>> e;
vector<int> ord;
set<int> back_uns;
vector<bool> vis;
vector<bool> st, res;

void dfs_ord(int i){
    if(vis[i])
        return;
    vis[i] = true;
    for(int j: e[i]){
        dfs_ord(j);
    }
    ord.push_back(i);
}

void dfs_uns(int i){
    if(vis[i])
        return;
    vis[i] = true;
    for(int j: e[i]){
        dfs_uns(j);
    }
    if(!st[i] && !res[i])
        back_uns.insert(i);
}

void solve(){
    int n;
    cin>>n;
    string s;
    st.resize(n);
    res.resize(n);
    vis.assign(n, false);
    e.resize(n);
    vector<vector<int>> meta_ord(5);
    vector<int> sets, unsets;
    for (int i = 0; i < n; ++i) {
        cin>>s;
        st[i] = s == "set";
        cin>>s;
        res[i] = s == "true";
        if(res[i]){
            if(st[i]){
                meta_ord[1].push_back(i);
            }
            else{
                meta_ord[3].push_back(i);
            }
        }
        else {
            if (st[i]) {
                sets.push_back(i);
            } else {
                unsets.push_back(i);
            }
        }
    }
    int m;
    cin>>m;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin>>x>>y;
        --x,--y;
        e[x].push_back(y);
    }

    for(int i: sets){
        dfs_uns(i);
    }
    for(int i: meta_ord[1]){
        dfs_uns(i);
    }

    meta_ord[4] = vector(back_uns.begin(), back_uns.end());
    meta_ord[2] = sets;
    for(int i: unsets){
        if(!back_uns.count(i))
            meta_ord[0].push_back(i);
    }
    vector<int> meta_num(n);
    for (int i = 0; i < 5; ++i) {
        for(int j: meta_ord[i])
            meta_num[j] = i;
    }

    vis.assign(n, false);
    for (int i = 4; i >= 0; --i) {
        for(int j: meta_ord[i])
            dfs_ord(j);
    }
    std::reverse(ord.begin(), ord.end());
    bool valid = true;
    for (int i = 0; i < n - 1; ++i) {
        valid &= meta_num[ord[i]] <= meta_num[ord[i+1]];
    }
    vector<bool> moe(5);
    for (int i = 0; i < 5; ++i) {
        moe[i] = meta_ord[i].empty();
    }
    valid &= (!moe[1] || moe[2] && moe[3] && moe[4]) && (!moe[3] || moe[4]);
    if(valid){
        for(int t: ord){
            cout<<t+1<<" ";
        }
    }else{
        cout<<-1;
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n = 1;
    //cin >> n;
    while(n--)
        solve();
}