#include <bits/stdc++.h>
using namespace std;
using ll=long long;

void solve(){
    int n;
    cin>>n;
    string s1, s2;
    cin>>s1>>s2;
    vector<int> m(n);
    for (int i = 0; i < n; ++i) {
        m[i] = (s1[i] == '#') * 2 + (s2[i] == '#');
    }
    vector<vector<int>> dp(4, vector(n+1, 0));
    dp[0][n] = 1;
    for(int i = n - 1; i >= 0; --i){
        for (int j = 0; j < 4; ++j) {
            if((m[i] & j) == 0) {
                int act = m[i] | j;
                dp[j][i] += dp[3^act][i+1];
                if(act == 0)
                dp[j][i] += dp[0][i+1];
            }
            if(dp[j][i] > 1)
                dp[j][i] = 2;
        }
    }
    switch(dp[0][0]) {
        case 0:
            cout << "None" << "\n";
            break;
        case 1:
            cout << "Unique" << "\n";
            break;
        case 2:
            cout << "Multiple" << "\n";
            break;
    }
}

int main() {
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int n;
    cin>>n;
    while(n--)
        solve();
}
