#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n; cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    vector <int> nw(n);
    for (int i = 1; i <= n; i++)
        nw[i - 1] = i;

    vector<pair<int, int>> ans;
    vector<bool> used(n + 1, false);
    for (int i = n - 1; i >= 0; i--){
        int v = a[i];
        used[v] = true;

        for (int x = v; x >= 1; x--)
            if (!used[x])
                ans.push_back({v, x});
        for (int x = 1; x < n + 1; x++)
            if (!used[x])
                ans.push_back({ x, v});
    }

    cout << ans.size() << "\n";

    for (auto u : ans)
        cout << u.first << " " << u.second << "\n";
}
