#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const ll inf = (ll) 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n), G(n);
    for (int i = 0; i < m; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        g[x].push_back({y, w});
        G[y].push_back({x, w});
    }
    vector<ll> dist(n, inf);
    dist[n - 1] = 0;
    set<pair<ll, int>> st = {{0, n - 1}};
    while (!st.empty()) {
        auto [d, v] = *st.begin();
//        cout << d << " " << v << endl;
        st.erase( st.begin());
        for (auto [u, w] : G[v]) {
            if (dist[u] > w + d) {
                st.erase({dist[u], u});
                dist[u] = w + d;
                st.insert({dist[u], u});
            }
        }
    }
    vector<int> bad(n);
    vector<vector<int>> dgr(n), gr(n), dgrrev(n), grrev(n);
    for (int i = 0; i < n; i++) {
        if (dist[i] == inf) {
            bad[i] = 1;
        }
//        cout << dist[i] << endl;
    }
    vector<ll> dp(n, inf);
    for (int i = 0; i < n; i++) {
        for (auto [j, d] : g[i]) {
            if (!bad[i] && !bad[j] && dist[i] + d == dist[j]) {
                dgr[i].push_back(j);
                dgrrev[j].push_back(i);
            }
            if (!bad[i] && !bad[j]) {
                gr[i].push_back(j);
                grrev[j].push_back(i);
            }
            if (!bad[i] && bad[j]) {
                dp[i] = 0;
            }
        }
    }
    if (bad[0]) {
        cout << -1 << '\n';
        return;
    }
    vector<int> cur, used = bad;
    for (int i = 0; i < n; i++) {
        if (!bad[i] && dp[i] == 0 && !(i == n - 1)) {
            cur.push_back(i);
            used[i] = 1;
        }
    }
    used[n - 1] = 1;
    vector<pair<ll, int>> cnt(n, {inf, 0});
    while (!cur.empty()) {
        int val = dp[cur[0]];
//        cout << val << endl;
//        for (auto x : cur) cout << x << " "; cout << " + ";
        for (int i = 0; i < (int) cur.size(); i++) {
            int v = cur[i];
            for (auto u : dgrrev[v]) {
                if (cnt[u].first > val) {
                    cnt[u] = {val, 1};
                } else if (cnt[u].first == val) {
                    cnt[u].second++;
                }
                if (!used[u] && cnt[u].second == dgr[u].size()) {
                    used[u] = 1;
                    dp[u] = val;
                    cur.push_back(u);
                }
            }
        }
//        for (auto x : cur) cout << x << " "; cout << endl;
        vector<int> ncur;
        for (auto v : cur) {
            for (auto u : grrev[v]) {
                if (!used[u]) {
                    used[u] = 1;
                    dp[u] = val + 1;
                    ncur.push_back(u);
                }
            }
        }
        cur = ncur;
    }
    cout << min((ll) n, dp[0]) << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

/*
5 7
1 3 5
4 5 2
3 4 3
1 5 9
4 2 8
5 2 11
3 5 5

 */