#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<vector<int>> g(2 * n);
    for (int i = 0; i + 1 < 2 * n; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<int> p(2 * n, -1);
//    int it = 0;
    auto dfs = [&] (auto&& dfs, int v, int pr) -> void {
//        cout << v << " " << pr << endl;;
//        if (it++>100)exit(0);
        for (auto u : g[v]) {
            if (u != pr) {
                dfs(dfs, u, v);
                if (p[u] == -1 && p[v] == -1) {
                    p[v] = u;
                }
            }
        }
    };
    dfs(dfs, 0, 0);
    vector<int> used(2 * n);
    vector<vector<array<int, 3>>> G(n);
    for (int i = 0; i < 2 * n; i++) {
        if (p[i] != -1) {
            int j = p[i];
            used[i] = used[j] = 1;
//            cerr << i << " " << j << endl;
            G[a[i]].push_back({a[j], i, j});
            G[a[j]].push_back({a[i], j, i});
        }
    }
    int pr = -1;
    for (int i = 0; i < 2 * n; i++) {
        if (!used[i]) {
            if (pr == -1) pr = i;
            else {
                int j = pr;
                used[i] = used[j] = 1;
//                cerr << i << " " << j << endl;
                G[a[i]].push_back({a[j], i, j});
                G[a[j]].push_back({a[i], j, i});
                pr = -1;
            }
        }
    }
    vector<pair<int, int>> ans;
    vector<int> usd(n);
    for (int st = 0; st < n; st++) {
        if (usd[st]) continue;
        vector<int> tmp = {st};
        int pr = -1;
        usd[st] = 1;
        vector<pair<int, int>> f;
        while (1) {
            int v = tmp.back();
            int nxt = -1;
            for (auto u : G[v]) {
                if (!usd[u[0]] && u[0] != pr) {
                    nxt = u[0];
                    f.push_back({u[1], u[2]});
                    break;
                }
            }
            if (nxt == -1) break;
            usd[nxt] = 1;
            tmp.push_back(nxt);
            pr = v;
        }
        if (tmp.size() == 1) {
            continue;
        }
        for (auto u : G[st]) {
            if (f[0] != pair{u[1], u[2]}) {
                f.push_back({u[2], u[1]});
                break;
            }
        }
//        for (auto [x, y] : f) {
//            cout << x << " " << y << " + ";
//        }
//        cout << endl;
        int m = (int) f.size();
        ans.push_back({f[m - 1].second, f[m - 2].second});
        int l = 0, r = m - 2, uk = 0;
        while (l < r) {
            if (uk % 2 == 0) {
                ans.push_back({f[l].first, f[r].first});
                r--;
            } else {
                ans.push_back({f[l].second, f[r].second});
                l++;
            }
            uk++;
        }
    }
    cout << ans.size() << '\n';
    for (auto [x, y] : ans) {
        cout << x + 1 << " " << y + 1 << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
