#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

void solve(){
    ll n, m, q;
    cin >> n >> m >> q;

    vector<ll> a(n);
    vector<ll> d(n);
    vector<ll> l(m);
    vector<ll> t(q);

    for(int i = 0; i < n; i++){
        cin >> a[i];
    }

    for(int i = 0; i < n; i++){
        cin >> d[i];
    }

    for(int i = 0; i < m; i++){
        cin >> l[i];
    }

    for(int i = 0; i < q; i++){
        cin >> t[i];
    }

    vector<pair<ll, ll>> da(n);
    for(int i = 0; i < n; i++){
        da[i].first = d[i];
        da[i].second = a[i];
    }

    std::sort(da.begin(), da.end());

    vector<ll> pref_a(n + 1);
    for(int i = 0; i < n; i++){
        pref_a[i + 1] = pref_a[i] + da[i].second;
    }

    vector<ll> pref_l(m + 1);
    for(int i = 0; i < m; i++){
        pref_l[i + 1] = pref_l[i] + l[i];
    }

    for(int i = 0; i < n; i++){
        d[i] = da[i].first;
        a[i] = da[i].second;
    }

    vector<ll> rems(n + 1);
    for(int i = 0; i < n; i++){
        rems[i + 1] = d[i] - pref_a[i + 1];
    }

    vector<ll> mins(n + 1);
    mins[n] = rems[n];
    for(int j = n; j > 0; j--){
        mins[j - 1] = min(mins[j], rems[j]);
    }

    for(int i = 0; i < q; i++){
        ll curr_t = t[i];

        auto di = upper_bound(d.begin(), d.end(), curr_t);
        ll index = di - d.begin();
        ll time_to_a = pref_a[index];

        ll rem_time = min(curr_t - time_to_a, mins[index]);
        if(di == d.end()){
            rem_time = curr_t - time_to_a;
        }
        auto li = upper_bound(pref_l.begin(), pref_l.end(), rem_time);
        ll cnt = li - pref_l.begin() - 1;

        cout << cnt << " ";
    }

    cout << endl;
}

int main() {
    ll t;
    cin >> t;
    while(t--){
        solve();
    }

    return 0;
}
