#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <stack>
#include <algorithm>
#include <cmath>
using ll = long long;

using namespace std;
void sol(ll n,string& first,string& second){
    bool isM = false;
    for (ll i = 0; i <= n-1; ++i) {
        if (first[i] == '.' && second[i] == '#'){
            if(i+1 == n || first[i+1] == '#'){
                cout << "None" << endl;
                return;
            }
            first[i] = '#';
            first[i+1] = '#';
        }
        else if (first[i] == '#' && second[i] == '.'){
            if(i+1 == n || second[i+1] == '#'){
                cout << "None" << endl;
                return;
            }
            second[i] = '#';
            second[i+1] = '#';
        }
        else if(first[i] == '#' && second[i] == '#'){
            continue;
        } else {
            if(i+1 != n && second[i+1] == '.' && first[i+1] == '.'){
                isM = true;
            } else  {
                first[i] = '#';
                second[i] = '#';
            }
        }
    }
    for (ll i = n-1; i <=0 ; i--) {

        if(first[i]=='.' || second[i] == '.'){
            cout << "None" << endl;
            return;
        }
        if(i == 0){
            break;
        }
    }
    if(isM){
        cout << "Multiple" << endl;
        return;
    }
    cout << "Unique" << endl;
}
int main()
{
    ll t;
    cin >> t;
    while(t--)
    {
        ll n;
        cin>>n;
        string first;
        string second;
        cin>>first;
        cin>>second;
        pair<ll, ll> left(make_pair(-1,-1));
        pair<ll, ll> right(make_pair(-1,-1));

        sol(n, first, second);
    }
    return 0;
}
