#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e5;

vector<int> vp[MAXN];

vector <pair<int, int>> vv;
vector <int> cnt(MAXN);
vector <int> bl(MAXN, -1);

void solve(){
    int n;
    cin >> n;
    for(int i = 0; i < n; i++){
        string s1, s2;
        cin >> s1 >> s2;
        vv.push_back({s1[0] == 's', s2[0] == 't'});
        if(s2[0] == 't'){
            bl[i] = 2 - (s1[0] == 's');
        }
    }
    int m;
    cin >> m;
    vector <pair<int, int>> chk;
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        vp[a].push_back(b);
        cnt[b]++;
        chk.push_back({a, b});
    }
    set <pair<int, int>> sp;
    for(int i = 0; i < n; i++){
        sp.insert({cnt[i], i});
    }
    deque <int> ans[3];
    while(sp.size()){
        auto [a, b] = *sp.begin();
        sp.erase(sp.begin());
        if(bl[b] == -1){
            bl[b] = vv[b].first;
        } else if(bl[b] > 2){
            cout << -1;
            return;
        }
        if(vv[b].second){
            ans[bl[b]].push_front(b);
        } else {
            ans[bl[b]].push_back(b);
        }
        for(auto to:vp[b]){
            bl[to] = max(bl[to], bl[b] + (vv[b].first != vv[to].first));
            sp.erase({cnt[to], to});
            cnt[to]--;
            sp.insert({cnt[to], to});
        }
    }
    vector <int> pos(n);
    int cnt = 0;
    int type = 0;
    for(int i = 0; i < 3; i++){
        for(auto j:ans[i]){
            if(((type != vv[j].first) ^ (vv[j].second))){
                cout << -1;
                return;
            }
            type = vv[j].first;
            pos[j] = cnt;
            cnt++;
        }
    }
    for(auto [a,b]:chk){
        if(pos[a] > pos[b]){
            cout << -1;
            return;
        }
    }
    for(int i = 0; i < 3; i++){
        for(auto j:ans[i]){
            cout << j + 1 << ' ';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
}