
from copy import deepcopy
def main():
    n = int(input())
    st1 = input()
    st2 = input()

    mp = [[st1[i], st2[i]] for i in range(n)]
    reverse_mp = deepcopy(mp)

    is_answer, is_multiply = test(mp)

    if is_answer and is_multiply:
        print('Multiple')
        return
    backup_is_answer = is_answer

    is_answer, is_multiply = test(reverse_mp[::-1])
    
    if is_answer and is_multiply:
        print('Multiple')
    elif backup_is_answer or is_answer:
        print('Unique')
    else:
        print('None')

def test(mp):
    n = len(mp)
    is_multiply = False
    is_answer = True
    last_is_vertical = False
    for i in range(n):
        if mp[i][1] == '#' and mp[i][0] == '#':
            continue
        if mp[i][1] == '.' and mp[i][0] == '.':
            if last_is_vertical:
                is_multiply = True
            mp[i][1] = '#' 
            mp[i][0] = '#'
            last_is_vertical = True
            continue
        if i < (n-1) and mp[i][1] == '.' and mp[i+1][1] == '.':
            mp[i+1][1] = '#' 
            mp[i][1] = '#' 

        if i < (n-1) and mp[i][0] == '.' and mp[i+1][0] == '.':
            mp[i+1][0] = '#' 
            mp[i][0] = '#' 
        last_is_vertical = False
    for i in range(n):
        if mp[i][0] == '.':
            is_answer = False
            break
        if mp[i][1] == '.':
            is_answer = False
            break
    return is_answer, is_multiply


t = int(input())
while t>0:
    main()
    t -= 1
