#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>
using ll = long long;
#define int ll
using namespace ::std;
using vi = vector<int>;
#define forn(i, n) for(int i = 0; i < n; ++i)
#define fore(col) for(auto& val : col)
#define all(v) v.begin(), v.end()
using pii = pair<int ,int>;


void doWork() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<pii> vect(n);
    fore(vect)
        cin >> val.first;
    fore(vect)
        cin >> val.second;
    fore(vect)
        val.second -= val.first;
    multimap<int, int> mp;
    fore(vect) {
        mp.insert({val.second, val.first});
    }
    {
        auto curCheck = mp.begin();
        auto curNext = ++mp.begin();
        while (curNext != mp.end()) {
            auto curPrev = curCheck;
            if (curPrev != mp.begin())
                --curPrev;
            if (curCheck->first + curCheck->second >= curNext->first) {
                int f = curNext->first - curCheck->second, s = curCheck->second + curNext->second;
                bool isBegin = curPrev == mp.begin();
                mp.erase(curCheck);
                mp.erase(curNext);
                mp.insert({f, s});

                if (isBegin)
                    curPrev = mp.begin();
                curCheck = curPrev;
                curNext = curPrev;
                ++curNext;
                if (curPrev != mp.begin())
                    --curPrev;
            } else {
                ++curCheck;
                ++curNext;
            }
        }
    }
    {
        auto curIt = mp.begin();
        auto curNext = ++mp.begin();
        while (curNext != mp.end()) {
            assert(curIt->first + curIt->second < curNext->first);
            ++curIt;
            ++curNext;
        }
        
    }

    vi serrials(m);
    fore(serrials)
        cin >> val;
    forn(i, m - 1)
        serrials[i + 1] += serrials[i];

    vector<pii> times(q);
    forn(i, q) {
        cin >> times[i].first;
        times[i].second = i;
    }
    sort(all(times));

    auto itMp = mp.begin();
    int serrialsPos = 0;
    int curTime = 0;
    int curWorkTime = 0;
    forn(i, q) {
        while (curTime < times[i].first) {
            if (itMp == mp.end() || itMp->first > times[i].first) {
                curTime = times[i].first;
                break;
            }
            curTime = itMp->first + itMp->second;
            curWorkTime += itMp->second;
            ++itMp;
        }
        while (serrialsPos < m && serrials[serrialsPos] <= curTime - curWorkTime) {
            ++serrialsPos;
        }

        assert(curTime >= times[i].first);
        times[i].first = serrialsPos;
    }
    sort(all(times), [](pii l, pii r){ return l.second < r.second; });
    fore(times) {
        cout << val.first << " ";
    }
    cout << endl;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        doWork();
    }
}