#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;



void solve() {
    long long n, m, q;
    cin >> n >> m >> q;
    // 0 - dedline 1 - dlit
    vector<vector <long long>> dz(n, vector <long long> (2));
    vector <long long> series(m + 1);
    series[0] = 0;
    for (long long i = 0; i < n; ++i){
        cin >> dz[i][1];
    }
    for (long long i = 0; i < n; ++i){
        cin >> dz[i][0];
    }
    sort(dz.begin(), dz.end());
    for (long long i = 1; i <= m; ++i){
        cin >> series[i];
        series[i] += series[i-1];
    }

    vector <vector <long long>> otrez;
    for (long long i = n - 1; i >= 0; --i){
        if (otrez.empty()){
            otrez.push_back({dz[i][0] - dz[i][1], dz[i][0]});
        }else{
            long long last = min(otrez.back()[0], dz[i][0]);
            otrez.push_back({last - dz[i][1], last});
        }
    }

    reverse(otrez.begin(), otrez.end());
    vector <long long> potr(otrez.size() + 1, 0);
    for (long long i = 0; i < otrez.size(); ++i){
        potr[i + 1] = potr[i] + (otrez[i][1] - otrez[i][0]);
    }

    long long t;
    for (long long i = 0; i < q; ++i){
        cin >> t;
        
        long long l = 0, r = otrez.size();
        while (r - l > 1){
            long long mm = (r + l) / 2;
            if (otrez[mm][0] <= t){
                l = mm;
            }else{
                r = mm;
            }
        }

        long long left, right;
        if (t <= otrez[l][1]){
            right = otrez[l][0];
            l -= 1;
        }else{
            right = t;
        }

        left = potr[l + 1];
        long long free_time = right - left;
        //cout << "free_time: " << free_time << "\n";
        l = 0; r = series.size();
        //cout << "l: " << l << " r: " << r << "\n";
        while (r - l > 1){
            long long mm = (r + l) / 2;
            //cout << "mm: " << mm << " " << series[mm] << "\n";
            if (series[mm] <= free_time){
                l = mm;
            }else{
                r = mm;
            }
        }
        cout << l << " ";
    }
    cout << "\n";
    
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t=1;
    cin >> t;
    while (t > 0){
        solve();
        --t;
    }
}

/*
2
1 2 3
10
15
5 5
5 15 20
3 4 5
8 100 8
10 150 20
2 32 1 1
9 200 51 50 10

*/