#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n, ans;
vector<int> pattern, cur;
vector<pair<int, int>> ansSteps, steps;
unordered_set<string> st;


void rec() {
    if (cur == pattern && steps.size() > ans) {
        ans = steps.size();
        ansSteps.resize(ans);
        for (int i = 0; i < steps.size(); ++i) {
            ansSteps[i] = steps[i];
        }
    }

    for (int i = 0; i < n - 1; ++i) {
        pair<int, int> p = {cur[i + 1], cur[i]};
        string p_s = to_string(p.first) + " " + to_string(p.second);

        if (st.find(p_s) == st.end()) {
            st.emplace(p_s);
            steps.push_back(p);
            swap(cur[i], cur[i + 1]);
            rec();
            st.erase(p_s);
            steps.pop_back();
            swap(cur[i], cur[i + 1]);
        }
    }
}

void solve() {

    cin >> n;
    ans = 0;
    pattern.resize(n);
    cur.resize(n);
    st.reserve(n);
    st.max_load_factor(0.25);

    for (int i = 0; i < n; ++i) {
        cin >> pattern[i];
        cur[i] = i + 1;
    }

    rec();
    cout << ans << '\n';
    for (auto [a, b]: ansSteps) {
        cout << a << ' ' << b << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();

    return 0;
}
