#include <iomanip>
#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <ctype.h>
#include <functional>
#include <string>
#define ll long long

using namespace std;

void solve();

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}

void solve() {
	string s;
	cin >> s;

	string a = s.substr(0, s.find('='));
	string b = s.substr(s.find('=') + 1);
	vector<string> numa(1), numb(1), num(1);
	vector<char> opa, opb;

	function<void()> make = [&]() {
		numa = numb = num = vector<string>(1);
		opa.clear(); opb.clear();

		for (auto c : a) {
			if (isdigit(c)) {
				numa.back() += c;
				num.back() += c;
			}
			else {
				opa.push_back(c);
				numa.push_back("");
				num.push_back("");
			}
		}

		num.push_back("");

		for (auto c : b) {
			if (isdigit(c)) {
				numb.back() += c;
				num.back() += c;
			}
			else {
				opb.push_back(c);
				numb.push_back("");
				num.push_back("");
			}
		}
	};

	function<bool()> check = [&]() {
		ll left = stoll(numa.front());
		ll right = stoll(numb.front());

		for (int i = 1; i < numa.size(); ++i) {
			if (opa[i - 1] == '+') {
				left += stoll(numa[i]);
			}
			else {
				left -= stoll(numa[i]);
			}
		}

		for (int i = 1; i < numb.size(); ++i) {
			if (opb[i - 1] == '+') {
				right += stoll(numb[i]);
			}
			else {
				right -= stoll(numb[i]);
			}
		}

		return left == right;
	};

	make();
	if (check()) {
		cout << "Correct";
		return;
	}

	for (int i = 0; i < s.size(); ++i) {
		if (!isdigit(s[i])) continue;
		string cpy = s.substr(0, i) + s.substr(i + 1);



		for (int j = 0; j < s.size(); ++j) {
			string ccpy;
			if (j == s.size() - 1) {
				ccpy = cpy + s[i];
			}
			else {
				ccpy = cpy.substr(0, j) + s[i] + cpy.substr(j);
			}

			a = ccpy.substr(0, ccpy.find('='));
			b = ccpy.substr(ccpy.find('=') + 1);
			make();
			bool pos = true;

			for (auto x : num) {
				if (x.size() > 1 && x[0] == '0') {
					pos = false;
					break;
				}

				if (x.size() == 0 || x.size() > 10) {
					pos = false;
					break;
				}
			}

			if (!pos) continue;

			if (check()) {
				cout << a + '=' + b;
				return;
			}
		}
	}

	cout << "Impossible";
}