#include <bits/stdc++.h>

using namespace std;
using ll = long long ;
using ull = unsigned long long;
using ld = long double;
struct triple{
    ll first, second, third;
    auto operator<=>(const triple&) const = default;
};

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;

using pll = pair<ll,ll>;
using vll = vector<pll>;
using vvll = vector<vll>;

using vlll = vector<triple>;
using vvlll = vector<vlll>;

using vs = vector<string>;
using vld = vector<ld>;

#define fi first
#define se second
#define th third

#define X first
#define Y second
#define Z third

#define con continue
#define pb push_back
#define re return

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(x) (int)(x).size()

template <typename T>
inline void sort(T & v) {
    sort(all(v));
}

template <typename T>
inline void reverse(T & v) {
    reverse(all(v));
}

template <typename T>
inline void unique( T & v) {
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
}

template <typename T>
void smin(T& s, const T& ot) {
    s = min(s, ot);
}

template <typename T>
void smax(T& s, const T& ot) {
    s = max(s, ot);
}

template <typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.fi >> p.se; return in;
}

template <typename T>
istream& operator>>(istream &in, vector<T> &p) {
    for (auto &x : p) in >> x; return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream &out, pair<T1, T2> &p) {
    out << p.fi << p.se; return out;
}

//template <typename T1, typename T2>
//ostream& operator<<(ostream &out, pair<T1, T2> &p) {
//    out << p.fi << p.se; return out;
//}
/*
void solve()
{
    ll ans = 0;
    cin >> n;
    vector<ll> v(n);
    cin >> v;
    for(int i  = 0; i < n; i++) {
        ll tmp = v[i] - 1;
        ans += tmp + (n - v[i]);
    }
    cout << ans;
}
*/

bool test(const string& s) {
    vl left;
    vl right;

    ll sign = 1;
    ll val = 0;
    ll len = 0;
    bool leadingz = false;
    for (auto v : s) {
        if (isdigit(v)) {
            if (v == '0' && len == 0) leadingz = true;
            val = 10 * val + (v-'0');
            len++;
            continue;
        }

        if (leadingz && len > 1) return false;
        if (len > 10) return false;
        right.push_back(val * sign);
        val = 0;
        sign = 1;
        len = 0;
        leadingz = false;

        if (v == '=') {
            swap(left, right);
        }
        else if (v == '-') {
            sign = -1;
        }
        else if (v == '+') {
            sign = 1;
        }
    }

    if (leadingz && len > 1) return false;
    if (len > 10) return false;
    if (val) right.push_back(sign*val);

    ll sum = 0;
    for (auto v : left) sum += v;
    for (auto v : right) sum -= v;

    return sum == 0;
}


void solve() {
    string s;
    cin >> s;

    bool ch1 = test(s);
    if (ch1) {
        cout << "Correct\n";
        return;
    }

    for (ll i = 0; i < s.size(); i++) {
        char c = s[i];
        string tmp = s;
        tmp.erase(tmp.begin() + i);
        tmp.insert(tmp.begin(), c);

        for (ll j = 0; j < s.size(); j++) {
            if (!isdigit(tmp[0]) || !isdigit(tmp.back())) continue;
            bool vld = true;
            for (ll k = 0; k < s.size(); k++) {
                if (!isdigit(tmp[k])) {
                    if (k == 0 || k == tmp.size() - 1 || !isdigit(tmp[k-1]) || !isdigit(tmp[k+1])) {
                        vld = false;
                        break;
                    }
                }
            }
            if (!vld) continue;

            //cout << tmp << endl;
            bool ch = test(tmp);

            if (ch) {
                cout << tmp << '\n';
                return;
            }

            if (j < s.size() - 1)
                swap(tmp[j], tmp[j + 1]);
        }
    }

    cout << "Impossible\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    // cin >> t;
    while(t--)
        solve();

    return 0;
}
