#include <bits/stdc++.h>

using namespace std;
using ll = long long ;
using ull = unsigned long long;
using ld = long double;
struct triple{
    ll first, second, third;
    auto operator<=>(const triple&) const = default;
};

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;

using pll = pair<ll,ll>;
using vll = vector<pll>;
using vvll = vector<vll>;

using vlll = vector<triple>;
using vvlll = vector<vlll>;

using vs = vector<string>;
using vld = vector<ld>;

#define fi first
#define se second
#define th third

#define X first
#define Y second
#define Z third

#define con continue
#define pb push_back
#define re return

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(x) (int)(x).size()

template <typename T>
inline void sort(T & v) {
    sort(all(v));
}

template <typename T>
inline void reverse(T & v) {
    reverse(all(v));
}

template <typename T>
inline void unique( T & v) {
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
}

template <typename T>
void smin(T& s, const T& ot) {
    s = min(s, ot);
}

template <typename T>
void smax(T& s, const T& ot) {
    s = max(s, ot);
}

template <typename T1, typename T2>
istream& operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.fi >> p.se; return in;
}

template <typename T>
istream& operator>>(istream &in, vector<T> &p) {
    for (auto &x : p) in >> x; return in;
}

template <typename T>
ostream& operator<<(ostream &ostr, const vector<T> &v) {
    for (const auto& el : v) cout << el << ' ';
    return ostr;
}

template <typename T1, typename T2>
ostream& operator<<(ostream &out, pair<T1, T2> &p) {
    out << p.fi << p.se; return out;
}

//template <typename T1, typename T2>
//ostream& operator<<(ostream &out, pair<T1, T2> &p) {
//    out << p.fi << p.se; return out;
//}


void solve() {
    ll n, m, q;
    cin >> n >> m >> q;

    vll homeworks(n);
    for (auto& v : homeworks) {
        cin >> v.second;
    }
    for (auto& v : homeworks) {
        cin >> v.first;
    }

    sort(homeworks);

    ll curEnd = homeworks.back().first;
    vll worko;
    for (ll i = n - 1; i >= 0; i--) {
        worko.push_back({curEnd - homeworks[i].second, curEnd});
        if (i > 0)
            curEnd = min(curEnd - homeworks[i].second, homeworks[i-1].first);
    }
    reverse(worko);

    vll chill;
    if (worko[0].first > 0) {
        chill.push_back({0, worko[0].first});
    }
    for (ll i = 1; i < worko.size(); i++) {
        if (worko[i].first - worko[i - 1].second > 0)
            chill.push_back({worko[i-1].second, worko[i].first});
    }
    if (worko.back().second < LLONG_MAX) {
        chill.push_back({worko.back().second, LLONG_MAX});
    }

    vl movs(m);
    cin >> movs;
    vl times(q);
    cin >> times;

    vl chillpref(chill.size() + 1);
    for (ll i = 0; i < chill.size(); i++) {
        chillpref[i + 1] = chillpref[i] + chill[i].second - chill[i].first;
    }

    vl movpref(movs.size() + 1);
    for (ll i = 0; i < movs.size(); i++) {
        movpref[i+1] = movpref[i] + movs[i];
    }

    vl segstarts(chill.size());
    for (ll i = 0; i < segstarts.size(); i++) segstarts[i] = chill[i].first;

    for (ll i = 0; i < q; i++) {
        ll targ =  times[i];

        ll ind = upper_bound(all(segstarts), targ) - segstarts.begin() - 1;
        ll hasTime = chillpref[ind] + min(targ, chill[ind].second) - segstarts[ind];

        ll ind2 = upper_bound(all(movpref), hasTime)  - movpref.begin();
        cout << ind2 - 1 << ' ';
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    cin >> t;
    while(t--)
        solve();

    return 0;
}
