#include <bits/stdc++.h>

using namespace std;
#define int long long

constexpr int maxn = 100000;
vector<unordered_set<int>> g;
vector<bool> used(maxn), used1(maxn);
vector<int> t;
int n;

void dfs1(int v) {
    used1[v] = true;
    for (int u : g[v]){
        if (!used1[u]){
            dfs1(u);
        }
    }
}

void dfs(int v) {
    used[v] = true;
    for (int u : g[v]){
        if (!used[u]){
            dfs(u);
        }
    }
    t.push_back(v);
}

void top_sort() {
    for (int v = 0; v < n; v++){
        if(!used[v]){
            dfs(v);
        }
    }
    std::reverse(t.begin(), t.end());
}

void print() {
    unordered_set<int> been;
    for (auto x : t) {
        for (auto u : g[x]) {
            if (been.contains(u)) {
                cout << "-1"; return;
            }
        }
        been.insert(x);
    }
    for (auto x : t) cout << x + 1 << ' ';
    cout << endl;
}

signed main() {
    cin >> n;
    string op, res;
    g.resize(n);
    
    int s1 = -1, u1 = -1;
    unordered_set<int> s0, u0;
   
    for (int i = 0; i< n;i++){
        cin >> op >> res;
        if (op == "set") {
            if (res == "true") s1 = i;
            else s0.insert(i);
        } else {
            if (res == "true") u1 = i;
            else u0.insert(i);
        }
    }
    int m;
    cin >> m;
    for (int i = 0; i< m ;i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].insert(v);
    }
    
    if (s1 == -1 && (u1 != -1 || !s0.empty())) { cout << "-1\n"; return 0; }
    if (s1 == -1) {
        top_sort();
        print();
        return 0;
    }
    // с этого момента есть set true
    if (u1 == -1) {
        for (auto x : s0) {
            g[s1].insert(x);
        }
        if (u0.empty()) {
            top_sort();
            print();
            return 0;
        }
        for (auto x : u0) g[x].insert(s1);
        top_sort();
        print();
        return 0;
    }

    // тут есть все set true unset true
    
    for (auto x : s0) {
        g[s1].insert(x); // s1 -> s0
        g[x].insert(u1); // s0 -> u1
    }
    g[s1].insert(u1); // s1 -> u1


    unordered_set<int> p, l;
    for (auto x : s0) { // ребра из s0 в u0
        for (auto u : g[x]) {
            if (u0.contains(u)) {
                p.insert(u);
            }
        }
    }
    for (auto u : g[s1]) {
        if (u0.contains(u)) {
            p.insert(u);
        }
    }
    for (auto u : g[u1]) {
        if (u0.contains(u)) {
            p.insert(u);
        }
    }


    for (auto x : p) if (!used1[x]) dfs1(x);
    for (auto x : u0) if (used1[x]) p.insert(x);

    for (auto x : p) g[u1].insert(x); // из u1 во всех правых
    for (auto x : u0) {
        if (!p.contains(x)) l.insert(x);
    }
    for (auto x : l) g[x].insert(s1);

    top_sort();
    print();
}
