#include <bits/stdc++.h>
using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int tt;
  cin >> tt;
  while (tt--) {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
      cin >> a[i];
    }
    vector<long long> d(n);
    vector<pair<long long, int>> tasks;
    vector<long long> len;
    for (int i = 0; i < n; i++) {
      cin >> d[i];
      len.push_back(d[i]);
      tasks.emplace_back(d[i], a[i]);
    }
    sort(len.begin(), len.end());
    sort(tasks.begin(), tasks.end());
    vector<long long> bounds;
    for (int i = 0; i < n; i++) {
      bounds.push_back(tasks[i].first - tasks[i].second);
    }
    vector<long long> duration(n, 0);
    duration[0] = tasks[0].second;
    for (int i = 1; i < n; i++) {
      duration[i] = duration[i - 1] + tasks[i].second;
    }
    vector<int> episodes(m);
    for (int i = 0; i < m; i++) {
      cin >> episodes[i];
    }
    vector<long long> eduration(m, 0);
    eduration[0] = episodes[0];
    for (int i = 1; i < m; i++) {
      eduration[i] = eduration[i - 1] + episodes[i];
    }
    long long need;
    auto ok = [&](long long x) -> bool {
      long long must = 0;
      int ind = upper_bound(len.begin(), len.end(), need) - len.begin();
      need = min(need, bounds[ind]);
      ind = upper_bound(len.begin(), len.end(), need) - len.begin();
      ind--;
      if (ind >= 0) {
        must += duration[ind];
      }
      long long rem = need - must;
      int where = lower_bound(eduration.begin(), eduration.end(), rem) - eduration.begin();
      while (where >= 0 && where < m && eduration[where] > rem) {
        where--;
      }
      int total = where + 1;
      return total >= x;
    };
    while (q--) {
      cin >> need;
      int low = 0, high = m;
      while (low < high) {
        int mid = (low + high + 1) >> 1;
        if (ok(mid)) {
          low = mid;
        } else {
          high = mid - 1;
        }
      }
      cout << high << " ";
    }
    cout << '\n';
  }
}