#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> gr;
vector<vector<int>> grr;
vector<vector<int>> gruf;
vector<vector<int>> grruf;
vector<vector<int>> grsf;
vector<vector<int>> grrsf;
vector<pair<int, int>> a;
vector<int> colors;
vector<bool> used1;
vector<bool> used2;

bool flag = true;

void dfs1(int i) {
    if (!flag)
        return;
    used1[i] = true;
    for (auto v : gruf[i]) {
        if (used2[v]) {
            flag = false;
            return;
        }
        if (!used1[v]) {
            colors[v] = 1;
            dfs1(v);
        }
    }
}

void dfs2(int i) {
    if (!flag)
        return;
    used2[i] = true;
    for (auto v : grruf[i]) {
        if (used1[v]) {
            flag = false;
            return;
        }
        if (!used2[v]) {
            colors[v] = 2;
            dfs2(v);
        }
    }
}

inline void solve() {
    int n;
    cin >> n;
    gr.resize(n);
    grr.resize(n);
    gruf.resize(n);
    grruf.resize(n);
    grsf.resize(n);
    grrsf.resize(n);
    a.resize(n);
    int hasst = 0;
    int hasut = 0;
    int hassf = 0;
    for (int i = 0; i < n; ++i) {
        string f, s;
        cin >> f >> s;
        pair<int, int> ti;
        ti.first = f == "set";
        ti.second = s == "true";
        hasst += ti == pair<int, int>{1, 1};
        hassf += ti == pair<int, int>{1, 0};
        hasut += ti == pair<int, int>{0, 1};
        if (hasst >= 2 || hasut >= 2) {
            cout << -1;
            return;
        }
        a[i] = ti;
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int b, c;
        cin >> b >> c;
        gr[b - 1].push_back(c - 1);
        grr[c - 1].push_back(b - 1);
        if (a[b - 1] == a[c - 1] && a[b - 1] == pair<int, int>{0, 0}) {
            gruf[b - 1].push_back(c - 1);
            grruf[c - 1].push_back(b - 1);
        }
        if (a[b - 1] == a[c - 1] && a[b - 1] == pair<int, int>{1, 0}) {
            grsf[b - 1].push_back(c - 1);
            grrsf[c - 1].push_back(b - 1);
        }
    }
    if (!hasst) {
        if (hasut || hassf) {
            cout << -1;
            return;
        }
        map<int, set<int>> mp;
        vector<int> vc(n);
        for (int i = 0; i < n; ++i) {
            mp[grr[i].size()].insert(i);
            vc[i] = grr[i].size();
        }
        while (mp[0].size()) {
            int i = *(mp[0].begin());
            cout << i + 1 << ' ';
            for (int j : gr[i]) {
                mp[vc[j]].erase(j);
                vc[j]--;
                mp[vc[j]].insert(j);
            }
            mp[0].erase(i);
        }
    }
    else if (!hasut) {
        for (int i = 0; i < n; ++i) {
            auto t1 = a[i];
            for (auto j : gr[i]) {
                auto t2 = a[j];
                if (t1 == pair<int, int>{1, 0} && t2 == pair<int, int>{1, 1}) {
                    cout << -1;
                    return;
                }
                if (t1 == pair<int, int>{1, 1} && t2 == pair<int, int>{0, 0}) {
                    cout << -1;
                    return;
                }
                if (t1 == pair<int, int>{1, 0} && t2 == pair<int, int>{0, 0}) {
                    cout << -1;
                    return;
                }
            }
        }

        {
            map<int, set<int>> mp;
            vector<int> vc(n);
            for (int i = 0; i < n; ++i) {
                if (a[i] != pair<int, int>{0, 0})
                    continue;
                mp[grruf[i].size()].insert(i);
                vc[i] = grruf[i].size();
            }
            while (mp[0].size()) {
                int i = *(mp[0].begin());
                cout << i + 1 << ' ';
                for (int j: gruf[i]) {
                    mp[vc[j]].erase(j);
                    vc[j]--;
                    mp[vc[j]].insert(j);
                }
                mp[0].erase(i);
            }
        }

        cout << (find(a.begin(), a.end(), pair<int, int>{1, 1}) - a.begin()) + 1 << ' ';

        {
            map<int, set<int>> mp;
            vector<int> vc(n);
            for (int i = 0; i < n; ++i) {
                if (a[i] != pair<int, int>{1, 0})
                    continue;
                mp[grrsf[i].size()].insert(i);
                vc[i] = grrsf[i].size();
            }
            while (mp[0].size()) {
                int i = *(mp[0].begin());
                cout << i + 1 << ' ';
                for (int j : grsf[i]) {
                    mp[vc[j]].erase(j);
                    vc[j]--;
                    mp[vc[j]].insert(j);
                }
                mp[0].erase(i);
            }
        }
    }
    else {
        colors.resize(n);
        used1.resize(n);
        used2.resize(n);
        for (int i = 0; i < n; ++i) {
            auto t1 = a[i];
            for (auto j : gr[i]) {
                auto t2 = a[j];
                if (t1 == pair<int, int>{0, 1} && t2 != pair<int, int>{0, 0}) {
                    cout << -1;
                    return;
                }
                if (t1 != pair<int, int>{0, 0} && t2 == pair<int, int>{1, 1}) {
                    cout << -1;
                    return;
                }
                if (t1 != pair<int, int>{0, 0} && t2 == pair<int, int>{0, 0}) {
                    if (colors[j] == 2) {
                        cout << -1;
                        return;
                    }
                    colors[j] = 1;
                }
                if (t1 == pair<int, int>{0, 0} && t2 != pair<int, int>{0, 0}) {
                    if (colors[j] == 1) {
                        cout << -1;
                        return;
                    }
                    colors[i] = 2;
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (colors[i] == 1 && !used1[i])
                dfs1(i);
            if (colors[i] == 2 && !used2[i])
                dfs2(i);
        }
        if (!flag) {
            cout << -1;
            return;
        }

        vector<vector<int>> gruf1(n);
        vector<vector<int>> grruf1(n);
        vector<vector<int>> gruf2(n);
        vector<vector<int>> grruf2(n);
        vector<vector<int>> gruf0(n);
        vector<vector<int>> grruf0(n);
        for (int i = 0; i < n; ++i) {
            for (auto j : gr[i]) {
                if (colors[i] == colors[j] && colors[i] == 1) {
                    gruf1[i].push_back(j);
                    grruf1[j].push_back(i);
                }
                if (colors[i] == colors[j] && colors[i] == 2) {
                    gruf2[i].push_back(j);
                    grruf2[j].push_back(i);
                }

                if (colors[i] == colors[j] && colors[i] == 0 && a[i] == pair<int, int>{0, 0}) {
                    gruf0[i].push_back(j);
                    grruf0[j].push_back(i);
                }
            }
        }

        {
            map<int, set<int>> mp;
            vector<int> vc(n);
            for (int i = 0; i < n; ++i) {
                if (a[i] != pair<int, int>{0, 0} || colors[i] != 2)
                    continue;
                mp[grruf2[i].size()].insert(i);
                vc[i] = grruf2[i].size();
            }
            while (mp[0].size()) {
                int i = *(mp[0].begin());
                cout << i + 1 << ' ';
                for (int j : gruf2[i]) {
                    mp[vc[j]].erase(j);
                    vc[j]--;
                    mp[vc[j]].insert(j);
                }
                mp[0].erase(i);
            }
        }

        cout << (find(a.begin(), a.end(), pair<int, int>{1, 1}) - a.begin()) + 1 << ' ';

        {
            map<int, set<int>> mp;
            vector<int> vc(n);
            for (int i = 0; i < n; ++i) {
                if (a[i] != pair<int, int>{1, 0})
                    continue;
                mp[grrsf[i].size()].insert(i);
                vc[i] = grrsf[i].size();
            }
            while (mp[0].size()) {
                int i = *(mp[0].begin());
                cout << i + 1 << ' ';
                for (int j : grsf[i]) {
                    mp[vc[j]].erase(j);
                    vc[j]--;
                    mp[vc[j]].insert(j);
                }
                mp[0].erase(i);
            }
        }

        cout << (find(a.begin(), a.end(), pair<int, int>{0, 1}) - a.begin()) + 1 << ' ';

        {
            map<int, set<int>> mp;
            vector<int> vc(n);
            for (int i = 0; i < n; ++i) {
                if (a[i] != pair<int, int>{0, 0} || colors[i] != 1)
                    continue;
                mp[grruf1[i].size()].insert(i);
                vc[i] = grruf1[i].size();
            }
            while (mp[0].size()) {
                int i = *(mp[0].begin());
                cout << i + 1 << ' ';
                for (int j : gruf1[i]) {
                    mp[vc[j]].erase(j);
                    vc[j]--;
                    mp[vc[j]].insert(j);
                }
                mp[0].erase(i);
            }
        }

        {
            map<int, set<int>> mp;
            vector<int> vc(n);
            for (int i = 0; i < n; ++i) {
                if (a[i] != pair<int, int>{0, 0} || colors[i] != 0)
                    continue;
                mp[grruf0[i].size()].insert(i);
                vc[i] = grruf0[i].size();
            }
            while (mp[0].size()) {
                int i = *(mp[0].begin());
                cout << i + 1 << ' ';
                for (int j : gruf0[i]) {
                    mp[vc[j]].erase(j);
                    vc[j]--;
                    mp[vc[j]].insert(j);
                }
                mp[0].erase(i);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 1; i <= t; ++i)
        solve();
    return 0;
}
