#include <bits/stdc++.h>

typedef long long ll;
using namespace std;
#define int long long
int inf = 1e18;

inline void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> a(n);
    vector<int> d(n);
    vector<int> l(m);
    vector<int> req(q);
    for (auto &i: a)cin >> i;
    for (auto &i: d)cin >> i;
    for (auto &i: l)cin >> i;
    for (auto &i: req)cin >> i;
    vector<pair<int, int>> d_a;
    for (int i = 0; i < n; ++i) {
        d_a.emplace_back(d[i], a[i]);
    }
    d_a.emplace_back(inf, 0);
    std::sort(d_a.begin(), d_a.end());
    int max_need_to_start = inf;
    vector<int> need_to_starts;
    for (int i = n; i >= 0; --i) {
        int true_deadline = min(max_need_to_start, d_a[i].first);
        max_need_to_start = true_deadline - d_a[i].second;
        need_to_starts.emplace_back(max_need_to_start);
    }
    std::reverse(need_to_starts.begin(), need_to_starts.end());
    vector<int> pref_films{0};
    vector<int> pref_tasks{0};
    for (int i = 0; i <= n; ++i) {
        pref_tasks.emplace_back(pref_tasks.back() + d_a[i].second);
    }
    for (int i = 0; i < m; ++i) {
        pref_films.emplace_back(pref_films.back() + l[i]);
    }
    int curtime = 0;
    vector<int> finishedfilms;
    int curfilm = 0;
    for (int curi = 0; curi <= n; ++curi) {
        if (curfilm == l.size())break;
        while (l[curfilm] + curtime <= need_to_starts[curi]) {
            curtime = l[curfilm] + curtime;
            finishedfilms.emplace_back(curtime);
            curfilm++;
            if (curfilm == l.size())break;
        }
        curtime += d_a[curi].second;
    }
    for (auto r: req) {
        cout << upper_bound(finishedfilms.begin(), finishedfilms.end(), r) - finishedfilms.begin() << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
//    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    for (int i = 1; i <= t; ++i)
        solve();
    return 0;
}
