#include <bits/stdc++.h>

#define pb push_back
#define vi vector<int>
#define pii pair<int,int>
#define vpii vector<pii>

using namespace std;



using ll = long long;

string s;
char c;
int pos;
string lex;
bool flag;

void nextChar(){
    if(pos < s.size()){
        c = s[pos];
        pos++;
    } else {
        c = '\n';
    }
}

ll number(){
    ll ans = 0;

    if('1' <= c && c <= '9'){
        ans = c - '0';
    } else {
        flag = false;
    }

    while('0' <= c && c <= '9'){
        ans *= 10;
        ans += (c - '0');
        nextChar();
    }

    return ans;
}

ll expression(){
    ll ans = number();

    int sign;
    while(c == '+' || c == '-'){
        if(c == '+'){
            sign = 1;
        } else {
            sign = -1;
        }

        nextChar();
        ans += sign * number();
    }

    return ans;
}

bool correctEquality(){
     ll left = expression();
     if(c != '='){
         flag = false;
     }
     nextChar();
     ll right = expression();
     if(c != '\n'){
         flag  = false;
     }
     return left == right && flag;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    ll n;
    std::cin >> n;

    std::vector<ll> a(n);
    std::vector<ll> curr_idx(n + 1);
    std::iota(curr_idx.begin(), curr_idx.end(), -1);

    std::vector<ll> curr(n);
    std::iota(curr.begin(), curr.end(), 1);
    for (long long & i : a) {
        std::cin >> i;
    }

    std::vector<std::pair<ll, ll>> ans;
    for (ll i = 0; i < a.size(); ++i) {
        for (ll j = curr_idx[a[i]]; j + 1 < a.size(); ++j) {
            ans.emplace_back(curr[j + 1], curr[j]);
            std::swap(curr_idx[curr[j]], curr_idx[curr[j + 1]]);
            std::swap(curr[j], curr[j + 1]);
        }
        for (ll j = (ll)a.size() - 2; j >= i; --j) {
            ans.emplace_back(curr[j + 1], curr[j]);
            std::swap(curr_idx[curr[j]], curr_idx[curr[j + 1]]);
            std::swap(curr[j], curr[j + 1]);
        }
    }

    std::cout << ans.size() << '\n';
    for (auto& [x, y] : ans) {
        std::cout << x << ' ' << y << '\n';
    }

    return 0;
}

