#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

#define itn int

#define F first
#define S second

#define int ll

const ll inf = 1e18 + 123;

int32_t main(){


#ifdef LOCAL
    freopen( "input.txt" , "r", stdin );
    freopen( "output.txt" , "w", stdout );
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;

    vector <array <string, 2>> a(n + 1);
    vector <int> tp(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> a[i][0] >> a[i][1];
        if (a[i][0] == "unset" && a[i][1] == "false") {
            tp[i] = 0;
        }
        if (a[i][0] == "set" && a[i][1] == "true") {
            tp[i] = 1;
        }
        if (a[i][0] == "set" && a[i][1] == "false") {
            tp[i] = 2;
        }
        if (a[i][0] == "unset" && a[i][1] == "true") {
            tp[i] = 3;
        }
    }

    vector <vector <int>> g(n + 1);

    for (int i = 0; i < n; i++) g[n].push_back(i);

    int m; cin >> m;
    while (m--) {
        int u, v; cin >> u >> v, u--, v--;
        g[u].push_back(v);
    }

    vector <int> used(n + 1, 0), order;
    function <void(int)> dfs = [&](int v) {
        if (used[v]) return;
        used[v] = 1;
        for (auto to : g[v]) {
            dfs(to);
        }
        order.push_back(v);
    };

    vector <vector <int>> ans(5);

    dfs(n);

    reverse(order.begin(), order.end());

    vector <int> tp4(n + 1, 0);

    for (auto x : order) {
        tp4[x] |= tp[x] != 0;
        for (auto to : g[x]) {
            tp4[to] |= tp4[x];
        }
    }

    for (const auto& y : order) {
        if (y == n) continue;
        if (tp4[y] && tp[y] == 0) tp[y] = 4;
        ans[tp[y]].push_back(y);
    }

    bool r = false;

    for (auto x : ans) {
        for (auto y : x) {
            if ((tp[y] == 0 || tp[y] == 4) && r == true) {
                cout << "-1\n";
                return 0;
            }
            if (tp[y] == 1 && r == true) {
                cout << "-1\n";
                return 0;
            }
            if (tp[y] == 2 && r == false) {
                cout << "-1\n";
                return 0;
            }
            if (tp[y] == 3 && r == false) {
                cout << "-1\n";
                return 0;
            }
            if (tp[y] == 1) r = true;
            if (tp[y] == 3) r = false;
        }
    }

    vector <int> tin(n + 1, 0);
    int timer = 0;

    for (auto x : ans) {
        for (auto y : x) tin[y] = timer++;
    }

    for (int i = 0; i < n; i++) {
        for (auto to : g[i]) {
            if (tin[i] > tin[to]) {
                cout << "-1\n";
                return 0;
            }
        }
    }

    for (auto x : ans) {
        for (auto y : x) cout << y + 1 << " ";
    }


    return 0;
}
