#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()

using namespace std;

const ll mod = 1e9+7;
const ll MAXN = 1e5+10;

void start(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll gcd(ll a, ll b){
    while(a){
        b %= a;
        swap(a, b);
    }
    return b;
}

pair<bool, bool> fill(vector<bool>& a, int n){
    bool mul = false;
    for(int i = 0; i < n; ++i){
        int mask = 0;
        if (a[i * 2]) {
            mask += 1;
        }
        if (a[i * 2 + 1]) {
            mask += 2;
        }
        if (a[i * 2 + 2]) {
            mask += 4;
        }
        if (a[i * 2 + 3]) {
            mask += 8;
        }
        if (mask == 1 || mask == 5) {
            a[i*2 + 1] = true;
            a[i*2 + 3] = true;
        } else if (mask == 2 || mask == 10) {
            a[i*2 + 0] = true;
            a[i*2 + 2] = true;
        } else if (mask == 4 || mask == 8 || mask == 12) {
            a[i*2 + 0] = true;
            a[i*2 + 1] = true;
        } else if (mask == 9 || mask == 6 || mask == 13 || mask == 14) {
            return {false, true};
        } else if (mask == 0){
            mul = true;
        }
    }
    return {mul, false};
}

void solve(){
    int n;
    cin >> n;
    string m[2];
    vector<bool> r1((n + 1) * 2, true), r2((n + 1) * 2, true);
    cin >> m[0] >> m[1];
    for(int i = 0; i < n; i++){
        r1[i*2] = m[0][i] == '#';
        r1[i*2 + 1] = m[1][i] == '#';
        r2[i*2] = m[0][n - i - 1] == '#';
        r2[i*2 + 1] = m[1][n - i - 1] == '#';
    }
    auto [mul1, dnt1] = fill(r1, n);
    auto [mul2, dnt2] = fill(r2, n);
    if (dnt1 && dnt2){
        cout << "None\n";
    }else if (mul1 && mul2) {
        cout << "Multiple\n";
    }else {
        cout << "Unique\n";
    }

}

int main() {
    start();
    int t = 1;
    cin >> t;
    while(t--){
        solve();
    }

    return 0;
}
