#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define F first
#define S second
#define endl '\n'

typedef long long ll;

using namespace std;

ll sum(string s) {
    if (s[0] < '0' || s[0] > '9') {
        s.erase(s.begin());
    }
    if (s.back() < '0' || s.back() > '9') {
        s.erase(s.begin() + s.size() - 1);
    }
    for (int i = 1; i < s.size(); i++) {
        if ((s[i] < '0' || s[i] > '9') && (s[i - 1] < '0' || s[i - 1] > '9')) {
            s.erase(s.begin() + (i - 1));
            s.erase(s.begin() + (i - 1));
        }
    }
    if (s.size() == 0) return 0;
    s += "#";
    ll res = 0;
    int last = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] >= '0' && s[i] <= '9') continue;
        string f = s.substr(last, i - last);
        if (f.size() > 10 || (!f.empty() && f[0] == '0')) return LLONG_MIN;
        ll cur = stoll(f);
        if (last == 0 || s[last - 1] == '+') res += cur;
        else res -= cur;
        last = i + 1;
    }
    return res;
}


bool check(string s) {
    if (s[0] == '0') return false;
    string l, r;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '=') {
            l = s.substr(0, i);
            r = s.substr(i + 1, s.size() - l.size() - 1);
        }
    }

    ll suml = sum(l), sumr = sum(r);
    cout << suml << ' ' << sumr << endl;

    return sum(l) == sum(r);
}

int main() {
    string s; cin >> s;
    if (check(s)) {
        cout << "Correct";
        return 0;
    }
    for (int i = 0; i < s.size(); i++) {
        if (s[i] >= '0' && s[i] <= '9') {
            string cop = s;
            char c = s[i];
            cop.erase(cop.begin() + i);
            for (int j = 0; j < cop.size(); j++) {
                if (c == '0' && (j == 0 || (cop[j - 1] < '0' || cop[j - 1] > '9'))) continue;
                string a = cop;
                a.insert(a.begin() + j, c);
                if (check(a)) {
                    cout << a;
                    return 0;
                }
            }
            if (check(cop + c)) {
                cout << cop + c;
                return 0;
            }
        }
    }
    cout << "Impossible";
}
