#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define F first
#define S second
#define endl '\n'

typedef long long ll;

using namespace std;

pair<ll, bool> sum(string s) {
    s += "#";
    ll res = 0;
    int last = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] >= '0' && s[i] <= '9') continue;
        if (i <= last) return {0, false};
        string f = s.substr(last, i - last);
        if (f.size() > 10 || (f != "0" && f[0] == '0')) return {0, false};
        ll cur = stoll(f);
        if (last == 0 || s[last - 1] == '+') res += cur;
        else res -= cur;
        last = i + 1;
    }
    return {res, true};
}


bool check(string s) {
    string l, r;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '=') {
            l = s.substr(0, i);
            r = s.substr(i + 1, s.size() - l.size() - 1);
        }
    }

    auto suml = sum(l), sumr = sum(r);

    if (!suml.S || !sumr.S) return false;

    return suml.F == sumr.F;
}

int main() {
    string s; cin >> s;
    if (check(s)) {
        cout << "Correct";
        return 0;
    }
    for (int i = 0; i < s.size(); i++) {
        if (s[i] >= '0' && s[i] <= '9') {
            string cop = s;
            char c = s[i];
            cop.erase(cop.begin() + i);
            for (int j = 0; j < cop.size(); j++) {
                if (c == '0' && (j == 0 || (cop[j - 1] < '0' || cop[j - 1] > '9'))) continue;
                string a = cop;
                a.insert(a.begin() + j, c);
                if (check(a)) {
                    cout << a;
                    return 0;
                }
            }
            if (check(cop + c)) {
                cout << cop + c;
                return 0;
            }
        }
    }
    cout << "Impossible";
}
