#include <bits/stdc++.h>
#define sz(_a) ((int)((_a).size()))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const par tur[4] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

inline signed solve() {
    int n;
    cin >> n;
    string s[2];
    cin >> s[0] >> s[1];

    vector<int> cnt[2];
    cnt[0].resize(n);
    cnt[1].resize(n);
    set<par> st;

    auto is_good = [&](int nx, int ny) -> bool {
        if (nx < 0 || nx >= 2 || ny < 0 || ny >= n) {
            return false;
        }
        if (s[nx][ny] == '#') {
            return false;
        }
        return true;
    };

    int cnt_odd = 0, cnt_even = 0;
    for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            if (s[i][j] == '#') {
                continue;
            }
            if ((i + j) & 1) {
                ++cnt_odd;
            } else {
                ++cnt_even;
            }
            for (auto [dx, dy] : tur) {
                int nx = i + dx;
                int ny = j + dy;
                if (!is_good(nx, ny)) {
                    continue;
                }

                ++cnt[i][j];
            }
            if (cnt[i][j] == 0) {
                return cout << "None", 0;
            }
            st.emplace(cnt[i][j], i * n + j);
        }
    }

    if (cnt_odd != cnt_even) {
        return cout << "None", 0;
    }
    /*for (int i = 0; i < 2; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << cnt[i][j] << ' ';
        }
        cout << '\n';
    }*/
    while (!st.empty()) {
        auto [val, ind] = *st.begin();
        st.erase(st.begin());
        if (val > 1) {
            return cout << "Multiple", 0;
        }
        int x = ind / n, y = ind % n;
        int k = 0;
        // cerr << val << ' ' << x << ' ' << y << '\n';
        cnt[x][y] = 0;
        for (auto [dx, dy] : tur) {
            int nx = x + dx;
            int ny = y + dy;
            if (!is_good(nx, ny)) {
                continue;
            }
            st.erase({cnt[nx][ny], nx * n + ny});
            if (cnt[nx][ny] > 0) {
                cnt[nx][ny] = 0;
                // st.emplace(cnt[nx][ny], nx * n + ny);
                for (auto [dx1, dy1] : tur) {
                    int nnx = nx + dx1, nny = ny + dy1;
                    if (!is_good(nnx, nny)) {
                        continue;
                    }
                    if (cnt[nnx][nny] == 0) {
                        continue;
                    }
                    // cerr << "\t\t" <<nnx << ' ' << nny << '\n';
                    st.erase({cnt[nnx][nny], nnx * n + nny});
                    --cnt[nnx][nny];
                    if (cnt[nnx][nny] > 0) {
                        st.emplace(cnt[nnx][nny], nnx * n + nny);
                    }
                }
                ++k;
                // cerr << '\t' << nx << ' ' << ny << '\n';
            }
        /*for (int i = 0; i < 2; ++i) {
            for (int j = 0; j < n; ++j) {
                    cout << cnt[i][j] << ' ';
                }
                cout << '\n';
            }*/

        }
        if (k == 0) {
            return cout << "None", 0;
        }
    }
    cout << "Unique";

    return 0;
}

signed main() {
#ifdef MAKS
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    cerr << fixed << setprecision(3);
    int t_t = 1;
    cin >> t_t;
    while (t_t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
