#include <bits/stdc++.h>

int add(int a, int b) {
    return std::min(a + b, 2);
}

void solve() {
    int n;
    std::cin >> n;
    std::array<std::string, 2> ar;
    std::cin >> ar[0] >> ar[1];
    std::map<int, int> map;
    map[0b11] = 1;

    for (int i = 0; i <= n; i++) {
        decltype(map) map2;
        for (auto [mask0, val] : map) {
            int mask = mask0;
            if (i < n) {
                mask |= (int(ar[0][i] == '#') << 2);
                mask |= (int(ar[1][i] == '#') << 3);
            }
            for (int dt : {0b0, 0b11, 0b101, 0b1010, 0b1111, 0b1111}) {
                if ((mask & dt) == 0) {
                    int mk = mask | dt;
                    if ((mk & 0b11) == 0b11) {
                        map2[mk >> 2] = add(map2[mk >> 2], val);
                    }
                }
            }
        }
        map.swap(map2);
    }
    int ans = map[0];
    std::cout << std::vector{"None", "Unique", "Multiple"}[ans] << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
